# (C) http://spcms.ru
use strict;
use locale;

sub aj_login_free() {
    my $log = param('login');
    aj_print '  .' unless $log;
    my $q = $gdb->prepare('select 1 from sp_users where log = ?') or db_error();
    $q->execute($log) or db_error();
    my $a = ( $q->fetchrow_array() )[0];
    $q->finish;
    if ($a) {
        aj_print
q[<span class="login_validity_fail">  ,<br> .</span>];
    }
    else { aj_print " ."; }
}

sub aj_subgrp() {
    my $c = param('c');
    sec_gt0 $c;
    my $s = param('s');
    sec_gt0 $s;

    my $response =
'&nbsp;&nbsp;: <select name=g class=def><option value=""></option>';
    my $q = sqlp qq[select id,name from sp_class_subgrp_ref
          where  c = $c and s = $s];
    my @a;
    my $found = 0;
    while ( @a = $q->fetchrow_array ) {
        $found ||= 1;
        $response .=
          ($DEBUG)
          ? qq[<option value="$a[0]">ID=$a[0] $a[1]</option>]
          : qq[<option value="$a[0]">$a[1]</option>];
    }
    $response .= '</select>';
    if ($found) {
        aj_print $response;
    }
    aj_print
      qq[&nbsp;&nbsp;: <a href="?act=subgroups&c=$c&s=$s"></a>];
}

sub aj_acl_switch() {
    my $id  = param('id');
    my $uid = param('uid');
    sec_gt0 $uid;
    my $gid = param('gid');

    unless ( $gid == 1 or $gid == 6 ) { security_alert($gid); }

    if ( sqlff "select 1 from sp_users_acl where uid = $uid and gid = $gid" ) {
        sql "delete from sp_users_acl where uid = $uid and gid = $gid";
        aj_print "$uid,$gid,0";
    }
    else {
        sql "insert into sp_users_acl (uid, gid) values ($uid, $gid)";
        aj_print "$uid,$gid,1";
    }

}

sub aj_sms_send() {
    my $datetime = strftime( "%d %B %Y %H:%M", localtime );
    $datetime = win_to_koi8r($datetime);

    my $number                             = param('number');
    my $text                               = param('text');
    my $catch_naked_text_before_converting = $text;
    $text = utf8_to_koi8r($text);

    $text =~ s/'//g;

    $text = trim($text);

    unless ( length($text) ) {
        system
qq[echo '$datetime | ERROR! Empty SMS to $number | raw text: $catch_naked_text_before_converting' >> sms-log2];
        aj_print("Empty SMS");
    }

    my $rc = system
qq[export LC_ALL=ru_RU.KOI8-R; echo '$text' | gnokii --sendsms $number --long 1500];

    if ( $rc == 0 ) {
        system qq[echo '$datetime | $number | $text' >> sms-log2];
    }
    else {
        system
          qq[echo '$datetime | ERROR! Code: $rc | $number | $text' >> sms-log2];
    }

    aj_print($rc);
}

our %g_allowed_autocomplete_types = map { $_ => 1 } qw|human.first_name|;

sub aj_autocomplete() {
    my $type = param('type');
    my $text = lc( utf8_to_win( trim( substr( param('text'), 0, 64 ) ) ) );

    unless ( length($text) ) {
        aj_print("-1");
    }

    unless ( exists( $g_allowed_autocomplete_types{$type} ) ) {
        aj_print("     ");
    }

    my ( $table, $field ) = split( /\./, $type );

    $text = $gdb->quote($text);
    $text =~ s/'//g;

    my @response;

    sqlffa( \@response,
qq[select distinct $field from $table where lower($field) like '%$text%' order by 1]
    );

    aj_print( join( "\n", @response ) );
}

1;
