# (C) http://spcms.ru
use locale;
use strict;

use vars qw( @months3 );

sub ktp_list_all() {
    my ( $datetime1, $datetime2 );
    my ( $mday, $mon, $year );

    my $ktp = '<TABLE border=0 cellspacing=0 class=d width=100%>
  <TR>
  <TH></TH>
  <TH></TH>
  <TH></TH>
  <TH></TH></TR>';

    my $q = sqlp( "
    SELECT   KTP_ID, sp_ktp_ref.NAME, lesson.name, TIME_START, TIME_END
    FROM     sp_ktp_ref, lesson
    where    sp_ktp_ref.SUBJ = lesson.lesson_id" );
    my @data;
    while ( @data = $q->fetchrow_array() ) {
        ( undef, undef, undef, $mday, $mon, $year, undef, undef, undef ) =
          localtime( $data[3] );
        $year += 1900;
        $datetime1 = "$mday $months3[$mon] $year";
        ( undef, undef, undef, $mday, $mon, $year, undef, undef, undef ) =
          localtime( $data[4] );
        $year += 1900;
        $datetime2 = "$mday $months3[$mon] $year";
        $ktp .= "
      <tr OnMouseOver='m_over(this);'
          OnMouseOut='m_out(this);'
          OnClick='document.location.href=\"?act=ktp_view&ktp_id=$data[0]\";'
          style='cursor:hand;'
          title=',      '>
      <TD>$data[1]</TD>
      <TD>$data[2]</TD>
      <TD align=right><nobr>$datetime1</nobr></TD>
      <TD align=right><nobr>$datetime2</nobr></TD>
      </tr>";
    }
    $q->finish();

    $ktp .= "</TABLE>";
    my %replace = (
        fx1 =>
"<button type=submit value=send onclick=\"document.location.href = '?act=ktp_form_create'\"> </button>",
        ktp     => $ktp,
        menu    => generate_menu(),
        footers => generate_footers(),
    );
    tpl( "./tpl/ktp_list.html", \%replace );
}

sub ktp_form_create() {
    my ( undef, undef, undef, undef, undef, $year, undef, undef, undef ) =
      localtime;
    $year += 1900;

    my $year2 = $year + 1;

    my %replace = (
        menu       => generate_menu(),
        subj       => filter_subj(undef),
        date_begin => "<input type=text class=def name=d1 size=3 value=1>&nbsp;"
          . "<input type=text class=def name=m1 size=3 value=9>&nbsp;"
          . "<input type=text class=def name=y1 size=5 value=$year>",
        date_end => "<input type=text class=def name=d2 size=3 value=31>&nbsp;"
          . "<input type=text class=def name=m2 size=3 value=8>&nbsp;"
          . "<input type=text class=def name=y2 size=5 value=$year2>",
        name =>
'<input type=text class=def name=name style="width: 280px;" maxlength=128>',
        submit  => '<button type=submit value="send"> </button>',
        footers => generate_footers(),
    );
    tpl( "./tpl/ktp_form_create.html", \%replace );
}

sub ktp_create() {
    my $name = param("name")
      or error(
        "   . <a href=\"javascript:history.go(-1);\"></a>"
      );
    my $subj  = param("subj");
    my $time1 = timelocal( undef, undef, undef, param("d1"), param("m1") - 1,
        param("y1") );
    my $time2 = timelocal( undef, undef, undef, param("d2"), param("m2") - 1,
        param("y2") );
    my $class_id = param("class_id");
    my $ktp_id   = gen_unical_ktp_id();

    sql(
        "insert into sp_ktp_ref
  (KTP_ID, NAME, SUBJ, TIME_START, TIME_END)
  values
  ($ktp_id, '$name', $subj, $time1, $time2)"
    );

    redir("ktp_view&ktp_id=$ktp_id");
}

sub ktp_view() {
    my $ktp_id = param("ktp_id");
    if ($ktp_id) {
        my $q = sqlp(
            "select sp_ktp_ref.NAME, lesson.name
       from sp_ktp_ref,lesson
       where KTP_ID = $ktp_id and SUBJ = lesson.LESSON_ID"
        );
        my @head = $q->fetchrow_array();
        if ( !@head ) { error("  ."); }
        $q->finish;

        my $ktp = "<TABLE border=0 cellspacing=0 class=d width=\"100%\">
    <TR>
    <TH></TH>
    <TH></TH>
    <TH> ()</TH>
    <TH> ()</TH>";
        $q = sqlp(
"select sp_ktp_section_ref.name, theme, theor, pract, ktp_id, sp_ktp.id, sp_ktp_section_ref.id
     from sp_ktp, sp_ktp_section_ref
     where ktp_id = $ktp_id
       and sp_ktp.section = sp_ktp_section_ref.id"
        );
        my @data;
        while ( @data = $q->fetchrow_array() ) {
            $ktp .= "
      <tr OnMouseOver='m_over(this);'
          OnMouseOut='m_out(this);'
          OnClick='document.location.href=\"?act=ktp_form_modify&"
              . "section=$data[6]&"
              . "theme=$data[1]&"
              . "theor=$data[2]&"
              . "pract=$data[3]&"
              . "ktp_id=$data[4]&"
              . "id=$data[5]\";'
          style='cursor:hand;'
          title=',  '>
      <TD>$data[0]</TD>
      <TD>$data[1]</TD>
      <TD align=right>$data[2]</TD>
      <TD align=right>$data[3]</TD>
      </tr>";
        }
        $q->finish();
        $ktp .= "</TABLE>";
        my %replace = (
            head => "<b></b>: $head[0]<br>"
              . "<b></b>: $head[1]",
            fx1 =>
"<button type=submit value=send onclick=\"document.location.href = '?act=ktp_form_add&ktp_id=$ktp_id'\"> </button> ",
            fx2 =>
"<button type=submit value=send onclick=\"document.location.href = '?act=ktp_section_list_all&ktp="
              . param("ktp_id")
              . "'\"> </button>",
            ktp     => $ktp,
            menu    => generate_menu(),
            footers => generate_footers(),
        );
        tpl( "./tpl/ktp_view.html", \%replace );
    }
    else {
        error(
            "  :
                ."
        );
    }
}

sub ktp_form_add() {
    my $section = "<select name=section class=def>";
    my @a;

    my $q = sqlp("SELECT id, name from sp_ktp_section_ref");

    while ( @a = $q->fetchrow_array() ) {
        $section .= "<option value=\"$a[0]\">$a[1]</option>";
    }
    $q->finish;

    $section .= "</select>";

    my $THEME;

    my %replace = (
        menu         => generate_menu(),
        input_ktp_id => "<input type=hidden name=ktp_id value="
          . param("ktp_id") . ">",
        input_ktp_subid => '', section => $section,
        theme => '<INPUT TYPE=text class=def NAME=theme maxlength=128 size=32>',
        theor => '<INPUT TYPE=text class=def NAME=theor size=5>',
        pract => '<INPUT TYPE=text class=def NAME=pract size=5>',
        submit  => '<button type=submit value="send"> </button>',
        footers => generate_footers(),
    );
    tpl( "./tpl/ktp_form_add.html", \%replace );
}

sub ktp_add() {
    my ( $theme, $section, $theor, $pract, $ktp_id ) = (
        param("theme"), param("section"), param("theor"), param("pract"),
        param("ktp_id")
    );

    sql(
        "insert into sp_ktp (KTP_ID, ID, SECTION, THEME, THEOR, PRACT)
  values ($ktp_id, 0, $section, '$theme', $theor, $pract)"
    );

    redir("ktp_view&ktp_id=$ktp_id");
}

sub ktp_form_modify() {
    my ( $theme, $section, $theor, $pract, $id, $ktp_id ) = (
        param("theme"), param("section"), param("theor"), param("pract"),
        param("id"),    param("ktp_id")
    );

    my $section_combo = "<select name=section>";
    my @a;
    my $q = sqlp("SELECT id, name from sp_ktp_section_ref");
    my $selected;
    while ( @a = $q->fetchrow_array() ) {
        if   ( $section == $a[0] ) { $selected = 'selected' }
        else                       { $selected = '' }
        $section_combo .= "<option $selected value=\"$a[0]\">$a[1]</option>";
    }
    $q->finish;
    $section_combo .= "</select>";

    my %replace = (
        menu            => generate_menu(),
        input_ktp_id    => "<input type=hidden name=ktp_id value=$ktp_id>",
        input_ktp_subid => "<input type=hidden name=id value=$id>",
        section         => $section_combo,
        theme =>
          "<INPUT TYPE=text class=def NAME=theme value='$theme' maxlength=128>",
        theor   => "<INPUT TYPE=text class=def NAME=theor value='$theor'>",
        pract   => "<INPUT TYPE=text class=def NAME=pract value='$pract'>",
        footers => generate_footers(),
    );
    tpl( "./tpl/ktp_form_modify.html", \%replace );
}

sub ktp_modify() {
    my ( $theme, $section, $theor, $pract, $id, $ktp_id ) = (
        param("theme"), param("section"), param("theor"), param("pract"),
        param("id"),    param("ktp_id")
    );

    sql( "
   update sp_ktp set
   SECTION = $section, THEME = '$theme', THEOR = $theor, PRACT = $pract
   where KTP_ID = $ktp_id and ID = $id" );

    redir("ktp_view&ktp_id=$ktp_id");
}

sub ktp_section_list_all() {
    my $ktp = param("ktp");
    my $q   = sqlp(
        "select sp_ktp_ref.NAME, lesson.name
       from sp_ktp_ref,lesson
       where KTP_ID = $ktp and SUBJ = lesson.LESSON_ID"
    );
    my @head = $q->fetchrow_array();
    if ( !@head ) { error("  ."); }
    $q->finish;

    my $sections =
      "<TABLE border=0 cellspacing=0 class=d width=90% align=center>
  <TR>
  <TH></TH>
  <TH width=200 colspan=2></TH>
  </TR>";

    $q = sqlp("select id,name from sp_ktp_section_ref where ktp = $ktp");
    my @a;
    while ( @a = $q->fetchrow_array() ) {
        $sections .= "<tr OnMouseOver='m_over(this);' OnMouseOut='m_out(this);'>
     <td
       style='cursor: hand;'
       title=',  '
       OnClick='document.location.href=\"?act=ktp_form_section_modify&ktp=$ktp&id=$a[0]\";'>
     $a[1]</td>
     <td align=center width=100>
       <a href=\"?act=ktp_form_section_modify&ktp=$ktp&id=$a[0]\"></a>
     </td>
     <td align=center width=100>
       <a href=\"?act=ktp_section_delete&ktp=$ktp&id=$a[0]\" onClick=\"return confirm('    $a[1]?')\"></a>
     </td>
     </tr>";
    }
    $q->finish;

    $sections .= "</TABLE>";

    my %replace = (
        menu => generate_menu(),
        head => "<b></b>: $head[0]<br>" . "<b></b>: $head[1]",
        sections => $sections,
        ktp      => $ktp,
        footers  => generate_footers(),
    );
    tpl( "./tpl/ktp_section_list.html", \%replace );
}

sub ktp_section_add() {
    my $ktp  = param("ktp");
    my $name = param("name");
    sql(
        "insert into sp_ktp_section_ref
       (name,ktp) values ('$name',$ktp)"
    );
    redir("ktp_section_list_all&ktp=$ktp");
}

sub ktp_section_delete() {
    my $id  = param("id");
    my $ktp = param("ktp");

    my $q = sqlp("select id from sp_ktp where section = $id");
    my @a = $q->fetchrow_array();
    $q->finish();
    if (@a) {
        error(
"   ,  ,    .   ,    ,        . <a href=\"javascript:history.go(-1);\">.</a>"
        );
    }

    sql(
        "delete from sp_ktp_section_ref
       where id = $id"
    );
    redir("ktp_section_list_all&ktp=$ktp");
}

sub ktp_form_section_modify() {
    my $id  = param("id");
    my $ktp = param("ktp");

    my $q = sqlp("select name from sp_ktp_section_ref where id = $id");
    my @a = $q->fetchrow_array();
    $q->finish();
    if ( !@a ) {
        error(
"   . <a href=\"javascript:history.go(-1);\"></a>"
        );
    }

    my %replace = (
        menu   => generate_menu(),
        id     => $id,
        ktp    => $ktp,
        name   => "<INPUT TYPE=text class=def NAME=name value='$a[0]' size=64>",
        submit => '<button type=submit value="send"> </button>',
        footers => generate_footers(),
    );
    tpl( "./tpl/ktp_form_section_modify.html", \%replace );
}

sub ktp_section_modify() {
    my ( $name, $id, $ktp ) = ( param("name"), param("id"), param("ktp") );

    sql("update sp_ktp_section_ref set name = '$name' where id = $id");

    redir("ktp_section_list_all&ktp=$ktp");
}

1;
