# (C) http://spcms.ru
use locale;
use strict;

use vars
  qw / %gconf $gdsn $gdb $gdate $ggid $state_date $DEBUG @mnths @months3 $gteacher_show_all %gid_decl %g_recipient_ref/;
use vars qw / @access_pupil @access_teacher @access_admin /;

sub payfood_error_pay() {
    if ( $ENV{'REQUEST_METHOD'} eq 'GET' ) {
        tpl './tpl/payfood/error_pay.html',
          {
            menu          => generate_menu(),
            footers       => generate_footers(),
            show_msg_sent => param('sent') ? '1' : '0'
          };
    }

    elsif ( $ENV{'REQUEST_METHOD'} eq 'POST' ) {
        my $body = '';

        my %hash = (

            'date'    => '',
            'sum'     => '',
            'account' => ' /',

            'receipt'  => '',
            'terminal' => '',
            'opcode'   => ' '

        );

        for (qw(date sum account)) {
            $body .=
                $hash{$_}
              . ( ' ' x ( 23 - length( $hash{$_} ) ) )
              . "${\(param($_))}\n";
        }

        for (qw(receipt terminal opcode)) {
            if ( param($_) ) {
                $body .=
                    $hash{$_}
                  . ( ' ' x ( 23 - length( $hash{$_} ) ) )
                  . "${\(param($_))}\n";
            }
        }

        my $fake_from = $gconf{db_path};
        $fake_from =~ s/^.+XXI-.-//i;
        $fake_from =~ s/\.gdb$//i;
        $fake_from =~ s/^0+//;
        $fake_from = 'SP at school #' . $fake_from;

        my $mail_sender = new Mail::Sender {
            smtp      => $gconf{'smtp'},
            from      => 'xxibasequery@' . $ENV{'SERVER_NAME'},
            fake_from => $fake_from
              . ' <xxibasequery@'
              . $ENV{'SERVER_NAME'} . '>',
            charset  => 'Windows-1251',
            priority => 1
        };

        unless ( $mail_sender =~ /^-\d+$/ ) {
            $mail_sender->MailMsg(
                {
                    to => $gconf{'payfood_support'} || 'support@pitanie-tlt.ru',
                    subject => (
                            '   '
                          . param('date') . "  "
                          . param('account')
                    ),
                    msg => $body
                }
            );
        }
        else {
            stop(
"  .   ,  SMTP  ."
            );
        }

        redir("payfood_error_pay&sent=1");
    }

    else { deny(); }
}

sub translit ($) {
    my $q = shift;
    $q =~ s//yu/go;
    $q =~ s//Yu/go;
    $q =~ s//ya/go;
    $q =~ s//Ya/go;
    $q =~ s//ch/go;
    $q =~ s//Ch/go;
    $q =~ s//sh/go;
    $q =~ s//Sh/go;
    $q =~ s//sh/go;
    $q =~ s//Sh/go;
    $q =~ s//ts/go;
    $q =~ s//Ts/go;
    $q =~ s/[]//gio;
    $q =~ tr/Ũ/ABVGDEEJZIYKLMNOPRSTUFHCIE/;
    $q =~ tr//abvgdeejziyklmnoprstufhcie/;
    return $q;
}

sub msg( $$ ) {
    my $title = shift;
    my $msg   = shift;

    my %replace = (
        title   => $title,
        msg     => $msg,
        menu    => generate_menu(),
        footers => generate_footers(),
    );
    tpl( "./tpl/msg.html", \%replace );
}

sub OnStart() {

    setlocale( LC_ALL, "ru_RU.CP1251" );
    if ( !defined($gdb) or !$gdb->ping ) {
        %gconf = read_config('sp.conf') unless defined %gconf;

        $gdsn =
"dbi:InterBase:db=$gconf{db_path};host=$gconf{db_server};ib_charset=WIN1251";

        $gdb = DBI->connect( $gdsn, $gconf{"db_user"}, $gconf{"db_pass"} )
          || db_error_connect();
        $gdb->{FetchHashKeyName} = 'NAME_lc';
        $connected = 1;
    }

}

sub OnEnd() {
}

sub gen_unical_ktp_id() {
    my $q;
    my $fail = 1;
    my @data;
    my $ktp_id;
    while ($fail) {
        $ktp_id .= int( rand(2147483644) ) + 1;
        $q    = sqlp("select ktp_id from sp_ktp_ref where ktp_id = '$ktp_id'");
        @data = $q->fetchrow_array();
        $q->finish();
        if ( !@data ) { undef $fail; }
    }
    return ($ktp_id);
}

sub weak_password ($) {
    my $pass = shift;
    open A, "./dic/wordlist.txt";
    while (<A>) {
        chop;
        if ( $_ eq $pass ) { close A; return 1; }
    }
    close A;
    return 0;
}

sub users_logged() {
    my $q     = sqlp("select count(1) from sp_users_logged");
    my @count = $q->fetchrow_array();
    $q->finish();

    my $table;
    $gdb->{"AutoCommit"} = 0;
    $q = sqlp(
        "SELECT
      human.last_name || ' ' || human.first_name || ' ' || human.middle_name,
      sp_users.UID, sp_users.GID, sp_users.log,
      sp_users_logged.LOGTIME, sp_users_logged.LASTTIME,
      sp_users_logged.IP, sp_users_logged.IP_FOR,
      sp_users_logged.AGENT,
      (select name from sp_gid_ref where gid=sp_users.GID)
    FROM  sp_users_logged, human, sp_users
    where human.HUMAN_ID = sp_users_logged.UID and
          sp_users_logged.uid = sp_users.uid"
    );
    my @result;
    my $rem;
    my $style;
    my ( $sec, $min, $hour, $mday, $mon, $year, $wday );
    my $time_logged;
    my $time_last_activity;
    my $time_session_length;
    while ( @result = $q->fetchrow_array() ) {
        $time_session_length = $result[5] - $result[4];
        if ( $time_session_length > 60 ) {
            my $time_session_length_seconds = $time_session_length % 60;
            $time_session_length =
              $time_session_length - $time_session_length_seconds;
            $time_session_length =
              $time_session_length / 60 . "  $time_session_length_seconds";
        }
        $style = '';
        if ( $result[2] == 0 ) { $style = 'style="background-color: #FFF1D0;"' }
        if ( $result[2] == 1 ) { $style = 'style="background-color: #fffae5;"' }
        if ( $result[2] == 2 ) { $style = 'style="background-color: #efe;"' }
        if ( $result[2] == 6 ) { $style = 'style="background-color: #f7f9ff;"' }
        ( $sec, $min, $hour, $mday, $mon, $year, undef, undef, undef ) =
          localtime( $result[4] );
        $time_logged =
            "$mday $months3[$mon] "
          . ( $year + 1900 )
          . ( sprintf( " %02d:%02d:%02d", $hour, $min, $sec ) );
        ( $sec, $min, $hour, $mday, $mon, $year, undef, undef, undef ) =
          localtime( $result[5] );
        $time_last_activity =
            "$mday $months3[$mon] "
          . ( $year + 1900 )
          . ( sprintf( " %02d:%02d:%02d", $hour, $min, $sec ) );
        my $fio =
          ( $guid == $result[1] )
          ? "<b style='color:#D9360D'>$result[0]</b>"
          : $result[0];

        if ( $result[2] == 4 ) {
            $result[9] .= ',&nbsp;' . get_pupil_class( 1, $result[1] );
            $fio =
              qq[<a class=small href="?act=pupil_info&uid=$result[1]">$fio</a>];
        }
        $table .= qq[<tr $style>
<td>$fio</td>
<td>$result[9]<br>$result[1]<br>$result[3]</td>
<td nowrap align=right>: $time_logged<br>: $time_last_activity<br>: $time_session_length </td>
<td>$result[6]<br>$result[7]</td>
<td>$result[8]</td>
<td align=center>
<button class=i type=button onclick="if (confirm('      \\n$result[0]?')) document.location.href='?act=session_kill&amp;uid=$result[1]';"><img src="/sp/img/button_del.gif"></button>
</td>
</tr>];
    }
    $gdb->{"AutoCommit"} = 1;

    my %replace = (
        menu    => generate_menu(),
        count   => $count[0],
        table   => $table,
        footers => generate_footers(),
    );
    tpl( "./tpl/users_logged.html", \%replace );
}

sub users_registered() {
    my ( @acl, %acl_web, %acl_adm );
    sqla \@acl, "select uid,gid from sp_users_acl where gid in (1,6)";
    for (@acl) {
        $acl_adm{ $$_[0] }++ if $$_[1] == 1;
        $acl_web{ $$_[0] }++ if $$_[1] == 6;
    }

    my $t = '';

    my $hide_root_sql = $DEBUG ? '' : q[and sp_users.log <> 'root'];

    my @groups;
    sqla \@groups, "select sp_gid_ref.gid, sp_gid_ref.name from sp_gid_ref
where exists ( select 1 from sp_users where sp_users.gid = sp_gid_ref.gid $hide_root_sql )
order by sp_gid_ref.name";

    my %pupil_class;
    sqlh \%pupil_class,
"select vw_pupil, paralel || ' ' || (select name from class where class_id = sys_matrix.class)
from sys_matrix, sp_users
where
sys_matrix.vw_pupil = sp_users.uid
and sys_matrix.view_class = 1
and sp_users.gid = 4
and exists
(
  select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0)
  where saldo_sum <> 0
)";
    for ( values %pupil_class ) {
        s/^(\d+\s*".+").+/$1/o;
    }

    my $color;
    my $fio;

    my $links = '';
    if ( scalar(@groups) > 1 ) {
        $links .= qq[<div id="SP_gid_flt">];
        $links .=
qq[<p class="active" id="SP_gid999" onclick="filter_group(this,999)"></p>];
        for my $g (@groups) {
            $links .=
qq[<p id="SP_gid$$g[0]" onclick="filter_group(this,$$g[0])">$$g[1]</p>];
        }
        $links .= qq[</div>];
    }

    for my $g (@groups) {
        $color = 'fff1d0' if $$g[0] == 0;
        $color = 'fffae5' if $$g[0] == 1;
        $color = 'efe'    if $$g[0] == 2;
        $color = 'fff'    if $$g[0] == 4;

        my $class_sort_checked_html = '';
        if ( $$g[0] == 4 ) {
            my $class_sort_checked =
              ( param('sort') and param('sort') eq 'class' )
              ? 'checked="checked"'
              : '';
            $class_sort_checked_html =
qq[<input type=checkbox name="checkbox_sort_class" id="checkbox_sort_class" onclick="turn_sort_class()" $class_sort_checked>
<label for="checkbox_sort_class">  </label>];
        }

        $t .=
qq[<div id="SP_gid_table$$g[0]"><h2 style="text-align:left">$$g[1]</h2>$class_sort_checked_html];

        my $add_columns = '';
        my $add_columns_web =
'<th><span class="hint" title="   ">Web-</span></th>';

        if ( $$g[0] == 4 ) {
            $add_columns .= '<th></th>';
            $add_columns .= $add_columns_web;
        }
        elsif ( $$g[0] == 2 ) {
            $add_columns .= $add_columns_web;
            $add_columns .= '<th></th>';
            $add_columns .= '<th></th>';
        }
        else {
            $add_columns .= $add_columns_web;
        }

        $t .=
qq[<table cellpadding=2 cellspacing=0 class="d pad" style="margin-bottom:8px">
<tr>
  <th><span class="hint" title="  ">UID</span></th>
  <th></th>
  <th> / <span class="hint" title="  ,    "> </span></th>
  $add_columns
</tr>];

        my @a;
        sqla \@a, qq[select sp_users.uid, sp_users.log,
human.last_name || ' ' || human.first_name || ' ' || human.middle_name
from sp_users join human on uid = human_id
where sp_users.gid = $$g[0] $hide_root_sql
order by last_name, first_name, middle_name];

        if ( param('sort') and param('sort') eq 'class' and $$g[0] == 4 ) {
            @a = sort {
                int( $pupil_class{ $$a[0] } ) <=> int( $pupil_class{ $$b[0] } )
                  || substr( $pupil_class{ $$a[0] }, 2 ) cmp
                  substr( $pupil_class{ $$b[0] }, 2 )
            } @a;
        }

        for (@a) {
            my $checked_6 = $acl_web{ $$_[0] } ? "checked" : "";
            my $checked_1 = $acl_adm{ $$_[0] } ? "checked" : "";

            my $login =
qq[<a class=small href="javascript:void(0)" onclick="set_password_setup($$_[0], '$$_[2]');">$$_[1]</a>];

            $t .= '<tr>';
            $fio =
              ( $$g[0] == 4 )
              ? qq[<a class="small unbold" href="?act=pupil_info&uid=$$_[0]">$$_[2]</a>]
              : $$_[2];
            $t .= qq[<td style="background-color:$color">$$_[0]</td>];
            $t .= qq[<td>$fio</td>];
            $t .= qq[<td>$login</td>];

            if ( $$g[0] == 4 ) {
                unless ( $pupil_class{ $$_[0] } ) {
                    my $hint = sqlff "select name from deduction_type_ref
where deduction_type_id = (select max(deduction_type)
from doc_deduction_order_sp where human_id = $$_[0])";
                    escape_tag \$hint;
                    $pupil_class{ $$_[0] } =
                      qq[<span class="hint" title="$hint"></span>];
                }
                $t .= qq[<td>$pupil_class{$$_[0]}</td>];
            }

            my $style_6 =
              $acl_web{ $$_[0] } ? q[style="background-color:#edf1ff"] : '';

            $t .=
qq[<td $style_6 align=center id="acl_6_$$_[0]"><input type=checkbox $checked_6 onclick="getContent(0, '?act=aj_acl_switch&uid=$$_[0]&gid=6','paint_acl');"></td>];
            if ( $$g[0] == 2 ) {
                my $style_1 =
                  $acl_adm{ $$_[0] } ? q[style="background-color:#fffae5"] : '';
                $t .=
qq[<td $style_1 align=center id="acl_1_$$_[0]"><input type=checkbox $checked_1 onclick="getContent(0, '?act=aj_acl_switch&uid=$$_[0]&gid=1','paint_acl');"></td>];
                $t .=
qq[<td align=center><a class=small href="?act=user_delete&uid=$_->[0]" onclick="return confirm('       \\'$$_[2]\\'?')"></a></td>];
            }

            $t .= '</tr>';

        }

        $t .= q[</table></div>];
    }

    my %user_count;
    sqlh \%user_count, "select gid, count(1) from sp_users
where gid in (1,2,4)
group by gid";
    my $summary;
    for ( sort keys %user_count ) {
        $summary .=
          (     $user_count{$_} . ' '
              . declension( $user_count{$_}, $gid_decl{$_} )
              . ',<br>' );
    }

    my $all = sqlff("select count(1) from sp_users where gid in (1,2,4)");

    tpl(
        "./tpl/users_registered.html",
        {
            menu    => generate_menu(),
            footers => generate_footers(),
            users   => $t,
            summary => ( $summary . ' : ' . $all ),
            links   => $links,
        }
    );
}

sub users_all_pupils() {
    my ( $table, $class_sql );

    my $class = param('class');

    $class_sql = '';
    if ( defined $class ) {
        sec_gt0($class);
        $class_sql = "and sys_matrix.class = $class";
    }

    my $q = sqlp(
        "select
  vw_pupil,
  (select ser from human_doc_list where human_id = cast(sys_matrix.vw_pupil as integer) and doc_type = 1),
  (select num from human_doc_list where human_id = cast(sys_matrix.vw_pupil as integer) and doc_type = 1),
  (select trim(last_name)||' '||first_name||' '||middle_name from human where human_id = cast(sys_matrix.vw_pupil as integer)),
  paralel || (select name from class where class_id = sys_matrix.class),
  (select ser from human_doc_list where human_id = cast(sys_matrix.vw_pupil as integer) and doc_type = 2),
  (select num from human_doc_list where human_id = cast(sys_matrix.vw_pupil as integer) and doc_type = 2)
from sys_matrix inner join human on cast(vw_pupil as integer) = human_id
where
sys_matrix.view_class = 1
$class_sql
and exists
(
  select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0)
  where saldo_sum <> 0
)
order by trim(human.last_name)"
    );

    my @result;
    my $first_iteration = 1;
    my $first_letter    = '';
    my $subhead;
    my $counter = 0;
    my $id      = 1;
    my $letters;
    while ( @result = $q->fetchrow_array() ) {
        $counter++;
        if ( !defined $class ) {
            if (   $first_letter ne substr( $result[3], 0, 1 )
                or $first_iteration )
            {
                $first_letter = substr( $result[3], 0, 1 );
                $subhead      = trim($first_letter);
                $subhead      = ' ' if ( $subhead eq '' );
                $table .= "<tr class='def'>
<td class='def table_separator'>&nbsp;<a id=letter$id></a></td>
<td class='def table_separator' colspan=6>$subhead</td></tr>";
                if ($first_iteration) {
                    $letters         = ' : ';
                    $first_iteration = 0;
                    $first_letter    = substr( $result[3], 0, 1 );
                }
                $letters .= qq[<a href="#letter$id">$first_letter</a>&nbsp;];
                $id++;
            }
        }
        if ( !defined $class ) {
            $result[4] =~ s/^(\d+\".+\").+/$1/o;
            $result[4] =~ s/^(\d+)\"(.+)/$1 \"$2/o;
            $result[4] =~ s/^(\d{1})(\s.+)/ $1$2/o;
            $result[4] =~ s/\"/&quot;/go;
            $result[4] = ' (' . $result[4] . ' )';
        }
        else {
            $result[4] = '';
        }
        $result[1] ||= '&nbsp;';
        $result[2] ||= '&nbsp;';
        $result[5] ||= '&nbsp;';
        $result[6] ||= '&nbsp;';
        $table .= qq[<tr OnMouseOver='m_over(this);' OnMouseOut='m_out(this);'>
<td width=25 class='pr4' align=right>$counter</td>
<td><a class="small unbold" href="?act=pupil_info&uid=$result[0]">$result[3]$result[4]</a></td>
<td>$result[0]</td>
<td>$result[1]</td>
<td>$result[2]</td>
<td>$result[5]</td>
<td>$result[6]</td>
</tr>];
    }
    $q->finish();

    my %replace = (
        menu    => generate_menu(),
        date    => $gdate,
        count   => $counter,
        classes => filter_class( param('class') || 0 ),
        letters => $letters,
        table   => $table,
        footers => generate_footers(),
    );
    tpl( "./tpl/users_all_pupils.html", \%replace );

}

sub users_clear_logged() {
    my ( @kill, @result, $q );
    $q = sqlp("SELECT uid, sid, ip FROM sp_users_logged");
    while ( @result = $q->fetchrow_array() ) {
        log_user_sesion( 5, $result[0], [ $result[1], $result[2] ] );
    }
    sql('DELETE FROM sp_users_logged');
    exit print redirect('/sp/') if ($DEBUG);
    exit print redirect('/');
}

sub session_kill() {
    my $uid = param('uid');
    sec_gt0 $uid;
    my @logged_info =
      sqlf("SELECT sid, ip FROM sp_users_logged WHERE uid = $uid");
    log_user_sesion( 5, $uid, \@logged_info ) if @logged_info;
    sql("delete FROM sp_users_logged where uid = $uid");
    redir('logged');
}

sub user_delete() {
    my $uid = param('uid');
    sec_gt0 $uid;
    unless ( sqlff "select gid from sp_users where uid = $uid" ) {
        stop "    $uid  .";
    }
    my $gid = sqlff "select gid from sp_users where uid = $uid";
    if ( $gid == 2 || $gid == 4 ) {
        sql("delete FROM sp_users where uid = $uid");
        sql("delete FROM sp_users_acl where uid = $uid");
        redir('registered');
    }
    else {
        stop "     .";
    }
}

sub gen_list_form() {
    tpl './tpl/users_gen_list_form.html',
      {
        menu    => generate_menu(),
        classes => filter_class( param('class') || 0 ),
        footers => generate_footers(),
      };
}

sub gen_list() {
    my (
        $q,         $h,         $t,     @fields, $fields_str,
        $page_head, $order_str, $index, @a,      @head,
    );

    $page_head = "    $gdate";

    my $class_sql;
    my $class = param('class');
    if ( $class ne '' ) {
        sec_gt0($class);
        $class_sql = "and sys_matrix.class = $class";
        $page_head = ' ' . sqlff(
            "select paralel || class.name
from sys_matrix,class
where sys_matrix.view_class = 7
and sys_matrix.class = class.class_id
and class=$class
and exists
(
  select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0)
  where saldo_sum <> 0
)"
        ) . "  $gdate";
    }

    my $lang_sql =
        '(select name from language_ref,human_language '
      . 'where human_language.human_lang_type = 3 '
      . 'and human_language.language_id = language_ref.language_id '
      . 'and human_language.human_id = human.human_id)';
    my $addr_sql =
qq[(select ( select address_str from get_address_str(address_id) ) from human_address where sys_matrix.vw_pupil = human_id and address_type_id = (select max(address_type_id) from human_address where sys_matrix.vw_pupil = human_id) )];
    my $age_sql = q[cast (('now' - birth_day) / 365 as integer)];

    my %fields = (
        'uid'   => 'human_id~UID',
        'f'     => 'last_name~',
        'i'     => 'first_name~',
        'o'     => 'middle_name~',
        'sex'   => 'sex~',
        'addr'  => "$addr_sql~",
        'date'  => 'birth_day~ ',
        'age'   => "$age_sql~",
        'place' => 'birth_place~ ',
        'c'     => 'paralel||class.name~',
        'lang'  => "$lang_sql~",
    );

    my @order = qw/uid f i o sex addr date age place c lang/;

    for (@order) {
        if ( param($_) ) {
            my ( $name_field, $name_head ) = split /~/, $fields{$_};
            push @fields, $name_field;
            push @head,   $name_head;
        }
    }

    $fields_str = join ',', @fields;

    if ( $fields_str eq '' ) {
        stop
'        &laquo;    ?&raquo;   .';
    }

    $order_str = 'last_name';
    my $attr = { ib_timestampformat => '%d %B %Y' };
    $q = sqlp(
        "select $fields_str
from sys_matrix
join human on sys_matrix.vw_pupil = human_id
join class on sys_matrix.class = class_id
      where sys_matrix.view_class = 1
      $class_sql
      and exists
      (
        select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0)
        where saldo_sum <> 0
      )
      order by $order_str",
        $attr
    );
    my $counter = 0;
    my $align;
    while ( @a = $q->fetchrow_array ) {
        $t .= '<tr>';
        $index = 0;
        $counter++;

        if ( param('num') ) {
            $t .= "<td align=right>$counter</td>";
        }

        for (@a) {

            $align = '';

            if ( $fields[$index] eq $age_sql ) { $align = ' align=center'; }
            if ( $fields[$index] eq 'sex' )    { $align = ' align=center'; }

            if ( $fields[$index] eq 'sex' ) {
                if    ( $_ == 1 ) { $_ = ''; }
                elsif ( $_ == 0 ) { $_ = ''; }
            }

            if ( $fields[$index] eq $lang_sql ) {
                $_ = ucfirst lc $_;
            }

            if (
                (
                       $fields[$index] eq 'first_name'
                    or $fields[$index] eq 'middle_name'
                )
                and param('initials')
              )
            {
                $_ = substr( trim($_), 0, 1 ) . '.';
            }

            $_ = trim($_);
            $_ ||= '&nbsp;';

            $t .= qq[<td$align>$_</td>];

            $index++;

        }
        $t .= '</tr>';
    }

    for (@head) {
        if ( param('initials') ) {
            $_ = '.' if $_ eq '';
            $_ = '.' if $_ eq '';
        }
        $h .= "<th nowrap>$_</th>";
    }

    tpl './tpl/users_gen_list.html',
      {
        menu      => generate_menu(),
        head      => ( param('num') ) ? '<th></th>' . $h : $h,
        page_head => $page_head,
        table     => $t,
        footers   => generate_footers(),
      };
}

sub get_score_color($) {
    if ( $_[0] == 4 ) { return '#2364B5' }
    if ( $_[0] == 5 ) { return '#008729' }
    if ( $_[0] == 3 ) { return '#8A4A3D' }
    if ( $_[0] == 2 ) { return '#FF6B00' }
    if ( $_[0] == 1 ) { return '#CC0000' }
    return '#000000';
}

sub filter_class_teacher_binded($) {
    my $c = shift;
    if ($c) { sec_gt0 $c }
    my %classes;
    my ( $filter_class, $selected, $id, $name );
    my $q;

    $q = sqlp(
        "select class_id, cast(paralel as integer),
( select name from class where class_id = cast(sys_matrix.class as integer) )
from sys_matrix, class
where view_class = 7
and class.class_id = sys_matrix.class
and exists ( select 1 from get_node_saldo(
  sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0 )"
    );
    my ( @t, @a );
    while ( @a = $q->fetchrow_array() ) {
        $a[2] =~ s/^(\".+\").+/$1/o;
        $a[2] =~ s/\"/&quot;/go;
        push @t, [@a];
    }

    my %class_binding;
    $q = sqlp qq[select distinct sys_matrix.class
from sys_matrix where view_class = 9001
and vw_teacher = $guid and exists ( select 1 from get_node_saldo_by_unit ( sys_matrix.node_id, '$gdate', '', 0 )
where saldo_sum <> 0)];
    while ( @a = $q->fetchrow_array ) { $class_binding{ $a[0] }++; }

    my @b;
    for ( my $i = 0 ; $i < @t ; $i++ ) {
        push @b, $t[$i] if ( $class_binding{ $t[$i][0] } );
    }
    @t = @b;

    return filter_class($c) unless ( scalar @t );

    @t = sort { $a->[1] <=> $b->[1] || $a->[2] <=> $a->[2] } @t;

    for (@t) {
        $selected = ( $c == $_->[0] ) ? 'selected' : '';
        $filter_class .=
          ($DEBUG)
          ? "<option $selected value=\"$_->[0]\">ID=$_->[0]&nbsp;&nbsp;$_->[1] $_->[2]</option>"
          : "<option $selected value=\"$_->[0]\">$_->[1] $_->[2]</option>";
    }
    return $filter_class;
}

sub filter_parallel {

    my $selected_id = shift || 0;
    my $selected;

    my %parallels;
    sqlh(
        \%parallels, "select paralel_id, name from paralel
where exists
(
  select 1 from sys_matrix
  where view_class = 7
  and sys_matrix.paralel = paralel_id
  and exists (
    select 1 from get_node_saldo
    (sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0
  )
)"
    );

    my $html = '';
    for ( sort { $a <=> $b } keys %parallels ) {
        $parallels{$_} =~ s/0?(\d+)-(.+)/$1 &mdash; $2/;
        $selected = ( $selected_id == $_ ) ? ' selected' : '';
        $html .= qq[<option$selected value="$_">$parallels{$_}</option>];
    }

    return $html;
}

sub filter_teacher($) {
    my $uid = shift;
    sec_gt0($uid) if $uid;

    my ( $teachers, $aref, $q );

    my %namesake;

    my %teacher_login;
    sqlh \%teacher_login, "select uid, log from sp_users where gid = 2";

    $q = sqlp
      q[select human_id, last_name || ' ' || first_name || ' ' || middle_name
from human left join sp_users on uid = human_id where human.class = 0
order by last_name, first_name, middle_name];

    $teachers = '';
    while ( $aref = $q->fetchrow_arrayref ) {
        if ( exists $namesake{ $$aref[1] } ) {
            $$aref[1] .=
              $teacher_login{ $$aref[0] }
              ? " (: $teacher_login{$$aref[0]})"
              : " (UID: $$aref[0])";
        }
        else {
            $namesake{ $$aref[1] }++;
        }
        $teachers .= '<option ';
        $teachers .= 'selected ' if ( defined($uid) and $uid == $aref->[0] );
        $teachers .= qq[value="$aref->[0]">];
        $teachers .= qq[uid=$aref->[0]&nbsp;&nbsp;] if ($DEBUG);
        $teachers .= qq[$aref->[1]</option>];
    }

    return $teachers;
}

sub filter_subj($) {
    my $s = shift || 0;
    if ($s) { sec_gt0 $s }
    my %subjects;
    my ( $filter_subj, $selected, $id, $name );

    my $q;
    if ( $ggid == 4 ) {
        $q = sqlp 'select lesson_id, name from lesson
where exists ( select 1 from sp_scores
               where sp_scores.subj = lesson.lesson_id )'
    }
    else {
        $q = sqlp 'select lesson_id, name from lesson';
    }

    while ( ( $id, $name ) = $q->fetchrow_array() ) {
        $subjects{"$name"} = $id;
    }

    for ( sort keys %subjects ) {
        $selected = ( $s == $subjects{$_} ) ? 'selected' : '';
        if ($DEBUG) {
            $filter_subj .=
"<option $selected value=\"$subjects{$_}\">ID=$subjects{$_}&nbsp;&nbsp;$_</option>";
        }
        else {
            $filter_subj .=
              "<option $selected value=\"$subjects{$_}\">$_</option>";
        }
    }
    return $filter_subj;
}

sub filter_subj_teacher_binded($) {
    my $s = shift;
    if ($s) { sec_gt0 $s }
    my %subjects;
    my ( $filter_subj, $selected, $id, $name );
    my $q;

    my $kr = sqlff qq[select 1 from sys_matrix
where sys_matrix.view_class = 9003
and sys_matrix.vw_teacher = $guid
and exists ( select 1 from get_node_saldo_by_unit ( sys_matrix.node_id, '$gdate', '', 0 )
where saldo_sum <> 0)];

    if ($kr) { return filter_subj($s); }

    $q = sqlp qq[select sys_matrix.lesson,
(select lesson.name from lesson where lesson.lesson_id = sys_matrix.lesson)
from sys_matrix where view_class = 9001
and vw_teacher = $guid and exists ( select 1 from get_node_saldo_by_unit ( sys_matrix.node_id, '$gdate', '', 0 )
where saldo_sum <> 0)];

    while ( ( $id, $name ) = $q->fetchrow_array() ) {
        $subjects{$name} = $id unless $subjects{$name};
    }

    return filter_subj($s) unless ( scalar %subjects );

    for ( sort keys %subjects ) {
        $selected = ( $s == $subjects{$_} ) ? 'selected' : '';
        if ($DEBUG) {
            $filter_subj .=
"<option $selected value=\"$subjects{$_}\">ID=$subjects{$_}&nbsp;&nbsp;$_</option>";
        }
        else {
            $filter_subj .=
              "<option $selected value=\"$subjects{$_}\">$_</option>";
        }
    }
    return $filter_subj;
}

sub filter_subgrp {
    my $c            = shift;
    my $s            = shift;
    my $g            = shift;
    my $onchange     = shift;
    my $combo_subgrp = '';
    my $group_count  = sqlff
      qq[select count(1) from sp_class_subgrp_ref where c = $c and s = $s];
    if ($group_count) {
        $combo_subgrp =
qq[: <select class=def name=g onchange='$onchange'><option value=""></option>];
        my $q = sqlp
          qq[select id, name from sp_class_subgrp_ref where c = $c and s = $s];
        my @a;
        my $selected;
        while ( @a = $q->fetchrow_array ) {
            $selected = ( $g == $a[0] ) ? 'selected' : '';
            $combo_subgrp .= qq{<option $selected value="$a[0]">$a[1]</option>};
        }
        $combo_subgrp .= '</select>';
    }
    return $combo_subgrp;
}

sub fill_class_ref($) {
    my $ref = shift;
    sqlh $ref, qq[select
class_id, paralel ||' '||(select name from class where class_id = cast(sys_matrix.class as integer))
from sys_matrix, class
where class = class_id and
      sys_matrix.view_class = 7 and
      exists ( select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0)];
    for ( values %{$ref} ) {
        s/^(\d+\s*".+").+/$1/o;
        s/"/&quot;/go;
    }
}

sub year_set() {
    my $year;
    if ($state_date) {
        $gdate =~ /^\d+\.\d+\.(\d+)/;
        $year = $1;
    }
    else {
        my $time =
          sqlff("select time_start from sp_periods where link = 0 and id = 0");
        ( undef, undef, undef, undef, undef, $year, undef, undef, undef ) =
          localtime $time;
        $year += 1900;
    }
    return $year;
}

sub sql_execute_form() {
    printfile('./tpl/sql_execute_form.html');
}

sub sql_execute() {
    my $sql = param('q');
    unless ( defined $sql ) { error "empty query" }

    my $gdsn_tmp =
"dbi:InterBase:db=$gconf{cmsdbname};host=$gconf{cmsdbhost};ib_charset=WIN1251";
    my $gdb_tmp =
      DBI->connect( $gdsn_tmp, $gconf{'cmsdbuser'}, $gconf{'cmsdbpasswd'} )
      || db_error_connect();

    unless ( param('db') eq 'xxi' or param('db') eq 'cms' ) {
        error "db not selected";
    }

    my @data;
    my $result = "</pre><table border=1 cellspacing=0 cellpadding=2><tr>";
    my $q;
    my @fields;

    if ( $sql =~ m/^\s*select/i ) {
        if ( param('db') eq 'xxi' ) {
            $q      = sqlp($sql);
            @fields = @{ $q->{NAME} };
            foreach (@fields) { $result .= "<th bgcolor=#eeeeee>$_</th>"; }
            while ( @data = $q->fetchrow_array() ) {
                $result .= "</tr><tr>";
                foreach (@data) {
                    s/\s/&nbsp;/g;
                    unless ( defined $_ ) {
                        $_ = '<span class=copy id="error">Nul</span>';
                    }
                    $result .= "<td bgcolor=\"#ffffff\">$_</td>";
                }
            }
            $q->finish;
            error qq[<a href="?act=sql_execute_form"></a><br>$sql]
              . '<br>--------------------------------------------------------<pre>'
              . $result
              . '</pre>';
        }
        else {
            $q = $gdb_tmp->prepare($sql)
              or error
"   SQL:<br><b><pre>$sql</pre></b>   : <b><pre>$DBI::errstr</pre></b>";
            $q->execute()
              or error
"   SQL:<br><b><pre>$sql</pre></b>   : <b><pre>$DBI::errstr</pre></b>";
            @fields = @{ $q->{NAME} };
            foreach (@fields) { $result .= "<th bgcolor=#eeeeee>$_</th>"; }
            while ( @data = $q->fetchrow_array() ) {
                $result .= "</tr><tr>";
                foreach (@data) {
                    s/\s/&nbsp;/g;
                    unless ( defined $_ ) {
                        $_ = '<span class=copy id="error">Nul</span>';
                    }
                    $result .= "<td bgcolor=\"#ffffff\">$_</td>";
                }
            }
            $q->finish;
            $gdb_tmp->disconnect();
            error qq[<a href="?act=sql_execute_form"></a><br>$sql]
              . '<br>--------------------------------------------------------<pre>'
              . $result
              . '</pre>';
        }
    }
    else {
        if ( param('db') eq 'xxi' ) {
            sql($sql);
            redir("SQL");
        }
        else {
            $q = $gdb_tmp->prepare($sql)
              or error
"   SQL:<br><b><pre>$sql</pre></b>   : <b><pre>$DBI::errstr</pre></b>";
            my $count = $q->execute()
              or error
"   SQL:<br><b><pre>$sql</pre></b>   : <b><pre>$DBI::errstr</pre></b>";
            $q->finish;
            $gdb_tmp->disconnect();
            error "$count";
            redir("SQL");
        }
    }
}

sub pupil_info() {
    my $uid = param('uid');
    sec_gt0 $uid;
    unless ( sqlff "select 1 from human where human_id = $uid" ) {
        stop "   $uid  $gdate  .";
    }

    my ( $fio, $sex, $bday, $bplace, $s_status, $addr, $age, $human_class ) =
      sqlf qq[select last_name||'&nbsp;'||first_name||'&nbsp;'||middle_name,
sex, birth_day, birth_place, (select name from social_status_ref where social_status_id = social_status),
(select address_str from get_address_str(human_address.address_id)),
cast( (cast('$gdate' as date) - birth_day) / 365 as integer),
human.class
from human
left join human_address on human_address.human_id = human.human_id
where human.human_id = $uid], { ib_timestampformat => '%d.%m.%Y' };
    unless ( $human_class == 1 ) {
        stop
"      .<br>  ,   .";
    }

    my $c = get_pupil_class( 1, $uid, 1 );

    my @a;
    sqlffa \@a, "select name from language_ref,human_language
where human_language.human_lang_type = 3
and human_language.language_id = language_ref.language_id
and human_language.human_id = $uid";
    my $lang = join ', ', @a;

    @a = ();
    sqla \@a, "select
(select name from human_doc_type_ref where doc_type_id = doc_type),
ser, num, giveout_date, giveout_org, note from human_doc_list where human_id = $uid",
      { ib_timestampformat => '%d.%m.%Y' };

    my $docs;
    for ( my $i = 0 ; $i < scalar(@a) ; $i++ ) {
        $docs .= ( $i + 1 ) . '. ' if scalar(@a) > 1;
        $docs .= "$a[$i][0]:<br>";
        $docs .= ": $a[$i][1], : $a[$i][2]<br>";
        $docs .= ": $a[$i][4]<br>";
        $docs .= " : $a[$i][3]<br>";
        $docs .= '<br>' if scalar(@a) > 1 and $i != scalar(@a) - 1;
    }

    my $login = sqlff "select log from sp_users where uid = $uid";

    my $NA = '<font color="#AAAAAA"> </font>';

    tpl './tpl/pupil_info.html',
      {
        menu    => generate_menu(),
        footers => generate_footers(),
        gdate   => $gdate,
        fio     => $fio,
        uid     => $uid,
        c       => $c,
        sex     => ( $sex ? '' : '' ),
        bday    => $bday,
        bplace => ( $bplace || $NA ),
        s_status => $s_status,
        addr     => ( $addr || $NA ),
        lang     => ( ucfirst $lang || $NA ),
        docs     => ( $docs || $NA ),
        age      => $age,
        sp_user  => ($login) ? ", : $login" : '  ',
      };

}

sub check_new_year() {
    if ($state_date) {
        msg '  ',
'     .<br>     .';
    }

    my $now = time;
    my $t   = '';
    my ( $q, @a );

    my @messages = ();

    if ( sqlff
"select 1 from sp_periods where link = 0 and id = 0 and time_start > time_end"
      )
    {
        push @messages,
          '         .';
    }
    if ( sqlff
"select 1 from sp_periods where link = 1 and id = 0 and time_start > time_end"
      )
    {
        push @messages,
          '         .';
    }
    if ( sqlff
"select 1 from sp_periods where link = 2 and id = 0 and time_start > time_end"
      )
    {
        push @messages,
          '         .';
    }

    if ( sqlff
"select 1 from sp_periods where link = 0 and id = 0 and time_start = time_end"
      )
    {
        push @messages, '        .';
    }
    if ( sqlff
"select 1 from sp_periods where link = 1 and id = 0 and time_start = time_end"
      )
    {
        push @messages, '        .';
    }
    if ( sqlff
"select 1 from sp_periods where link = 2 and id = 0 and time_start = time_end"
      )
    {
        push @messages, '        .';
    }

    if ( sqlff
"select 1 from sp_periods where link = 0 and id = 0 and not $now between time_start and time_end"
      )
    {
        push @messages, '      .';
    }
    if ( sqlff
"select 1 from sp_periods where link = 1 and id = 0 and not $now between time_start and time_end"
      )
    {
        push @messages, '      .';
    }
    if ( sqlff
"select 1 from sp_periods where link = 2 and id = 0 and not $now between time_start and time_end"
      )
    {
        push @messages, '      .';
    }

    if (@messages) {
        $t .=
'<table border=0 cellspacing=0 cellpadding=7><tr><td class=sign><img src="/sp/img/danger.gif"></td><td><table class=d border=0 cellspacing=0 cellpadding=3>';
        $t .= "<tr><th>   </th></tr>";
        for (@messages) {
            $t .= "<tr><td>$_</td></tr>";
        }
        $t .= '</table>
    <a href="?act=setup_periods"> ...</a>
    </td></tr></table>';
    }

    @messages = ();

    my $periods_mode =
      sqlff q[select F_INT from SP_SETTINGS where NAME = 'periods_mode'];

    my %y;
    $q = sqlp "select link, time_start, time_end
             from sp_periods where id = 0";
    while ( @a = $q->fetchrow_array() ) {
        $y{ $a[0] } = [ $a[1], $a[2] ];
    }

    my $sql =
      ($periods_mode)
      ? "select link,id,time_start,time_end from sp_periods where id between 1 and 4"
      : "select link,id,time_start,time_end from sp_periods where id between 5 and 7";

    $q = sqlp $sql;
    my %times;
    while ( @a = $q->fetchrow_array() ) {
        $times{"$a[0],$a[1]"} = [ $a[2], $a[3] ];
    }

    my %hash_periods = (
        1, '1 ', 2, '2 ', 3, '3 ', 4, '4 ',
        5, '1 ', 6, '2 ', 7, '3 ',
    );

    my %hash_links = ( 0, '', 1, '', 2, '' );

    for ( sort keys %times ) {
        my @tmp = split /,/;
        unless (@{ $times{$_} }[0] >= @{ $y{ $tmp[0] } }[0]
            and @{ $times{$_} }[1] <= @{ $y{ $tmp[0] } }[1] )
        {
            push @messages,
"<td>$hash_periods{$tmp[1]}</td><td>$hash_links{$tmp[0]} </td>";
        }
    }

    if ( sqlff "select f_int from sp_settings where name = 'enable_half_year'" )
    {
        my @tmp = split ',', sqlff
          "select f_char from sp_settings where name = 'half_year_periods'";

        unless ($tmp[0] >= @{ $y{"2"} }[0]
            and $tmp[1] <= @{ $y{"2"} }[1] )
        {
            push @messages,
"<td> </td><td>,   </td>";
        }
        unless ($tmp[2] >= @{ $y{"2"} }[0]
            and $tmp[3] <= @{ $y{"2"} }[1] )
        {
            push @messages,
"<td> </td><td>,   </td>";
        }
    }

    if (@messages) {
        $t .=
'<table border=0 cellspacing=0 cellpadding=7><tr><td class=sign><img src="/sp/img/danger.gif"></td><td><table class=d border=0 cellspacing=0 cellpadding=3>';
        $t .=
"<tr><th colspan=2>     </th></tr>";
        $t .= "<tr class=light_grey><td></td><td> </td></tr>";
        for (@messages) {
            $t .= "<tr>$_</tr>";
        }
        $t .= '</table>
    <a href="?act=setup_periods"> ...</a>
    </td></tr></table>';
    }

    @messages = ();

    unless ( sqlff "select count(1) from human where class=1" ) {
        push @messages, '   .';
    }

    unless ( sqlff "select count(1) from class" ) {
        push @messages, '   .';
    }

    if (@messages) {
        $t .= '<table border=0 cellspacing=0 cellpadding=7>
    <tr>
    	<td class=sign><img src="/sp/img/danger.gif"></td>
    	<td>
    		<table class=d border=0 cellspacing=0 cellpadding=3>
    			<tr>
				    <th>   ?</th>
				</tr>';
        for (@messages) {
            $t .= "<tr><td>$_</td></tr>";
        }
        $t .= '</table>
    	</td>
    </tr>
    </table>';
    }

    sql
'delete from sp_users where not exists (select 1 from human where human_id = uid)';

    @messages = ();
    $q        = sqlp
q[select human_id, count(uid), (select name from human_class_ref where class_id = class), last_name||' '||first_name||' '||middle_name
from human left join sp_users on uid = human_id
group by human_id, class, last_name, first_name, middle_name
order by 2, 3, 4];
    while ( @a = $q->fetchrow_array() ) {
        if ( $a[1] > 1 ) {
            push @messages, [ $a[0], $a[1], $a[2], $a[3] ];
        }
    }
    if (@messages) {
        my $tmp = scalar @messages;
        $t .=
'<table border=0 cellspacing=0 cellpadding=7><tr><td class=sign><img src="/sp/img/danger.gif"></td><td><table class=d border=0 cellspacing=0 cellpadding=3>';
        $t .= "<tr><th colspan=4>  ($tmp)</th></tr>";
        $t .=
"<tr class=light_grey><td>UID</td><td></td><td></td><td></td></tr>";
        for (@messages) {
            $t .=
"<tr><td>$_->[0]</td><td>$_->[1]</td><td>$_->[2]</td><td>$_->[3]</td></tr>";
        }
        $t .= '</table></td></tr></table>';
    }

    @messages = ();
    my %class_hash;
    fill_class_ref( \%class_hash );
    my %subj_hash;
    sqlh \%subj_hash, "select lesson_id, name from lesson";

    my @unbroken_classes;
    sqlffa \@unbroken_classes, "select class from sys_matrix
where sys_matrix.view_class = 7
and exists ( select 1 from get_node_saldo
(sys_matrix.node_id, 'now', 0) where saldo_sum <> 0)
and not exists ( select 1 from sp_class_subgrp_ref where c = class )";
    for (@unbroken_classes) {
        push @messages, "$class_hash{$_}";
    }

    if (@messages) {
        my $tmp = scalar @messages;
        $t .=
'<table border=0 cellspacing=0 cellpadding=7><tr><td class=sign><img src="/sp/img/stop.gif"></td><td><table class=d border=0 cellspacing=0 cellpadding=3>';
        $t .=
          "<tr><th colspan=2>,     ($tmp)</th></tr>";
        for ( my $i = 0 ; $i < scalar @messages ; $i++ ) {
            $t .= "<tr>"  if $i % 2 == 0;
            $t .= "<td>$messages[$i]</td>";
            $t .= "</tr>" if $i % 2;
        }
        $t .= '</table>
    <a href="?act=subgrp_list"> ...</a>
    </td></tr></table>';
    }

    @messages = ();
    my @tmp;
    sqla \@tmp, "select distinct c, s from sp_class_subgrp_ref";
    my %hash_class_num_pupil;

    for (@tmp) {
        my $subgrp_pupils_sum = sqlff "select count(1) from sp_class_subgrp
           where sp_class_subgrp.id in (
           select id from sp_class_subgrp_ref
           where c = $_->[0] and s = $_->[1])";
        unless ( $hash_class_num_pupil{ $_->[0] } ) {
            $hash_class_num_pupil{ $_->[0] } = sqlff "select count(1)
        from sys_matrix
        where view_class = 1
          and class = $_->[0]
          and exists(select 1 from get_node_saldo
          (sys_matrix.node_id, 'now', 0) where saldo_sum <> 0)";
        }
        if ( $subgrp_pupils_sum != $hash_class_num_pupil{ $_->[0] } ) {
            my $temp = $hash_class_num_pupil{ $_->[0] } - $subgrp_pupils_sum;
            next unless $class_hash{ $_->[0] };
            if ( $temp < 0 ) {
                $temp = ': ' . -$temp;
            }
            push @messages, "<td>$class_hash{$_->[0]}</td>
<td>$subj_hash{$_->[1]}</td>
<td align=right>$hash_class_num_pupil{$_->[0]}</td>
<td align=right>$subgrp_pupils_sum</td>
<td align=right>$temp</td>
<td><a class=small href='?act=subgroups&c=$_->[0]&s=$_->[1]'></a></td>";
        }
    }

    if (@messages) {
        my $tmp = scalar @messages;
        $t .=
'<table border=0 cellspacing=0 cellpadding=7><tr><td class=sign><img src="/sp/img/stop.gif"></td><td><table class=d border=0 cellspacing=0 cellpadding=3>';
        $t .=
"<tr><th colspan=6> ,      ($tmp)</th></tr>";
        $t .=
"<tr class=light_grey><td></td><td></td><td></td><td> </td><td></td><td></td></tr>";
        for (@messages) {
            $t .= "<tr>$_</tr>";
        }
        $t .= '</table></td></tr></table>';
    }

    @messages = ();

    my @cache_clases_with_form_master;
    sqlffa \@cache_clases_with_form_master, "select distinct sys_matrix.class
  from sys_matrix where view_class = 9003
  and exists ( select 1 from get_node_saldo_by_unit
  ( sys_matrix.node_id, 'now', '', 0 ) where saldo_sum <> 0)";

    my @classes_without_leader;

    if ( scalar @cache_clases_with_form_master ) {
        sqlffa \@classes_without_leader, "select class_id from sys_matrix, class
where class = class_id and
      sys_matrix.view_class = 7 and
      exists ( select 1 from get_node_saldo(sys_matrix.node_id, 'now', 0) where saldo_sum <> 0)
and class_id not in
(" . join( ',', @cache_clases_with_form_master ) . ")";
        for (@classes_without_leader) {
            push @messages, $class_hash{$_};
        }
    }
    else {
        push @messages, "    .";
    }

    if (@messages) {
        my $tmp = scalar @messages;
        $t .=
'<table border=0 cellspacing=0 cellpadding=7><tr><td class=sign><img src="/sp/img/stop.gif"></td><td><table class=d border=0 cellspacing=0 cellpadding=3>';
        $t .=
"<tr><th colspan=2>      ($tmp)</th></tr>";
        for ( my $i = 0 ; $i < scalar @messages ; $i++ ) {
            $t .= "<tr>"  if $i % 2 == 0;
            $t .= "<td>$messages[$i]</td>";
            $t .= "</tr>" if $i % 2;
        }
        $t .= '</table>
    <a href="?act=teacher_form_master">  ...</a>
    </td></tr></table>';
    }

    @messages = ();
    my @cache_clases_with_bindings;

    sqlffa \@cache_clases_with_bindings, "select distinct sys_matrix.class
  from sys_matrix where view_class = 9001
  and exists ( select 1 from get_node_saldo_by_unit
  ( sys_matrix.node_id, 'now', '', 0 ) where saldo_sum <> 0)";

    if ( scalar @cache_clases_with_bindings ) {
        my @classes_without_bindings;
        sqlffa \@classes_without_bindings,
          "select class_id from sys_matrix, class
where class = class_id and
	sys_matrix.view_class = 7 and
	exists ( select 1 from get_node_saldo(sys_matrix.node_id, 'now', 0) where saldo_sum <> 0)
and class_id not in
(" . join( ',', @cache_clases_with_bindings ) . ")";
        for (@classes_without_bindings) {
            push @messages, $class_hash{$_};
        }
    }

    if (@messages) {
        my $tmp = scalar @messages;
        $t .=
'<table border=0 cellspacing=0 cellpadding=7><tr><td class=sign><img src="/sp/img/stop.gif"></td><td><table class=d border=0 cellspacing=0 cellpadding=3>';
        $t .= "<tr><th colspan=2>   ($tmp)</th></tr>";
        for ( my $i = 0 ; $i < scalar @messages ; $i++ ) {
            $t .= "<tr>"  if $i % 2 == 0;
            $t .= "<td>$messages[$i]</td>";
            $t .= "</tr>" if $i % 2;
        }
        $t .= '</table>
    <a href="?act=teacher_placement">  ...</a>
    </td></tr></table>';
    }

    @messages = ();
    my @teachers_without_bindings;
    sqlffa \@teachers_without_bindings,
      "select last_name || ' ' || first_name || ' ' || middle_name
from human where class = 0
and human_id not in (
  select vw_teacher from sys_matrix
  where view_class = 9001
  and exists ( select 1 from get_node_saldo_by_unit
  ( sys_matrix.node_id, 'now', '', 0 )
  where saldo_sum <> 0)
union all
  select vw_teacher from sys_matrix
  where view_class = 9003
  and exists ( select 1 from get_node_saldo_by_unit
  ( sys_matrix.node_id, 'now', '', 0 )
  where saldo_sum <> 0)
)
order by 1";

    if (@teachers_without_bindings) {
        my $tmp = scalar @teachers_without_bindings;
        $t .=
'<table border=0 cellspacing=0 cellpadding=7><tr><td class=sign><img src="/sp/img/stop.gif"></td><td><table class=d border=0 cellspacing=0 cellpadding=3>';
        $t .=
"<tr><th colspan=2>      ($tmp)</th></tr>";
        for ( my $i = 0 ; $i < scalar @teachers_without_bindings ; $i++ ) {
            $t .= "<tr>"  if $i % 2 == 0;
            $t .= "<td>$teachers_without_bindings[$i]</td>";
            $t .= "</tr>" if $i % 2;
        }
        $t .= '</table>
    <a href="?act=teacher_form_master">  ...</a><br>
    <a href="?act=teacher_placement">  ...</a>
    </td></tr></table>';
    }

    $t = "<h2>  .</h2>" unless $t;

    tpl './tpl/check_new_year.html',
      {
        menu     => generate_menu(),
        messages => $t,
        footers  => generate_footers(),
      };

}

sub name_rating() {
    my $my_name =
      sqlff "select trim(first_name) from human where human_id = $guid";

    my $q = sqlp
qq[select trim(first_name), iif(sex=0,'<span style=color:#b4a></span>','<span style=color:#238></span>')
from sys_matrix, human
where
vw_pupil = human_id and
sys_matrix.view_class = 1
and exists
(
  select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0)
  where saldo_sum <> 0
)];
    my ( @a, @uniq );
    my %names;
    my %sex;
    while ( @a = $q->fetchrow_array() ) {
        $names{ $a[0] }++;
        $sex{ $a[0] } = $a[1];
    }
    @a = ();
    for ( keys %names ) {
        if ( $names{$_} == 1 ) {
            push @uniq, [ $_, $sex{$_} ];
        }
        else {
            push @a, [ $_, $names{$_}, $sex{$_} ];
        }
    }

    my ( $t1, $t2 );
    $t1 = $t2 = '';
    for ( reverse sort { $$a[1] <=> $$b[1] || $$b[0] cmp $$a[0] } @a ) {
        my $style =
          $my_name eq $$_[0] ? 'style="background-color:#F7F6E6"' : '';
        $t1 .=
qq[<tr $style><td>&nbsp;$$_[2]&nbsp;</td><td>$$_[0]</td><td align=right>$$_[1]</td></tr>];
    }

    for ( reverse sort { $$b[0] cmp $$a[0] } @uniq ) {
        my $style =
          $my_name eq $$_[0] ? 'style="background-color:#F7F6E6"' : '';
        $t2 .= qq[<tr $style><td>&nbsp;$$_[1]&nbsp;</td><td>$$_[0]</td></tr>];
    }

    tpl './tpl/name_rating.html',
      {
        menu    => generate_menu(),
        footers => generate_footers(),
        t1      => $t1,
        t2      => $t2,
      };
}

sub internet_access_control() {

    my $can = $gconf{'auth'};

    if ( param('op') and param('op') eq 'save' ) {

        stop "    ." unless $can;

        my @a = param();
        my %passwords;
        sqlh \%passwords, "select log, pas from sp_users";
        my %gids;
        sqlh \%gids, "select log, gid from sp_users";
        my $user_count = 0;
        my $opts       = '-cb';
        open SPU, '>', $gconf{'sp_users_allowed'};
        for (@a) {

            if (/^[atu]:(.+)$/) {
                my $uid = $1;
                my @allowed_gids = ( 1, 2, 4 );
                unless ( grep /^$gids{$uid}$/, @allowed_gids ) {
                    stop
" $1   , ,    .";
                }

                next unless ( $passwords{$1} );

                print SPU "$1\n";

                my $htpasswd = '/usr/sbin/htpasswd';
                $htpasswd = '/usr/bin/htpasswd2' if -e '/etc/altlinux-release';

                unless (
                    0 == system( $htpasswd, $opts, $gconf{'htpasswd'},
                        $1, $passwords{$1}
                    )
                  )
                {
                    stop "    $1   .";
                }

                $opts = '-b' if $opts eq '-cb';

                $user_count++;
            }
        }
        close SPU;

        unless ($user_count) {

            my @chrs = ( 'a' .. 'z', 'A' .. 'Z', 0 .. 9 );
            my $log = '';
            for ( my $i = 0 ; $i < 64 ; $i++ ) {
                $log .= $chrs[ rand( scalar @chrs ) ];
            }

            push @chrs, split '', q~-_=!@#$%*()_+{}[]~;
            my $pas = '';
            for ( my $i = 0 ; $i < 64 ; $i++ ) {
                $pas .= $chrs[ rand( scalar @chrs ) ];
            }

            my $htpasswd = '/usr/sbin/htpasswd';
            $htpasswd = '/usr/bin/htpasswd2' if -e '/etc/altlinux-release';

            unless (
                0 == system( $htpasswd, $opts,
                    $gconf{'htpasswd'}, "sp_dummy_user_$log",
                    $pas
                )
              )
            {
                stop
                  "       .";
            }
        }
        system('sudo /etc/init.d/squid reload');
        redir('internet_access_control');

    }

    my $q;
    my @a;
    my $admins_html    = '';
    my $teachers_html  = '';
    my $parallels_html = '';

    my %users;
    if ($can) {
        open F, '<', $gconf{'htpasswd'}
          or security_alert("     $gconf{'htpasswd'}");
        while (<F>) {
            chop;
            ( $_, undef ) = split ':';
            $users{$_}++;
        }
        close F;
    }

    $q = sqlp
      "select log, (select last_name || ' ' || first_name || ' ' || middle_name
from human where human_id = uid) from sp_users where gid = 1
order by 2";
    my $adm_count         = 0;
    my $adm_count_checked = 0;
    my $checked;
    while ( @a = $q->fetchrow_array() ) {
        $checked = $users{ $a[0] } ? 'checked' : '';
        $admins_html .=
qq[new YAHOO.widget.TextNode("<input type=checkbox $checked name='a:$a[0]' id='a:$a[0]' onclick='paint_me(this)'>&nbsp;<label id='l_a:$a[0]' for='a:$a[0]'>$a[1] ($a[0])<\\/label>", admins, false);\n];
        $adm_count++;
        $adm_count_checked++ if $checked eq 'checked';
    }

    $q = sqlp
      "select log, (select last_name || ' ' || first_name || ' ' || middle_name
from human where human_id = uid) from sp_users where gid = 2
order by 2";
    my $teach_count         = 0;
    my $teach_count_checked = 0;
    while ( @a = $q->fetchrow_array() ) {
        $checked = $users{ $a[0] } ? 'checked' : '';
        $teachers_html .=
qq[new YAHOO.widget.TextNode("<input type=checkbox $checked name='t:$a[0]' id='t:$a[0]' onclick='paint_me(this)'>&nbsp;<label id='l_t:$a[0]' for='t:$a[0]'>$a[1] ($a[0])<\\/label>", teachers, false);\n];
        $teach_count++;
        $teach_count_checked++ if $users{ $a[0] };
    }

    my @parallels;
    sqlffa \@parallels, "select distinct paralel
from sys_matrix, sp_users
where vw_pupil = uid
and sys_matrix.view_class = 1
and exists
(
  select 1 from get_node_saldo
  (sys_matrix.node_id, 'now', 0) where saldo_sum <> 0
)
order by cast(paralel as integer)";

    my $js_check_classes  = '';
    my $pup_count         = 0;
    my $pup_count_checked = 0;
    my %pup_parallel_checked;
    for my $p (@parallels) {
        my $pupils_in_parallel = sqlff "select count(1)
from sp_users, sys_matrix
where vw_pupil = uid
and sys_matrix.view_class = 1
and sys_matrix.class in
(
select class from sys_matrix
      where view_class = 7
      and paralel = $p
      and exists
      (
        select 1 from get_node_saldo
        (sys_matrix.node_id, 'now', 0) where saldo_sum <> 0
      )
)
and exists(select 1 from get_node_saldo
(sys_matrix.node_id, 'now', 0) where saldo_sum <> 0)";
        $parallels_html .=
qq[var p$p = new YAHOO.widget.TextNode("$p  ( <span id='paralel_$p'>0<\\/span>&nbsp;/ $pupils_in_parallel )", parallels, false);\n];
        my @classes;
        sqla \@classes,
"select class, (SELECT name from class where class_id = sys_matrix.class)
from sys_matrix
      where view_class = 7
      and paralel = $p
      and exists
      (
        select 1 from get_node_saldo
        (sys_matrix.node_id, 'now', 0) where saldo_sum <> 0
      )
      order by 2";
        for my $c (@classes) {
            my @pupils;
            sqla \@pupils, "select log,
(select last_name || ' ' || first_name || ' ' || middle_name
from human where human_id = uid)
from sp_users, sys_matrix
where vw_pupil = uid
and sys_matrix.view_class = 1
and sys_matrix.class = $$c[0]
and exists(select 1 from get_node_saldo(sys_matrix.node_id, 'now', 0) where saldo_sum <> 0)
order by 2";
            if ( scalar @pupils ) {
                $$c[1] =~ s/^(\s{0,}".+").+/$1/o;
                escape_tag \$$c[1];
                my $pupils_in_class   = scalar @pupils;
                my $selected_in_class = 0;
                for (@pupils) {
                    $selected_in_class++ if $users{ $$_[0] };
                    $pup_parallel_checked{$p}++ if $users{ $$_[0] };
                }
                $parallels_html .=
qq[var c$$c[0] = new YAHOO.widget.TextNode("<input type=checkbox name='c$$c[0]' id='c$$c[0]' onclick='check_class($$c[0],checked,$p)'>&nbsp;<label for='c$$c[0]'>$p $$c[1] ( <span id='class_count_$$c[0]'>$selected_in_class<\\/span>&nbsp;/ $pupils_in_class )<\\/label>", p$p, false);\n];
                for (@pupils) {
                    $checked = $users{ $$_[0] } ? 'checked' : '';
                    $parallels_html .=
qq[new YAHOO.widget.TextNode("<input type=checkbox $checked name='u:$$_[0]' id='c$$c[0]:$$_[0]' onclick='check_pupil($$c[0],checked,$p)'>&nbsp;<label for='c$$c[0]:$$_[0]'><span id='span_c$$c[0]:$$_[0]'>$$_[1]<\\/span><\\/label>", c$$c[0], false);\n];
                    $pup_count++;
                    $pup_count_checked++ if $users{ $$_[0] };
                }
                $js_check_classes .= "check_pupil($$c[0],-1,-1);";
            }
        }
    }

    my $js_set_parallel_checked = '';

    for ( keys %pup_parallel_checked ) {
        $js_set_parallel_checked .=
          "set_parallel_checked($_,$pup_parallel_checked{$_});";
    }

    for (@parallels) {
        $js_set_parallel_checked .=
qq[e('paralel_$_').className = parseInt(e('paralel_$_').innerHTML) ? 'has_checked' : '';];
    }

    if ($teach_count_checked) {
        $teach_count_checked =
          qq[<span style='color:green'><b>$teach_count_checked</b><\\/span>];
    }
    if ($adm_count_checked) {
        $adm_count_checked =
          qq[<span style='color:green'><b>$adm_count_checked</b><\\/span>];
    }

    my $js_paint_pupil_spans = '';
    if ($pup_count_checked) {
        $js_paint_pupil_spans = qq[e('pup_count').className = "has_checked";];
    }

    tpl './tpl/internet_access_control.html',
      {
        menu                    => generate_menu(),
        footers                 => generate_footers(),
        admins                  => $admins_html,
        teachers                => $teachers_html,
        parallels               => $parallels_html,
        adm_count_checked       => $adm_count_checked,
        adm_count               => $adm_count,
        teach_count_checked     => $teach_count_checked,
        teach_count             => $teach_count,
        pup_count_checked       => $pup_count_checked,
        pup_count               => $pup_count,
        js_check_classes        => $js_check_classes,
        js_set_parallel_checked => $js_set_parallel_checked,
        js_paint_pupil_spans    => $js_paint_pupil_spans,
        disabled                => $can ? '' : 'disabled',
        disabled_text           => $can
        ? ''
        : '<h2 class=bred>  (    )</h2>',
      };
}

sub kill_speedy() {

    if ( param('p') eq 'jAnmQh02wDS0Lxs7rrc4Ro9JyaTnZg4p' ) {
        system('killall -9 speedy_backend');
        stop("Speedy stopped.");
    }
    else {
        redir('main');
    }
}

sub medallist_editor() {
    if ( $ENV{'REQUEST_METHOD'} eq 'GET' ) {

        my $q = sqlp(
"select t1.vw_pupil as uid, t2.entry_date, t1.paralel || ' ' || (select name from class where class_id = t1.class) as class_name,
			last_name || ' ' || first_name || ' ' || middle_name as fio,
			t3.deduction_type
			from sys_matrix t1, sys_entry t2, doc_deduction_order_sp t3, human
			where
			human_id = t1.vw_pupil and t1.node_id = t2.credit_node and
			t2.doc_class = 5 and
			t2.doc = t3.doc_no and t1.vw_pupil = t3.human_id
			and t3.deduction_type in (1032,1033,1034)
			order by 2,3,4",
            { ib_timestampformat => '%Y' }
        );

        my %hash;
        $q->bind_columns( \( @hash{ @{ $q->{NAME_lc} } } ) );

        my $tmp = '';
        while ( $q->fetch ) {
            my %medal = ( $hash{deduction_type} => 'checked' );

            $tmp .= qq[
<tr>
	<td>$hash{entry_date}</td>
	<td>$hash{class_name}</td>
	<td>$hash{fio}</td>
	<td><label                   ><input type=radio name="u$hash{uid}" value="1032" $medal{1032}><span style="color:gray"></span></label></td>
	<td><label title=""><input type=radio name="u$hash{uid}" value="1033" $medal{1033}><img src="/sp/img/medal-silver.png"></label></td>
	<td><label title=""   ><input type=radio name="u$hash{uid}" value="1034" $medal{1034}><img src="/sp/img/medal-gold.png"></label></td>
</tr>
];
        }

        tpl './tpl/medallist_editor.html',
          {
            menu    => generate_menu(),
            footers => generate_footers(),
            t       => $tmp
          };
    }

    elsif ( $ENV{'REQUEST_METHOD'} eq 'POST' ) {
        my $counter = 0;

        for ( param() ) {

            if (/^u(\d+)$/) {
                my $deduction_type = param("u$1");

                unless ( $deduction_type == 1032
                    or $deduction_type == 1033
                    or $deduction_type == 1034 )
                {
                    security_alert(" deduction_type = $deduction_type");
                }

                if (
                    $deduction_type != sqlff(
"select deduction_type from doc_deduction_order_sp where human_id = $1 and deduction_type in (1032,1033,1034)"
                    )
                  )
                {
                    $counter++;
                    sql(
"update doc_deduction_order_sp set deduction_type = $deduction_type where human_id = $1 and deduction_type in (1032,1033,1034)"
                    );
                }
            }

        }

        msg
          "",
          qq[    $counter .<br><br>
			<a href="?act=medallist_editor"> </a><br>
			<a href="/graduates/fio/1/medal/1033,1034/year/" target="_blank">   (  )</a>];

    }
}

1;
