#!/usr/bin/speedy -X
# (C) http://spcms.ru
#!/usr/bin/perl -W

use CGI qw(:standard escapeHTML -no_xhtml);
use GD;
use GD::Graph::bars;
use locale;

use strict;
use vars qw( @mnths );

our $GZIP  = 1;
our $gpage = '';

$CGI::POST_MAX = 1048576;

use CGI::Carp qw/fatalsToBrowser name=SP_MSG/;

require "common.pl";
require "misc.pl";
require "menu.pl";
require "reg.pl";

use vars qw /$DEBUG $GZIP $version $HTTP_HEADER_ADD/;

our (
    %SQLH,      %ACL,      %human_hash, %gconf,
    $gdsn,      $gdb,      $gdbcms,     $stat_inbox_new,
    $gdate,     $guid,     $ggid,       $state_date,
    $connected, $msg_text, $msg,        $auto_check_msg,
    @months3,   $act,      $sact
);

our ( $queryes, $gentime );
$queryes         = 0;
$HTTP_HEADER_ADD = '';

%SQLH = ();
OnStart();
ConnectDBCms();

if ($DEBUG) { $gentime = Time::HiRes::time(); }

my ( $body_txt, $pupil_our );

if ( $gconf{'gzip'} && ( $ENV{HTTP_ACCEPT_ENCODING} || '' ) =~ /gzip/ ) {
    $GZIP = 1;
}

session_check();
$pupil_our = 0;
( $guid, $ggid, $state_date ) = uid_gid_gdate();
if ( $ggid == 4 ) {
    $pupil_our = ($state_date) ? 1 : 0;
    $gdate = ($state_date) ? todate($state_date) : todate(time);
    get_pupil_class(0);

}
else {
    $gdate = todate(time);
}
read_acl();
$stat_inbox_new = get_new_message_count();

$body_txt = '';
$act      = param('act') || '';
$sact     = param('sact') || '';
my @exclude = qw / aj_newm aj_gr msg_send_act pub_send_act pub_edit_act /;

if ( grep /^\Q$act\E$/, @exclude ) {
    session_keep_alive();
}

sub msg_desktop {
    $act  = param("act")  || '';
    $sact = param("sact") || '';

    my $stat  = $_[0];
    my $error = $_[1];
    my $body  = $_[2] || '';

    my $mesg = param("mesg") || '';
    my %nMesg = (
        'inbox'         => q[ &mdash; ],
        'sent'          => q[ &mdash; ],
        'recycler'      => q[ &mdash; ],
        'msg_stat'      => q[ &mdash; ],
        'address_book'  => q[ &mdash;  ],
        'address_black' => q[ &mdash;  ],
        'read'          => q[ &mdash;  ],
        'new_msg'       => q[ ],
        'new_pub'       => q[ ],
        'announcement'  => q[],
        'set'           => q[   &mdash; ],
    );
    my $title_d = defined $nMesg{$act} ? $nMesg{$act} : '  ';

    if ( $act eq 'announcement' ) {
        %nMesg = (
            'all'    => q[ ],
            'active' => q[],
        );
        $title_d .=
          $nMesg{$sact} ne '' ? ' &mdash; ' . $nMesg{$sact} : ' &mdash;  ';
    }

    my $mesg = param("mesg") || '';
    my %nMesg = (
        'send_ok' => q[  ],
        'ban' =>
q[<img src='/sp/img/forbidden.gif' width='24' height='24' hspace='5' align='absmiddle'>    ],
        'resore'   => q[  ],
        'pub_ok'   => q[ ],
        'pub_edit' => q[  ],
        'set_ok'   => q[ ],
        'pubdel'   => q[  ],
        'favdel'   => q[ ],
        'deny'     => q[<dl class='worn'></dl> ],
    );

    my $stat_inbox = sqlffcms(
'SELECT count(1) FROM msg_message_text,msg_send WHERE msg_message_text.id = msg_send.msg_id AND msg_send.u_id = '
          . $guid
          . ' AND msg_send.cmd_s < 2' );
    $stat_inbox .=
      $stat_inbox_new > 0
      ? "&nbsp;<b title=' '>($stat_inbox_new)</b>"
      : '';

    my @stat_trash = sqlfcms(
            'SELECT (SELECT count(1) FROM msg_message_text WHERE author_id = '
          . $guid
          . ' AND cmd_i = 2) ,
     (SELECT count(1) FROM msg_send WHERE u_id = ' 
          . $guid
          . ' AND cmd_s = 2) from dual'
    );

    my $announcement_blok_for_admin;
    if ( isadmin() ) {
        my $tmp = sqlffcms("SELECT count(1) FROM msg_public_text");
        $announcement_blok_for_admin = qq[<tr>
        <td class="msg_ln"><img src="/sp/img/msg_ln2.gif" width="9" height="2"></td>
        <td class="msg_menu"><a href="?act=announcement&sact=all" title="   (  )"><img src="/sp/img/msg_announcement_all_admin.gif" border="0" width="24" height="24" align="absmiddle">  </a></td>
        <td class="msg_menu_it">$tmp</td>
      </tr>];
    }

    tpl(
        './tpl/msg/desktop.html',
        {
            menu       => generate_menu(),
            title_d    => $title_d,
            stat_inbox => $stat_inbox,
            stat_sent  => sqlffcms(
                    "SELECT count(1) FROM msg_message_text WHERE author_id = "
                  . $guid
                  . " AND cmd_i = 1"
            ),
            stat_announcement           => stat_announcement( 1, 0 ),
            stat_announcement_all       => stat_announcement( 0, 1 ),
            announcement_blok_for_admin => $announcement_blok_for_admin,
            stat_trash                  => $stat_trash[0] + $stat_trash[1],
            button_nav                  => button_nav('')
              . ( defined $nMesg{$mesg} ? mesg( $nMesg{$mesg} ) : '' ),
            body => $body eq '' ? msg_body( $stat, $error ) : $body,
            footers => generate_footers()
        }
    );
}

sub msg_body {
    my $stat = $_[0];
    my $error = $_[1] || '';
    my (
        $temp,        @result,      $grp_select, $stat_send,
        $subject_txt, $message_txt, $name_find,  $subject_e,
        $message_e,   $send_hd,     $html_st
    );
    $subject_txt = $message_txt = $subject_e = $message_e = $stat_send =
      $body_txt = $send_hd = $html_st = '';

    if ( length($error) > 0 ) {
        $stat_send =
qq{<h2>!</h2><h4>         </h4>};

        if ( $error !~ /m/ ) {
            $subject_e = "class='error_sel_fl'";
        }
        if ( $error !~ /s/ ) {
            $message_e = "class='error_sel_fl'";
        }

        $subject_txt = param("subject") || '';
        $message_txt = param("message") || '';

        $act = "new_msg";
    }

    if ( $act eq "inbox" ) {
        $body_txt .= letter_list('0');
    }
    elsif ( $act eq "sent" ) {
        $body_txt .= letter_list('1');
    }
    elsif ( $act eq "recycler" ) {
        $body_txt .= letter_list('2');
    }
    elsif ( $act eq "announcement" ) {
        $body_txt .= pub_list('0');
    }
    elsif ( $act eq "set" ) {
        $body_txt .= set_form();
    }
    elsif ( $act eq "address_book" ) {
        $body_txt .= address_book();
    }
    elsif ( $act eq "address_black" ) {
        $body_txt .= address_book(1);
    }

    elsif ( $act eq "new_pub" or $act eq "pub" ) {
        $pupil_our and redir("announcement&mesg=deny");

        my (
            $edit_name,  $select_grp, $select_paralel, $select_class,
            @pup_arr,    $class_id,   $paralel,        $filter,
            $filter_pup, $js_function
        );
        my (
            $SQLm,       $date_begin, $date_end,     $send_st_block,
            $form_block, $selGrp_v,   $selParalel_v, $selClass_v,
            @selGrp,     @selParalel, @selClass
        );
        my $id = param('id');
        if ($id) { sec_gt0($id); }
        $filter = $filter_pup = '';

        if ( $ggid == 4 ) {
            $filter = "gid = 4 and";
            $js_function =
qq[e('sel_gr').style.display = "none";\ne('sel_pr').style.display = "none";];
        }
        else {
            my $q = sqlp(
                "SELECT gid, name from sp_gid_ref WHERE $filter EXISTS
        (SELECT 1 from sp_users where sp_users.gid = sp_gid_ref.gid)"
            );
            while ( @result = $q->fetchrow_array() ) {
                $selGrp[ $result[0] ] = $result[1];
                my $sel = ( $ggid == $result[0] ) ? ' selected' : '';
                $select_grp .=
qq{    <option value="$result[0]" id="selGrp$result[0]"$sel>$result[1]</option>\n};
            }
        }

        if ( $ggid == 4 ) {
            $class_id = get_pupil_class(0);
            $paralel  = sqlff(
"SELECT paralel FROM sys_matrix WHERE class = $class_id AND sys_matrix.view_class = 7
      AND exists ( select 1 from get_node_saldo (sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0)"
            );
            $filter_pup = "paralel = $paralel AND";
        }
        else {
            $paralel = 0;
        }

        my $q = sqlp(
"SELECT sys_matrix.class, paralel ||' '||(select name FROM class where sys_matrix.class=class.class_id)
       FROM sys_matrix WHERE view_class = 7 AND $filter_pup EXISTS (
       select 1 from get_node_saldo
       (sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0 )"
        );
        while ( @result = $q->fetchrow_array() ) {
            push @pup_arr, [@result];
        }

        @pup_arr = sort { $a->[1] <=> $b->[1] } @pup_arr;
        for (@pup_arr) {
            $selClass[ $_->[0] ] = $_->[1];
            my $sel = $class_id == $_->[0] ? ' selected' : '';
            $_->[1] =~ s/(.+\").+/$1/;
            $select_class .=
qq{    <option value="$_->[0]" id="selClass$_->[0]"$sel>$_->[1]</option>\n};
        }

        $q = sqlp('SELECT name, paralel_id FROM paralel ORDER BY paralel_id');
        while ( @result = $q->fetchrow_array() ) {
            $selParalel[ $result[1] ] = $result[0];
            my $sel = $paralel == $result[1] ? ' selected' : '';
            $select_paralel .=
qq{<option value="$result[1]" id="selParalel$result[1]"$sel>$result[0]</option>\n};
        }

        if ($id) { if ( !isadmin() ) { $SQLm .= " AND author_id = $guid "; }

            my @pub = sqlfcms(
                "SELECT subject, message_text, date_begin, date_end, author_edit
      FROM msg_public_text WHERE id = $id $SQLm",
                { ib_timestampformat => '%d.%m.%Y' }
            );

            if ( $pub[2] eq "" ) { redir('announcement&mesg=ban'); }

            $subject_txt = $pub[0];
            $message_txt = $pub[1];
            $date_begin  = $pub[2];
            $date_end    = $pub[3];
            $edit_name   = $pub[4];

            my $q = sqlpcms(
"SELECT type_g, gid FROM msg_public_send WHERE pub_id = $id ORDER BY type_g ASC, gid ASC"
            );
            my $i = 0;
            while ( my @result = $q->fetchrow_array() ) {
                if ( $result[0] == 1 ) {
                    $selGrp_v .= $result[1] . ",";
                    $send_st_block .=
qq[<a href="JavaScript:pub_del('selGrp',$result[1])" title=""><dl class="del_smal"></dl></a> $selGrp[$result[1]] <br>];
                    $js_function .=
qq[p_ID[$i] = $result[1]; p_NAME[$i] = "$selGrp[$result[1]]"; p_P[$i] = "selGrp"; ];
                }
                elsif ( $result[0] == 2 ) {
                    $selParalel_v .= $result[1] . ",";
                    $send_st_block .=
qq[<a href="JavaScript:pub_del('selParalel',$result[1])" title=""><dl class="del_smal"></dl></a> $selParalel[$result[1]] <br>];
                    $js_function .=
qq[p_ID[$i] = $result[1]; p_NAME[$i] = "$selParalel[$result[1]]"; p_P[$i] = "selParalel"; ];
                }
                elsif ( $result[0] == 3 ) {
                    $selClass_v .= $result[1] . ",";
                    $send_st_block .=
qq[<a href="JavaScript:pub_del('selClass',$result[1])" title=""><dl class="del_smal"></dl></a> $selClass[$result[1]] <br>];
                    $js_function .=
qq[p_ID[$i] = $result[1]; p_NAME[$i] = '$selClass[$result[1]]'; p_P[$i] = "selClass"; ];
                }
                $i++;
            }
            $form_block .=
qq[<input type='hidden' name="act" value="pub_edit_act"><input type='hidden' name="id" value="$id">
      <div align="left" style="padding: 4px 0px 2px 12px;"><input type="checkbox" id="noRead" name="noRead" value="1">
      <label for="noRead">         </label></div>];
        }
        else {
            $date_begin = todate( time() );
            $date_end   = todate( time() + 604800 );
            $send_st_block =
"<font color='red'><i>    </i></font>";
            $form_block .=
              q[<input type='hidden' name="act" value="pub_send_act">];
        }

        my $submit_button_txt =
          $id ? ' ' : ' ';

        my $max_time_end = todate(
            sqlff(
                "select max(time_end) from sp_periods where id = "
                  . (
                    sqlff(
"select F_INT from SP_SETTINGS where NAME = 'periods_mode'"
                      ) ? '4' : '7'
                  )
            )
        );

        $form_block .=
qq[<input type='hidden' name="selGrp_v" value="$selGrp_v" id="selGrp_v">
<input type='hidden' name="selParalel_v" value="$selParalel_v" id="selParalel_v">
<input type='hidden' name="selClass_v" value="$selClass_v" id="selClass_v">];

        $body_txt .= tpl_str(
            './tpl/msg/pub_form.html',
            {
                id                => $id,
                max_time_end      => $max_time_end,
                form_block        => $form_block,
                send_st_block     => $send_st_block,
                js_function       => $js_function,
                select_grp        => $select_grp,
                select_paralel    => $select_paralel,
                select_class      => $select_class,
                stat_send         => $stat_send,
                subject           => $subject_txt,
                subject_e         => $subject_e,
                message           => $message_txt,
                message_e         => $message_e,
                date_begin        => $date_begin,
                date_end          => $date_end,
                submit_button_txt => $submit_button_txt,
                edit_name         => (
                    $edit_name
                    ? qq[<tr><td colspan=2 align="right" style="color:#990000;font-size:11px;padding: 3px 30px 4px 0px;"> : <b>]
                      . human_hash($edit_name)
                      . qq[</b></td></tr>]
                    : ""
                ),
            }
        );
    }

    elsif ( $act eq "new_msg" ) {
        my $class_sel;
        if ( $ggid == 4 ) {
            $class_sel = get_pupil_class(0);
        }
        else {
            $class_sel = 0;
        }

        my $q = sqlp(
            'SELECT gid, name from sp_gid_ref where EXISTS
       (SELECT 1 from sp_users where sp_users.gid = sp_gid_ref.gid)'
        );
        $grp_select .=
qq[<select name="name_send_two" id="name_send_two" onchange="getContent('sel_grp', 'msg.pl?act=aj_gr&f=$class_sel&s='+e('name_send_two').value);">];
        while ( @result = $q->fetchrow_array() ) {
            my $sel = ( $ggid == $result[0] ) ? ' selected' : '';
            $grp_select .=
              qq{<option value="$result[0]"$sel>$result[1]</option>\n};
        }
        $grp_select .=
qq[</select> &nbsp;<dl onClick="getContent('sel_grp', 'msg.pl?act=aj_gr&f=$class_sel&s='+e('name_send_two').value);" class="ok"></dl>];

        if ( $sact eq "reply" ) {
            my $id = param('id');
            sec_gt0($id);
            my $ssact = param('ssact');
            my @q     = sqlfcms(
                'SELECT msg_message_text.id, msg_message_text.author_id,
       msg_message_text.subject, msg_message_text.message_text, msg_message_text.date_sent
       FROM msg_message_text,msg_send WHERE msg_message_text.id = msg_send.msg_id
       AND (msg_send.u_id = ' 
                  . $guid
                  . ' OR msg_message_text.author_id = '
                  . $guid . ')
       AND  id = ' . $id, { ib_timestampformat => '%d %b %Y, %H:%M' }
            );

            $send_hd = $q[1];
            my $js_block .= "uNAME[0] = '" . human_hash( $q[1], 0 ) . "';\n";

            if ( $q[1] == -1 && $ssact ne 'transmit' ) {
                stop(
"    ,    ,     .    ,   ."
                );
            }

            if ( $ssact eq 'transmit' ) {
                $subject_txt = 'Fwd: ' . $q[2];
            }
            else {
                if ( $q[2] =~ m/^re: /i ) {
                    $q[2] =~ s/^re: //i;
                    $subject_txt = 'Re(2): ' . $q[2];
                }
                elsif ( $q[2] =~ m/^Re\((\d+)\): / ) {
                    my $tmp = '';
                    $tmp = $1 + 1;
                    $q[2] =~ s/^re\((\d+)\): //i;
                    $subject_txt = "Re($tmp): " . $q[2];
                }
                elsif ( $q[2] !~ m/^re: /i ) {
                    $subject_txt = "Re: " . $q[2];
                }
            }

            if ( $ssact ne "transmit" ) {
                $message_txt .=
                  "\n\n\n\n---------  : " . $q[4] . " -----------\n";
                $message_txt .=
                  "---------------------------------------------------\n";
            }

            $q[5] = human_hash( $q[1], 0 );
            $message_txt .= ": " . $q[5] . "\n";
            $message_txt .= ": " . $q[4] . "\n";
            $message_txt .= ": " . $q[2] . "\n\n";

            if ( $ssact ne "transmit" ) {
                my @aMsg = split /\n/, $q[3];
                for (@aMsg) {
                    $message_txt .= ">> " . $_ . "\n";
                }
                $message_txt .=
                  "---------------------------------------------------";

                $html_st =
                  qq[<script type="text/javascript" language="JavaScript"><!--
       e('send_st_block').innerHTML = '$q[5]';
$js_block --></script>];
            }
            else {
                $message_txt .= $q[3];
                $send_hd = '';
            }
        }
        elsif ( $sact eq "sent" ) {
            $send_hd = address_book_act();

            my ( @a, $v, $name_block, $js_block );
            my $i = 0;
            @a = split /,/, $send_hd;
            for $v (@a) {
                if ( $v ne '' ) {

                    $name_block .=
qq[<a href="JavaScript:send_del($v)" title=""><dl class="del_smal"></dl></a> ]
                      . human_hash( $v, 0 )
                      . qq[ <a href="JavaScript:address_book($v)" title="   "><dl class="fav_add_smal"></dl></a><br>];
                    $js_block .= "uNAME[$i] = '" . human_hash( $v, 0 ) . "';\n";
                    $i++;
                }
            }

            $html_st =
              qq[<script type="text/javascript" language="JavaScript"><!--
       e('send_st_block').innerHTML = '$name_block';
$js_block --></script>];
        }

        $body_txt .= tpl_str(
            './tpl/msg/send_form.html',
            {
                grp_select => $grp_select,
                class_sel  => $class_sel,
                stat_send  => $stat_send,
                send_hd    => $send_hd,
                subject    => $subject_txt,
                message    => $message_txt,
                subject_e  => $subject_e,
                message_e  => $message_e,
                save_send  => 0,
                html_st    => $html_st,
            }
        );
    }
    elsif ( $act eq "read" ) {
        my $id = param("id");
        sec_gt0($id);

        my @q = sqlfcms(
            "SELECT msg_message_text.id, msg_message_text.author_id,
     msg_message_text.date_sent, msg_message_text.cmd_i, msg_send.cmd_s,
     msg_message_text.subject, msg_message_text.message_text
     FROM msg_message_text, msg_send WHERE msg_message_text.id = msg_send.msg_id
     AND (msg_send.u_id = $guid OR msg_message_text.author_id = $guid)
     AND  id = $id",
            { ib_timestampformat => '%d %b %Y %H:%M' }
        );

        my $stat_announcement = stat_announcement(1);
        my $set_cookie        = cookie(
            -NAME   => "count_mag",
            -VALUE  => $auto_check_msg . "_" . $stat_announcement,
            -domain => $ENV{SERVER_NAME},
            -path   => '/'
        );

        !$q[1] and redir('inbox');

        $q[11] = human_hash( $q[1] );

        my @fl_img;
        $fl_img[0] = q[<img src='/sp/img/];
        $fl_img[1] = q[ width="21" height="12" align="absmiddle">];

        my $users = sqlpcms( 'SELECT * FROM msg_send WHERE msg_id = ' . $q[0] );
        my @result;
        $q[10] = '';
        while ( @result = $users->fetchrow_array() ) {
            $q[10] .=
                ( $q[10] eq '' ? '' : '<br>' )
              . $fl_img[0]
              . ( $result[2] == 0
                ? "msg_unread.gif' title=' '"
                : "msg_read.gif' title=''" )
              . $fl_img[1]
              . "&nbsp; ";
            $q[10] .= sqlff(
'SELECT human.last_name ||" "|| human.first_name ||" "|| human.middle_name FROM human WHERE human_id ='
                  . $result[1] );
        }

        if ( $q[1] == -1 ) {
            $html_st =
q[<script type="text/javascript" language="JavaScript">e('AddBan').style.display="none";</script>];
        }

        $q[6] =~ s!\n!<br>!g;
        $q[6] =~
s/\b(https?|ftp|file|ed2k)(:\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;\[\]()]*[\-A-Z-0-9+&@,.#\/%=~_|\[\](){}*]*)/<a target="_blank" href="$1$2">$1$2<\/a>/gi;

        $body_txt .= tpl_str(
            './tpl/msg/form_read.html',
            {
                id            => $q[0],
                stat_send     => $q[2],
                name_find     => $q[11],
                name_send_two => $q[10],
                subject       => $q[5],
                message       => $q[6],
                html_st       => $html_st,
            }
        );
        sqlcms(
            "UPDATE msg_send SET msg_send.cmd_s = 1 WHERE cmd_s = 0 AND u_id = "
              . $guid
              . " AND msg_id = $id" );
    }
    else {
        $body_txt .= letter_list('0');
    }

    return $body_txt;
}

sub pub_read() {
    my $id = param("id");
    sec_gt0($id);
    my ( $SQLm, $stat );

    if ( $ggid == 4 ) {
        my $class_id = get_pupil_class(0);
        my $paralel  = get_pupil_paralel($class_id);
        $SQLm = '(
      (msg_public_send.type_g = 2 AND msg_public_send.gid = 11)
      OR (msg_public_send.type_g = 3 AND msg_public_send.gid = 39)
      OR (msg_public_send.type_g = 1 AND msg_public_send.gid = 4)
    ) OR
    (msg_public_text.author_id = 101900333)';
    }
    elsif ( isadmin() ) {
        $SQLm = '1 = 1';
    }
    else {
        $SQLm = 'msg_public_send.type_g = 1 AND msg_public_send.gid = ' . $ggid;
    }

    my @q = sqlfcms(
        "SELECT msg_public_text.author_id, msg_public_text.subject,
     msg_public_text.date_begin, msg_public_text.date_end, msg_public_text.message_text,
     msg_public_text.author_edit, msg_public_send.type_g, msg_public_send.gid
     FROM msg_public_text,msg_public_send
     WHERE msg_public_text.id = msg_public_send.pub_id AND msg_public_text.id = $id AND ($SQLm)",
        { ib_timestampformat => "%d.%m.%Y" }
    );

    if ( $q[2] eq "" ) { redir('announcement&mesg=ban'); }

    if ( $q[0] > 0 ) {
        $q[4] =~ s/\n/<br>/g;
    }

    if ( $q[5] ) {
        $stat =
qq[<div align="right" style="color:#666666;font-size:9px;padding: 0px 10px 5px 0px;"> : <b>]
          . human_hash( $q[5] )
          . qq[</b></div>];
    }

    my ( $mn, $h, $d, $m, $y );
    my $read_d = sqlffcms(
        "SELECT status FROM msg_public_read WHERE uid = $guid AND p_id = $id");
    if ( $read_d > 100 ) {
        ( undef, $mn, $h, $d, $m, $y, undef, undef, undef ) = localtime $read_d;
        $y += 1900;
        $m++;
        $stat .=
q[<input type="checkbox" checked disabled="true">&nbsp;&nbsp;<b>  ];
        $stat .=
          sprintf( "$d %s $y  %02d:%02d", $mnths[ $m - 1 ], $h, $mn ) . '</b>';
    }
    elsif ( totime( $q[3] ) + 86399 < time() ) {
        $stat .= q[<i>   .</i>];
    }
    else {
        $stat .=
qq[<label for="read_yes"><input style="size:14px;margin: 0 10px;" type="checkbox" id="read_yes" name="read" value="$id" onClick="(e('submit').disabled = e('read_yes').checked ?'':'true')"
    ></label><button type="submit" style="width: 440px;" id="submit" disabled="true"><img src="/sp/img/ok.gif"
    > .     .</button>];
    }

    tpl(
        './tpl/msg/pub_read.html',
        {
            menu    => generate_menu(),
            footers => generate_footers(),
            stat    => $stat . (
                ( $q[0] == $guid or isadmin() )
                ? qq[<div style="word-spacing:6px;padding:5px;">
<button type="button" onClick="location='?act=pub_stat&id=$id'" value="send" style="width: 140px;"
><img src="/sp/img/msg_para.gif"></button>&nbsp;&nbsp;
<button type="button" onClick="location='?act=pub&id=$id'" value="" style="width: 150px;"
><img src="/sp/img/msg_announcement_edit.gif"></button>
</div>]
                : ""
            ),
            act        => $act,
            sact       => $sact,
            msg        => $gconf{msg},
            date_begin => $q[2],
            date_end   => $q[3],
            subject    => $q[1],
            message    => $q[4],
        }
    );
}

sub pub_read_confirm() {
    if ( $ENV{"REQUEST_METHOD"} ne 'POST' ) { redir( $sact . '&mesg=ban' ); }
    my ( $SQLp, $id );
    $id = param('read');
    sec_gt0($id);

    my $q = stat_announcement( 1, 0, $id );

    if ( $q <= 0 ) { redir("announcement&mesg=ban"); }

    my $date = time();
    sqlcms(
        "INSERT INTO msg_public_read (p_id,uid,status) VALUES ($id,$guid,$date)"
    );

    if ( $sact eq "ref" ) {
        if ( $ggid == 4 ) {
            my $class_id = get_pupil_class(0);
            my $paralel  = get_pupil_paralel($class_id);

            $SQLp = " OR
      (msg_public_send.type_g = 2 AND msg_public_send.gid = $paralel)
               OR
      (msg_public_send.type_g = 3 AND msg_public_send.gid = $class_id)";
        }

        my $id_announcement = sqlffcms(
            "SELECT msg_public_text.id
    FROM msg_public_text,msg_public_send WHERE
    msg_public_text.id = msg_public_send.pub_id AND
    (
      (msg_public_send.type_g = 1 AND msg_public_send.gid = $ggid)
      $SQLp
    ) AND (msg_public_text.date_begin <= '$gdate' AND msg_public_text.date_end > '$gdate')
      AND NOT EXISTS (
        SELECT 1 FROM msg_public_read WHERE
        msg_public_read.p_id = msg_public_text.id AND msg_public_read.uid = $guid )
      ORDER BY msg_public_text.date_begin DESC"
        );

        if ($id_announcement) {
            $sact = "sact=ref&id=" . $id_announcement;
        }
        else {
            redir("main.pl");
        }

    }
    else {
        $sact = "sact=active";
    }

    redir( "announcement&" . $sact );
}

sub letter_list($) {
    my $filter = shift;
    my (
        $temp,        $fl_to,    @result,    @arr_letter,
        $SQLm,        $title,    @user_name, @user_read,
        $tempUID,     $print_rs, $i,         $user_name_sub,
        $fl_ot_title, $fl_read
    );
    $print_rs = 1;

    if ( $filter == 0 ) {
        $SQLm = 'msg_message_text.id = msg_send.msg_id
         AND msg_send.u_id = ' . $guid . ' AND msg_send.cmd_s < 2';
        $title = "";
    }
    elsif ( $filter == 1 ) {
        $SQLm = 'msg_message_text.id = msg_send.msg_id
         AND msg_message_text.author_id = ' . $guid
          . ' AND msg_message_text.cmd_i = 1';
        $title = "";
    }
    elsif ( $filter == 2 ) {
        $SQLm =
            '(msg_message_text.id = msg_send.msg_id AND msg_send.u_id = ' 
          . $guid
          . ' AND msg_send.cmd_s = 2)
        OR (msg_message_text.id = msg_send.msg_id AND msg_message_text.author_id = '
          . $guid
          . ' AND msg_message_text.cmd_i = 2)';
        $title = " ()";
    }

    my $q = sqlpcms(
'SELECT msg_message_text.id, msg_message_text.subject, msg_message_text.date_sent,
     msg_message_text.author_id, msg_send.cmd_s, msg_send.u_id
     FROM msg_message_text,msg_send WHERE ' 
          . $SQLm
          . ' ORDER BY msg_message_text.date_sent DESC, msg_message_text.id ASC',
        { ib_timestampformat => '%d %b %Y %H:%M' }
    );

    while ( @result = $q->fetchrow_array() ) {
        push @arr_letter, [@result];
    }

    $tempUID = $print_rs = my $count = my $letter = my $k = 0;
    $print_rs = 1;
    $fl_read  = -1;
    $count    = scalar(@arr_letter);

    my %names_hash;

    if ( $count > 22 ) {
        $temp .=
qq[<div style="height: 464px; overflow: auto; overflow-y: scroll; overflow-x: none;">];
    }
    $temp .= tpl_str(
        './tpl/msg/heading.html',
        {
            title => $title,
            act   => $act,
        }
    );

    for ( $i = 0 ; $i < $count ; ++$i ) {
        $tempUID = $tempUID == 0 ? $arr_letter[$i]->[0] : $tempUID;

        if ( $filter == 0 ) {
            $user_name[0] = human_hash( $arr_letter[$i][3] );
            $user_read[0] = $arr_letter[$i][4];
        }
        elsif ( $filter == 1 ) {
            if ( defined( $arr_letter[ $i + 1 ][0] ) ) {
                if (    $tempUID == $arr_letter[$i][0]
                    and $tempUID == $arr_letter[ $i + 1 ][0] )
                {
                    $print_rs = 0;
                }
                else {
                    $tempUID  = $arr_letter[ $i + 1 ][0];
                    $print_rs = 1;
                }
            }
            $user_name[$k] = human_hash( $arr_letter[$i][5], 1 );
            $user_read[$k] = $arr_letter[$i][4];
        }
        elsif ( $filter == 2 ) {
            if ( defined( $arr_letter[ $i + 1 ][0] ) ) {
                if (    $tempUID == $arr_letter[$i][0]
                    and $tempUID == $arr_letter[ $i + 1 ][0] )
                {
                    $print_rs = 0;
                }
                else {
                    $tempUID  = $arr_letter[ $i + 1 ][0];
                    $print_rs = 1;
                }
            }
            $user_name[$k] = human_hash( $arr_letter[$i][3], 1 );
            $user_read[$k] = $arr_letter[$i][4];
        }

        if ($print_rs) {
            $user_name_sub = $user_name[0];
            defined( $user_name[1] ) and $user_name_sub .= $user_name[1];

            $fl_ot_title = '';
            my @fl_title =
              ( ' ', '', '  ' );
            for ( my $t = 0 ; $t < @user_read ; ++$t ) {
                if ( $user_read[$t] >= 2 ) {
                    $user_read[$t] = 1;
                } if ( $t == 0 ) {
                    $fl_read = $user_read[0];
                } if ( $fl_read != $user_read[$t] ) {
                    $fl_read = 2;
                } if ( $filter > 0 )
                { $fl_ot_title .=
                        $user_name[$t] . " - "
                      . $fl_title[ $user_read[$t] ] . ";\n ";
                }
            }

            my $fl_to =
qq [<a href="?act=read&id=$arr_letter[$i][0]"><img src="/sp/img/msg_];
            $fl_to .= $fl_read == 0 ? "un" : ( $fl_read == 2 ? "h" : "" );
            $fl_to .=
qq [read.gif" width="21" height="12" border="0" title='$fl_title[$fl_read]'></a>];

            if ($DEBUG) {
                $arr_letter[$i][1] =
                  "ID " . $arr_letter[$i][0] . "; " . $arr_letter[$i][1];
            }
            $temp .= tpl_str(
                './tpl/msg/heading_tr.html',
                {
                    lf_ch =>
qq[<input type="checkbox" name="ID" value="$arr_letter[$i][0]">],
                    fl_to => $fl_to,
                    fl_ot =>
"<a title='$fl_ot_title' href='?act=read&id=$arr_letter[$i][0]'>"
                      . $user_name_sub . "</a>",
                    fl_ot_title => $fl_ot_title,
                    fl_tema =>
qq{<a href="?act=read&id=$arr_letter[$i][0]">$arr_letter[$i][1]</a>},
                    fl_date => $arr_letter[$i][2],
                }
            );

            ( @user_name, @user_read, $fl_ot_title ) = undef;
            $k = 0;
        }
        else {
            $k++;
        }
    }

    $temp .= qq [</table></div>];
    if ( $i == 0 ) {
        $temp .=
qq [<div align='center' style="border-bottom: 1px dotted #2F4F4F;padding: 5px 50px 5px 0px;" colspan='5'>   </div>];
    }
    else {
        $temp .=
qq [<div style="padding: 5px 50px 2px 8px;" colspan='5'><input type="submit" name="Submit" value=""></div>];
    }

    $temp .= qq [</form>
<script type="text/javascript" language="JavaScript">
<!--
var ie;
var agt = navigator.userAgent.toLowerCase();
if (document.all&&(agt.indexOf('msie')!=-1)) {
  ie=false;
  if (agt.indexOf('msie 4')==-1) {ie=true;}
}
if (ie) {e("TableWidthForIE").style.width = "97%";}
-->
</script>];

    return $temp;
}

sub pub_list($) {
    my $filter = shift;
    my (
        $temp,   $q,          $my_stat_del,   $SQLm,
        @result, %names_hash, $user_name_sub, $fl_ot_title,
        $fl_to,  $fl_class,   @arr_letter,    $pub_id
    );
    my $i = 0;

    if ( $ggid <= 3 ) {
        $SQLm = 'msg_public_send.type_g = 1 AND msg_public_send.gid = ' . $ggid;
    }
    elsif ( $ggid == 4 ) {
        my $class_id = get_pupil_class(0);
        my $paralel  = get_pupil_paralel($class_id);

        $SQLm = '(msg_public_send.type_g = 2 AND msg_public_send.gid = ' 
          . $paralel . ')
      OR (msg_public_send.type_g = 3 AND msg_public_send.gid = '
          . $class_id . ')
      OR (msg_public_send.type_g = 1 AND msg_public_send.gid = 4)';
    }
    else {
        $SQLm = 'msg_public_send.type_g = 1 AND msg_public_send.gid = ' . $ggid;
    }

    if ( $sact eq "all" and isadmin() ) {
        $q = sqlpcms(
            "SELECT distinct id, author_id, subject, date_begin, date_end, stat,
    ( SELECT status FROM msg_public_read WHERE
      msg_public_read.p_id = msg_public_text.id
      AND msg_public_read.uid =  $guid )
    FROM msg_public_text
    ORDER BY date_begin DESC, date_end DESC, id DESC",
            { ib_timestampformat => "%d.%m.%Y" }
        );
    }
    elsif ( $sact eq "active" ) {
        $q = sqlpcms(
"SELECT distinct msg_public_text.id, msg_public_text.author_id, msg_public_text.subject,
    msg_public_text.date_begin, msg_public_text.date_end, msg_public_text.stat,
    ( SELECT status FROM msg_public_read WHERE
        msg_public_read.p_id = msg_public_text.id AND msg_public_read.uid =  $guid )
      FROM msg_public_text, msg_public_send
      WHERE msg_public_text.id = msg_public_send.pub_id
      AND ($SQLm) AND msg_public_text.date_end >= '$gdate' AND msg_public_text.date_begin <= '$gdate'
      ORDER BY 4 DESC, 1 DESC, 6 DESC",
            { ib_timestampformat => "%d.%m.%Y" }
        );
    }
    else {
        $q = sqlpcms(
"SELECT distinct msg_public_text.id, msg_public_text.author_id, msg_public_text.subject,
    msg_public_text.date_begin, msg_public_text.date_end, msg_public_text.stat,
    ( SELECT status FROM msg_public_read WHERE
        msg_public_read.p_id = msg_public_text.id AND msg_public_read.uid =  $guid )
      FROM msg_public_text, msg_public_send
      WHERE msg_public_text.id = msg_public_send.pub_id
      AND ( ( $SQLm ) OR msg_public_text.author_id = $guid)
      ORDER BY 4 DESC, 1 DESC, 6 DESC",
            { ib_timestampformat => "%d.%m.%Y" }
        );
    }

    while ( @result = $q->fetchrow_array() ) {
        push @arr_letter, [@result];
    }

    if ( @arr_letter > 21 ) {
        $temp .=
q[<div style="height:464px;overflow:auto;overflow-y:scroll;overflow-x:none;">];
    }
    $temp .= tpl_str(
        './tpl/msg/heading_pub.html',
        {
            title => '',
            act   => $act,
            sact  => $sact,
        }
    );

    $pub_id = 0;
    for ( my $i = 0 ; $i < @arr_letter ; ++$i ) {
        if ( $pub_id == $arr_letter[$i][0] ) { next; }
        $pub_id = $arr_letter[$i][0];

        $fl_to =
q[<img src='/sp/img/msg_announcement_new.gif' title=' - ' width='21' height='14'>];
        $fl_class    = 'sel';
        $fl_ot_title = '';

        if ( defined $arr_letter[$i][1] ) {
            $user_name_sub = human_hash( $arr_letter[$i][1] );
            $user_name_sub =
              $user_name_sub eq '' ? ' <b>-</b>' : $user_name_sub;
        }
        else {
            $user_name_sub = ' <b>-</b>';
        }

        $arr_letter[$i][3] = totime( $arr_letter[$i][3] );
        $arr_letter[$i][4] = totime( $arr_letter[$i][4] ) + 86399;

        if ( defined( $arr_letter[$i][6] ) and $arr_letter[$i][6] > 100 ) {
            $fl_ot_title = ' ' . todate( $arr_letter[$i][6] );
            $fl_to =
q[<img src='/sp/img/msg_announcement_r.gif' title='' width='21' height='14'>];
            $fl_class = '';
        }
        elsif ( $arr_letter[$i][3] > time() and $arr_letter[$i][4] > time() ) {
            $fl_ot_title = '';
            $fl_to =
q[<img src='/sp/img/msg_announcement_new.gif' title='' width='21' height='14'>];
            $fl_class = '';
        }
        elsif ( $arr_letter[$i][3] < time() and $arr_letter[$i][4] < time() ) {
            $fl_ot_title = '';
            $fl_to =
q[<img src='/sp/img/msg_announcement_new.gif' title='' width='21' height='14'>];
            $fl_class = '';
        }

        my ( undef, undef, undef, $d, $m, $y, undef, undef, undef ) =
          localtime( $arr_letter[$i][3] );
        $y += 1900;
        $arr_letter[$i][3] = "$d " . $mnths[$m] . " $y";
        ( undef, undef, undef, $d, $m, $y, undef, undef, undef ) =
          localtime( $arr_letter[$i][4] );
        $y += 1900;
        $arr_letter[$i][4] = "$d " . $mnths[$m] . " $y";

        if ($DEBUG) {
            $arr_letter[$i][2] =
              "ID " . $arr_letter[$i][0] . "; " . $arr_letter[$i][2];
        }
        $temp .= tpl_str(
            './tpl/msg/heading_tr.html',
            {
                lf_ch => ( $guid == $arr_letter[$i][1] or isadmin() )
                ? qq[<input type="checkbox" name="ID" value="$arr_letter[$i][0]">]
                : "&nbsp;",
                fl_class => $fl_class,
                fl_to =>
                  "<a href='msg.pl?act=announcement&id=$arr_letter[$i][0]'>"
                  . $fl_to . "</a>"
                  . (
                    ( $guid == $arr_letter[$i][1] or isadmin() )
                    ? " <a href='msg.pl?act=pub&id=$arr_letter[$i][0]'><img src='/sp/img/msg_announcement_edit.gif' title='' width='20' height='15' border='0'></a>&nbsp;<a href='msg.pl?act=pub_stat&id=$arr_letter[$i][0]'><img src='/sp/img/msg_smal_stat.gif' title='  ' width='16' height='16'></a>"
                    : ""
                  ),
                fl_ot =>
                  "<a href='msg.pl?act=announcement&id=$arr_letter[$i][0]'>"
                  . $user_name_sub . "</a>",
                fl_ot_title => $fl_ot_title,
                fl_tema =>
qq{<a href="msg.pl?act=announcement&id=$arr_letter[$i][0]">$arr_letter[$i][2]</a>},
                fl_date => $arr_letter[$i][3]
                  . "</td><td>"
                  . $arr_letter[$i][4],
            }
        );

        if ( $guid == $arr_letter[$i][1] ) { $my_stat_del = 1; }
    }

    $temp .= qq [</table></div>];

    if ( @arr_letter < 1 ) {
        $temp .=
qq [<div align='center' style="border-bottom: 1px dotted #2F4F4F;padding: 5px 50px 5px 0px;" colspan='6'>  </div>];
    }
    elsif ( $my_stat_del or isadmin() ) {
        $temp .=
qq [<div style="padding: 5px 50px 2px 8px;" colspan='6'>&nbsp;<input type="submit" name="Submit" value=""></div>];
    }

    $temp .= qq [</form>
<script type="text/javascript" language="JavaScript">
<!--
var ie;
var agt = navigator.userAgent.toLowerCase();
if (document.all&&(agt.indexOf('msie')!=-1)) {
  ie=false;
  if (agt.indexOf('msie 4')==-1) {ie=true;}
}
if (ie) {e("TableWidthForIE").style.width = "97%";}
-->
</script>];

    return $temp;
}

sub pub_stat() {
    my (
        $q,         $id,   $teyp, @result,     @pup_arr,
        $SQL1,      $SQL2, $SQL3, @names_hash, @gid_ref,
        %read_hash, $i,    $j
    );
    $id   = param('id');
    $teyp = param('teyp');

    sec_gteq0($id);

    my @DateBegin = sqlfcms(
        "SELECT 1, date_begin FROM msg_public_text WHERE "
          . ( !isadmin() ? "author_id = $guid AND " : "" )
          . "id = $id",
        { ib_timestampformat => '%d.%m.%Y' }
    );
    !( $DateBegin[0] ) and redir('announcement&mesg=ban');

    $q = sqlpcms(
"SELECT type_g, gid FROM msg_public_send WHERE PUB_ID = $id ORDER BY type_g, gid"
    );

    while ( @result = $q->fetchrow_array() ) {
        if ( $result[0] == 1 ) {
            $SQL1 .= length($SQL1) > 2 ? " OR " : "";
            $SQL1 .= "gid = " . $result[1];
        }
        elsif ( $result[0] == 3 ) {
            $SQL2 .= length($SQL2) > 2 ? " OR " : "";
            $SQL2 .= "sys_matrix.class = " . $result[1];
        }
        elsif ( $result[0] == 2 ) {
            $SQL3 .= length($SQL3) > 2 ? " OR " : "";
            $SQL3 .= "sys_matrix.paralel = " . $result[1];
        }
    }

    $q = sqlpcms("SELECT uid,status FROM msg_public_read WHERE p_id = $id");
    while ( @result = $q->fetchrow_array() ) {
        $read_hash{ $result[0] } = $result[1];
    }

    $i = 0;
    if ( $SQL1 ne "" ) {
        $q = sqlp(
"SELECT sp_users.uid, human.last_name ||' '|| human.first_name ||' '|| human.middle_name, gid
        FROM sp_users,human WHERE human.human_id = sp_users.uid AND ($SQL1)"
        );
        while ( @result = $q->fetchrow_array() ) {
            $names_hash[$i][0] = $result[0];
            $names_hash[$i][1] = $result[1];
            $names_hash[$i][2] = $result[2];
            $names_hash[$i][3] = 0;
            $i++;
        }
    }

    if ( $SQL2 ne "" ) {
        $q = sqlp(
            "SELECT cast (sys_matrix.vw_pupil as integer),
       human.last_name ||' '|| human.first_name ||' '|| human.middle_name,
       paralel ||' '||(SELECT name FROM class WHERE sys_matrix.class = class.class_id)
       FROM sys_matrix,human
       WHERE human.human_id = sys_matrix.vw_pupil AND sys_matrix.view_class = 1
       AND ($SQL2)
       AND EXISTS (SELECT 1 FROM get_node_saldo (sys_matrix.node_id, '$gdate', 0)
           WHERE saldo_sum <> 0)"
        );
        while ( @result = $q->fetchrow_array() ) {
            $names_hash[$i][0] = $result[0];
            $names_hash[$i][1] = $result[1];
            $names_hash[$i][2] = 4;
            $result[2] =~ s/^(\d+\s{0,}".+").+/$1/;
            $names_hash[$i][3] = $result[2];
            $i++;
        }
    }

    if ( $SQL3 ne "" ) {
        $q = sqlp(
            "SELECT sys_matrix.vw_pupil,
       human.last_name ||' '|| human.first_name ||' '|| human.middle_name,
       paralel ||' '||(SELECT name FROM class WHERE sys_matrix.class = class.class_id)
       FROM sys_matrix, human where
       human.human_id = sys_matrix.vw_pupil AND
       sys_matrix.view_class = 1
       AND ($SQL3)
       AND (
         EXISTS (SELECT 1 FROM get_node_saldo (sys_matrix.node_id, 'NOW', 0) WHERE saldo_sum <> 0)
         OR
         EXISTS (SELECT 1 FROM get_node_saldo (sys_matrix.node_id, '$DateBegin[1]', 0) WHERE saldo_sum <> 0)
       )"
        );
        while ( @result = $q->fetchrow_array() ) {
            $names_hash[$i][0] = $result[0];
            $names_hash[$i][1] = $result[1];
            $names_hash[$i][2] = 4;
            $result[2] =~ s/^(\d+\s{0,}".+").+/$1/;
            $names_hash[$i][3] = $result[2];
            $i++;
        }
    }

    $q = sqlp(
        'SELECT gid, name FROM sp_gid_ref WHERE EXISTS
   (SELECT 1 FROM sp_users WHERE sp_users.gid = sp_gid_ref.gid) ORDER BY gid'
    );
    while ( @result = $q->fetchrow_array() ) {
        $gid_ref[ $result[0] ] = $result[1];
    }

    my @sel;
    undef(@sel);
    $sel[$teyp] = 'selected';
    my $body_txt1 = qq[<div style="padding: 8px 15px 2px 15px;">
  <div align="center">
  <table border="0" align="center" class="debug" cellspacing="0" cellpadding="8"><tr align="center">
  <form method="get" name="filter">
    <input type="hidden" name="act" value="pub_stat">
    <input type="hidden" name="id" value="$id">
    <tr><th class=debug> </th><tr>
    <tr><td><select name="teyp" onchange="document.filter.submit();">
    <option value="0" $sel[0]> </option>
    <option value="1" $sel[1]></option>
    <option value="2" $sel[2]> </option>
    <option value="3" $sel[3]> </option>
  </select></td><tr>
  </tr></form></table>
  </div>];

    $body_txt = qq[
  <table border="0" cellspacing=0 cellpadding=10 align="center"><tr><td align="center">];

    @names_hash =
      sort { $a->[2] <=> $b->[2] || $a->[1] <=> $a->[1] } @names_hash;

    my (
        $PrifCount,    $PrifCountTwo, $temp,       $grp_th,
        $class_th,     $stats,        $count_name, $count_read,
        @arr_stat_def, $proc,         $body_ful,   $min,
        $hour,         $mday,         $mon,        $year,
        $wday,         $datetime
    );

    $PrifCount = 0;
    $grp_th = $class_th = -1;
    my $numNH = scalar @names_hash;
    for ( my $i = 0 ; $i < $numNH ; $i++ ) {
        $datetime = '';
        if ( $read_hash{ $names_hash[$i][0] } > 100 ) {
            ( undef, $min, $hour, $mday, $mon, $year, $wday, undef, undef ) =
              localtime $read_hash{ $names_hash[$i][0] };
            $datetime =
                "$mday $mnths[$mon] "
              . ( $year + 1900 ) . " , "
              . sprintf( "%02d:%02d", $hour, $min );
        }

        if ( $grp_th != $names_hash[$i][2] and $teyp != 0 ) {
            $PrifCount = 0;
            if ( $i != 0 ) {
                $body_txt .=
qq[<tr><td colspan=2 style="background-color: #ededed;padding: 3px 6px 3px 6px;" nowrap>  : <b>$count_name</b>    <b>$count_read</b> (<b>]
                  . sprintf( "%.2f", ( ($count_read) * 100 ) / ($count_name) )
                  . qq[%</b>)</td></tr>];
                $body_txt .= qq[</table><br>];
            }
            $body_txt .=
qq[<table border="0" width="100%" class="debug" cellspacing=0 cellpadding=2 align="center"><tr>
       <th class=debug colspan=2>$gid_ref[$names_hash[$i][2]]</th></tr><tr>
       <td class='def table_separator'><b>&nbsp;&nbsp;</b></td><td class='def table_separator'><b>&nbsp;&nbsp;</b></td></tr>];
        }

        if (    $class_th ne $names_hash[$i][3]
            and $names_hash[$i][2] == 4
            and $teyp != 0 )
        {
            $PrifCount = 0;
            $temp =
qq[<tr><td class='table_separator' colspan=2 style="border-top: 1px solid #99A4B0;"><b>$names_hash[$i][3]</b></td></tr>];
        }

        if ( $grp_th != $names_hash[$i][2] ) {
            $count_name = $count_read = 0;
        }
        $count_name++;
        $count_read += ( $read_hash{ $names_hash[$i][0] } > 100 ? 1 : 0 );

        if ( $PrifCountTwo ne $temp ) {
            $body_txt .= $PrifCountTwo = $temp;
        }
        if ( ( $teyp == 2 or $teyp == 1 ) && $PrifCount < 1 && $i < $numNH ) {
            if (
                (
                    $names_hash[$i][2] != $names_hash[ $i + 1 ][2]
                    && (
                        (
                            $teyp == 2
                            && ( $read_hash{ $names_hash[$i][0] } > 100 )
                        )
                        || ( $teyp == 1
                            && !( $read_hash{ $names_hash[$i][0] } > 100 ) )
                    )
                    && $names_hash[$i][3] == 0
                )
                or (   $names_hash[$i][2] == 4
                    && $names_hash[$i][3] ne $names_hash[ $i + 1 ][3] )
              )
            {
                $body_txt .=
qq[<tr><td colspan=2 align="center"><i>    </i></td></tr>];
                $PrifCountTwo = $PrifCount = 0;
            }
        }
        $grp_th   = $names_hash[$i][2];
        $class_th = $names_hash[$i][3];

        if ( $teyp == 2 and !( $read_hash{ $names_hash[$i][0] } > 100 ) ) {
            $PrifCount++;
            $body_txt .= tpl_str(
                './tpl/msg/pub_stat.html',
                {
                    name => "<font color='"
                      . (
                        $read_hash{ $names_hash[$i][0] } > 100
                        ? "#009900' title=''"
                        : "#000000"
                      )
                      . "'>"
                      . $names_hash[$i][1]
                      . "</font>",
                    read_p => $datetime,
                }
            );
        }

        elsif ( $teyp == 1 and ( $read_hash{ $names_hash[$i][0] } > 100 ) ) {
            $PrifCount++;
            $body_txt .= tpl_str(
                './tpl/msg/pub_stat.html',
                {
                    name => "<font color='"
                      . (
                        $read_hash{ $names_hash[$i][0] } > 100
                        ? "#009900' title=''"
                        : "#000000"
                      )
                      . "'>"
                      . $names_hash[$i][1]
                      . "</font>",
                    read_p => $datetime,
                }
            );
        }

        elsif ( $teyp == 3 ) {
            $body_txt .= tpl_str(
                './tpl/msg/pub_stat.html',
                {
                    name => "<font color='"
                      . (
                        $read_hash{ $names_hash[$i][0] } > 100
                        ? "#009900' title=''"
                        : "#000000"
                      )
                      . "'>"
                      . $names_hash[$i][1]
                      . "</font>",
                    read_p => $datetime,
                }
            );
        }

        else {
            $arr_stat_def[ $names_hash[$i][2] ][0] = $count_name;
            $arr_stat_def[ $names_hash[$i][2] ][1] = $count_read;
        }
    }

    if ( $teyp != 0 and ( scalar @names_hash > 1 ) ) {
        $body_txt .=
qq[<tr><td colspan="2" align="center" style="background-color: #ededed;padding: 3px 6px 3px 6px;" nowrap>  : <b>$count_name</b>    <b>$count_read</b> (<b> ];
        $body_txt .=
          $count_name
          ? sprintf( "%.2f", ( ($count_read) * 100 ) / ($count_name) )
          : 0;
        $body_txt .= qq[%</b>)</td></tr></table></td></tr></table>];
        $body_ful .=
            qq[<div align=center> : <b>]
          . ( scalar @names_hash )
          . qq[</b>    <b>]
          . ( scalar keys %read_hash )
          . qq[</b> (<b>]
          . sprintf( "%.2f",
            ( ( scalar keys %read_hash ) * 100 ) / ( scalar @names_hash ) )
          . qq[%</b>).</div>];
    }
    else {
        $body_txt .=
qq[</table><table class="debug nw" align=center width="50%" border="0" cellspacing="0" cellpadding="4">
  <tr>
    <th scope="col">&nbsp;</th>
    <th scope="col"></th>
    <th scope="col">&nbsp;</th>
  </tr>];

        $i = $j = 0;
        for (@gid_ref) {
            if ( $gid_ref[$i] ne "" and $arr_stat_def[$i][0] ) {
                $proc = sprintf( "%.2f",
                    ( ( $arr_stat_def[$i][1] ) * 100 ) /
                      ( $arr_stat_def[$i][0] ) );
                $body_txt .= "<tr>
         <td scope='row'><b>$gid_ref[$i]</b></th>
         <td align='center'>$arr_stat_def[$i][1] (" . $proc . " %)</td>
         <td align='center'>$arr_stat_def[$i][0] ("
                  . ( 100 - $proc )
                  . " %)</td></tr>";
                $j++;
            }
            $i++;
        }

        if ( $j < 1 ) {
            $body_txt .=
              "<tr><td align='center' colspan='3'>&nbsp;</td></tr>";
        }
        $body_txt .= qq[</table>];
    }

    msg_desktop( '', '', $body_txt1 . $body_ful . $body_txt );
}

sub msg_stat() {
    !isadmin() and redir('&mesg=ban');
    my (
        $q,         $teyp,          @result,   $body,
        $body_ful,  $date_begin,    $date_end, %gid_ref,
        $msg_count, $msg_all_count, %msg_count_g
    );
    $msg_count = 0;
    $teyp      = param('teyp');
    $body      = '';
    my $reverse_checked = param('reverse') || 1;

    $date_begin = param('date_begin') || todate( time() - 604800 );
    $date_end   = param('date_end')   || todate( time() );

    $date_begin =~ s/[^0-9*.]//gi;
    $date_end   =~ s/[^0-9*.]//gi;
    sex_date( $date_begin, $date_end );

    my ( $d,  $m,  $y )  = split( /\./, $date_begin );
    my ( $d2, $m2, $y2 ) = split( /\./, $date_end );

    if ( $y2 . $m2 . $d2 < $y . $m . $d ) {
        stop('     ');
    }

    $q = sqlp(
        'SELECT gid, name FROM sp_gid_ref WHERE EXISTS
  (SELECT 1 FROM sp_users WHERE sp_users.gid = sp_gid_ref.gid) ORDER BY gid'
    );
    my $gid_ref_c = 1;
    while ( @result = $q->fetchrow_array() ) {
        $gid_ref{ $result[0] } = $result[1];
        if ( $result[0] ) { $gid_ref_c++; }
    }
    $gid_ref{-1} = ' ';

    my $gid_ref_temp = $gid_ref_c + 1;
    $body .=
qq[<table border="0" align="center" class="debug" cellpadding="0" cellspacing="0">
  <tr>
    <th colspan="$gid_ref_temp"> </th>
  </tr>];

    $q = sqlpcms(
"SELECT date_m, type_g, c FROM msg_stat WHERE DATE_M BETWEEN '$date_begin' AND '$date_end' ORDER BY date_m, type_g",
        { ib_timestampformat => "%Y.%m.%d" }
    );

    my %arr_stat_def;
    while ( @result = $q->fetchrow_array() ) {
        push @{ $arr_stat_def{"$result[0]"} }, [ $result[1], $result[2] ];
        $msg_count += $result[2];

        $msg_count_g{ $result[1] } += $result[2];
    }

    my $tmp_date;
    if ( $reverse_checked == 1 ) {
        for ( reverse sort keys %arr_stat_def ) {
            $_ =~ m/^(.*)\.(.*)\.(.*)$/;
            $tmp_date = "$3.$2.$1";
            $body .=
"<tr><td colspan='3'><div class='button_nav'><div style='color:green;padding: 1px 6px 1px 6px;'><b>$tmp_date</b></div></div></td><tr>";
            for my $i ( @{ $arr_stat_def{$_} } ) {
                $body .=
"<tr><td style='padding: 0px 0px 0px 60px;'>&nbsp;</td><td>$gid_ref{$i->[0]}</td><td class='pt'>$i->[1]</td></tr>";
            }
        }
    }
    else {
        for ( sort keys %arr_stat_def ) {
            $_ =~ m/^(.*)\.(.*)\.(.*)$/;
            $tmp_date = "$3.$2.$1";
            $body .=
"<tr><td colspan='3'><div style='padding: 0px 0px 0px 6px;' class='button_nav'><div style='color:green;padding: 1px 6px 1px 6px;'><b>$tmp_date</b></div></div></td><tr>";
            for my $i ( @{ $arr_stat_def{$_} } ) {
                $body .=
"<tr><td style='padding: 0px 0px 0px 60px;'>&nbsp;</td><td>$gid_ref{$i->[0]}</td><td class='pt'>$i->[1]</td></tr>";
            }
        }
    }

    $msg_all_count = sqlffcms(
"select gen_id(gen_msg_message_text_id, 0) as gen_msg_message_text_id from dual"
    );

    my $body2 .=
qq[<br><table border="0" align="center" class="debug" cellpadding="0" cellspacing="0">
  <tr>
    <th colspan="2">  </th>
  </tr>];
    for ( sort keys %msg_count_g ) {
        $body2 .=
qq[<tr><td style='padding: 0px 0px 0px 6px;'>$gid_ref{$_}</td><td class='pt'>$msg_count_g{$_}<td></tr>];
    }
    $body2 .=
qq[<tr><td style='padding: 0px 0px 0px 6px;' class='button_nav'><b>:</b></td><td class='button_nav pt'>$msg_count<td></tr>];
    $body2 .= qq[</table>];

    $body_ful .= tpl_str(
        './tpl/msg/stat.html',
        {
            act           => $act,
            sact          => $sact,
            title         => '',
            date_begin    => $date_begin,
            date_end      => $date_end,
            body_block    => $body . "</table>" . $body2,
            js_function   => '',
            msg_count     => $msg_count,
            msg_all_count => $msg_all_count,
            reverse_checked =>
              ( $reverse_checked == 0 ? '' : 'checked="checked"' ),
        }
    );

    msg_desktop( "", "", $body_ful . "<br>" );
}

sub msg_send_act() {
    if ( $ENV{"REQUEST_METHOD"} ne 'POST' ) { redir( $sact . '&mesg=ban' ); }

    my ($new_id_credit);
    my $subject = param("subject");
    my $message = param("message");
    my $send    = param("send");
    my $error   = '';
    if ( length($subject) < 1 ) { $error .= 's'; }
    if ( length($message) < 3 ) { $error .= 'm'; }
    if ( length($send) < 2 )    { $error .= 'u'; }

    my $save_send = defined( param('save_send') ) ? 1 : 3;

    my $date_send = 'NOW';

    if ( $error eq '' ) {
        $subject =~ s/&/&amp;/g;
        $subject =~ s/</&lt;/g;
        $subject =~ s/>/&gt;/g;
        $subject =~ s/'/&ldquo;/g;
        $subject =~ s/"/&quot;/g;
        $subject = substr( $subject, 0, 127 );
        $message =~ s/&/&amp;/g;
        $message =~ s/</&lt;/g;
        $message =~ s/>/&gt;/g;
        $message =~ s/'/&ldquo;/g;
        $message =~ s/"/&quot;/g;

        my ( @black_list, @result );
        my $q = sqlpcms(
            "SELECT uid FROM msg_address_book WHERE fav = $guid AND s = -1");
        while ( @result = $q->fetchrow_array() ) {
            push @black_list, @result;
        }

        $new_id_credit =
          sqlffcms('SELECT gen_id(gen_msg_message_text_id, 1) FROM dual');

        my $i = 0;
        for my $send_st ( split /,/, $send ) {
            next if grep( /^\Q$send_st\E$/, @black_list );
            if ( $send_st ne '' ) {
                sec_gt0($send_st);
                sqlcms(
"INSERT INTO msg_send (msg_id,u_id) VALUES ($new_id_credit,$send_st)"
                );

                my $tmp_user = sqlff(
"SELECT f_int FROM sp_user_settings WHERE uid='$send_st' AND id=2"
                );
                if ( defined $tmp_user ) {
                    my $sender = new Mail::Sender {
                        smtp      => $gconf{'smtp'},
                        from      => 'xxibasequery@' . $ENV{'SERVER_NAME'},
                        fake_from => "SP-MSG at "
                          . $ENV{'SERVER_NAME'}
                          . ' <xxibasequery@'
                          . $ENV{'SERVER_NAME'} . '>',
                        priority => 1,
                        charset  => 'Windows-1251'
                    };

                    my $mail_to = $tmp_user;
                    if ($DEBUG) { $mail_to = 'root@x01.okt.lan'; }

                    my @fio;
                    fio( \@fio );
                    my $fio = "$fio[0] $fio[1] $fio[2]";
                    if ( $ggid == 4 ) { $fio .= get_pupil_class(1); }

                    $sender->MailMsg(
                        {
                            to      => $mail_to,
                            subject => 'Message for SP Support',
                            msg =>
qq[http://$ENV{'SERVER_NAME'}$gconf{'msg'}?act=read&id=$new_id_credit\n: $fio (uid = $guid, gid = $ggid)\n: $subject\n\n:\n----------\n$message],
                            replyto =>
"Robot, Don't reply. <dev-null\@$ENV{'SERVER_NAME'}>"
                        }
                    );
                }

                if ( $send_st == $guid ) {
                    $save_send = 3;
                } $i++;
            }
        }

        if ( $i >= 1 ) {
            $q = $gdbcms->prepare(
qq{INSERT INTO msg_message_text (id,author_id,date_sent,cmd_i,subject,message_text) VALUES (?, ?, ?, ?, ?, ?)}
            ) or db_error();
            $q->execute( $new_id_credit, $guid, $date_send, $save_send,
                $subject, $message )
              or db_error();
        }

        my $NOW = todate(time);

        my @q = sqlfcms(
            "SELECT c FROM msg_stat WHERE date_m='$NOW' AND type_g = $ggid");

        if ( $q[0] ) {
            sqlcms(
"UPDATE msg_stat SET c=c+1 WHERE date_m='$NOW' AND type_g = $ggid"
            );
        }
        else {
            sqlcms(
                "INSERT INTO msg_stat (c,type_g,date_m) VALUES (1,$ggid,'$NOW')"
            );
        }

        redir("inbox&mesg=send_ok");
    }
    else {
        msg_desktop( '', $error );
    }
}

sub pub_send_act($) {
    if ( $ENV{"REQUEST_METHOD"} ne 'POST' ) { redir( $sact . '&mesg=ban' ); }
    my $edit = shift;

    my ( $q, $error, $new_id_credit, %pup_hash, $edit_noRead, $author_id,
        $author_edit );

    my $id = param('id');
    $edit = $edit == 1 ? 1 : 0;

    if ($edit) {
        sec_gteq0($id);

        $author_id =
          sqlffcms( "SELECT author_id FROM msg_public_text WHERE "
              . ( $ggid >= 1 ? "author_id = $guid AND " : '' )
              . "id = $id" );
        if ( $ggid >= 1 ) {
            $author_id < 1 and redir('announcement&mesg=ban');
        }
    }
    $edit_noRead = param('noRead') eq '1' ? 1 : 0;

    my $subject    = param("subject");
    my $message    = param("message");
    my $selGrp     = param("selGrp_v");
    my $selParalel = param("selParalel_v");
    my $selClass   = param("selClass_v");

    my $date_begin = param("date_begin");
    my $date_end   = param("date_end");

    sec_date($date_begin);
    sec_date($date_end);

    my ( $d,  $m,  $y )  = split( /\./, $date_begin );
    my ( $d2, $m2, $y2 ) = split( /\./, $date_end );

    if ( $y2 . $m2 . $d2 < $y . $m . $d ) {
        stop('       '
        );
    }

    unless ( $ggid == 0 ) {
        my $t_date =
          (   ( (localtime)[5] + 1900 )
            . ( length( (localtime)[4] + 1 ) == 1 ? "0" : "" )
              . (localtime)[4] + 1
              . ( length( (localtime)[3] ) == 1 ? "0" : "" )
              . (localtime)[3] );
        if ( $y2 . $m2 . $d2 < $t_date
            or ( $edit ? 0 : ( $y . $m . $d < $t_date ) ) )
        {
            stop(
'        '
            );
        }

        my $max_time_end = sqlff(
            "select max(time_end) from sp_periods where id = "
              . (
                sqlff(
                    "select F_INT from SP_SETTINGS where NAME = 'periods_mode'")
                ? '4'
                : '7'
              )
        );

        my ( undef, undef, undef, $d2, $m2, $y2, undef, undef, undef ) =
          localtime $max_time_end;
        $y2 += 1900;
        $m2++;
        $max_time_end = sprintf "%04d%02d%02d", $y2, $m2, $d2;

        if ( $y2 . $m2 . $d2 > $max_time_end and $y . $m . $d < $max_time_end )
        {
            stop(
"          "
            );
        }
    }

    $date_end = $date_end . " 23:59:59";

    if ( $ggid == 4 ) { $selGrp = $selParalel = '';
    }

    if ( length($subject) < 1 )                            { $error .= 's'; }
    if ( length($message) < 3 )                            { $error .= 'm'; }
    if ( length( $selGrp . $selParalel . $selClass ) < 1 ) { $error .= 'u'; }

    my ( $sec, $min, $hour, $mday, $mon, $year, $wday, undef, undef ) =
      localtime;
    my $date_send = $gdate;

    if ( $error eq '' ) {
        $subject =~ s/&/&amp;/g;
        $subject =~ s/</&lt;/g;
        $subject =~ s/>/&gt;/g;
        $subject =~ s/'/&ldquo;/g;
        $subject =~ s/"/&quot;/g;
        $subject = substr( $subject, 0, 127 );
        strip_tag( \$message, 'html' );

        $new_id_credit =
            $edit
          ? $id
          : sqlffcms('SELECT gen_id(gen_msg_public_text_id, 1) FROM dual');

        $edit
          and sqlpcms( "DELETE FROM msg_public_send WHERE pub_id = " . $id );

        my $pupels = 1;
        my $selGrp_st;

        for $selGrp_st ( split /,/, $selGrp ) {
            if ( $selGrp_st ne '' ) {
                sqlcms(
                    "INSERT INTO msg_public_send (pub_id,type_g,gid)
          VALUES ($new_id_credit,1,$selGrp_st)"
                );
            }
            if ( $selGrp_st == 4 ) {
                $pupels = 0;
            };
        }

        if ( $pupels == 1 ) {
            for my $selParalel_st ( split /,/, $selParalel ) {
                if ( $selParalel_st ne '' ) {
                    sqlcms(
                        "INSERT INTO msg_public_send (pub_id,type_g,gid)
            VALUES ($new_id_credit,2,$selParalel_st)"
                    );
                }
                $q = sqlp(
"select cast(class AS integer) from sys_matrix where view_class = 7 and paralel = $selParalel_st
          and exists (select 1 from get_node_saldo (sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0)"
                );
                while ( my @result = $q->fetchrow_array() ) {
                    $pup_hash{ $result[0] } = $selParalel_st;
                }
            }

            for my $selClass_st ( split /,/, $selClass ) {
                if ( $selClass_st ne '' and $pup_hash{$selClass_st} < 1 ) {
                    sqlcms(
                        "INSERT INTO msg_public_send (pub_id,type_g,gid)
            VALUES ($new_id_credit,3,$selClass_st)"
                    );
                }
            }
        }

        $edit and sqlpcms( "DELETE FROM msg_public_text WHERE id = " . $id );

        if ( $edit and $guid != $author_id ) {
            $q = $gdbcms->prepare(
qq[INSERT INTO msg_public_text (id,author_id,date_begin,date_end,stat,subject,message_text,author_edit) VALUES (?, ?, ?, ?, ?, ?, ?, ?)]
            ) or db_error();
            $q->execute( $new_id_credit, $author_id, $date_begin, $date_end, 0,
                $subject, $message, $guid )
              or db_error();
        }
        else {
            $q = $gdbcms->prepare(
qq[INSERT INTO msg_public_text (id,author_id,date_begin,date_end,stat,subject,message_text) VALUES (?, ?, ?, ?, ?, ?, ?)]
            ) or db_error();
            $q->execute( $new_id_credit, $guid, $date_begin, $date_end, 0,
                $subject, $message )
              or db_error();
        }

        $edit_noRead
          and sqlpcms( "DELETE FROM msg_public_read WHERE p_id = " . $id );

        redir( 'announcement&mesg=pub_' . ( $edit ? 'edit' : 'ok' ) );
    }
    else {
        msg_desktop( '', $error );
    }

}

sub address_book {
    my $type = shift || 0;
    my ( $print, $q, @result, @addr_letter, $temp, %gid_ref, $i );

    $q = sqlpcms(
        "SELECT id, fav, s FROM msg_address_book WHERE uid = $guid AND (s "
          . ( $type == 1 ? "= -1" : "> 0 OR s is NULL" ) . ")",
        { ib_timestampformat => "%d.%m.%Y" }
    );

    while ( @result = $q->fetchrow_array() ) {
        if ( $result[1] > 0 ) {
            not defined( $result[2] ) and $result[2] = 0;
            push @addr_letter, [ @result, human_hash( $result[1] ) ];
        }
    }

    @addr_letter =
      sort { $b->[2] <=> $a->[2] || $a->[3] cmp $b->[3] } @addr_letter;

    $print =
q[<table width="100%" id="TableWidthForIE" class="tabl_msg" cellspacing="0" cellpadding="0">
<form method="get" name="fdel" onsubmit='this.Submit.disabled = true;'>
<input type='hidden' name="act" value="new_msg" id="act">
  <tr class="underline">
    <td width="21" class="title"><input type="checkbox" name="allbox" value="1" title=" " onclick="CheckAll('fdel');"></td>
    <td class="title"></td>
  </tr>];

    for ( $i = 0 ; $i < @addr_letter ; ++$i ) {
        $print .= tpl_str(
            './tpl/msg/address_book.html',
            {
                lf_ch =>
qq[<input type="checkbox" name="ID" value="$addr_letter[$i][0]">],
                fl_st       => '',
                fl_nm_title => " ",
                fl_nm =>
qq{<a href="msg.pl?act=new_msg&sact=sent&ID=$addr_letter[$i][0]">$addr_letter[$i][3]</a>},
            }
        );
    }

    $print .= q[</table>
<script type="text/javascript" language="JavaScript">
function selsact(vl)
{
   e('sel_submit').value =  e('sel_'+vl).innerHTML;
   e('act').value = (vl == "sent") ? "new_msg" : "address_book_act";
}

var ie;
var agt = navigator.userAgent.toLowerCase();
if (document.all&&(agt.indexOf('msie')!=-1)) {
  ie=false;
  if (agt.indexOf('msie 4')==-1) {ie=true;}
}
if(ie){e("TableWidthForIE").style.width="97%";}
</script></div>];

    if ( $i == 0 ) {
        $print .=
qq[<div align='center' style="border-bottom: 1px dotted #2F4F4F;padding: 5px 50px 5px 0px;" colspan='3'>]
          . ( $type ? '  ' : '  ' )
          . q[</div>];
    }
    else {
        if ( $type == 1 ) {
            $print .=
qq[&nbsp;<input type="submit" name="submit" value=""><input type="hidden" name="ssact" value="$type"><input type="hidden" name="sact" value="del">];
            $print .=
q[<script type="text/javascript" language="JavaScript">e('act').value = "address_book_act";</script>];
        }
        else {
            $print .= q[<div style="padding: 5px 50px 2px 8px;" colspan="3">
  <select name="sact" onChange="selsact( e('sel_sact').value );" id="sel_sact">
    <option value="sent" id="sel_sent"> </option>
    <option value="del" id="sel_del"></option>
  </select>
  <input type="submit" name="submit" value=" " id="sel_submit"></div>];
        }
    }

    $print .= qq [</form>];

    return $print;
}

sub address_book_act() {
    if ( $ENV{"REQUEST_METHOD"} ne 'GET' ) { redir( $sact . '&mesg=ban' ); }
    $sact = param("sact") || '';
    my $ssact = param("ssact");

    if ( defined( param('id') ) or $sact eq 'single' ) {
        redir('inbox&mesg=ban');
    }

    my @a = split /&/, $ENV{"QUERY_STRING"};
    my ( $p, $v, $i, $SQL, $q, $uid_send, @result );
    $i = 0;
    for (@a) {
        ( $p, $v ) = split /=/;
        if ( $p eq 'ID' and $v =~ m/^\d+$/ ) {
            if ( $i > 0 ) { $SQL .= ' OR '; }
            $SQL .= "id = $v";
            $i++;
        }
    }

    if ($i) {
        if ( $sact eq "del" ) {
            sqlpcms(
                "DELETE FROM msg_address_book WHERE uid = $guid AND ( $SQL )");
        }
        else {
            $q = sqlpcms(
"SELECT fav FROM msg_address_book WHERE uid = $guid AND ( $SQL )"
            );
            while ( @result = $q->fetchrow_array() ) {
                $uid_send .= qq{$result[0],};
            }
        }
    }

    if ( defined($ssact) && $ssact == 1 ) {
        redir('address_black&mesg=favdel');
    }
    elsif ( $sact eq "del" ) {
        redir('address_book&mesg=favdel');
    }
    else {
        return $uid_send;
    }
}

sub address_black_list_act() {
    my $id = param("id");
    sec_gteq0($id);

    my @q = sqlfcms(
        "SELECT msg_message_text.author_id
     FROM msg_message_text, msg_send WHERE msg_message_text.id = msg_send.msg_id
     AND msg_message_text.id = $id AND msg_send.u_id = $guid"
    );

    if ( $q[0] < 0 ) {
        stop("  .     .");
    }

    if ( $q[0] ) {
        if ( $q[0] == $guid ) {
            stop('      ');
        }

        if (
            !sqlffcms(
"SELECT 1 FROM msg_address_book WHERE s = -1 AND uid = $guid AND fav = "
                  . $q[0]
            )
          )
        {
            sqlcms(
"INSERT INTO msg_address_book (uid,fav,s) VALUES ($guid,$q[0],-1)"
            );
        }

        sqlcms( "UPDATE msg_send SET cmd_s = 2 WHERE msg_id = " 
              . $id
              . " AND u_id = "
              . $guid );

        redir('inbox&mesg=black');
    }
    else {
        redir('inbox');
    }
}

sub pub_del() {
    if ( $ENV{"REQUEST_METHOD"} ne 'GET' ) { redir( $sact . '&mesg=ban' ); }

    my @a;
    if ( defined( param('id') ) ) {
        $a[0] = "ID=" . param("id");
    }
    else {
        @a = split /&/, $ENV{"QUERY_STRING"};
    }

    my ( $p, $id, $delStat );
    for (@a) {
        ( $p, $id ) = split /=/;
        if ( $p eq 'ID' and $id =~ m/^\d+$/ ) {

            if (
                sqlfcms(
                        "SELECT 1 FROM msg_public_text WHERE "
                      . ( !isadmin() ? 'author_id = ' . $guid . ' AND ' : '' )
                      . "id = "
                      . $id
                )
              )
            { my $q =
                  sqlpcms( "DELETE FROM msg_public_text WHERE id = " . $id );
                $q = sqlpcms(
                    "DELETE FROM msg_public_send WHERE pub_id = " . $id );
                $q =
                  sqlpcms( "DELETE FROM msg_public_read WHERE p_id = " . $id );
                $delStat = "ok";
            }

        }
    }

    if ( $delStat eq "ok" ) {
        redir( 'announcement&sact=' . param('sact') . '&mesg=pubdel' );
    }
    else {
        redir('announcement');
    }
}

sub msg_del($) {
    $act  = param("act")  || '';
    $sact = param("sact") || '';
    my $id = shift;

    my @msg_str =
      sqlfcms( 'SELECT author_id, cmd_i FROM msg_message_text WHERE id = ' 
          . $id
          . ' AND author_id = '
          . $guid );
    my $inbox_mg =
      sqlffcms( 'SELECT cmd_s FROM msg_send WHERE msg_id = ' 
          . $id
          . ' AND u_id = '
          . $guid );
    not defined($inbox_mg) and redir('inbox&mesg=ban');

    if ( $msg_str[1] < 2 and $msg_str[0] == $guid ) {
        sqlcms( "UPDATE msg_message_text SET cmd_i = 2 WHERE id = " 
              . $id
              . " AND cmd_i < 2" );
        if ( $sact eq "single" ) { redir('sent&mesg=msgdel'); }
    }
    elsif ( $inbox_mg >= 0 and $inbox_mg < 2 ) {
        sqlcms( "UPDATE msg_send SET cmd_s = 2 WHERE msg_id = " 
              . $id
              . " AND u_id = "
              . $guid );
        if ( $sact eq "single" ) { redir('inbox&mesg=msgdel'); }
    }
    elsif ( $msg_str[1] >= 2 or $inbox_mg >= 2 ) {
        my $inbox_NoDel =
          sqlffcms( 'SELECT u_id FROM msg_send WHERE msg_id = ' 
              . $id
              . ' AND cmd_s < 3 AND u_id != '
              . $guid );

        if (
            $inbox_NoDel <= 1
            and sqlfcms(
                'SELECT 1 FROM msg_message_text WHERE cmd_i > 2 AND id = ' . $id
            )
          )
        {
            msg_del_sql($id);
        }
        elsif ( $msg_str[0] != $guid ) {
            sqlcms( "UPDATE msg_send SET cmd_s = 3 WHERE msg_id = " 
                  . $id
                  . " AND u_id = "
                  . $guid );
        }
        elsif ( $msg_str[0] == $guid ) {
            sqlcms( "UPDATE msg_message_text SET cmd_i = 3 WHERE id = " 
                  . $id
                  . " AND author_id = "
                  . $guid );
            if (
                sqlfcms(
                        'SELECT 1 FROM msg_send WHERE cmd_s < 3 AND msg_id = ' 
                      . $id
                      . ' AND u_id = '
                      . $guid
                )
              ) {
                sqlcms( "UPDATE msg_send SET cmd_s = 3 WHERE msg_id = " 
                      . $id
                      . " AND u_id = "
                      . $guid );
            }
        }

        if ( $sact eq "single" ) { redir('recycler&mesg=msgdel'); }
    }

    if ( $sact eq "single" ) { redir('inbox&mesg=ban'); }
}

sub msg_del_mass() {
    if ( $ENV{"REQUEST_METHOD"} ne 'GET' ) { redir( $sact . '&mesg=ban' ); }
    $act  = param("act");
    $sact = param("sact");

    if ( defined( param('id') ) or $sact eq 'single' ) {
        redir('inbox&mesg=ban');
    }

    my @a = split /&/, $ENV{"QUERY_STRING"};
    my ( $p, $v, $i );
    for (@a) {
        ( $p, $v ) = split /=/;
        if ( $p eq 'ID' and $v =~ m/^\d+$/ ) {
            msg_del($v);
            $i++;
        }
    }

    if ( $i < 1 ) {
        redir( $sact . '' );
    }
    elsif ( $sact ne "" ) {
        redir( $sact . '&mesg=msgdel' );
    }
    else {
        redir('inbox&mesg=msgdel');
    }
}

sub msg_del_sql($) {
    my $id = shift;
    my $q  = sqlpcms( "DELETE FROM msg_send WHERE msg_id = " . $id );
    $q = sqlpcms( "DELETE FROM msg_message_text WHERE id = " . $id );
}

sub msg_restore() {
    my $id = param("id");
    sec_gt0($id);

    if (
        sqlffcms(
            'SELECT 1 FROM msg_message_text WHERE cmd_i = 2 AND author_id = '
              . $guid
              . ' AND id = '
              . $id
        )
      )
    {
        sqlcms( "UPDATE msg_message_text SET cmd_i = 1 WHERE id = " . $id );
    }
    elsif (
        sqlffcms(
                'SELECT 1 FROM msg_send WHERE cmd_s = 2 AND msg_id = ' 
              . $id
              . ' AND u_id = '
              . $guid
        )
      )
    {
        sqlcms( "UPDATE msg_send SET cmd_s = 1 WHERE msg_id = " 
              . $id
              . " AND u_id = "
              . $guid );
    }
    redir("recycler&mesg=resore");
}

sub aj_newmes() {
    my $aj_print          = '';
    my $stat_announcement = stat_announcement(1);

    my $cookie_str = $stat_announcement . '_' . $stat_inbox_new;
    my $cookie = cookie('count_mag') || '';

    if ( ( $stat_inbox_new > 0 or $stat_announcement > 0 )
        and $cookie ne $cookie_str )
    {
        $aj_print .= $cookie_str;
    }
    else {
        $aj_print = '';
    }

    aj_print($aj_print);
}

sub aj_field {
    my $s = param("s");
    sec_gteq0($s);
    my $f = defined param("f") ? param("f") : 0;
    my ( @result, $q, $aj_print, $sel, @pup_arr, $SQL );

    if ( $s == 4 ) {
        $aj_print =
q[<select name="sel_class" id="sel_class" onchange="getContent('sel_grp','msg.pl?act=aj_gr&s=4&f='+e('sel_class').value);">];
        $aj_print .=
q[<option style="color:#00008B;font-style:oblique;" value="0"> </option>];
        $aj_print .= filter_class( $f, $gdate );
        $aj_print .= q[</select><br>];
    }

    if ( $s == 4 && $f > 0 ) {
        $SQL =
"cast (sys_matrix.vw_pupil as integer), human.last_name ||' '|| human.first_name ||' '|| human.middle_name
    FROM sys_matrix, human, sp_users WHERE human.human_id = sys_matrix.vw_pupil AND
    sp_users.uid = human.human_id AND
    sys_matrix.view_class = 1 AND sys_matrix.class = $f
    AND EXISTS (SELECT 1 FROM get_node_saldo (sys_matrix.node_id, '$gdate', 0) WHERE saldo_sum <> 0)";
    }
    else {
        $SQL =
"sp_users.uid, human.last_name ||' '|| human.first_name ||' '|| human.middle_name
      FROM sp_users, human WHERE sp_users.uid = human.human_id AND sp_users.gid = $s";
    }

    my $aj_print_use .=
      qq[<select name="send_select" id="send_select" onchange="send_add_i();">];
    $q = sqlp(
        "SELECT $SQL
       ORDER BY human.last_name, human.first_name, human.middle_name"
    );
    my $num_res = 0;
    while ( @result = $q->fetchrow_array() ) {
        $aj_print_use .=
          qq[<option value="$result[0]" id="$result[0]">$result[1]</option>];
        $num_res++;
    }
    $q->finish();

    $aj_print_use .=
      qq[</select> &nbsp;<dl class="plus" onClick="send_add();"></dl></button>];
    if ( !$num_res ) { $aj_print_use = ""; }
    $aj_print_use =
        $num_res
      ? $aj_print_use
      : "<b>    ,     </b>";

    $aj_print ||= '';
    aj_print( $aj_print . $aj_print_use );
}

sub aj_search() {
    my $aj_print  = '';
    my $name_find = param('name_find');

    use Text::Iconv;
    my $converter = Text::Iconv->new( "utf-8", "windows-1251" );
    $name_find = $converter->convert($name_find);

    $name_find = uc( trim($name_find) );

    $name_find =~ s/\s+/ /g;
    $name_find =~ s/\*+/*/g;

    my $name_find_tmp = $name_find;
    $name_find_tmp =~ s/[\s*]//g;
    if ( length($name_find_tmp) < 2 ) {
        aj_print('<i>     </i>');
    }

    $name_find =~ s/\*/%/g;
    if ( length($name_find) < 2 ) { aj_print('<i> </i>') }

    my ( @result, @arr_name, $q, $title, $i, $g_tmp );
    $g_tmp = '';
    $q     = sqlp(
"SELECT sp_users.uid, human.last_name ||' '|| human.first_name ||' '|| human.middle_name,
    sp_gid_ref.name, human.birth_day
    FROM sp_users, human, sp_gid_ref
    WHERE sp_users.gid = sp_gid_ref.gid AND sp_users.uid = human.human_id AND
    Upper(last_name) ||' '|| Upper(first_name) ||' '|| Upper(middle_name) LIKE \'%"
          . $name_find . "%\'
    ORDER BY sp_gid_ref.gid, human.last_name, human.first_name, human.middle_name",
        { ib_timestampformat => ";  : %Y.%m.%d" }
    );
    while ( @result = $q->fetchrow_array() ) {
        push @arr_name, [@result];
    }

    for ( $i = 0 ; $i < @arr_name ; $i++ ) {
        $title = $arr_name[$i][2];

        if ( $i != scalar(@arr_name) - 1 ) {
            if ( $arr_name[ $i + 1 ][1] eq $arr_name[$i][1] ) {
                $title .= $arr_name[$i][3];
            }
        }
        if ( $i != 0 ) {
            if ( $arr_name[ $i - 1 ][1] eq $arr_name[$i][1] ) {
                $title .= $arr_name[$i][3];
            }
        }

        if ( $g_tmp ne $arr_name[$i][2] ) {
            $g_tmp = $arr_name[$i][2];
            $aj_print .= "<b>$arr_name[$i][2]:</b><br>";
        }

        $arr_name[$i][1] =~ s!($name_find)!<span class=ajsearch>$1</span>!ig;
        $aj_print .=
qq{&nbsp;&nbsp;&nbsp;<a href="JavaScript:send_add($arr_name[$i][0])" id="$arr_name[$i][0]" title=": $title">$arr_name[$i][1]</a>};
        $aj_print .=
qq[<a href="JavaScript:address_book($arr_name[$i][0])" title="   "><dl class="fav_add_smal"></dl></a><br>];
    }
    $q->finish();
    if ( $i > 11 ) {
        $aj_print =
qq[<div style='height:15em;overflow:auto;overflow-y:scroll;'>$aj_print</div>];
    }
    $name_find =~ s/%/*/g;
    $aj_print .= $i > 0 ? "<i> $i</i>" : "<i>$name_find  </i>";

    aj_print($aj_print);
}

sub aj_address_book() {
    my $id = param('id');
    sec_gteq0($id);

    if ( $id == $guid ) { aj_print(3); }

    my @q = sqlfcms(
        "SELECT 1,s FROM msg_address_book WHERE uid = $guid AND fav = $id");

    if ( defined( $q[0] ) && $q[1] == -1 ) { aj_print(4); }

    if ( !$q[0] ) {
        sqlcms("INSERT INTO msg_address_book (uid,fav) VALUES ($guid,$id)");
    }
    aj_print( $q[0] + 1 );
}

sub stat_announcement {
    my $active = shift || 0;
    my $full   = shift || 0;
    my $id     = shift || 0;

    my $SQLp = my $SQLf = "";
    if ( $ggid == 4 ) {
        my $class_id = get_pupil_class(0);
        my $paralel  = get_pupil_paralel($class_id);

        $SQLp .= " OR
    (msg_public_send.type_g = 2 AND msg_public_send.gid = $paralel)
              OR
    (msg_public_send.type_g = 3 AND msg_public_send.gid = $class_id)";
    }

    if ( $active == 1 ) {
        $SQLf .=
" AND (msg_public_text.date_begin <= '$gdate' AND msg_public_text.date_end >= '$gdate')";
    }
    if ( $full != 1 ) {
        $SQLf .= " AND NOT EXISTS (
      SELECT 1 FROM msg_public_read WHERE
      msg_public_read.p_id = msg_public_text.id AND msg_public_read.uid = $guid )";
    }
    if ( $id > 0 ) {
        $SQLf .= " AND msg_public_text.id = $id";
    }

    my $stat_announcement = sqlffcms(
        "SELECT count(1) FROM (
    SELECT distinct msg_public_text.id
    FROM msg_public_text,msg_public_send WHERE
    msg_public_text.id = msg_public_send.pub_id AND
    (
      (msg_public_send.type_g = 1 AND msg_public_send.gid = $ggid)
      OR msg_public_text.author_id = $ggid
    $SQLp
    ) $SQLf )"
    );

    return $stat_announcement;
}

sub set_form() {
    my $auto_scan_ch  = $auto_check_msg > 0 ? 'checked' : '';
    my $auto_scan_sel = $auto_check_msg > 0 ? ''        : "disabled='disabled'";
    my $body_txt = qq[<div style="padding:10px">
   <form name="set" method="post">
   <input name="act" type="hidden" id="act" value="set_go">
   <fieldset><legend>
   <input $auto_scan_ch type="checkbox" id="a1" onClick="(e('auto_sel').disabled = e('a1').checked ? '' : 'disabled')">
   <label for="a1">      </label></legend>
     <select name="auto_scan" id="auto_sel" $auto_scan_sel>];
    my @autoS = ( 15, 10, 8, 5, 4, 3, 2 );
    for my $i (@autoS) {
        $body_txt .=
            "<option value='$i'"
          . ( $i == $auto_check_msg ? ' selected' : '' )
          . ">$i</option>";
    }
    $body_txt .= qq[</select> .</fieldset><br>];

    if ( isadmin() ) {
        my $tmp =
          sqlff("SELECT f_int FROM sp_user_settings WHERE uid='$guid' AND id=2")
          || '';
        my $auto_scan_ch  = $tmp ? 'checked' : '';
        my $auto_scan_sel = $tmp ? ''        : "disabled='disabled'";
        $body_txt .= qq[<fieldset><legend>
    <input $auto_scan_ch type="checkbox" id="a2" onClick="(e('sendmail').disabled = e('a2').checked ? '' : 'disabled')" maxlength='512'>
    <label for="a2">     e-mail</label></legend>
    e-Mail: <input name="sendmail" type="text" id="sendmail" value="$tmp" style="width:80%" $auto_scan_sel>
    ];
    }

    $body_txt .=
q[</fieldset><br><button type="submit"><img src="/sp/img/ok.gif"/></button></form></div>];
    return $body_txt;
}

sub set() {
    if ( $ENV{"REQUEST_METHOD"} ne 'POST' ) { redir( $sact . '&mesg=ban' ); }

    our $auto_check_msg = auto_check_msg();
    my $auto_scan = param('auto_scan') || 0;
    if ( $auto_scan > 0 ) { sec_range( $auto_scan, 2, 15 ); }
    setcookie( 'SP_ACheckMsg', $auto_scan );

    if ( $auto_scan > 0 and $auto_check_msg < 1 ) {
        sql(
"INSERT INTO sp_user_settings (uid,id,f_int) VALUES ($guid, 1, $auto_scan)"
        );
    }
    elsif ( $auto_scan > 0 and $auto_check_msg > 0 ) {
        sql("UPDATE sp_user_settings SET f_int = $auto_scan WHERE uid = $guid");
    }
    else {
        sql("DELETE FROM sp_user_settings WHERE uid = $guid AND id = 1");
    }

    if ( isadmin() ) {
        my $tmp = sqlff(
            "SELECT f_int FROM sp_user_settings WHERE uid='$guid' AND id=2");
        my $sendmail = param('sendmail');

        if ( ( not defined($tmp) ) && defined($sendmail) ) {
            sql(
"INSERT INTO sp_user_settings (uid,id,f_int) VALUES ($guid, 2, '$sendmail')"
            );
        }
        elsif ( defined($tmp) && defined($sendmail) ) {
            sql(
"UPDATE sp_user_settings SET f_int = '$sendmail' WHERE uid = $guid"
            );
        }
        else {
            sql("DELETE FROM sp_user_settings WHERE uid = $guid AND id = 2");
        }
    }

    redir('set&mesg=set_ok');
}

sub get_pupil_paralel($) {
    my $class_id = shift;
    my $paralel  = sqlff(
        "SELECT cast(paralel AS integer) FROM sys_matrix
  WHERE view_class = 7 AND class = $class_id AND exists
  (SELECT 1 FROM get_node_saldo (sys_matrix.node_id, '$gdate', 0) WHERE saldo_sum <> 0)"
    );
    return $paralel;
}

sub DrawVerticalText($$$) {
    my $id   = shift;
    my $text = shift;

    my $path = shift;

    my $delete = 0;
    if ( $text eq "" ) {
        $delete = 1;
    }

    $path = "/tmp/" . $path . "/";

    if   ( defined $id ) { }
    else                 { warn "DrawVerticalText: id not specified"; return; }

    if ($delete) {
        unlink $gconf{sppath} . $path . $id . '.png';
        return;
    }

    my $file = $gconf{sppath} . $path . $id . '.png';
    open F, ">$file" or error("    $file: $!");
    binmode F;

    my $tmp = new GD::Image( 1, 1 );
    my $black_tmp = $tmp->colorAllocate( 0, 0, 0 );

    my @a =
      GD::Image->stringFT( $black_tmp, "./tahoma.ttf", 9, 1.57, 0, 0,
        str2unicode($text) );

    my ( $w, $h ) = ( $a[0] - $a[4] - 1, $a[1] - $a[5] - 1 );
    my $offsetx = $a[0] - $a[4] - $a[2] - 1;

    my $img = new GD::Image( $w, $h );

    my $white = $img->colorAllocate( 0xff, 0xff, 0xff );
    my $black = $img->colorAllocate( 0,    0,    0 );

    $img->stringFT( $black, "./tahoma.ttf", 9, 1.57, $offsetx, $h,
        str2unicode($text) );

    print F $img->png;

    close F;
}

sub button_nav($) {
    my $filter = shift;
    my $id = param("id") || '';
    if ($id) { sec_gt0($id); }

    my ( $button, %hBut, @but );

    my %nBut = (
        '-'   => [ 'msg_r', "", '', '', '2', '54' ],
        'new' => [
            'msg_new',           "new_msg",
            ' ', '  '
        ],
        'pub' => [
            'msg_pub',            "new_pub",
            ' ', '  '
        ],
        'del' => [
            'msg_trach', "msgdel&sact=single&id=$id",
            '',   ' '
        ],
        'rest' => [
            'msg_restore',  "msgrst&id=$id",
            '', ' '
        ],
        'reply' =>
          [ 'msg_reply', "new_msg&sact=reply&id=$id", '', '' ],
        'transmit' => [
            'msg_transmit', "new_msg&sact=reply&ssact=transmit&id=$id",
            '',    ''
        ],
        'set'  => [ 'msg_set', "set", '', '' ],
        'stat' => [
            'msg_stat',   "msg_stat",
            '', '  '
        ],
        'fav' =>
          [ 'msg_fav', "address_book", ' ', ' ' ],
        'black' =>
          [ 'msg_black', "address_black", ' ', ' ' ],
    );

    for ( keys %nBut ) {
        $nBut{$_}[2] =~ s/ /<br>/g;
        $hBut{$_} =
          $nBut{$_}[1] ne ""
          ? qq[<td title='$nBut{$_}[3]'><a href='?act=$nBut{$_}[1]'>]
          : q[<td>];
        $hBut{$_} .=
            qq[<img src='/sp/img/$nBut{$_}[0].gif' width=']
          . ( $nBut{$_}[4] ? $nBut{$_}[4] : "24" )
          . q[' height=']
          . ( $nBut{$_}[5] ? $nBut{$_}[5] : "24" ) . q['>];
        $hBut{$_} .=
          $nBut{$_}[1] ne "" ? qq[<br>$nBut{$_}[2]</a></td>] : q[</td>];
    }

    $button = $hBut{'new'};
    !$pupil_our and $button .= $hBut{'pub'};
    $button .= $hBut{'-'};

    if ( $act eq "sent" ) {
        $button .= '';
    }
    elsif ( $act eq "recycler" ) {
        $button .= '';
    }
    elsif ( $act eq "read" ) {
        if ( $id > 0 ) { if (
                sqlffcms(
'SELECT 1 FROM msg_message_text WHERE cmd_i = 2 AND author_id = '
                      . $guid
                      . ' AND id = '
                      . $id
                )
                or sqlffcms(
                        'SELECT 1 FROM msg_send WHERE cmd_s = 2 AND msg_id = ' 
                      . $id
                      . ' AND u_id = '
                      . $guid
                )
              )
            {
                $button .= $hBut{'rest'};
            }
            $button .= $hBut{'reply'};
            $button .= $hBut{'transmit'};
            if ( $act ne 'new_msg' ) { $button .= $hBut{'del'}; }
            $button .= $hBut{'-'};
        }
    }

    $button .= $hBut{'fav'} . $hBut{'black'};
    $button .= $hBut{'-'};

    if ( isadmin() ) {
        $button .= $hBut{'stat'};
    }

    return
q[<table cellspacing="0" cellpadding="0" class="memu_bar"><tr style="background-color:transparent">]
      . $button
      . $hBut{'set'}
      . '</tr></table>';
}

sub mesg {
    return '';
}

if ( $act eq 'msg_send_act' ) { msg_send_act(); } elsif (
    $act eq 'pub_send_act' )
{
    pub_send_act(0);
} elsif ( $act eq 'pub_edit_act' ) {
    pub_send_act(1);
}

elsif ( $act eq 'pub_stat' ) { pub_stat(); } elsif ( $act eq 'msg_stat' ) {
    msg_stat();
}

elsif ( $act eq 'announcement' && param('id') > 0 ) { pub_read(); } elsif (
    $act eq 'read_announcement' && param('read') > 0 )
{
    pub_read_confirm();
}

elsif ( $act eq 'pubdel' ) { pub_del(); } elsif ( $act eq 'msgdel'
    && defined( param('id') )
    && $sact eq 'single' )
{
    msg_del( param('id') );
} elsif ( $act eq 'msgdel' ) {
    msg_del_mass();
} elsif ( $act eq 'msgrst' && param('id') > 0 ) {
    msg_restore();
}

elsif ( $act eq 'aj_newm' ) {
    aj_newmes();
} elsif ( $act eq 'aj_search' ) {
    aj_search();
} elsif ( $act eq 'aj_gr' ) {
    aj_field( param("s") );
}

elsif ( $act eq 'set_go' ) { set(); }

elsif ( $act eq 'address_book_act' ) {
    address_book_act();
} elsif ( $act eq 'aj_address_book' ) {
    aj_address_book();
}

elsif ( $act eq 'address_black_list' ) {
    address_black_list_act();
}

else { msg_desktop(); }

exit 0;
