# (C) http://spcms.ru
use strict;
use vars qw($gdate $gpage);

sub check_ser_num( $$$$ ) {

    my $ser = uc $_[0];
    my $num = uc $_[1];

    $ser = substr( $ser, 0, 11 );
    $num = substr( $num, 0, 21 );

    my $q = $gdb->prepare(
        'SELECT human_id FROM HUMAN_DOC_LIST WHERE SER = ? and NUM = ?')
      or db_error();
    $q->execute( $ser, $num )
      or db_error();

    my @result1 = $q->fetchrow_array();
    $q->finish;

    if ( !@result1 ) {
        return 0;
    }

    if ( sqlff("select 1 from sp_users where uid = $result1[0]") ) {
        log_user_sesion( 9, $result1[0] );
        stop("     .");
    }

    $q = sqlp(
        "select human_id, first_name, last_name from human where
  exists (
    select 1 from sys_matrix
    where sys_matrix.view_class = 1 and sys_matrix.vw_pupil = human.human_id
      and
    exists (
      select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0)
      where saldo_sum <> 0
    )
  )
  and human_id = \"$result1[0]\"
  and class = 1"
    );
    my @result3 = $q->fetchrow_array();
    $q->finish;

    if ( !@result3 ) {
        log_user_sesion( 8, $ser . "\n" . $num );
        return 0;
    }

    $_[2] = "$result3[1] $result3[2]";
    $_[3] = $result1[0];
    return (1);

}

sub form_register2( $$$ ) {
    if ( $gconf{'light'} ) { exit print redirect '/'; }

    my $login = $_[0];
    ( undef, $login ) = split( / /, $login );
    $login = lc( translit($login) );

    my $hser = $_[1];
    my $hnum = $_[2];

    tpl(
        './tpl/register2.html',
        {
            pupil            => $_[0],
            input_login      => $login,
            input_hidden_ser => $hser,
            input_hidden_num => $hnum,
            footers          => generate_footers(),
        }
    );
}

sub form_register3 ( $$ ) {
    if ( $gconf{'light'} ) { exit print redirect '/'; }

    tpl(
        './tpl/register3.html',
        {
            login    => $_[0],
            password => $_[1],
            footers  => generate_footers(),
        }
    );
}

sub user_check ( $$ ) {

    my $uid = shift;
    my $log = shift;

    my $q = $gdb->prepare('select uid from sp_users where log = ?')
      or db_error();
    $q->execute($log)
      or db_error();

    my @result1 = $q->fetchrow_array();
    $q->finish;
    if (@result1) { return 2; }

    $q = $gdb->prepare('select * from sp_users where uid = ?')
      or db_error();
    $q->execute($uid)
      or db_error();

    @result1 = $q->fetchrow_array();
    $q->finish;
    if (@result1) { return 1; }

    return (0);

}

sub user_add ( $$$ ) {
    my $uid = shift;
    my $log = shift;
    my $pas = shift;

    sqlb( "insert into sp_users (uid,gid,log,pas) values (?, 4, ?, ?)",
        $uid, $log, $pas );

    create_dc_user($uid);
}

sub register_teacher_form() {
    my @a;
    my ( $selected1, $selected2 );
    my $sex_list;
    my $uid;
    if ( defined param('op') and param('op') eq 'edit' ) {
        $uid = param('uid');
        sec_gt0($uid);
        my $attr = { ib_timestampformat => '%d.%m.%Y' };
        @a = sqlf(
"select FIRST_NAME, MIDDLE_NAME, LAST_NAME, BIRTH_DAY, BIRTH_PLACE, SEX from human where HUMAN_ID = $uid",
            $attr
        );
        if   ( $a[5] == 0 ) { $selected1 = 'selected'; }
        else                { $selected2 = 'selected'; }
        $sex_list =
qq[<option value="0" $selected1></option><option value="1" $selected2></option>];
    }
    else {
        $sex_list =
q[<option value="0" selected></option><option value="1"></option>];
    }
    tpl(
        './tpl/users_add_teacher.html',
        {
            menu    => generate_menu(),
            footers => generate_footers(),
            header  => ( defined param('op') and param('op') eq 'edit' )
            ? ''
            : '',
            uid => ( defined param('op') and param('op') eq 'edit' ) ? $uid
            : '',
            submit_text => ( defined param('op') and param('op') eq 'edit' )
            ? ''
            : '',
            first  => $a[0] || '',
            middle => $a[1] || '',
            'last' => $a[2] || '',
            date   => $a[3] || '',
            place  => $a[4] || '',
            sex    => $sex_list,
            msg    => param('ok')
            ? '<h2>  .   .</h2>'
            : ''
        }
    );
}

sub register_teacher() {
    my ( $first, $last, $middle, $sex, $date, $place ) = (
        param('first'), param('last'), param('middle'), param('sex'),
        param('date'),  param('place')
    );

    unless ( $sex eq '1' or $sex eq '0' ) { stop("  ."); }

    $first  = substr( trim($first),  0, 32 );
    $last   = substr( trim($last),   0, 32 );
    $middle = substr( trim($middle), 0, 32 );

    $date = trim($date);

    if (   $first eq ''
        or $last   eq ''
        or $middle eq ''
        or $date   eq '' )
    {
        stop
          ', ,     &mdash;  .';
    }

    sec_date($date);

    $place =~ s/\r/ /g;
    $place =~ s/\n/ /g;
    $place =~ s/\s+/ /g;

    if ( $place eq '' ) {
        $place = undef;
    }

    if ( param('edit_uid') =~ m/^\d+$/ ) {

        my $uid = param('edit_uid');
        sec_gt0($uid);

        sqlb(

            "update human set
first_name  = ?,
middle_name = ?,
last_name   = ?,
birth_day   = '$date',
birth_place = ?,
sex = $sex
where human_id = $uid",

            $first, $middle, $last, $place

        );

        redir 'users_teachers';

    }
    else {

        my $new_uid = sqlff q[select next_value from get_next_value('HUMAN')];

        sqlb(

            "insert into human
(human_id, class, first_name, middle_name, last_name, birth_day, birth_place, sex, social_status, note)
values
($new_uid, 0, ?, ?, ?, '$date', ?, $sex, 1, NULL)",

            $first, $middle, $last, $place

        );

        redir 'register_teacher_form&ok=1';

    }

}

sub register_sp_teachers() {
    unless ( sqlff "select count(*) from human where class = 0" ) {
        stop(
q[      .        <a href="?act=register_teacher_form">  .</a>]
        );
    }

    my ( @a,        @mas );
    my ( $password, $login );
    my $count = 0;

    my $q =
      sqlp 'select FIRST_NAME, MIDDLE_NAME, LAST_NAME, BIRTH_PLACE, HUMAN_ID
from human where class = 0
and human_id not in
(select uid from sp_users where human.human_id = sp_users.uid)';

    while ( @a = $q->fetchrow_array() ) {
        $password = generate_password();
        push @mas, [ $a[4], 2, $a[2], $password, "$a[2] $a[0] $a[1]" ];
        $count++;
    }
    $q->finish();

    if ( !@mas ) {
        stop("        .");
    }

    for (@mas) {
        $_->[2] = gen_unical_login( $_->[2] );
    }

  gen_unical:
    my $unical = 0;
    my %unical_log;

    while ( !$unical ) {
        $unical = 1;
        for (@mas) {
            unless ( $unical_log{"$_->[2]"} ) {
                $unical_log{"$_->[2]"}++;
            }
            else {
                $_->[2] = $_->[2] . int( rand(10) );
                undef %unical_log;
                $unical = 0;
                last;
            }
        }
    }

    html_header();

    $gpage .=
"<table border=1 cellpadding=5 cellspacing=0 bordercolor=#666666 CLASS=debug>
    <tr class=def>
      <th CLASS=debug></th>
      <th CLASS=debug> </th>
      <th CLASS=debug></th>
    </tr>";

    for ( my $i = 0 ; $i < @mas ; $i++ ) {
        $gpage .= "
    <tr class=def>
      <td CLASS=debug>$mas[$i][4]</td>
      <td CLASS=debug align=center><span class=mono>$mas[$i][2]</span></td>
      <td CLASS=debug align=center><span class=mono>$mas[$i][3]</span></td>
    </tr>";
    }

    $gpage .= "</table><br>";

    for ( my $x = 0 ; $x < @mas ; $x++ ) {
        sql(
            "insert into sp_users
         (UID,GID,LOG,PAS)
         values
         ( '$mas[$x][0]', '$mas[$x][1]', '$mas[$x][2]', '$mas[$x][3]' )"
        );
        create_dc_user( $mas[$x][0] );
    }

    $gpage .= "   $count  .<br><br>";

    $gpage .= "     .
    (   ).
      
      .<br><br>";

    $gpage .= "<a href='?act=main'>   </a>.";

    aj_print($gpage);

}

sub gen_unical_login($) {
    my $fam = shift;
    my $login;
    my $q;
    my $fail = 1;
    my @data;
    my $addcount = 0;
    my $x;
    while ($fail) {
        $login = lc( translit($fam) );
        for ( $x = 0 ; $x < $addcount ; $x++ ) {
            $login .= int( rand(10) );
        }
        unless ( sqlff "select log from sp_users where log = '$login'" ) {
            undef $fail;
        }
        else { $addcount++; }
    }

    return ($login);
}

sub change_password() {
    my $p   = param('p');
    my $p2  = param('p2');
    my $old = param('old');

    unless ( $p and $p2 and $old ) {
        tpl './tpl/users_change_password.html',
          {
            menu    => generate_menu(),
            footers => generate_footers()
          };
    }

    my $tmp = $p;
    $tmp =~ s/\s//g;

    if ( trim($p) eq '' ) {
        stop
'  &ndash;  .  - .';
    }

    if ( $p ne $p2 ) {
        stop
'       .       .      .';
    }

    if ( $old eq sqlff "select pas from sp_users where uid = $guid" ) {
        sqlb 'update sp_users set pas = ? where uid = ?', $p, $guid;

        if ( $gconf{'create_dc_users'} ) {
            my $password_base64 = encode_base64( $p, '' );
            my $log = sqlff "select log from sp_users where uid = $guid";
            system "sudo smbldap-passwd $log -p $password_base64 > /dev/null";
        }

        msg " ",
"    .        .";
    }
    else {
        stop '    .';
    }
}

sub set_password() {
    my ( $p1, $p2 ) = ( param('p1'), param('p2') );
    my $uid = param('uid');
    sec_gt0 $uid;

    if ( $p1 ne $p2 ) {
        stop
'      .       .';
    }

    if ( trim($p1) eq '' ) {
        stop ' !';
    }

    if ( 'root' eq sqlff "select log from sp_users where uid = $uid" ) {
        stop '   ,     .';
    }

    sqlb 'update sp_users set pas = ? where uid = ?', $p1, $uid;

    if ( $gconf{'create_dc_users'} ) {
        my $password_base64 = encode_base64( $p1, '' );
        my $log = sqlff "select log from sp_users where uid = $uid";
        system "sudo smbldap-passwd $log -p $password_base64 > /dev/null";
    }

    redir 'registered';

}

sub change_and_print_class_passwords() {
    if ( $ENV{'REQUEST_METHOD'} eq 'GET' ) {

        my $c = param('c');

        if ( not defined $c ) {
            msg " 1:  :", "<form method=get align=center>
<input type=hidden name='act' value='change_and_print_class_passwords'>
<select name=c size=10>" . filter_class() . "<select><br><br>
<input type=submit name=submit value=''>
</form>";
        }
        elsif ( defined $c ) {
            sec_gt0 $c;

            my @a;
            sqla(
                \@a, "select
  vw_pupil,
  (select log from sp_users where uid = cast(sys_matrix.vw_pupil as integer)),
  (select trim(last_name)||' '||first_name||' '||middle_name from human where human_id = cast(sys_matrix.vw_pupil as integer))
from sys_matrix inner join human on cast(vw_pupil as integer) = human_id
where
sys_matrix.view_class = 1
and sys_matrix.class = $c
and exists
(
  select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0)
  where saldo_sum <> 0
)
order by trim(human.last_name)
"
            );
            my $t =
qq[<table align="center" class="d pad" cellspacing=0><tr><th></th><th colspan=2> </th></tr>];
            for (@a) {
                $$_[1] ||= q[<span style="color:#bbb"> </span>];
                $t .= qq[<tr>
              <td>$$_[2]</td>
              <td><input type=checkbox name="u$$_[0]"></td>
              <td>$$_[1]</td>
             </tr>];
            }
            $t .= '</table>';

            msg " 2:  ,<br>   :", "
<style type=text/css><!--
table.d tr:hover { background-color: #f7f6f2 }
//--></style>

<form method=post align=center>
<input type=hidden name='act' value='change_and_print_class_passwords'>
<input type=hidden name='c' value='$c'>
$t<br>
<label for='url'><input id=url type=checkbox name='url'>     URL  </label>
<br><br>
<input type=button name=submit value=' ' onclick='Select_All_UIDS()'>
<input type=button name=submit value='   ' onclick='Select_All_UIDS(false)'>
<input style='margin-left:32px' type=submit name=submit value=''>
</form>";
        }

    }
    elsif ( $ENV{'REQUEST_METHOD'} eq 'POST' ) {
        my $report = '';

        my $changes_made = 0;

        for ( param() ) {

            if (/^u(\d+)$/) {
                my $password = generate_password();

                unless ( sqlff("select 1 from sp_users WHERE uid = $1") ) {
                    my $last_name =
                      sqlff("select last_name from human where human_id = $1");
                    if ($last_name) {
                        my $new_login = gen_unical_login($last_name);
                        sql( "
INSERT INTO SP_USERS  (UID, GID, LOG,          PAS)
              VALUES  ($1,  4,   '$new_login', '$password')" );
                        $report .= "  <br>";

                        create_dc_user($1);
                    }
                }

                if ( 1 !=
                    sqlff("select human.class from human where human_id = $1") )
                {
                    next;
                }

                if (    exists $gconf{'school19_aeapv'}
                    and $gconf{'school19_aeapv'} eq '0'
                    and $guid == 101901043 )
                {
                    ;
                }
                else {
                    sqlb 'update sp_users set sp_users.pas = ?
						where sp_users.gid = 4 and sp_users.uid = ?', $password, $1;

                    if ( $gconf{'create_dc_users'} ) {
                        my $password_base64 = encode_base64( $password, '' );
                        my $log =
                          sqlff "select log from sp_users where uid = $1";
                        system
"sudo smbldap-passwd $log -p $password_base64 > /dev/null";
                    }

                }

                $changes_made++;

                $report .= sqlff( "
select '<big>' || vw_pupil.name || '</big><br>: <span class=mono>' || log || '</span> : <span class=mono>' || pas || '</span>'
from sp_users join vw_pupil ON human_id = uid
where gid = 4 and uid = $1
" )
                  . ( param('url')
                    ? "<br><small>  &mdash; <span style='color:#999'>http://</span>$ENV{SERVER_NAME}</small>"
                    : '' )
                  . "<div style='margin: 1em 0; border-top: 1px dotted #999'></div>";

            }

        }

        unless ($changes_made) {
            stop('     ');
        }

        msg( "   ", $report );

    }

    else { deny(); }
}

sub change_teachers_passwords() {
    if ( param('ok') ) {
        my ( @a, @mas );

        my ( $password, $login );

        my $count = 0;

        my $q = sqlp 'select log, first_name, middle_name, last_name
from sp_users, human
where human.human_id = sp_users.uid
and gid = 2';

        while ( @a = $q->fetchrow_array() ) {
            $password = generate_password();
            push @mas, [ $a[0], $password, "$a[1] $a[2] $a[3]" ];
            $count++;
        }

        if ( !@mas ) { stop("  ."); }

        for (@mas) {
            sqlb "update sp_users set pas = ? where log = ?", $$_[1], $$_[0];

            if ( $gconf{'create_dc_users'} ) {
                my $password_base64 = encode_base64( $$_[1], '' );
                system
                  "sudo smbldap-passwd $$_[0] -p $password_base64 > /dev/null";
            }
        }

        html_header();

        $gpage .= q[<div class=dontprint>
<p style="margin:8px">   .
    (   ).
       (    )
      .<br>
</p>
<div class=panel align=center style="padding:5px">
<img src="/sp/img/print.gif" width=16 height=16 border=0 align=absmiddle>&nbsp;<a class=copy href='#' onclick="javascript:print(); return false;"></a>&nbsp;&nbsp;&nbsp;&nbsp;
<img src="/sp/img/ok.gif"    width=16 height=16 border=0 align=absmiddle>&nbsp;<a class=copy href='#' onclick="javascript:history.go(-2);"></a>
</div>
<br>
</div>];

        $gpage .=
"<table align=center class=d cellpadding=5 cellspacing=0 bordercolor=#666666>
<tr class=def>
<th class=debug></th>
<th class=debug> </th>
<th class=debug> </th>
</tr>";

        for (@mas) {
            $gpage .= "<tr class=def>
<td class=debug>$$_[2]</td>
<td class=debug align=center><span class=mono>$$_[0]</span></td>
<td class=debug align=center><span class=mono>$$_[1]</span></td>
</tr>";
        }

        $gpage .= "</table><br>";

        aj_print($gpage);
    }
    else {
        msg "  ",
          q[  ,     
     .
    .
         ,
         .
<br><br>
<div align=center>
<a href="?act=change_teachers_passwords&ok=1" onclick="return confirm(' ?')"></a>
</div>];
    }
}

sub create_dc_user($) {
    return unless $gconf{'create_dc_users'};

    use MIME::Base64;

    my $uid = shift;
    my $class_rus;
    my $class_grp;

    my $uniq = time;

    my $tmp_ldif        = "/tmp/sp_tmp_ldap_data-$uniq.ldif";
    my $tmp_ldap_script = "/tmp/sp_tmp_ldap_script-$uniq.sh";

    my ( $log, $pas, $gid ) =
      sqlf "select log,pas,gid from sp_users where uid = $uid";

    my @a = sqlf "select
(select last_name from human where human_id = $uid),
(select first_name  from human where human_id = $uid),
(select middle_name from human where human_id = $uid)
from dual
";

    my $fio = ucfirst( trim( $a[0] ) ) if $a[0];
    $fio .= ' ' . ucfirst( trim( $a[1] ) ) if $a[1];
    $fio .= ' ' . ucfirst( trim( $a[2] ) ) if $a[2];

    if ( $gid == 4 ) {
        $class_rus = sqlff
"select paralel || (select name from class where class_id = sys_matrix.class)
from sys_matrix
where
sys_matrix.view_class = 1
and vw_pupil = $uid
and exists
(
  select 1 from get_node_saldo(sys_matrix.node_id, 'now', 0)
  where saldo_sum <> 0
)";
        $class_rus =~ /(\d+)\"?(.)\"?/;
        $class_rus = "$1$2";
        $class_grp = lc translit($class_rus);
    }
    else {
        $class_grp = undef;
    }

    my $password_base64 = encode_base64( $pas, '' );

    open( F, '>', $tmp_ldap_script );

    print F qq[sudo smbldap-useradd -a -d /home/$log -m $log\n];

    print F qq[sudo smbldap-passwd $log -p $password_base64\n];

    print F qq[sudo smbldap-groupadd -a class_$class_grp\n] if $class_grp;

    my $group = ( $gid == 4 ) ? "students,class_$class_grp" : "teachers";

    print F qq[sudo smbldap-usermod -G "$group" $log\n];

    print F
qq[sudo ldapsearch -LL -H ldap://localhost -b"dc=school,dc=lan" -x "(uid=$log)" > $tmp_ldif\n];
    print F qq[sudo chmod 666 $tmp_ldif\n];

    my $desc = ( $gid == 4 ) ? "$fio ($class_rus)" : $fio;

    $desc = translit($desc);

    print F
qq[perl -i -p -e '\$t = q~$desc~; s/version: 1//; s/:\\s*System User/: \$t/g; s|/bin/bash|/bin/false|g;' $tmp_ldif\n];

    print F
qq[sudo ldapmodify -x -D "cn=Manager,dc=school,dc=lan" -w secret -f $tmp_ldif\n];
    print F qq[rm -f -- $tmp_ldif\n];

    print F qq[\n];

    close F;

    system "sh $tmp_ldap_script > /dev/null";
    unlink $tmp_ldap_script;

}

sub generate_password() {
    my @chars =
      qw/a b c d e f g h i j k m n o p q r s t u v w x y z 2 3 4 5 6 7 8 9/;

    my $password = '';
    for ( my $i = 0 ; $i < 6 ; $i++ ) {
        $password .= $chars[ rand( scalar(@chars) ) ];
    }
    return $password;
}

sub change_squid_password($) {
    unless ( $gconf{'auth'} eq 'basic' ) {
        return;
    }

    my $uid = shift;
    my ( $login, $password ) =
      sqlff("select log,pas fromsp_users where uid = $uid");

    unless ( $login or $password ) {
        security_alert("  $uid     ");
    }

    my $user_allowed = 0;
    open ALLOWED, '<', $gconf{'sp_users_allowed'};
    while (<ALLOWED>) {
        if (/^\Q$login\E$/) {
            $user_allowed = 1;
            last;
        }
    }
    close ALLOWED;

    unless ($user_allowed) {
        return;
    }

    open HTPASSWD, '<', $gconf{'htpasswd'};
    close HTPASSWD;

}

sub pupil_import_csv() {
    my $title = '   CSV-';

    if ( $ENV{'REQUEST_METHOD'} eq 'GET' ) {

        my $current_year = (localtime)[5] + 1900;

        my @a;
        sqla( \@a,
'select doc_type_id,name from human_doc_type_ref order by doc_type_id'
        );
        my $doc_type_html = '';
        for (@a) {
            $doc_type_html .= "$$_[0]  $$_[1]<br>";
        }

        msg(
            $title,
            qq[
<p>     :</p>
<ul>
	<li>: Windows-1251</li>
	<li> : ";" (  )</li>
	<li> :  ( )</li>
</ul>
<p>    ,   OpenOffice Calc.</p>
<p>      .</p>
<p> :</p>
<ul>
	<li>   ( )</li>
	<li>      <b> ""</b>,<br>
		   ,   </li>
	<li>    <b>..</b></li>
	<li> (  <b></b>  <b></b>   <b>/</b>,     )</li>
</ul>
<p> 5   ,   :</p>
<ul>
	<li>  ():<br>$doc_type_html</li>
	<li> </li>
	<li> </li>
	<li>   ( )</li>
	<li>  ( )</li>
</ul>

<fieldset style="margin-bottom: 1em">

	<p>  :</p>

<pre style="overflow-x: scroll; 1px solid #ddd; padding: 8px; background-color: #f5f5f5">
  ;5 "";10.10.1995;;2;1379;123456;11.10.1995;  .   .
 ϸ ;10 "";4.1.1998;;1;I-;159753;05.01.1998; .   
  ;10 "";08.08.1992;;1;V-;179325
  ;10 "";8.08.1992;;1;-;864235

</pre>

</fieldset>

<form id="import_csv" enctype='multipart/form-data' method='post'>

	<input type="hidden" name="act" value="pupil_import_csv">

	<p>     :<br>
    (,       )</p>
	<p><input type="text" name="date" value="31.08.$current_year"></p>

	<p>:<br>
	<input type="file" name="file"></p>

	<p><input type='submit' value=''></p>

</form>

]
        );
    }
    elsif ( $ENV{'REQUEST_METHOD'} eq 'POST' ) {

        my %pupil_by_class;
        my %class_name_in_parallel;

        unless ( length( param('file') ) ) {
            stop("   .");
        }

        my @allowed_doc_type_ids;
        sqlffa( \@allowed_doc_type_ids,
            'select doc_type_id from human_doc_type_ref order by doc_type_id' );

        my $fh = upload('file');

        while (<$fh>) {

            chomp;

            my (
                $fio, $class_name,   $birth_date,
                $sex, $doc_type_id,  $ser,
                $num, $giveout_date, $giveout_org
            ) = split /;/;

            {

                $birth_date   = trim($birth_date);
                $giveout_date = trim($giveout_date);

                $ser         = substr( trim($ser),         0, 10 );
                $num         = substr( trim($num),         0, 20 );
                $giveout_org = substr( trim($giveout_org), 0, 128 );

                unless ( grep /^\Q$doc_type_id\E$/, @allowed_doc_type_ids ) {
                    my $doc_type_by_comma = join( ',', @allowed_doc_type_ids );
                    escape_tag( \$_ );
                    stop(
qq[   : $doc_type_by_comma.<br>
					      :<br>
					$_]
                    );
                }

                my $dates_ok = 1;

                if ( $birth_date !~
                    m/^[0-3]?[0-9]\.[0-1]?[0-9]\.[0-9][0-9][0-9][0-9]$/ )
                {
                    $dates_ok = 0;
                }

                if ( defined $giveout_date and $giveout_date ne '' ) {
                    if ( $giveout_date !~
                        m/^[0-3]?[0-9]\.[0-1]?[0-9]\.[0-9][0-9][0-9][0-9]$/ )
                    {
                        $dates_ok = 0;
                    }
                }

                unless ($dates_ok) {
                    escape_tag( \$_ );
                    stop(
qq[   : ..   (,&nbsp;$gdate  2.1.2010).<br>
					          :<br>
					$_]
                    );
                }

            }

            my ( $f, $i, $o ) = split( /\s+/, $fio );

            $f = substr( $f, 0, 32 );
            $i = substr( $i, 0, 32 );
            $o = substr( $o, 0, 32 );

            $class_name =~ m|^(\d+)\s*(.+)|;
            my ( $class_parallel, $class_letter ) = ( $1, $2 );

            $sex = $sex =~ m/^/i ? 1 : 0;

            push @{ $pupil_by_class{$class_name} },
              [
                $f,            $i,           $o,   $birth_date,
                $sex,          $doc_type_id, $ser, $num,
                $giveout_date, $giveout_org
              ];

            $class_name_in_parallel{$class_name} = {
                parallel => $class_parallel,
                letter   => $class_letter
            };

        }

        my $class_id = sqlff("select max(class_id)+1 from class");

        $class_id ||= 1;

        my $date = param('date');
        sec_date($date);

        my $human_id;

        my $imported_pupil_count = 0;

        $gdb->{AutoCommit} = 0;

        for ( keys %pupil_by_class ) {

            sqlb( "insert into class (CLASS_ID, NAME) values($class_id,?)",
                $class_name_in_parallel{$_}{'letter'} );

            sqlb(
"insert into doc_order_class_create values((select next_value from get_next_doc_no(4)), '$date', 0, $class_id, ?, null)",
                $class_name_in_parallel{$_}{'parallel'}
            );

            for my $pupil ( @{ $pupil_by_class{$_} } ) {
                $human_id =
                  sqlff(q[select next_value from get_next_value('HUMAN')]);

                push @{$pupil}, ( $class_id, $human_id );

                sqlb(

                    "INSERT INTO HUMAN
					(
						human_id, class, first_name, middle_name, last_name,
						birth_day, sex, is_many_children
					)
					values
					(
						$human_id, 1, ?, ?, ?,
						?, $$pupil[4], 0
					)",

                    $$pupil[1], $$pupil[2], $$pupil[0], $$pupil[3]
                );

                sqlb(
                    "insert into human_doc_list
					(human_id, doc_type, ser, num, giveout_date, giveout_org)
					values
					($human_id, ?, ?, ?, ?, ?)",

                    $$pupil[5], $$pupil[6], $$pupil[7], $$pupil[8]
                    , $$pupil[9] );

                $imported_pupil_count++;
            }

            $class_id++;

        }

        sql("update sys_seqense set next_value = $human_id where name = 'HUMAN'"
        );

        sql(
            "insert into doc_order_in
			select
				(select next_value from get_next_doc_no(1)),
				'$date',
				0,
				class_id,
				null,
				null
			from class
			order by class_id"
        );

        for ( keys %pupil_by_class ) {
            for my $pupil ( @{ $pupil_by_class{$_} } ) {
                sql(
                    "insert into doc_order_in_sp values
						(
							(select next_value from get_next_value('DOC_ORDER_SP')),
							$$pupil[-2],
							$$pupil[-1]
						)
				"
                );
            }
        }

        $gdb->commit;

        $gdb->{AutoCommit} = 1;

        msg(
            $title,
            qq[
<p> $imported_pupil_count .</p>
<p>    CSV-      ,   :</p>
<ol>
	<li>  " ".</li>
	<li>   :  , ,     (), 01.    ().</li>
	<li>     0.   .         ""     .      "",  0,  [Enter].           .</li>
	<li>    :  ,     "",  "",  .</li>
	<li>        : "05.  ".</li>
	<li>         .    ,    3  4,      .</li>
</ol>
]
        );

    }

    else { deny(); }

}

sub teacher_import_csv() {

    my $title = '   CSV-';

    if ( $ENV{'REQUEST_METHOD'} eq 'GET' ) {

        msg(
            $title,
            qq[
<p>     :</p>
<ul>
	<li>: Windows-1251</li>
	<li> : ";" (  )</li>
	<li> :  ( )</li>
</ul>
<p>    ,   OpenOffice Calc.</p>
<p>      .</p>
<p> :</p>
<ul>
	<li>   ( )</li>
	<li>    ..</li>
	<li> (  <b></b>  <b></b>   <b>/</b>,     )</li>
</ul>

<p>  :</p>
<pre style="border: 1px solid #ddd; padding: 8px; background-color: #f5f5f5">
  ;10.10.1995;
 ϸ ;4.1.1998;
  ;08.08.1992;
  ;8.08.1992;
</pre>

<style type="text/css">
#import_csv p {
	margin-bottom: 1em;
}
</style>

<form id="import_csv" enctype='multipart/form-data' method='post'>

	<input type="hidden" name="act" value="teacher_import_csv">

	<p>:<br>
	<input type="file" name="file"></p>

	<p><input type='submit' value=''></p>

</form>

]
        );
    }

    elsif ( $ENV{'REQUEST_METHOD'} eq 'POST' ) {

        my %pupil_by_class;
        my %class_name_in_parallel;

        unless ( length( param('file') ) ) {
            stop("   .");
        }

        my $fh = upload('file');

        $gdb->{AutoCommit} = 0;

        my $imported_teacher_count = 0;

        while (<$fh>) {

            chomp;

            my ( $fio, $birth_date, $sex ) = split /;/;

            my ( $f, $i, $o ) = split( /\s+/, $fio );

            $f = substr( $f, 0, 32 );
            $i = substr( $i, 0, 32 );
            $o = substr( $o, 0, 32 );

            $birth_date = trim($birth_date);

            if ( $birth_date !~
                m/^[0-3]?[0-9]\.[0-1]?[0-9]\.[0-9][0-9][0-9][0-9]$/ )
            {
                escape_tag( \$_ );
                stop(
qq[   : ..   (,&nbsp;$gdate  7.1.2010).<br>
				         :<br>
				$_]
                );
            }

            $sex = trim($sex);

            $sex = $sex =~ m/^/i ? 1 : 0;

            my $new_uid =
              sqlff q[select next_value from get_next_value('HUMAN')];

            sqlb(
                "insert into human
(human_id, class, first_name, middle_name, last_name, birth_day, birth_place, sex, social_status, note)
values
($new_uid, 0, ?, ?, ?, ?, NULL, $sex, 1, NULL)",
                $i, $o, $f, $birth_date
            );

            $imported_teacher_count++;

        }

        $gdb->commit;

        $gdb->{AutoCommit} = 1;

        msg(
            $title,
            qq[
<p> $imported_teacher_count .</p>
<p>  :</p>
<ol>
	<li><a href="?act=users_teachers">  </a></li>
	<li> <a href="?act=register_sp_teachers">   </a></li>
	<li> <a href="?act=change_teachers_passwords">   </a></li>
</ol>
]
        );

    }

    else { deny(); }

}

1;
