# (C) http://spcms.ru
use locale;
use strict;

use vars qw( @months3 @mnths @mnths2 @wdays @daysinmonth @wdays2 );
use vars qw( $gdate $state_date $gteacher_show_all );
use vars qw( %g_period_to_str %g_period_to_name %g_period_id_to_name );

sub score_list_pupil_totals() {
    my $periods_mode =
      sqlff 'SELECT F_INT FROM SP_SETTINGS WHERE NAME = \'periods_mode\'';
    my $head_periods;
    my @sql_fields;
    if ($periods_mode) {
        for ( 1 .. 4 ) { $head_periods .= qq[<th>$_<br>.</th>]; }
        @sql_fields = qw/q1 q2 q3 q4/;
    }
    else {
        for ( 1 .. 3 ) { $head_periods .= qq[<th>$_<br>.</th>]; }
        @sql_fields = qw/t1 t2 t3/;
    }
    my $sql = join( ',', @sql_fields );

    my @year = year_academic();

    my @subjects;
    sqla \@subjects, "select lesson_id, name from lesson order by name";

    my $table = '';

    my %scores;

    my $q = sqlp "select subj,y,e,e1,t,$sql from sp_scores_totals
		where uid = $guid
		and scoreyear = $year[0]";
    my @a;
    while ( @a = $q->fetchrow_array ) {
        my $tmp = shift @a;
        $scores{"$tmp"} = [@a];
    }

    my $color;

    my $counter = 0;

    for (@subjects) {
        next unless $scores{ $$_[0] };
        my @tmp = @{ $scores{ $$_[0] } };

        $table .= qq[<tr>
<td>$$_[1]</td>
];

        $tmp[0] ||= '&nbsp;';
        $tmp[1] ||= '&nbsp;';
        $tmp[3] ||= '&nbsp;';

        for ( my $i = 0 ; $i < scalar(@sql_fields) ; $i++ ) {
            $color = get_score_color( $tmp[ 4 + $i ] );
            $tmp[ 4 + $i ] ||= '&nbsp;';
            $table .= qq[<td style='color:$color;'>$tmp[4+$i]</td>];
        }

        $table .= qq[<td>$tmp[0]</td>];

        $color = get_score_color( $tmp[1] );
        $table .= qq[<td><span style='color:$color;'>$tmp[1]</span>];
        if ( $tmp[2] ) {
            $color = get_score_color( $tmp[2] );
            $table .= qq[/<span style='color:$color;'>$tmp[2]</span>];
        }
        $table .= qq[</td>];

        $color = get_score_color( $tmp[3] );
        $table .= qq[<td style='color:$color;'>$tmp[3]</td>];

        $table .= q[</tr>];

        $counter++;

    }

    unless ($counter) {
        $table .=
            '<tr><td colspan='
          . ( 4 + scalar(@sql_fields) )
          . '>    </td></tr>';
    }

    $table .= q[</table>];

    my @fio;
    fio( \@fio );

    tpl './tpl/score_list_pupil_totals.html',
      {
        menu         => generate_menu(),
        footers      => generate_footers(),
        table        => $table,
        head_periods => $head_periods,
        fio          => "$fio[0] $fio[1] $fio[2], " . get_pupil_class(1),
        year0        => $year[0],
        year1        => $year[1],
      };
}

sub score_top() {
    if ( $ggid != 4 and !param('c') ) {
        redir 'score_form_select_class&goto=score_top';
    }

    my @y;
    if ( $ggid == 4 ) {
        @y = get_year_start_end();
    }

    my $s = param('s')
      || sqlff "select first 1 lesson_id from lesson order by name";
    if ( $s ne 'all' ) {
        sec_gt0 $s;
    }

    my $c;
    if ( $ggid == 4 ) {
        $c = get_pupil_class(0);
    }
    else {
        $c = param('c');
        sec_gt0 $c;
    }

    my $precision = param('precision');
    $precision = 2 unless defined $precision;
    sec_range( $precision, 0, 3 );

    my $precision_options = '';
    my @precision_data =
      ( [ 0, "" ], [ 1, "" ], [ 2, "" ], [ 3, "" ], );
    for (@precision_data) {
        my $selected = ( $precision == $$_[0] ) ? 'selected' : '';
        $precision_options .=
          qq[<option $selected value="$$_[0]"> $$_[1]</option>];
    }

    my $from = param 'from';
    my $to   = param 'to';
    if ( defined $from and defined $to ) {
        sex_date( $from, $to );
        $from = totime $from;
        $to   = totime $to;
    }
    else {

        my $is_half_year = is_half_year($c);

        my $enable_half_year =
          sqlff "select f_int from sp_settings where name = 'enable_half_year'";
        my $now = time;

        my $periods_mode =
          sqlff q[select F_INT from SP_SETTINGS where NAME = 'periods_mode'];

        my @half_year_periods = split /,/,
          sqlff(
            "select f_char from sp_settings where name = 'half_year_periods'");

        my $period;
        my $link = get_class_link($c);

        if ( $enable_half_year and $is_half_year ) {
            $period =
              ( $now >= $half_year_periods[0] and $now < $half_year_periods[1] )
              ? 10
              : 11;
        }
        else {
            my @ids = ( $periods_mode == 1 ) ? ( 1, 4 ) : ( 5, 7 );
            $period = sqlff(
                "select sp_periods.id from sp_periods
				where link = $link and
				$now between time_start and time_end
				and id between $ids[0] and $ids[1]"
            );
            $period ||= ( $periods_mode == 1 ) ? 1 : 5;
        }

        ( $from, $to ) = sqlf
"select time_start, time_end from sp_periods where link = $link and id = $period";

    }

    my @presets;

    my $now = totime $gdate;
    my $dow = ( localtime $now )[6];

    my $week_start = $now;
    if ( $dow != 1 ) { day_sub( $week_start, $dow - 1 ); }

    my $week_end = $week_start;
    day_add( $week_end, 6 );

    my ( $month_start, $month_end );
    $month_start = $month_end = $gdate;
    $month_start =~ s/^(\d+)/1/;
    $month_end   =~ /^\d\d?\.(\d\d?)\.(\d+)$/;
    $month_end = $daysinmonth[ $1 - 1 ] . ".$1.$2";

    my ( $prev_week_start, $prev_week_end ) = ( $week_start, $week_end );
    day_sub( $prev_week_start, 7 );
    day_sub( $prev_week_end,   7 );

    my $prev_month_end   = todate day_sub( totime $month_start);
    my $prev_month_start = $prev_month_end;
    $prev_month_start =~ s/\d\d?/1/;

    push @presets, [ ' ',     $week_start,      $week_end ];
    push @presets, [ ' ', $prev_week_start, $prev_week_end ];
    push @presets, [ ' ', totime($month_start), totime($month_end) ];
    push @presets,
      [ ' ', totime($prev_month_start), totime($prev_month_end) ];

    my $mode = param 'mode';

    my $period = param 'period';
    my ( $sel_period_start, $sel_period_end ) = split '-', $period;

    unless ( defined $sel_period_start ) {
        ( $sel_period_start, $sel_period_end ) = ( $week_start, $week_end );
    }
    else {
        sex_gteq0( $sel_period_start, $sel_period_end );
    }

    if ( $mode eq 'sel-to-cal' ) {
        $from = $sel_period_start;
        $to   = $sel_period_end;
    }

    my $select_html            = '';
    my $period_found_in_select = 0;

    for (@presets) {

        my $selected;

        if (    ( $mode eq 'cal-to-sel' or $mode eq 'sel-to-cal' )
            and $$_[1] == $from
            and $$_[2] == $to )
        {
            $selected               = 'selected';
            $period_found_in_select = 1;
        }
        else {
            $selected = '';
        }

        $select_html .=
          qq[<option $selected value="$$_[1]-$$_[2]">$$_[0]</option>];

    }

    $select_html .= qq[</optgroup><optgroup label="">];

    my $periods_mode =
      sqlff q[select F_INT from SP_SETTINGS where NAME = 'periods_mode'];

    my $class_link = get_class_link($c);

    my %period_times;
    sqlh \%period_times,
"select id, time_start||'-'||time_end from sp_periods where link = $class_link";

    my $selected;

    if ($periods_mode) {
        for ( 1 .. 4 ) {
            if ( $period_times{$_} eq "$from-$to" ) {
                $selected               = 'selected';
                $period_found_in_select = 1;
            }
            else {
                $selected = '';
            }
            $selected = '';
            $select_html .=
qq[<option $selected value="$period_times{$_}">$g_period_id_to_name{$_}</option>];
        }
    }
    else {
        for ( 5 .. 7 ) {
            $selected = '';
            if ( $period_times{$_} eq "$from-$to" ) {
                $selected               = 'selected';
                $period_found_in_select = 1;
            }
            else {
                $selected = '';
            }
            $select_html .=
qq[<option $selected value="$period_times{$_}">$g_period_id_to_name{$_}</option>];
        }
    }

    $select_html .= '</optgroup>';

    unless ($period_found_in_select) {
        $select_html .= '<option selected value="0-0"> </option>';
    }

    my $sql_subj = $s eq 'all' ? '' : "and subj = $s";

    my @filter_subj_ref;

    if ( $ggid == 4 ) {
        sqla \@filter_subj_ref, "SELECT distinct lesson_id, lesson.name
from lesson, sp_scores
where lesson_id = subj
and uid = $guid
and sp_scores.scoretime between $y[0] and $y[1]
order by lesson.name";
    }

    my @a;
    sqla(
        \@a, qq[
select uid,
AVG (CAST(sp_scores.score as float)),
(
select trim(last_name) || ' ' || trim(first_name) || ' ' || trim(middle_name)
from human where human_id = uid
) as fio
from sp_scores, sys_matrix
where scoretime between $from and $to
and view_class = 1
and sys_matrix.class = $c
and sp_scores.uid = sys_matrix.vw_pupil
$sql_subj
and score > 0
and exists
(
  select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0)
  where saldo_sum <> 0
)
group by uid, fio
order by 2 desc]
    );

    my $t                 = '';
    my $pupil_counter     = 0;
    my $i_were_in_a_table = 0;
    for (@a) {
        $pupil_counter++;
        $_->[1] = sprintf( "%0.\Q$precision\Ef", $_->[1] );
        my $style = $guid == $$_[0] ? 'style="background-color:#F7F6E6"' : '';
        if ( $$_[1] == 5 ) {
            $$_[1] = qq[<span class="tot_freed">$$_[1]</span>];
        }
        $t .=
"<tr $style><td align=right>$pupil_counter</td><td align=center><b>$$_[1]</b></td><td>";
        if ( $ggid == 4 ) {
            if ( $guid == $$_[0] ) { $t .= $$_[2]; $i_were_in_a_table = 1; }
            else                   { $t .= '&nbsp;'; }
        }
        else { $t .= $$_[2]; } $t .= "</td></tr>";
    }

    my $pupil_all_subjs = '';

    if ( $s eq 'all' and $ggid == 4 ) {
        my @tmp_array;

        for my $subj_id (@filter_subj_ref) {
            my @a;
            sqla \@a, "select uid, name,
AVG (CAST(sp_scores.score as float)), lesson_id
from sp_scores, sys_matrix, lesson
where scoretime between $from and $to
and view_class = 1
and sys_matrix.class = $c
and sp_scores.uid = sys_matrix.vw_pupil
and lesson.lesson_id = sp_scores.subj
and subj = $$subj_id[0]
and score > 0
and exists
(
  select 1 from get_node_saldo(sys_matrix.node_id, 'now', 0)
  where saldo_sum <> 0
)
group by uid, name, lesson_id
order by 2 desc";

            my $counter = 1;
            for (@a) {
                if ( $$_[0] == $guid ) {
                    push @tmp_array,
                      [
                        $$_[1],   sprintf( "%0.\Q$precision\Ef", $_->[2] ),
                        $counter, $$_[3]
                      ];
                    last;
                }
                $counter++;
            }

        }

        $pupil_all_subjs =
qq[<table class="d pad" style="margin-top: 16px" cellspacing=0 align=center>
<tr>
	<th></th>
	<th><br></th>
	<th>  $pupil_counter</th>
</tr>
];

        my $all_subjs_counter = 0;
        for (@tmp_array) {
            if ( $$_[2] == 1 ) {
                $$_[2] =
qq[<img src="/sp/img/award.png" align="absmiddle">&nbsp;$$_[2]];
            }
            $$_[2] = qq[<b>$$_[2]</b>];

            $pupil_all_subjs .= qq[
<tr>
	<td><a class=small href="?act=score_top&mode=sel-to-cal&precision=$precision&s=$$_[3]&period=$from-$to">$$_[0]</a></td>
	<td align=right>$$_[1]</td>
	<td align=center>$$_[2]</td>
</tr>
];
            $all_subjs_counter++;
        }
        unless ($all_subjs_counter) {
            $pupil_all_subjs .=
qq[<tr><td colspan="3">         </td></tr>];
        }
        $pupil_all_subjs .= q[</table>];
    }

    unless ($pupil_counter) {
        $t .=
"<tr><td colspan=3>        .</td></tr>";
    }
    elsif ( $ggid == 4 and !$i_were_in_a_table ) {
        $t .=
"<tr><td colspan=3>        &mdash;<br>        .</td></tr>";
    }

    $from = todate $from;
    $to   = todate $to;

    my $filter_subj_html;

    if ( $ggid == 4 ) {
        for (@filter_subj_ref) {
            my $selected = '';
            if ( $s ne 'all' ) {
                $selected = ( $$_[0] == $s ) ? 'selected' : '';
            }
            $filter_subj_html .=
              qq[<option $selected value="$$_[0]">$$_[1]</option>];
        }
    }
    else {
        $filter_subj_html = filter_subj( $s eq 'all' ? 0 : $s );
    }

    $t =
qq[<table style="margin-top:8px;" class="d pad" cellspacing=0 align=center>
<tr><th></th><th><br></th><th></th></tr>$t</table>];

    if ( $ggid == 4 and $s eq 'all' ) {
        $t = "<h2 style='margin-top:8px;'> </h2>" . $t;
    }

    tpl './tpl/score_top.html',
      {
        menu    => generate_menu(),
        footers => generate_footers(),
        subj    => $filter_subj_html, precision_options => $precision_options,
        from    => $from,
        to      => $to,
        t       => $pupil_all_subjs . $t,
        c       => $c,
        title_text => ( $ggid == 4 ) ? '' : resolve_class_id($c),
        select     => $select_html
      };

}

sub score_form_select_class() {
    my $disable_checkbox   = 0;
    my $filter_for_teacher = 0;
    my ( $class1, $class2, $class3 );
    my ( $q, @a );

    my $max_size = 1;
    my $tmp_size = 0;

    my ( $l1f, $l1t, $l2f, $l2t, $l3f, $l3t ) = split( ',',
        sqlff qq[select f_char from sp_settings where name = 'class_links'] );

    $q = sqlp(
        "select class_id, cast(paralel as integer),
( select name from class where class_id = cast(sys_matrix.class as integer) )
from sys_matrix, class
where view_class = 7
and class.class_id = sys_matrix.class
and exists ( select 1 from get_node_saldo(
  sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0 )"
    );
    my @t;
    while ( @a = $q->fetchrow_array() ) {
        $a[2] =~ s/^(\".+\").+/$1/;
        $a[2] =~ s/\"/&quot;/g;
        push @t, [@a];
    }

    if ( $ggid == 2 ) {
        unless ($gteacher_show_all) {
            my %class_binding;
            $q = sqlp qq[select distinct sys_matrix.class
  from sys_matrix where view_class = 9001
  and vw_teacher = $guid and exists ( select 1 from get_node_saldo_by_unit ( sys_matrix.node_id, '$gdate', '', 0 )
  where saldo_sum <> 0)];
            while ( @a = $q->fetchrow_array ) {
                $class_binding{ $a[0] }++;
            }

            if ( scalar %class_binding ) {
                $filter_for_teacher = 1;
            }
            else {
                $disable_checkbox = 1;
            }

            if ( $filter_for_teacher == 1 ) {
                my @b;
                for ( my $i = 0 ; $i < @t ; $i++ ) {
                    push @b, $t[$i] if ( $class_binding{ $t[$i][0] } );
                }
                @t = @b;
            }
        }
    }

    @t = sort { $a->[1] <=> $b->[1] || $a->[2] cmp $a->[2] } @t;

    my @max;
    my $tmp_str;
    for (@t) {
        $tmp_str =
          $DEBUG
          ? "<option value=\"$_->[0]\">ID=$_->[0]&nbsp;&nbsp;$_->[1] $_->[2]</option>"
          : "<option value=\"$_->[0]\">$_->[1] $_->[2]</option>";
        if ( $_->[1] >= $l1f and $_->[1] <= $l1t ) {
            $class1 .= $tmp_str;
            $max[0]++;
        }
        if ( $_->[1] >= $l2f and $_->[1] <= $l2t ) {
            $class2 .= $tmp_str;
            $max[1]++;
        }
        if ( $_->[1] >= $l3f and $_->[1] <= $l3t ) {
            $class3 .= $tmp_str;
            $max[2]++;
        }
    }

    for (@max) { $max_size = $_ if ( $max_size < $_ ) }
    $max_size = 10 if $max_size < 10;

    my ( $head, $act );
    if ( defined( param('goto') ) and param('goto') eq 'totals' ) {
        $head = '  ';
        $act  = 'score_list_class_totals';
    }
    elsif ( defined( param('goto') ) and param('goto') eq 'subgroups' ) {
        $head = '   ';
        $act  = 'subgroups';
    }
    elsif ( defined( param('goto') ) and param('goto') eq 'score_top' ) {
        $head = '  ';
        $act  = 'score_top';

    }
    else {
        $head = '  ';
        $act  = 'score_list_class';
    }

    my $str_subjects;

    my $check_show_all = '';

    if ( $ggid == 2 and $filter_for_teacher ) {
        $str_subjects = filter_subj_teacher_binded(undef);
        $max_size     = 10;
    }
    else {
        $str_subjects = filter_subj(undef);
    }

    if ( $ggid == 2 ) {
        my $checked = $gteacher_show_all ? '' : 'checked';
        my $disabled;
        my $binding_param_id = $gteacher_show_all ? 0 : 1;
        if ($disable_checkbox) {
            $disabled = 'disabled';
        }
        else {
            $disabled = '';
        }
        $check_show_all = qq[
<div class=panel style="padding:4px;">
<input $checked $disabled type=checkbox id="check_show_all" onclick="switch_binding($binding_param_id)"><label for="check_show_all"> <img src="/sp/img/teacher_bind.gif" align=absmiddle>   </label>
</div>
];
    }

    my %replace = (
        menu           => generate_menu(),
        head           => $head,
        check_show_all => $check_show_all,
        class1         => $class1,
        class2         => $class2,
        class3         => $class3,
        act            => $act,
        subj           => $str_subjects,
        max_size       => $max_size,
        footers        => generate_footers()
    );
    tpl( "./tpl/score_form_select_class.html", \%replace );
}

sub score_list_class() {
    my ( $q, @a, $selected );
    my $selected_class;
    my $selected_subj = param('s') or stop "   .";
    my $selected_grp  = param('g');
    my $period        = param('period') || -1;
    my ( $class, $subj, $combo_period );

    sec_gt0 param('s');

    if ( defined $period and $period != -1 ) {
        security_alert( param('period') )
          unless grep /^\Q$period\E$/, ( 1 .. 7, 10, 11 );
    }

    if ( $ggid == 4 ) {
        $selected_class = get_pupil_class(0);
    }
    else {
        $selected_class = param('c') or stop "   .";
    }
    sec_gt0 $selected_class;

    unless (
        sqlff "select paralel from sys_matrix
  where sys_matrix.view_class = 7 and class = $selected_class and
        exists ( select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0)"
      )
    {
        stop "   .";
    }

    if ( $ggid == 2 and !defined $selected_grp and !$gteacher_show_all ) {
        $selected_grp = sqlff qq[select subgrp from sys_matrix
where view_class = 9001
and vw_teacher = $guid
and class = $selected_class
and lesson = $selected_subj
and subgrp is not null
and exists ( select 1 from get_node_saldo_by_unit ( sys_matrix.node_id, '$gdate', '', 0 )
where saldo_sum <> 0)] || undef;
    }

    my $link = get_class_link($selected_class);

    my $periods_mode =
      sqlff q[select F_INT from SP_SETTINGS where NAME = 'periods_mode'];

    my $is_half_year = is_half_year($selected_class);
    my $enable_half_year =
      sqlff "select f_int from sp_settings where name = 'enable_half_year'";

    my $now = time;

    if ( !$is_half_year and $period == 10 or $period == 11 ) { $period = -1; }

    my @half_year_periods = split /,/, sqlff(
        "select f_char from sp_settings
                        where name = 'half_year_periods'"
    );

    if ( $period == -1 ) {
        if ( $enable_half_year and $is_half_year ) {
            $period =
              ( $now >= $half_year_periods[0] and $now < $half_year_periods[1] )
              ? 10
              : 11;
        }
        else {
            my @ids = ( $periods_mode == 1 ) ? ( 1, 4 ) : ( 5, 7 );
            $period = sqlff(
                "select sp_periods.id from sp_periods
        where link = $link and
        $now between time_start and time_end
        and id between $ids[0] and $ids[1]"
            );
            $period ||= ( $periods_mode == 1 ) ? 1 : 5;
        }
    }

    my (
        $scores_head, $scores_num,  $scores_mon,
        $alt_start,   @alt_middles, $alt_end
    );

    $scores_mon = $scores_num = '';

    my @periods;

    if ( $enable_half_year and $is_half_year ) {
        @periods = ( '1 ', '2 ' );
    }
    else {
        @periods =
          $periods_mode
          ? ( '1 ', '2 ', '3 ', '4 ' )
          : ( '1 ', '2 ', '3 ' );
    }

    my $value_counter = $periods_mode ? 1 : 5;
    if ( $enable_half_year and $is_half_year ) {
        $value_counter = 10;
    }
    for (@periods) {
        if ( $value_counter == $period ) {
            $combo_period .=
              "<option selected value=$value_counter>$_</option>";
        }
        else { $combo_period .= "<option value=$value_counter>$_</option>" }
        $value_counter++;
    }

    my @times;
    if ( $enable_half_year and $is_half_year ) {
        @times =
            ( $period == 10 )
          ? ( $half_year_periods[0], $half_year_periods[1] )
          : ( $half_year_periods[2], $half_year_periods[3] );
    }
    else {
        @times = sqlf(
            "select time_start, time_end from sp_periods
                        where link = $link and id = $period"
        );
    }

    my ( undef, undef, undef, undef, undef, $y, undef, undef, undef ) =
      localtime;
    my ( undef, undef, undef, $d1, $m1, $y1, undef, undef, undef ) =
      localtime( $times[0] );
    my ( undef, undef, undef, $d2, $m2, $y2, undef, undef, undef ) =
      localtime( $times[1] );

    if ($state_date) {
        my @year      = year_academic();
        my $year_turn = $y2 - $y1;

        if ( $m1 > 6 ) {
            $times[0] = timelocal undef, undef, undef, $d1, $m1, $year[0];
        }
        else {
            $times[0] = timelocal undef, undef, undef, $d1, $m1, $year[1];
        }
        if ( $m2 > 6 ) {
            $times[1] = timelocal undef, undef, undef, $d2, $m2,
              ( $year[0] + ( $y2 - $y1 ) );
        }
        else {
            $times[1] = timelocal undef, undef, undef, $d2, $m2,
              ( $year[0] + ( ($year_turn) ? 0 : 1 ) + ( $y2 - $y1 ) );
        }
        ( undef, undef, undef, $d1, $m1, $y1, undef, undef, undef ) =
          localtime( $times[0] );
        ( undef, undef, undef, $d2, $m2, $y2, undef, undef, undef ) =
          localtime( $times[1] );

    }

    my $y1_tmp = $y1;
    my $y2_tmp = $y2;

    if ( $y1 != $y or $y2 != $y ) {
        $y1_tmp += 1900;
        $y2_tmp += 1900;
        $y1_tmp = " $y1_tmp .";
        $y2_tmp = " $y2_tmp .";
    }
    else {
        $y1_tmp = $y2_tmp = '';
        $y1 += 1900;
        $y2 += 1900;
    }
    my $dat1 = "$d1 $mnths[$m1]$y1_tmp";
    my $dat2 = "$d2 $mnths[$m2]$y2_tmp";

    my $scf = param('f');
    if ( $scf and $scf != -1 && $scf != -2 ) {
        if ($scf) { sec_range $scf, $gconf{score_min}, $gconf{score_max} }
    }
    my $scfsql = '';
    if ($scf) {
        $scfsql = "and score = $scf";
    }

    my ( $grp_sql1, $grp_sql2, $grp_sql3 );
    $grp_sql1 = $grp_sql2 = $grp_sql3 = '';
    if ($selected_grp) {
        sec_gt0 $selected_grp;
        if ( sqlff
"select id from sp_class_subgrp_ref where c = $selected_class and s = $selected_subj"
          )
        {
            $grp_sql1 = ", sp_class_subgrp";
            $grp_sql2 =
"and sp_class_subgrp.uid = sp_scores.uid and sp_class_subgrp.id = $selected_grp";
            $grp_sql3 =
"and sp_class_subgrp.uid = human.human_id and sp_class_subgrp.id = $selected_grp";
        }
    }

    my %show;
    my $datetime;
    $q = sqlp( "
select distinct scoretime
 from  sp_scores, sys_matrix$grp_sql1
where  vw_pupil = uid
  and  scoretime between $times[0] and $times[1]
  and  sp_scores.subj = $selected_subj
  $scfsql
  $grp_sql2
  and  sys_matrix.class = $selected_class
  and  exists
  (
    select 1 from get_node_saldo (sys_matrix.node_id, '$gdate', 0)
    where saldo_sum <> 0
  )" );
    while ( $datetime = ( $q->fetchrow_array() )[0] ) {
        $show{$datetime} = 1;
    }
    $q->finish;

    my $table_output = 1;
    if ( !%show ) {
        $scores_head = '<h1 id=error align=center> .<br></h1>
<h2 align=center>   .</h2>';
        $table_output = 0;
    }

    if ($table_output) {

        $scores_head = "<table class=d cellspacing=0 cellspacing=0 align=center>
<tr align=center><th colspan=3></th>";

        my $cell_count = 0;
        my $wday;
        my $cell_date1 = $times[0];
        my $edt_title  = 'title="    "';
        my $dow = ( localtime( timelocal( 0, 0, 0, $d1, $m1, $y1 ) ) )[6];
        for ( my $x = $d1 ; $x <= $daysinmonth[$m1] ; $x++ ) {
            if ( $show{$cell_date1} ) {
                $alt_start++;
                $scores_num .=
                  $ggid == 4
                  ? "<td><b>$x</b><br>$wdays2[$dow]</td>"
                  : "<td><a $edt_title href='?act=score_form_class&mode=1&s=$selected_subj&c=$selected_class&p=$period&d=$cell_date1&g=$selected_grp'>$x</a><br>$wdays2[$dow]</td>";
            }
            $cell_count++;
            $dow++;
            $dow = 0 if $dow == 7;
            $cell_date1 = day_add($cell_date1);
        }
        my $middle_counter = 0;
        if ( $m2 > $m1 ) {
            $dow = ( localtime( timelocal( 0, 0, 0, 1, $m1 + 1, $y1 ) ) )[6];
            for ( my $mx = $m1 + 1 ; $mx < $m2 ; $mx++ ) {
                for ( my $day = 1 ; $day <= $daysinmonth[$mx] ; $day++ ) {
                    if ( $show{$cell_date1} ) {
                        $scores_num .=
                          $ggid == 4
                          ? "<td><b>$day</b><br>$wdays2[$dow]</td>"
                          : "<td><a $edt_title href='?act=score_form_class&mode=1&s=$selected_subj&c=$selected_class&p=$period&d=$cell_date1&g=$selected_grp'>$day</a><br>$wdays2[$dow]</td>";
                        $alt_middles[$middle_counter]++;
                    }
                    $cell_count++;
                    $dow++;
                    $dow = 0 if $dow == 7;
                    $cell_date1 = day_add($cell_date1);
                }
                $middle_counter++;
            }
        }
        else {
            for ( my $mx = $m1 + 1 ; $mx < 12 ; $mx++ ) {
                $dow =
                  ( localtime( timelocal( 0, 0, 0, 1, $m1 + 1, $y1 ) ) )[6];
                for ( my $day = 1 ; $day <= $daysinmonth[$mx] ; $day++ ) {
                    if ( $show{$cell_date1} ) {
                        $scores_num .=
                          $ggid == 4
                          ? "<td><b>$day</b><br>$wdays2[$dow]</td>"
                          : "<td><a $edt_title href='?act=score_form_class&mode=1&s=$selected_subj&c=$selected_class&p=$period&d=$cell_date1&g=$selected_grp'>$day</a><br>$wdays2[$dow]</td>";
                        $alt_middles[$middle_counter]++;
                    }
                    $cell_count++;
                    $dow++;
                    $dow = 0 if $dow == 7;
                    $cell_date1 = day_add($cell_date1);
                }
                $middle_counter++;
            }
            for ( my $mx = 0 ; $mx < $m2 ; $mx++ ) {
                for ( my $day = 1 ; $day <= $daysinmonth[$mx] ; $day++ ) {
                    if ( $show{$cell_date1} ) {
                        $scores_num .=
                          $ggid == 4
                          ? "<td><b>$day</b><br>$wdays2[$dow]</td>"
                          : "<td><a $edt_title href='?act=score_form_class&mode=1&s=$selected_subj&c=$selected_class&p=$period&d=$cell_date1&g=$selected_grp'>$day</a><br>$wdays2[$dow]</td>";
                        $alt_middles[$middle_counter]++;
                    }
                    $cell_count++;
                    $dow++;
                    $dow = 0 if $dow == 7;
                    $cell_date1 = day_add($cell_date1);
                }
                $middle_counter++;
            }
        }
        $dow = ( localtime( timelocal( 0, 0, 0, 1, $m2, $y2 ) ) )[6];
        for ( my $x = 1 ; $x <= $d2 ; $x++ ) {
            if ( $show{$cell_date1} ) {
                $scores_num .=
                  $ggid == 4
                  ? "<td><b>$x</b><br>$wdays2[$dow]</td>"
                  : "<td><a $edt_title href='?act=score_form_class&mode=1&s=$selected_subj&c=$selected_class&p=$period&d=$cell_date1&g=$selected_grp'>$x</a><br>$wdays2[$dow]</td>";
                $alt_end++;
            }
            $cell_count++;
            $dow++;
            $dow = 0 if $dow == 7;
            $cell_date1 = day_add($cell_date1);
        }

        my $index_middle = 0;
        if ( $m2 > $m1 ) {
            for ( my $x = $m1 ; $x <= $m2 ; $x++ ) {
                if ( $x == $m1 ) {
                    if ($alt_start) {
                        $scores_mon .=
                          "<th colspan=$alt_start>$mnths2[$x]</th>";
                    }
                }
                elsif ( $x == $m2 ) {
                    if ($alt_end) {
                        $scores_mon .= "<th colspan=$alt_end>$mnths2[$x]</th>";
                    }
                }
                else {
                    if ( $alt_middles[$index_middle] ) {
                        $scores_mon .=
"<th colspan=$alt_middles[$index_middle]>$mnths2[$x]</th>";
                    }
                    $index_middle++;
                }
            }
        }
        else {
            for ( my $x = $m1 ; $x < 12 ; $x++ ) {
                if ( $x == $m1 ) {
                    if ($alt_start) {
                        $scores_mon .=
                          "<th colspan=$alt_start>$mnths2[$x]</th>";
                    }
                }
                elsif ( $x == $m2 ) {
                    if ($alt_end) {
                        $scores_mon .= "<th colspan=$alt_end>$mnths2[$x]</th>";
                    }
                }
                else {
                    if ( $alt_middles[$index_middle] ) {
                        $scores_mon .=
"<th colspan=$alt_middles[$index_middle]>$mnths2[$x]</th>";
                    }
                    $index_middle++;
                }
            }
            for ( my $x = 0 ; $x <= $m2 ; $x++ ) {
                if ( $x == $m1 ) {
                    if ($alt_start) {
                        $scores_mon .=
                          "<th colspan=$alt_start>$mnths2[$x]</th>";
                    }
                }
                elsif ( $x == $m2 ) {
                    if ($alt_end) {
                        $scores_mon .= "<th colspan=$alt_end>$mnths2[$x]</th>";
                    }
                }
                else {
                    if ( $alt_middles[$index_middle] ) {
                        $scores_mon .=
"<th colspan=$alt_middles[$index_middle]>$mnths2[$x]</th>";
                    }
                    $index_middle++;
                }
            }
        }

        my $avgsort =
          ( param('sort') eq 'avg' )
          ? qq[<a class=small href="?act=score_list_class&c=$selected_class&s=$selected_subj&period=$period&f=$scf&g=$selected_grp" title="   , . .     " onclick="LoadingShow(1);"> </a>]
          : '&nbsp;';
        my $avgsort_on =
          ( param('sort') eq '' )
          ? qq[<a class=small href="?act=score_list_class&c=$selected_class&s=$selected_subj&period=$period&f=$scf&g=$selected_grp&sort=avg" title="   " onclick="LoadingShow(1);"></a>]
          : '';
        $scores_mon .=
"</tr><tr align=center><td colspan=2>$avgsort</td><td>$avgsort_on</td>";

        my $order_human =
          ( param('sort') eq 'avg' ) ? '' : 'order by last_name';
        $q = sqlp(
            "select human_id, last_name, first_name, middle_name
from sys_matrix, human$grp_sql1
where human_id = vw_pupil
$grp_sql3
and sys_matrix.view_class = 1
and sys_matrix.class = $selected_class
and exists(select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0)
$order_human"
        );
        my @human;
        my %names_hash;
        my $x = 0;
        while ( @a = $q->fetchrow_array() ) {
            push @human, $a[0];
            $names_hash{ $a[0] } =
                trim( $a[1] ) 
              . "&nbsp;"
              . substr( trim( $a[2] ), 0, 1 )
              . ".&nbsp;"
              . substr( trim( $a[3] ), 0, 1 ) . ".";
        }
        $q->finish;

        my ( $uid, $avg );
        my $id = 0;
        my ( %scores_avg, %scores_avg_cache );
        $q = sqlp(
            "select uid,
AVG (CAST(sp_scores.score as float))
from sp_scores, sys_matrix$grp_sql1
where scoretime between $times[0] and $times[1]
and subj = $selected_subj
and sys_matrix.class = $selected_class
and sp_scores.uid = sys_matrix.vw_pupil
$grp_sql2
and score > 0
and exists
(
  select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0)
  where saldo_sum <> 0
)
group by uid"
        );
        my @uids_list_avg;
        while ( ( $uid, $avg ) = $q->fetchrow_array() ) {
            if ( param('sort') eq 'avg' ) {
                push @uids_list_avg, $uid;
            }
            $avg = sprintf( "%.$gconf{avg_precision}f", $avg );
            $avg = '&nbsp;' if ( $avg =~ /^0\.0+$/ );
            $scores_avg{"$avg\u$uid"} = $id++;
            $scores_avg_cache{"$uid"} = $avg;
        }
        $q->finish;

        if ( param('sort') eq 'avg' ) {
            my @uids_new;
            push @uids_new, $uids_list_avg[ $scores_avg{$_} ]
              for ( reverse sort keys %scores_avg );
            my @uids_old;
            push @uids_old, @human;
            undef @human;
            push @human, @uids_new;
            my %hash;
            @hash{@human} = ();
            my @lost;
             for (@uids_old) {
                push( @lost, $_ ) unless exists $hash{$_};
            }
            push @human, @lost if @lost;
        }

        my @cell_dates;
        my $cell = $times[0];
        for ( my $x = 0 ; $x < $cell_count ; $x++ ) {
            $cell_dates[$x] = $cell;
            $cell = day_add($cell);
        }

        my %dates_more;
        my %dates_more_src;

        my $counter = 0;
        for my $i (@human) {
            $counter++;
            $q = sqlp(
                "select scoretime, score, score_src
           from sp_scores$grp_sql1
          where sp_scores.uid  = $i
                $scfsql $grp_sql2
                and subj = $selected_subj
                and scoretime between $times[0] and $times[1]"
            );

            my %scores;
            my %scores_src;
            while ( @a = $q->fetchrow_array() ) {
                if ( !$scores{ $a[0] } ) { $scores{ $a[0] } = $a[1] }
                else {
                    $dates_more{"$i$a[0]"} .=
                        q[/<span style="color:]
                      . get_score_color( $a[1] ) . q[">]
                      . "<b>$a[1]</b></span>";
                }
                if ( !$scores_src{ $a[2] } ) {
                    $scores_src{ $a[0] } = $a[2] if ( $a[2] );
                    if ( !$dates_more_src{"$i$a[0]"} ) {
                        $dates_more_src{"$i$a[0]"} = $a[2];
                    }
                    else { $dates_more_src{"$i$a[0]"} .= "/$a[2]" if $a[2] }
                }
            }
            $q->finish;

            $avg = $scores_avg_cache{$i} || '&nbsp;';

            my ( $color, $temp, $src, $scores_more, $scores_more_src );
            my ( $add_style, $add_title, $fio );
            if ( $ggid != 4 ) {
                $fio =
qq[<a class=small style="font-weight:normal" href="?act=score_all_subjects&uid=$i">$names_hash{$i}</a>];
            }
            else {
                $fio =
                  ( $guid == $i )
                  ? qq[<a class=small_uid href="?act=score_all_subjects">$names_hash{$i}</a>]
                  : $names_hash{$i};
            }
            $scores_num .=
q[<tr align=center OnMouseOver='m_over(this);' OnMouseOut='m_out(this);'>]
              . qq[<td align=right class='def pr2'>$counter</td>]
              . qq[<td align=left>$fio</td><td>$avg</td>];
            for ( my $x = 0 ; $x < $cell_count ; $x++ ) {
                if ( $scores{ $cell_dates[$x] } ) {
                    $color = get_score_color( $scores{ $cell_dates[$x] } );
                    $src   = $scores_src{ $cell_dates[$x] };

                    if ( $dates_more{"$i$cell_dates[$x]"} ) {
                        $scores_more = $dates_more{"$i$cell_dates[$x]"};
                    }
                    else { $scores_more = '' }

                    if ( $dates_more_src{"$i$cell_dates[$x]"} ) {
                        $scores_more_src = $dates_more_src{"$i$cell_dates[$x]"};
                    }
                    else { $scores_more_src = '' }

                    if ($src) {
                        $add_title =
qq[ class=score_changed title=" : $scores_more_src"];
                    }
                    else { $add_title = ''; }
                    $scores{ $cell_dates[$x] } =~ s/-2//g;
                    $scores{ $cell_dates[$x] } =~ s/-1//g;
                    $scores_more               =~ s/-2//g;
                    $scores_more               =~ s/-1//g;
                    $scores_num .=
"<td$add_title><span style='color:$color'><b>$scores{$cell_dates[$x]}</b></span>$scores_more</td>";
                }
                else {
                    if ( $show{ $cell_dates[$x] } ) {
                        $scores_num .= "<td>&nbsp;</td>";
                    }
                }
            }
        }
        $scores_num .= "</tr></table>";

        if ( isadmin() ) {
            $scores_num .=
"<div style='margin-top:8px' class=c><a href='?act=sms_select_scores_by_date_and_recipients_form&c=$selected_class&from=$times[0]&to=$times[1]'>  SMS</a></div>";
        }

    }

    my $combo_scores_selected_all = $scf ? 'selected' : '';
    my $combo_scores_selected_n  = ( $scf and $scf == -1 ) ? 'selected' : '';
    my $combo_scores_selected_nu = ( $scf and $scf == -2 ) ? 'selected' : '';
    my $combo_scores =
      qq[<option value="" $combo_scores_selected_all></option>
<option value="-1" $combo_scores_selected_n></option>
<option value="-2" $combo_scores_selected_nu></option>];
    my $combo_scores_selected = param('f') || 0;
    for ( my $x = $gconf{"score_max"} ; $x >= $gconf{"score_min"} ; $x-- ) {
        if ( $combo_scores_selected == $x ) {
            $combo_scores .= "<option selected value='$x'>$x</option>";
        }
        else { $combo_scores .= "<option value='$x'>$x</option>" }
    }

    my $hidden_sort = param('sort') || '';

    my $fx = '';
    if ( $ggid == 4 ) {
        $fx =
qq[<a href="?act=score_list_class_totals&s=$selected_subj&c=$selected_class">  </a>];
    }

    if ( $ggid != 4 ) {
        my $days_items;
        for ( 1 .. 15 ) {
            if ( $_ == 1 ) {
                $days_items .= q[<option value="1" selected>1</option>];
            }
            else { $days_items .= qq[<option value="$_">$_</option>] }
        }
        $selected_grp ||= '';
        $fx .= qq{<form name="form_date">
	<input type=hidden name=s value='$selected_subj'>
	<input type=hidden name=c value='$selected_class'>
	<input type=hidden name=p value='$period'>
	<input type=hidden name=g value='$selected_grp'>
	<input type=hidden name=mode value=1>
	<input type=hidden name=act value="score_form_class">

	<table width="100%" border="0" cellpadding=0 cellspacing=0>
	<tr>
	  <td align=right valign=baseline style="padding-right: 12px; border-right: 1px solid black">
	    <b></b>: &nbsp;&nbsp;<input type=text class=def size=10 maxlength=10 name=d id=d value="$gdate">
	    <img onclick="show_cal('d',event);" src="/sp/img/date.gif" title="" width=16 height=16 border=0 align=absmiddle class=hand>&nbsp;
	    -  <select class=def name="days">$days_items</select>&nbsp;
	    <a href="#" onclick="if (document.form_date.days.value == 1) document.form_date.mode.value=1; else document.form_date.mode.value=2; document.form_date.submit();"></a>
	  </td>
	  <td align=left valign=baseline style="padding-left: 12px;">
	    <b></b>: <a href="?act=score_list_class_totals&s=$selected_subj&c=$selected_class&g=$selected_grp\"></a>, <a href=\"?act=score_form_class&mode=3&s=$selected_subj&c=$selected_class&p=$period&g=$selected_grp"></a>
	  </td>
	</tr>
</table>

</form>

<div id="cal" class=cal></div>
};
    }

    my $filter_class;
    if ( $ggid == 4 ) {
        $filter_class =
          qq [<input type=hidden name="c" value="$selected_class">];
    }
    else {
        if ($gteacher_show_all) {
            $class = filter_class( $selected_class || 0 );
        }
        else {
            $class = filter_class_teacher_binded( $selected_class || 0 );
        }
        $filter_class .=
qq{ <select class=def name=c onchange='LoadingShow(1); document.filter.submit();'>
$class
</select>}
    }

    my $filter_subj;
    if ( $ggid == 2 ) {
        $filter_subj =
          $gteacher_show_all
          ? filter_subj($selected_subj)
          : filter_subj_teacher_binded($selected_subj);
    }
    else {
        $filter_subj = filter_subj($selected_subj);
    }

    if ( $ggid == 2 ) {
        my $corrected_class = $selected_class;
        my $corrected_subj  = $selected_subj;
        my $redir           = 0;
        unless ( $class =~ m/value="$selected_class"/ ) {
            $redir = 1;
            $class =~ /value="(\d+)"/;
            $corrected_class = $1;
        }
        unless ( $filter_subj =~ m/value="$selected_subj"/ ) {
            $redir = 1;
            $filter_subj =~ /value="(\d+)"/;
            $corrected_subj = $1;
        }
        if ($redir) {
            redir
"score_list_class&c=$corrected_class&s=$corrected_subj&period=$period&f=$scf&g=$selected_grp";
        }
    }

    tpl(
        "./tpl/score_list_class.html",
        {
            menu         => generate_menu(),
            fx           => $fx,
            combo_class  => $filter_class,
            combo_subj   => $filter_subj,
            combo_period => $combo_period,
            combo_scores => $combo_scores,
            subgrp       => filter_subgrp(
                $selected_class, $selected_subj,
                $selected_grp,   'LoadingShow(1); document.filter.submit();'
            ),
            hidden_sort => $hidden_sort,
            date1       => $dat1,
            date2       => $dat2,
            scores      => join( '', $scores_head, $scores_mon, $scores_num ),
            footers     => generate_footers()
        }
    );

}

sub score_list_class_totals() {
    my ( $Y, $T1, $T2, $T3, $Q1, $Q2, $Q3, $Q4 );
    my ( $q, $head, $t, @a, $g );

    my $subj = param('s');
    sec_gt0 $subj;

    my $class;
    if ( $ggid == 4 ) {
        $class = get_pupil_class(0);
    }
    else {
        $class = param('c') or stop "   .";
        sec_gt0 $class;
    }

    my $is_half_year = is_half_year($class);

    my ( $grp_sql1, $grp_sql2, $grp_sql3 );
    $g = param('g');
    if ($g) {
        sec_gt0 $g;
        if ( sqlff
            "select id from sp_class_subgrp_ref where c = $class and s = $subj"
          )
        {
            $grp_sql1 = ', sp_class_subgrp';
            $grp_sql2 =
"and sp_class_subgrp.uid = human.human_id and sp_class_subgrp.id = $g";
        }
        else {
            $grp_sql1 = $grp_sql2 = '';
        }
    }

    if ( $ggid == 2 and !defined $g and !$gteacher_show_all ) {
        $g = sqlff qq[select subgrp from sys_matrix
where view_class = 9001
and vw_teacher = $guid
and class = $class
and lesson = $subj
and subgrp is not null
and exists ( select 1 from get_node_saldo_by_unit ( sys_matrix.node_id, '$gdate', '', 0 )
where saldo_sum <> 0)] || undef;
    }

    my $periods_mode =
      sqlff "SELECT F_INT FROM SP_SETTINGS WHERE NAME = 'periods_mode'" || 0;

    my $enable_half_year =
      sqlff "select f_int from sp_settings where name = 'enable_half_year'";
    my $total = '';

    if ( $enable_half_year and $is_half_year ) {
        my @h;
        if ( $ggid == 4 ) {
            @h = ( '1 ', '2 ' );
        }
        else {
            @h = (
qq[<a href="?act=score_form_class&mode=3&s=$subj&c=$class&g=$g&p=10">1 </a>],
qq[<a href="?act=score_form_class&mode=3&s=$subj&c=$class&g=$g&p=11">2 </a>]
            );
            $total =
qq[<a href="?act=score_form_class&mode=3&s=$subj&c=$class&g=$g&p=9"></a>]
              ,;
        }
        $head = qq[<tr>
      <th class='pad_lr5'></th>
      <th class='pad_lr5'>$h[0]</th>
      <th class='pad_lr5'>$h[1]</th>
      <th class='pad_lr5'></th>
      <th title=",   " class='pad_lr5'>.</th>
      <th class='pad_lr5'>$total</th>
    </tr>];
    }
    elsif ( $periods_mode == 0 ) {
        my @h;
        if ( $ggid == 4 ) {
            @h = ( '1 ', '2 ', '3 ' );
        }
        else {
            @h = (
qq[<a href="?act=score_form_class&mode=3&s=$subj&c=$class&g=$g&p=5">1 </a>],
qq[<a href="?act=score_form_class&mode=3&s=$subj&c=$class&g=$g&p=6">2 </a>],
qq[<a href="?act=score_form_class&mode=3&s=$subj&c=$class&g=$g&p=7">3 </a>]
            );
            $total =
qq[<a href="?act=score_form_class&mode=3&s=$subj&c=$class&g=$g&p=9"></a>]
              ,;
        }
        $head = qq[<tr>
      <th class='pad_lr5'></th>
      <th class='pad_lr5'>$h[0]</th>
      <th class='pad_lr5'>$h[1]</th>
      <th class='pad_lr5'>$h[2]</th>
      <th class='pad_lr5'></th>
      <th title=",   " class='pad_lr5'>.</th>
      <th class='pad_lr5'>$total</th>
    </tr>];
    }
    else {
        my @h;
        if ( $ggid == 4 ) {
            @h = ( '1 ', '2 ', '3 ', '4 ' );
        }
        else {
            @h = (
qq[<a href="?act=score_form_class&mode=3&s=$subj&c=$class&g=$g&p=1">1 </a>],
qq[<a href="?act=score_form_class&mode=3&s=$subj&c=$class&g=$g&p=2">2 </a>],
qq[<a href="?act=score_form_class&mode=3&s=$subj&c=$class&g=$g&p=3">3 </a>],
qq[<a href="?act=score_form_class&mode=3&s=$subj&c=$class&g=$g&p=4">4 </a>]
            );
            $total =
qq[<a href="?act=score_form_class&mode=3&s=$subj&c=$class&g=$g&p=9"></a>]
              ,;
        }
        $head = qq[<tr style="white-space: nowrap;">
      <th class='pad_lr5'></th>
      <th class='pad_lr5'>$h[0]</th>
      <th class='pad_lr5'>$h[1]</th>
      <th class='pad_lr5'>$h[2]</th>
      <th class='pad_lr5'>$h[3]</th>
      <th class='pad_lr5'></th>
      <th title=",   " class='pad_lr5'>.</th>
      <th class='pad_lr5'>$total</th>
    </tr>];
    }

    $q = sqlp(
        "select human_id, last_name, first_name, middle_name
from sys_matrix, human$grp_sql1
where
human_id = vw_pupil
and sys_matrix.view_class = 1
and sys_matrix.class = $class
$grp_sql2
and exists(select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0)
order by last_name"
    );
    my ( @uids, @names );
    while ( @a = $q->fetchrow_array() ) {
        for my $i ( 1 .. 3 ) { $a[$i] = trim $a[$i] }
        push @uids, $a[0];
        push @names,
qq{$a[1]&nbsp;$a[2]&nbsp;$a[3] <br><a class=small href="?act=score_year&uid=$a[0]&s=$subj">   </a>};
    }
    $q->finish;

    my ( $year_total, undef ) = year_academic();

    my ( @scores_total, $score_index, $color );
    my ( $add, $mark_type, $mt1, $mt2, $mt3, $trimestr_id );
    $mt1 = '<span class=tot_na><br></span>';
    $mt2 = '<span class=tot_freed></span>';
    $mt3 = '<span class=tot_home> <br></span>';

    for ( my $i = 0 ; $i < @uids ; $i++ ) {

        @scores_total = sqlf(
            "select Y,T1,T2,T3,Q1,Q2,Q3,Q4,E,T,H1,H2,E1 from SP_SCORES_TOTALS
      where SCOREYEAR = $year_total and UID = $uids[$i] and SUBJ = $subj"
        );

        $t .=
'<tr align=center OnMouseOver="m_over(this);" OnMouseOut="m_out(this);" style="height: 28px;">'
          . '<td align=left>'
          . ( $i + 1 )
          . '.&nbsp;'
          . $names[$i] . '</td>';

        if ( $enable_half_year and $is_half_year ) {
            for ( 10 .. 11 ) {
                $mark_type =
                  sqlff "select t from SP_MARKS where y = $year_total "
                  . "and s = $subj and p = $_ and uid = $uids[$i]";
                $add = ( $mark_type == 3 ) ? 1 : 0;
                $mark_type = $mt1 if $mark_type == 1;
                $mark_type = $mt2 if $mark_type == 2;
                $mark_type = $mt3 if $mark_type == 3;
                $add = $add ? '<br>' . $mark_type : '';
                $mark_type = '&nbsp;' if !$mark_type;
                $color = get_score_color( $scores_total[$_] );
                $t .=
                  $scores_total[$_]
                  ? "<td style='color: $color;'><b>$scores_total[$_]$add</b></td>"
                  : "<td>$mark_type</td>";
            }
        }
        elsif ( $periods_mode == 0 ) {
            for ( my $x = 1 ; $x <= 3 ; $x++ ) {
                $trimestr_id = $x + 4;
                $mark_type =
                  sqlff "select t from SP_MARKS where y = $year_total "
                  . "and s = $subj and p = $trimestr_id and uid = $uids[$i]";
                $add = ( $mark_type == 3 ) ? 1 : 0;
                $mark_type = $mt1 if $mark_type == 1;
                $mark_type = $mt2 if $mark_type == 2;
                $mark_type = $mt3 if $mark_type == 3;
                $add = $add ? '<br>' . $mark_type : '';
                $mark_type = '&nbsp;' if !$mark_type;
                $color = get_score_color( $scores_total[$x] );
                $t .=
                  $scores_total[$x]
                  ? "<td style='color: $color;'><b>$scores_total[$x]$add</b></td>"
                  : "<td>$mark_type</td>";
            }
        }
        else {
            for ( my $x = 1 ; $x <= 4 ; $x++ ) {
                $mark_type =
                  sqlff "select t from SP_MARKS where y = $year_total "
                  . "and s = $subj and p = $x and uid = $uids[$i]";
                $add = ( $mark_type == 3 ) ? 1 : 0;
                $mark_type = $mt1 if $mark_type == 1;
                $mark_type = $mt2 if $mark_type == 2;
                $mark_type = $mt3 if $mark_type == 3;
                $add = $add ? '<br>' . $mark_type : '';
                $mark_type   = '&nbsp;' if !$mark_type;
                $score_index = $x + 3;
                $color       = get_score_color( $scores_total[$score_index] );
                $t .=
                  $scores_total[$score_index]
                  ? "<td style='color: $color;'><b>$scores_total[$score_index]$add</b></td>"
                  : "<td>$mark_type</td>";
            }
        }
        $mark_type = sqlff "select t from SP_MARKS where y = $year_total "
          . "and s = $subj and p = 0 and uid = $uids[$i]";
        $add = ( $mark_type == 3 ) ? 1 : 0;
        $mark_type = $mt1 if $mark_type == 1;
        $mark_type = $mt2 if $mark_type == 2;
        $mark_type = $mt3 if $mark_type == 3;
        $add = $add ? '<br>' . $mark_type : '';
        $mark_type = '&nbsp;' if !$mark_type;
        $color = get_score_color( $scores_total[0] );
        $t .=
          $scores_total[0]
          ? "<td style='color: $color;'><span class=tot_year>$scores_total[0]</span>$add</td>"
          : "<td>$mark_type</td>";

        $mark_type = sqlff "select t from SP_MARKS where y = $year_total "
          . "and s = $subj and p = 8 and uid = $uids[$i]";
        $add = ( $mark_type == 3 ) ? 1 : 0;
        $mark_type = $mt1 if $mark_type == 1;
        $mark_type = $mt2 if $mark_type == 2;
        $mark_type = $mt3 if $mark_type == 3;
        $add = $add ? '<br>' . $mark_type : '';
        $mark_type = '&nbsp;' if !$mark_type;
        if ( $scores_total[8] ) {
            $color = get_score_color( $scores_total[8] );
            $t .=
"<td><span class=tot_year><font color='$color'>$scores_total[8]</font>";
            if ( $scores_total[12] ) {
                $color = get_score_color( $scores_total[12] );
                $t .= "/<font color='$color'>$scores_total[12]</font>";
            }
            $t .= "</span>$add</td>";
        }
        else {
            $t .= "<td>$mark_type</td>";
        }
        $color = get_score_color( $scores_total[8] );

        $mark_type = sqlff "select t from SP_MARKS where y = $year_total "
          . "and s = $subj and p = 9 and uid = $uids[$i]";
        $add = ( $mark_type == 3 ) ? 1 : 0;
        $mark_type = $mt1 if $mark_type == 1;
        $mark_type = $mt2 if $mark_type == 2;
        $mark_type = $mt3 if $mark_type == 3;
        $add = $add ? '<br>' . $mark_type : '';
        $mark_type = '&nbsp;' if !$mark_type;
        $color = get_score_color( $scores_total[9] );
        $t .=
          $scores_total[9]
          ? "<td style='color: $color;'><span class=tot_year>$scores_total[9]</span>$add</td>"
          : "<td>$mark_type</td>";

        $t .= "</tr>";
    }

    my $current_year = $year_total . ' &ndash; ' . ( $year_total + 1 );

    my $fx;

    if ( $ggid == 4 ) {
        $fx = '';
    }
    else {
        $fx = qq[<form name=score_form_class style="margin-top:4px">
  <input type=hidden name="act" value="score_form_class">
  <input type=hidden name="s" value="$subj">
  <input type=hidden name="c" value="$class">
  <input type=hidden name="g" value="$g">
  <input type=hidden name="mode" value="3">

  <button type=submit style="width:220px">
  <img src="/sp/img/test_edit_a.gif" width="16" height="16" align=absmiddle>&nbsp;   
  </button>&nbsp;&nbsp;&nbsp;

  <a class=dots href=# onclick="turn_visibility('help')"></a>
</form>

<div class="help" id="help" style="display:none; width:600px; margin-top:4px" align=left>
    (  )
      ( ) ,
     // 
  ()     ,
      
   ,    .<br><br>

   &laquo;&raquo;  
    &laquo;&raquo;,
     &laquo;&raquo;.<br><br>

        ,
      .<br><br>

      .
      
      .
</div>];
    }

    my $filter_class;

    my $filter_subj;
    if ( $ggid == 2 ) {
        $filter_class =
          $gteacher_show_all
          ? filter_class($class)
          : filter_class_teacher_binded($class);
        $filter_subj =
          $gteacher_show_all
          ? filter_subj($subj)
          : filter_subj_teacher_binded($subj);
    }
    else {
        $filter_class = filter_class($class);
        $filter_subj  = filter_subj($subj);
    }

    if ( $ggid == 2 ) {
        my $corrected_class = $class;
        my $corrected_subj  = $subj;
        my $redir           = 0;
        unless ( $filter_class =~ m/value="$class"/ ) {
            $redir = 1;
            $filter_class =~ /value="(\d+)"/;
            $corrected_class = $1;
        }
        unless ( $filter_subj =~ m/value="$subj"/ ) {
            $redir = 1;
            $filter_subj =~ /value="(\d+)"/;
            $corrected_subj = $1;
        }
        if ($redir) {
            redir
"score_list_class_totals&c=$corrected_class&s=$corrected_subj&g=$g";
        }
    }

    my $filter_class2 = '';
    if ( $ggid != 4 ) {
        $filter_class2 = qq[
<select class=def name=c onchange='document.filter.submit();'>
$filter_class
</select>];
    }

    my %replace = (
        menu          => generate_menu(),
        fx            => $fx,
        date          => $gdate,
        filter_subj   => $filter_subj,
        filter_class2 => $filter_class2,
        subgrp =>
          filter_subgrp( $class, $subj, $g, 'document.filter.submit();' ),
        current_year => $current_year,
        scores       => join( ' ', $head, $t ),
        footers      => generate_footers()
    );
    tpl( "./tpl/score_list_class_totals.html", \%replace );
}

sub score_all_subjects() {
    stop "    ."
      if ( !param('uid') and $ggid != 4 );

    my $uid = param('uid');
    if   ($uid) { sec_gt0($uid); }
    else        { $uid = $guid; }
    my $d1 = param('d1');
    my $d2 = param('d2');
    if ( $d1 or $d2 ) { sec_date($d1); sec_date($d2); }

    my ( $q, $d, $datetime, @a );

    my $is_half_year = is_half_year( get_pupil_class( 0, $uid || $guid ) );
    my $enable_half_year =
      sqlff "select f_int from sp_settings where name = 'enable_half_year'";

    my $link = get_class_link( get_pupil_class( 0, $uid ) );
    my $periods_mode =
      sqlff q[select F_INT from SP_SETTINGS where NAME = 'periods_mode'];
    my @ids = ( $periods_mode == 1 ) ? ( 1, 4 ) : ( 5, 7 );

    my %period_hash = (
        '1'  => '1 ',
        '2'  => '2 ',
        '3'  => '3 ',
        '4'  => '4 ',
        '5'  => '1 ',
        '6'  => '2 ',
        '7'  => '3 ',
        '10' => '1 ',
        '11' => '2 '
    );

    my @half_year_periods = split /,/,
      sqlff("select f_char from sp_settings where name = 'half_year_periods'");

    my $periods_html = '';

    if ( $enable_half_year and $is_half_year ) {
        my $a1 = todate( $half_year_periods[0] );
        my $a2 = todate( $half_year_periods[1] );
        my $a3 = todate( $half_year_periods[2] );
        my $a4 = todate( $half_year_periods[3] );
        $periods_html .=
qq[<a href="?act=score_all_subjects&uid=$uid&d1=$a1&d2=$a2">1 </a>&nbsp;&nbsp;];
        $periods_html .=
qq[<a href="?act=score_all_subjects&uid=$uid&d1=$a3&d2=$a4">2 </a>&nbsp;&nbsp;];
    }
    else {
        $q = sqlp
"select id, time_start, time_end from sp_periods where link = $link and id between $ids[0] and $ids[1]";
        while ( @a = $q->fetchrow_array ) {
            $a[1] = todate( $a[1] );
            $a[2] = todate( $a[2] );
            $periods_html .=
qq[<a href="?act=score_all_subjects&uid=$uid&d1=$a[1]&d2=$a[2]">$period_hash{$a[0]}</a>&nbsp;&nbsp;];
        }
    }

    my @times;
    my $period;
    if ($d1) {
        @times = ( totime($d1), totime($d2) );
        if ( $times[1] - $times[0] > 31536000 ) {
            stop '    .';
        }
        if ( $times[0] > $times[1] ) { stop '   .' }
    }
    else {
        my $now = time();
        if ( $enable_half_year and $is_half_year ) {
            if (    $now >= $half_year_periods[0]
                and $now < $half_year_periods[1] )
            {
                @times = ( $half_year_periods[0], $half_year_periods[1] );
                $period = 10;
            }
            else {
                @times = ( $half_year_periods[2], $half_year_periods[3] );
                $period = 11;
            }
            $d1 = todate( $times[0] );
            $d2 = todate( $times[1] );
        }
        else {
            $period = sqlff(
                "select sp_periods.id from sp_periods
        where link = $link and
        $now between time_start and time_end
        and id between $ids[0] and $ids[1]"
            );
            $period ||= ( $periods_mode == 1 ) ? 1 : 5;
            @times = sqlf "select time_start, time_end from sp_periods
                        where link = $link and id = $period";
            $d1 = todate( $times[0] );
            $d2 = todate( $times[1] );
        }
    }

    my @fio;
    fio( \@fio, $uid );
    my %s;

    my %show;
    $q = sqlp "select distinct scoretime from sp_scores
where uid = $uid and scoretime between $times[0] and $times[1]";
    while ( $datetime = ( $q->fetchrow_array() )[0] ) {
        $show{$datetime} = 1;
    }
    $q->finish;

    if ( exists( $ENV{'HTTP_REFERER'} )
        and $ENV{'HTTP_REFERER'} =~ /act=score_all_subjects/ )
    {
        stop "    .<br><br>
      ,<br>
   :<br>$periods_html"
          unless int %show;
    }
    else {
        my $period_text = ' ';
        if ($period) {
            $period_text = "  ($period_hash{$period})";
        }
        msg " $period_text  .", qq[  :<br><br>
  <input class=def type='text' name='d1' id='d1' maxlength='10' size='10' value="$d1">&nbsp;<img class=hand onclick="javascript:show_cal('d1',event);" src="/sp/img/date.gif" title="" width=16 height=16 border=0 align=absmiddle>&nbsp;
 <input class=def type='text' name='d2' id='d2' maxlength='10' size='10' value="$d2">&nbsp;<img class=hand onclick="javascript:show_cal('d2',event);" src="/sp/img/date.gif" title="" width=16 height=16 border=0 align=absmiddle>&nbsp;&nbsp;
<button type=submit></button><br><br>
   :<br>$periods_html
<div id="cal"></div>]
          unless keys %show;
    }

    my $dates_line = '';
    my $date;
    for ( sort keys %show ) {
        $date = strftime "%b<br><b>%e</b><br>", localtime($_);
        $date .= $wdays2[ ( strftime '%w', localtime($_) ) ];
        $dates_line .= qq[<td>$date</td>];
    }

    sqlh \%s,
      "select distinct subj, name from sp_scores join lesson on lesson_id = subj
where uid = $uid and scoretime between $times[0] and $times[1]";

    my %avg;
    sqlh \%avg, "select subj, cast(avg(score) as float) from sp_scores
where uid = $uid and scoretime between $times[0] and $times[1] and score > 0
group by subj";
    for ( keys %avg ) {
        $avg{$_} = sprintf( "%.2f", $avg{$_} );
    }

    my %scores;
    $q = sqlp "select scoretime, subj, score from sp_scores
where uid = $uid and scoretime between $times[0] and $times[1]";
    while ( @a = $q->fetchrow_array ) {
        if ( $scores{"$a[0]s$a[1]"} ) {
            $scores{"$a[0]s$a[1]"} .=
                '/<font color="'
              . get_score_color( $a[2] ) . '"><b>'
              . $a[2]
              . '</b></font>';
        }
        else {
            $scores{"$a[0]s$a[1]"} =
                '<font color="'
              . get_score_color( $a[2] ) . '"><b>'
              . $a[2]
              . '</b></font>';
        }
    }

    my $t_left;
    my $t;
    if ( param('avg') ) {
        for ( reverse sort { $avg{$a} <=> $avg{$b} } keys %s ) {
            $avg{$_} ||= '&nbsp;';
            $t_left .=
              qq[<tr><td class=l>$s{$_}</td><td><b>$avg{$_}</b></td></tr>];
            for $d ( sort keys %show ) {
                $scores{"$d\Qs\E$_"} =~ s/-2//go;
                $scores{"$d\Qs\E$_"} =~ s/-1//go;
                $scores{"$d\Qs\E$_"} ||= '&nbsp;';
                $t .= qq[<td>$scores{"$d\Qs\E$_"}</td>];
            }
            $t .= '</tr>';
        }
    }
    else {
        for ( sort { $s{$a} cmp $s{$b} } keys %s ) {
            $avg{$_} ||= '&nbsp;';
            $t_left .=
              qq[<tr><td class=l>$s{$_}</td><td><b>$avg{$_}</b></td></tr>];
            for $d ( sort keys %show ) {
                if ( exists( $scores{"$d\Qs\E$_"} ) ) {
                    $scores{"$d\Qs\E$_"} =~ s/-2//go;
                    $scores{"$d\Qs\E$_"} =~ s/-1//go;
                }
                $scores{"$d\Qs\E$_"} ||= '&nbsp;';
                $t .= qq[<td>$scores{"$d\Qs\E$_"}</td>];
            }
            $t .= '</tr>';
        }
    }

    tpl './tpl/score_all_subjects.html',
      {
        menu          => generate_menu(),
        footers       => generate_footers(),
        fio           => join( ' ', @fio ),
        d1            => $d1,
        d2            => $d2,
        avg_checked   => param('avg') ? 'checked' : '',
        uid           => $uid,
        periods       => $periods_html,
        dates_line    => $dates_line,
        dates_colspan => scalar( keys %show ),
        t_left        => $t_left,
        table         => $t,
      };
}

sub score_all_subjects_class_form() {
    my $filter_class;

    if ( $ggid == 2 ) {
        $filter_class =
          $gteacher_show_all ? filter_class(0) : filter_class_teacher_binded(0);
    }
    else {
        $filter_class = filter_class(0);
    }

    my $this_month_start = $gdate;
    $this_month_start =~ s/\d\d?/01/;

    my $prev_month_end = todate day_sub( totime $this_month_start);

    my $prev_month_start = $prev_month_end;
    $prev_month_start =~ s/\d\d?/01/;

    tpl './tpl/score_all_subjects_class_form.html',
      {
        menu             => generate_menu(),
        footers          => generate_footers(),
        filter_class     => $filter_class,
        d1               => $this_month_start,
        d2               => $gdate,
        prev_month_end   => $prev_month_end,
        prev_month_start => $prev_month_start,
      };
}

sub score_all_subjects_class() {
    my ( @a, $q );

    my @classes = param('c');
    stop "   ." unless @classes;
    for (@classes) { sec_gt0 $_ }

    my ( $d1, $d2 ) = ( param('d1'), param('d2') );
    sec_date $d1;
    sec_date $d2;

    my @times = ( totime($d1), totime($d2) );

    my $classes = join ',', @classes;

    my $page_break_threshold = param('page_break_threshold') || 210;
    sec_range( $page_break_threshold, 100, 900 );

    my @uids;
    $q = sqlp(
        "select human_id, last_name, first_name, middle_name, paralel,
  (select name from class where class_id = cast(sys_matrix.class as integer)),
  sys_matrix.class
from sys_matrix, human
where
  human_id = vw_pupil
  and sys_matrix.view_class = 1
  and sys_matrix.class in ($classes)
  and exists(select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0)
order by 5,6,2,3,4"
    );
    while ( @a = $q->fetchrow_array() ) {
        $a[5] =~ s/^(\s{0,}".+").+/ $1/;
        push @uids, [@a];
    }

    unless (@uids) {
        stop " $gdate     .";
    }

    my $t;
    my $table;

    my %subjects;
    my ( $id, $name );
    my $counter = 1;
    my $datetime;
    my $mm;
    my $mm_all = 0;
    my %hash_class_masters;

    my %dates_by_uid;
    {
        my @tmp;
        for (@uids) { push @tmp, $_->[0]; }
        $q =
            sqlp "select distinct uid, scoretime from sp_scores where uid in ("
          . join( ',', @tmp )
          . ") and scoretime between $times[0] and $times[1] order by scoretime";
        my @a;
        while ( @a = $q->fetchrow_array() ) {
            push @{ $dates_by_uid{ $a[0] } }, $a[1];
        }
        $q->finish;
    }

    my @uids_without_scores;

    for (@uids) {
        $t  = '';
        $mm = 0;

        my $dates_line = '';
        my $date;
        for ( @{ $dates_by_uid{ $$_[0] } } ) {
            $date = strftime "<b>%e</b><br>", localtime($_);

            $date .= $wdays2[ ( strftime '%w', localtime($_) ) ];
            $dates_line .= qq[<td nowrap>$date</td>];
        }

        my $colspan = ( scalar @{ $dates_by_uid{ $$_[0] } } ) + 2;

        $t .= qq[<table class=d border=0 cellspacing=0 cellpadding=0>
<tr><th style="text-align:left" colspan="$colspan">$$_[1] $$_[2] $$_[3] ($$_[4]$$_[5]). : $d1&ndash;$d2</th></tr>];

        $t .= qq[<tr><td> / </td><td></td>$dates_line</tr>];

        $mm += 17.9;

        $q = sqlp "select lesson_id, name from lesson
where exists
  ( select 1 from sp_scores
    where sp_scores.subj = lesson.lesson_id
    and uid = $$_[0]
    and scoretime between $times[0] and $times[1]
  )";
        %subjects = ();
        while ( ( $id, $name ) = $q->fetchrow_array() ) {
            $subjects{"$id"} = $name;
        }

        my %scores_by_subject = ();

        my %scores_by_subject_for_AVG = ();

        $q = sqlp "select subj,scoretime,score from sp_scores
where uid = $$_[0]
and scoretime between $times[0] and $times[1]";
        while ( @a = $q->fetchrow_array() ) {
            push @{ $scores_by_subject_for_AVG{ $a[0] } }, $a[2] if $a[2] > 0;

            if ( $scores_by_subject{ $a[0] }{ $a[1] } ) {
                $scores_by_subject{ $a[0] }{ $a[1] } .=
                    '/<font color="'
                  . get_score_color( $a[2] ) . '">'
                  . $a[2]
                  . '</font>';
            }
            else {
                $scores_by_subject{ $a[0] }{ $a[1] } =
                    '<font color="'
                  . get_score_color( $a[2] ) . '">'
                  . $a[2]
                  . '</font>';
            }

            $scores_by_subject{ $a[0] }{ $a[1] } =~ s/-2//go;
            $scores_by_subject{ $a[0] }{ $a[1] } =~ s/-1//go;
        }

        unless ( scalar keys %scores_by_subject ) {
            push @uids_without_scores, $_->[0];
            next;
        }

        $counter = 1;

        for my $subj ( sort { $subjects{$a} cmp $subjects{$b} } keys %subjects )
        {
            $t .= qq[<tr>];
            $t .=
              qq[<td style="text-align:left">$counter $subjects{$subj}</td>];
            $counter++;

            my $avg = 0;

            for ( @{ $scores_by_subject_for_AVG{$subj} } ) {
                $avg += $_;
            }

            if ($avg) {
                $avg /= scalar( @{ $scores_by_subject_for_AVG{$subj} } );
                $avg = sprintf( "%.$gconf{avg_precision}f", $avg );
            }
            else {
                $avg = '&nbsp;';
            }

            $t .= "<td>$avg</td>";

            for ( @{ $dates_by_uid{ $$_[0] } } ) {
                $t .=
                  $scores_by_subject{$subj}{$_}
                  ? "<td>$scores_by_subject{$subj}{$_}</td>"
                  : "<td>&nbsp;</td>";
            }

            $t .= qq[</tr>];
        }

        $mm += 3.3 * ( scalar keys %subjects );

        unless ( $hash_class_masters{ $$_[6] } ) {
            $hash_class_masters{ $$_[6] } =
              sqlff "select last_name || ' ' || first_name || ' ' || middle_name
from sys_matrix join human on human_id = cast(sys_matrix.vw_teacher as integer)
where view_class = 9003
and sys_matrix.class = $$_[6]
and exists ( select 1 from get_node_saldo_by_unit ( sys_matrix.node_id, '$gdate', '', 0 )
where saldo_sum <> 0)" || 1;
            $hash_class_masters{ $$_[6] } = '-'
              unless $hash_class_masters{ $$_[6] };
        }

        my $class_master_text =
          $hash_class_masters{ $$_[6] } ne '-'
          ? " : $hash_class_masters{$$_[6]}. : __________"
          : '  : __________';

        $class_master_text .=
          '&nbsp;&nbsp;&nbsp;&nbsp; : __________';

        $t .=
qq[</table><p style="border-bottom:1px dashed #ddd;font-size:8pt;margin:9px 0 10px 0;padding-bottom:10px;">$class_master_text</p>];

        if ( $mm_all + $mm >= $page_break_threshold ) {
            $table .=
q[<div style="page-break-after:always"><span style="display:none">&nbsp;</span></div>];
            $mm_all = $mm;
        }
        else {
            $mm_all += $mm;
        }

        $table .= $t;

    }

    my %uids_to_class_and_names =
      map { $_->[0] => "$_->[1] $_->[2] $_->[3] ($_->[4]$_->[5])" } @uids;

    my @names_without_scores;
    for (@uids_without_scores) {
        push @names_without_scores, $uids_to_class_and_names{$_};
    }
    @names_without_scores = sort @names_without_scores;

    my $no_scores =
      scalar(@uids_without_scores)
      ? "<br><b></b>: ,  ,      .        .<br><br>"
      . join '<br>', @names_without_scores
      : '';

    tpl './tpl/score_all_subjects_class.html',
      {
        menu      => generate_menu(),
        footers   => generate_footers(),
        t         => $table,
        no_scores => $no_scores,
      };
}

sub score_year() {
    my $uid = param('uid');
    sec_gt0 $uid;
    my $subj = param('s');
    sec_gt0 $subj;

    my $filter_subj;
    if ( $ggid == 2 ) {
        $filter_subj =
          $gteacher_show_all
          ? filter_subj($subj)
          : filter_subj_teacher_binded($subj);
    }
    else {
        $filter_subj = filter_subj($subj);
    }

    if ( $ggid == 2 ) {
        my $corrected_subj = $subj;
        my $redir          = 0;
        unless ( $filter_subj =~ m/value="$subj"/ ) {
            $redir = 1;
            $filter_subj =~ /value="(\d+)"/;
            $corrected_subj = $1;
        }
        if ($redir) {
            redir "score_year&uid=$uid&s=$corrected_subj";
        }
    }

    my $periods_mode =
      sqlff q[select F_INT from SP_SETTINGS where NAME = 'periods_mode'];

    my $link = get_class_link( get_pupil_class( 0, $uid ) );

    my @months_year;
    $months_year[0] =
      sqlff "select time_start from sp_periods where link = $link and id = 0";

    if ($periods_mode) {
        $months_year[1] =
          sqlff "select time_end from sp_periods where link = $link and id = 7";
    }
    else {
        $months_year[1] =
          sqlff "select time_end from sp_periods where link = $link and id = 4";
    }

    for (@months_year) {
        $_ = todate $_;
        $_ = int( substr( $_, 3, 2 ) );
    }

    my @year_academic = year_academic();

    my $scores = '';
    my ( $q, $scoretime, $scores_str, @tmp, $sum, $count );

    if ( $year_academic[1] % 4 == 0
        and ( $year_academic[1] % 100 != 0 or $year_academic[1] % 400 == 0 ) )
    {
        $daysinmonth[1] = 29;
    }

    $scores .= (
"<tr class=light_grey align=center><td align=left><b style='color:grey'>$year_academic[0]</b></td>"
          . '<td class=min2b>'
          . join( '</td><td class=min2b>', ( 1 .. 31 ) )
          . '</td><td colspan=2>&nbsp;</td></tr>' );

    for ( my $month = $months_year[0] - 1 ; $month < 12 ; $month++ ) {
        $scores .=
"<tr align=center OnMouseOver='m_over(this);' OnMouseOut='m_out(this);'>";
        $scores .= "<td align=left>$mnths2[$month]</td>";

        $sum = $count = 0;
        for ( my $day = 0 ; $day < 31 ; $day++ ) {
            if ( $daysinmonth[$month] < $day + 1 ) {
                $scores .= "<td class=grey>&nbsp;</td>";
            }
            else {
                $scoretime =
                  totime
                  sprintf( "%d.%d.%d", $day + 1, $month + 1,
                    $year_academic[0] );
                $q = sqlp "select score from sp_scores
                  where sp_scores.uid  = $uid
                  and score > 0
                  and subj = $subj
                  and scoretime = $scoretime";
                $scores_str = '';
                while ( @tmp = $q->fetchrow_array ) {
                    $sum += $tmp[0];
                    $count++;
                    $tmp[0] =
                        '<span style="color:'
                      . get_score_color( $tmp[0] )
                      . "\"><b>$tmp[0]</b></span>";
                    $scores_str .=
                      ( $scores_str eq '' ) ? $tmp[0] : '/' . $tmp[0];
                }
                $scores_str ||= '&nbsp;';
                $scores .= "<td>$scores_str</td>";
            }
        }
        if ($count) {
            $sum /= $count;
            $sum = sprintf( "%.01f", $sum );
        }
        $scores .= "<td><b>$sum</b></td>";
        $scores .= "<td>$count</td>";
        $scores .= '</tr>';
    }

    $scores .=
"<tr class=light_grey align=center><td colspan=34 align=left><b style='color:grey'>$year_academic[1]</b></td></tr>";

    for ( my $month = 0 ; $month < $months_year[1] ; $month++ ) {
        $scores .=
"<tr align=center OnMouseOver='m_over(this);' OnMouseOut='m_out(this);'>";
        $scores .= "<td align=left>$mnths2[$month]</td>";

        $sum = $count = 0;

        for ( my $day = 0 ; $day < 31 ; $day++ ) {
            if ( $daysinmonth[$month] < $day + 1 ) {
                $scores .= "<td class=grey>&nbsp;</td>";
            }
            else {
                $scoretime =
                  totime
                  sprintf( "%d.%d.%d", $day + 1, $month + 1,
                    $year_academic[1] );
                $q = sqlp "select score from sp_scores
                    where sp_scores.uid  = $uid
                    and score > 0
                    and subj = $subj
                    and scoretime = $scoretime";
                $scores_str = '';
                while ( @tmp = $q->fetchrow_array ) {
                    $sum += $tmp[0];
                    $count++;
                    $tmp[0] =
                        '<span style="color:'
                      . get_score_color( $tmp[0] )
                      . "\"><b>$tmp[0]</b></span>";
                    $scores_str .=
                      ( $scores_str eq '' ) ? $tmp[0] : '/' . $tmp[0];
                }
                $scores_str ||= '&nbsp;';
                $scores .= "<td>$scores_str</td>";
            }
        }
        if ($count) {
            $sum /= $count;
            $sum = sprintf( "%.01f", $sum );
        }
        $scores .= "<td><b>$sum</b></td>";
        $scores .= "<td>$count</td>";
        $scores .= '</tr>';
    }

    tpl './tpl/score_year.html',
      {
        menu  => generate_menu(),
        pupil => sqlff(
"select last_name||' '||first_name||' '||middle_name from human where human_id = $uid"
          )
          . ', '
          . get_pupil_class( 1, $uid ),
        year        => "$year_academic[0] &ndash; $year_academic[1]",
        scores      => $scores,
        filter_subj => $filter_subj,
        uid         => $uid,
        footers     => generate_footers(),
      };
}

sub score_form_class() {
    my $c = param('c');
    sec_gt0($c);
    my $s = param('s');
    sec_gt0($s);
    if ( $ggid == 2 ) { check_teacher_binded_to( $c, $s ); } my $d = param('d');

    my $p = param('p');
    if ($p) { security_alert($p) unless grep /^\Q$p\E$/, ( 1 .. 7, 9 .. 11 ); }

    my ( @a, $t );
    my $class = $c;
    my $subj  = $s;
    my $periods_mode =
      sqlff q[select f_int from sp_settings where name = 'periods_mode'];
    if ( !param 'mode' ) { security_alert('!mode') }

    my ( $days, $d1, $m1, $y1, $dat, $worktype );

    my ( $grp_sql1, $grp_sql2, $grp_sql3 );
    my $g = param('g');
    if ($g) {
        sec_gt0 $g;
        if (
            sqlff "select id from sp_class_subgrp_ref where c = $c and s = $s" )
        {
            $grp_sql1 = ", sp_class_subgrp";
            $grp_sql3 =
"and sp_class_subgrp.uid = human.human_id and sp_class_subgrp.id = $g";
        }
        else {
            $grp_sql1 = $grp_sql2 = $grp_sql3 = '';
        }
    }

    if ( param("mode") == 2 ) {
        $days = param("days");
        sec_range( $days, 2, 15 );
    }

    if ( param("mode") != 3 ) {
        sec_date $d unless ( $d =~ /^\d+$/ );
        if ( $d =~ m/^\d{1,2}\.\d{1,2}\.\d{4}$/ ) {
            ( $d1, $m1, $y1 ) = split /\./, $d;
            $m1--;
            $d = timelocal( undef, undef, undef, $d1, $m1, $y1 );
        }
        else {
            ( undef, undef, undef, $d1, $m1, $y1, undef, undef, undef ) =
              localtime($d);
            my ( undef, undef, undef, undef, undef, $y, undef, undef, undef ) =
              localtime;
            if   ( $y1 != $y ) { $y1 = $y1 + 1900 . " ." }
            else               { $y1 = '' }
        }
    }

    if ( param("mode") == 1 ) {
        $dat = "$d1 $mnths[$m1] $y1";
    }

    my @scores;
    for ( my $x = $gconf{"score_min"} ; $x <= $gconf{"score_max"} ; $x++ ) {
        push @scores, $x;
    }

    $s = sqlff "select name from lesson where lesson_id = $s";

    $c = sqlff "select
    paralel || (select name from class where class_id = cast(sys_matrix.class as integer))
  from
    class, sys_matrix
  where
    class_id = $class
    and sys_matrix.class = class_id
    and sys_matrix.view_class = 7
    and exists ( select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0)";
    $c =~ s/^(\d+\".+\").+/$1/;

    if ( param("mode") != 3 ) {
        $worktype = "<select class=def name=worktype>";
        my $q        = sqlp("select id,name from sp_worktype");
        my $selected = ' selected';
        while ( @a = $q->fetchrow_array() ) {
            $worktype .= "<option$selected value=\"$a[0]\">$a[1]</option>";
            $selected = '' if $selected;
        }
        $q->finish;
        $worktype .= "</select>";
    }

    my $q = sqlp(
        "select human_id, last_name, first_name, middle_name
from sys_matrix, human$grp_sql1
where
  human_id = vw_pupil
  and sys_matrix.view_class = 1
  and sys_matrix.class = $class
  $grp_sql3
  and exists(select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0)
order by last_name, first_name, middle_name"
    );
    my @human;
    my $x = 0;
    my $w;
    my ( @uids, @names, $numbering_counter );
    $numbering_counter = 1;
    while ( @a = $q->fetchrow_array() ) {
        for my $i ( 1 .. 3 ) { $a[$i] = trim $a[$i] }
        if ( param('mode') == 3 ) {
            $a[2] = substr( $a[2], 0, 1 ) . '.';
            $a[3] = substr( $a[3], 0, 1 ) . '.';
        }
        push @uids,  $a[0];
        push @names, "$numbering_counter.&nbsp;$a[1]&nbsp;$a[2]&nbsp;$a[3]";
        $numbering_counter++;
    }
    $q->finish;

    my @dates    = ();
    my $tmp_date = $d;
    my @dates1   = ();
    my ( undef, undef, undef, undef, undef, $y, undef, undef, undef ) =
      localtime;
    my ( $mday, $mon, $year, $wday );
    for ( my $x = 0 ; $x < $days ; $x++ ) {
        ( undef, undef, undef, $mday, $mon, $year, $wday, undef, undef ) =
          localtime($tmp_date);
        if ( $y != $year ) { $year += 1900 }
        else               { $year = '' }
        push @dates,  "$mday&nbsp;$months3[$mon]&nbsp;$year<br>$wdays2[$wday]";
        push @dates1, $tmp_date;
        $tmp_date = day_add($tmp_date);
    }

    my $head;
    if ( param('mode') == 1 ) {
        $head = "<tr><th class=def></th>
<th class=def colspan=" . ( scalar @scores + 3 ) . "></th></tr>";
    }

    if ( param('mode') == 2 ) {
        $head = "<tr><th class=def></th>
<th class=def colspan=$days></th>
</tr><tr class=def><td class=def>&nbsp;</td>";
        for ( my $x = 0 ; $x < $days ; $x++ ) {
            my $class_add = $dates[$x] =~ /$/o ? ' sc_has2na' : '';

            $head .= qq[<td class="def$class_add" align=center>$dates[$x]</td>];
        }
        $head .= "</tr>";
    }

    my %tmp;
    my $literal_period;
    my $is_half_year;
    my $enable_half_year;

    if ( param('mode') == 3 ) {

        $is_half_year = is_half_year($class);
        $enable_half_year =
          sqlff "select f_int from sp_settings where name = 'enable_half_year'";

        if ($p) {
            my $scores_range = scalar(@scores);

            %tmp            = reverse %g_period_to_str;
            $literal_period = $tmp{$p};

            my $AVG_or_YEAR = $p == 9 ? ''      : '';
            my $js_all_fx   = $p == 9 ? 'year_all' : 'avg_all';

            $head = qq[<tr>
  <th class='def pad_lr5'></th>
  <th class='def pad_lr5' colspan=]
              . ( $scores_range + 4 )
              . qq[>$g_period_to_name{$tmp{$p}}</th>
</tr>
<tr class=def>
  <td class=def colspan=2>&nbsp;</td>
  <td class=def align=center><b>$AVG_or_YEAR</b><br><a class=small href="#" title="       " onclick="$js_all_fx('$literal_period')"><br></a></td>
  <td class=def align=center colspan=$scores_range><b> <br> </b></td>
  <td class=def align=center colspan=2><b></b></td>
</tr>];
        }
        else {
            if ( $enable_half_year and $is_half_year ) {
                $head = "<tr>
  <th class='def pad_lr5'></th>
  <th class='def pad_lr5' colspan=2>1 </th>
  <th class='def pad_lr5' colspan=2>2 </th>
  <th class='def pad_lr5' colspan=2></th>
  <th class='def pad_lr5' colspan=2>.</th>
  <th class='def pad_lr5' colspan=2></th>
</tr>";
            }
            elsif ( $periods_mode == 1 ) {
                $head = "<tr>
  <th class='def pad_lr5'></th>
  <th class='def pad_lr5' colspan=2>1 .</th>
  <th class='def pad_lr5' colspan=2>2 .</th>
  <th class='def pad_lr5' colspan=2>3 .</th>
  <th class='def pad_lr5' colspan=2>4 .</th>
  <th class='def pad_lr5' colspan=2></th>
  <th class='def pad_lr5' colspan=2>.</th>
  <th class='def pad_lr5' colspan=2></th>
</tr>";
            }
            else {
                $head = "<tr>
  <th class='def pad_lr5'></th>
  <th class='def pad_lr5' colspan=2>1 .</th>
  <th class='def pad_lr5' colspan=2>2 .</th>
  <th class='def pad_lr5' colspan=2>3 .</th>
  <th class='def pad_lr5' colspan=2></th>
  <th class='def pad_lr5' colspan=2>.</th>
  <th class='def pad_lr5' colspan=2></th>
</tr>";
            }
        }
    }

    my @scores_week;
    my @scores_total;

    my ( $year_total, undef ) = year_academic();

    my $scores;
    my $score;
    my $input_size;
    my ( $pop_id_year, $pop_id_period );
    $pop_id_year   = 1;
    $pop_id_period = 1;
    my ( $mark_id, $mark_text );
    my %mark_map = (
        '1' => ' ',
        '2' => '',
        '3' => '  ',
    );

    my %avg;

    my %period_id_to_index = (
        0 => 0, 1 => 4, 2 => 5, 3 => 6, 4 => 7, 5 => 1, 6 => 2, 7 => 3, 10 =>
          10, 11 => 11, 9 => 9, );

    if ( param('mode') == 3 and $p ) {
        my $link = get_class_link($class);
        my @times;
        if ( $enable_half_year and $is_half_year ) {
            my @half_year = split /,/,
              sqlff(
"select f_char from sp_settings where name = 'half_year_periods'"
              );
            if ( $p == 10 ) {
                @times = ( $half_year[0], $half_year[1] );
            } else { @times = ( $half_year[2], $half_year[3] ); };
        }
        else {
            if ( $p != 9 ) {
                @times = sqlf(
                    "select time_start, time_end from sp_periods
                         where link = $link and id = $p"
                );
            }
        }

        if ( $state_date and $p != 9 ) {
            my @tmp;
            for ( my $i = 0 ; $i < scalar @times ; $i++ ) {
                $times[$i] = todate( $times[$i] );
                $tmp[$i] = substr( $times[$i], 6 );
            }

            my $year_turn = $tmp[0] - $tmp[1];

            my $gdate_y = substr( $gdate, 6 );

            substr( $times[0], 6, 4, $gdate_y );

            if   ($year_turn) { substr( $times[1], 6, 4, $gdate_y + 1 ); }
            else              { substr( $times[1], 6, 4, $gdate_y ); }

            $_ = totime($_) for @times;
        }

        if ( $p != 9 ) {
            sqlh \%avg, "select uid, avg (cast(sp_scores.score as float))
from sp_scores, sys_matrix
where scoretime between $times[0] and $times[1]
and subj = $subj
and sys_matrix.class = $class
and sp_scores.uid = sys_matrix.vw_pupil
and score > 0
and exists (  select 1 from get_node_saldo
              (sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0  )
group by uid";

            for ( keys %avg ) {
                $avg{$_} = sprintf( "%.2f", $avg{$_} );
                $avg{$_} =~ s/,/./;
            }

            for ( keys %avg ) {
                $t .= qq[<input type=hidden name="avg${_}s$avg{$_}">];
            }

        }

    }

    my %periods_to_literal_serial_number = (
        1  => 1,
        2  => 2,
        3  => 3,
        4  => 4,
        5  => 1,
        6  => 2,
        7  => 3,
        9  => 9,
        10 => 10,
        11 => 11
    );

    for ( my $i = 0 ; $i < @uids ; $i++ ) {

        if ( param('mode') == 3 ) {
            $t .= "<tr class=def><td class=def>$names[$i]</td>";
        }
        else {
            $t .=
"<tr OnMouseOver='m_over(this);' OnMouseOut='m_out(this);' class=def><td class=def>$names[$i]</td>";
        }

        if ( param('mode') == 1 ) {
            $q = sqlp( "select score from sp_scores
         where uid       = $uids[$i]
           and subj      = $subj
           and scoretime = $d" );
            $scores = '';
            while ( $score = ( $q->fetchrow_array() )[0] ) {
                $scores .= ( $scores eq '' ) ? $score : "/$score";
            }
            $scores =~ s/-2//g;
            $scores =~ s/-1//g;
            $input_size = length $scores > 3 ? length $scores : 2;
            $t .=
qq[<td class=def align=center><input id=\"$uids[$i]\" name=\"f$uids[$i]\" type=text class=def size=$input_size maxlength=19 style=\"text-align: center; cursor:default\" value=\"$scores\" OnChange='this.className = \"highlight_edited_input\";' onkeyup="if (this.value.match(/[ye]/i)) {this.value=this.value.replace(/Y/ig,'');this.value=this.value.replace(/E/ig,'');}"></td>];
            $t .= qq{<td class="def hand" align=center width=25
OnMouseOver='m_over_score(this);'
OnMouseOut='m_out_score(this);'
OnClick='if (e("$uids[$i]").value=="") { e("$uids[$i]").value = ""; } else { e("$uids[$i]").value = e("$uids[$i]").value + "/"; e("$uids[$i]").size = e("$uids[$i]").value.length; } e("$uids[$i]").className = \"highlight_edited_input\"'
></td>};
            $t .= qq{<td class="def hand" align=center width=25
OnMouseOver='m_over_score(this);'
OnMouseOut='m_out_score(this);'
OnClick='if (e("$uids[$i]").value=="") { e("$uids[$i]").value = ""; } else { e("$uids[$i]").value = e("$uids[$i]").value + "/"; e("$uids[$i]").size = e("$uids[$i]").value.length; } e("$uids[$i]").className = \"highlight_edited_input\"'
></td>};

            foreach (@scores) {
                $t .= qq{<td class="def hand" align=center width=25
OnMouseOver='m_over_score(this);'
OnMouseOut='m_out_score(this);'
OnClick='if (e("$uids[$i]").value=="") { e("$uids[$i]").value = "$_"; } else { e("$uids[$i]").value = e("$uids[$i]").value + "/$_"; e("$uids[$i]").size = e("$uids[$i]").value.length; } e("$uids[$i]").className = \"highlight_edited_input\"'
>$_</td>};
            }
        }

        if ( param('mode') == 2 ) {
            for ( my $x = 0 ; $x < $days ; $x++ ) {
                $q = sqlp "select score from sp_scores
           where uid       = $uids[$i]
             and subj      = $subj
             and scoretime = $dates1[$x]";
                $scores = '';
                while ( $score = ( $q->fetchrow_array() )[0] ) {
                    $scores .= ( $scores eq '' ) ? $score : "/$score";
                }
                $scores =~ s/-2//g;
                $scores =~ s/-1//g;
                $scores_week[$x] = $scores;
            }
            for ( my $x = 0 ; $x < $days ; $x++ ) {
                $input_size =
                  length $scores_week[$x] > 3 ? length $scores_week[$x] : 2;
                $t .=
                    "<td class=def align=center>"
                  . "<input name=\"f$uids[$i]d$dates1[$x]\" "
                  . "type=text class=def size=$input_size maxlength=19 style=\"text-align: center; cursor:default\" "
                  . "value=\"$scores_week[$x]\" "
                  . q[OnChange='this.className = "highlight_edited_input";' onkeyup="if (this.value.match(/[ye]/i)) {this.value=this.value.replace(/Y/ig,'');this.value=this.value.replace(/E/ig,'');}"></td>];
            }
        }

        if ( param('mode') == 3 ) {
            @scores_total =
              sqlf( "select Y,T1,T2,T3,Q1,Q2,Q3,Q4,E,T,H1,H2,E1 from SP_SCORES_TOTALS
          where SCOREYEAR = $year_total and UID = $uids[$i] and SUBJ = $subj" );

            if ($p) {

                $mark_id = sqlff "select t from SP_MARKS
            where y = $year_total and s = $subj
            and p = $p and uid = $uids[$i]";
                $mark_text = $mark_map{$mark_id} || '';

                $t .= qq{
<td class=def align=left nowrap>
  <input type=hidden value="$mark_id"
    name="hidden_status$uids[$i]$literal_period" id="hidden_status$uids[$i]$literal_period">
  <input
    name="f$uids[$i]$literal_period" id="f$uids[$i]$literal_period"
    value="$scores_total[$period_id_to_index{$p}]"
    type=text class=def size=2 maxlength=1 style="text-align:center; cursor:default"
    OnChange='this.className="highlight_edited_input";'
    onkeypress='kick_score($uids[$i],1,$p,$pop_id_period);'>
</td>};

                if ( $p == 9 ) {
                    if ( !$scores_total[8] and $scores_total[0] ) {
                        $t .=
qq[<td align=center class="def hand" id=year_to_total$uids[$i]$literal_period
onclick="e('f$uids[$i]$literal_period').value = $scores_total[0]; e('f$uids[$i]$literal_period').className = 'highlight_edited_input';"
OnMouseOver="this.className='def avg_over';"
OnMouseOut="this.className='def';">$scores_total[0]</td>];
                    }
                    else {
                        $t .=
qq[<td align=center class=def><span style="color:grey">&nbsp;</span></td>];
                    }
                }
                else {
                    $t .= $avg{ $uids[$i] }
                      ? qq{<td class="def hand" align=center
style="padding-left:8px; padding-right:8px"
onclick="e('f$uids[$i]$literal_period').value = Math.round($avg{$uids[$i]}); e('f$uids[$i]$literal_period').className = 'highlight_edited_input';"
OnMouseOver="this.className = 'def avg_over';"
OnMouseOut="this.className = 'def';">
$avg{$uids[$i]}
</td>}
                      : q[<td class=def align=center><span class=noscores style="font-size: 9px; color:#aaa;"> <br></span></td>];
                }

                foreach (@scores) {
                    $t .= qq{<td class="def hand" align=center width=25
OnMouseOver="this.className = 'def avg_over';"
OnMouseOut="this.className = 'def';"
OnClick='e("f$uids[$i]$literal_period").value = "$_"; e("f$uids[$i]$literal_period").className = "highlight_edited_input";'>
$_</td>};
                }

                my $mode =
                  ( $enable_half_year and $is_half_year ) ? $p : $periods_mode;
                $p == 9 and $mode = 9;
                $t .= qq{<td class="def hand"
OnMouseOver="this.className = 'def avg_over';"
OnMouseOut="this.className = 'def';"
onclick="show_popup($pop_id_period); e('pop$pop_id_period').innerHTML = sp_popup(200,static_text,static_images,'js:sp_set_text($pop_id_period,t1,1,$uids[$i],$mode,$periods_to_literal_serial_number{$p})|js:sp_set_text($pop_id_period,t2,2,$uids[$i],$mode,$periods_to_literal_serial_number{$p})|js:sp_set_text($pop_id_period,t3,3,$uids[$i],$mode,$periods_to_literal_serial_number{$p})||js:sp_set_text($pop_id_period,t0,0,$uids[$i],$mode,$periods_to_literal_serial_number{$p});hide_popup($pop_id_period)');">
<img src="$gconf{sproot}/img/popup_arrow_down.gif" border=0
     style="margin-left: 8px; margin-right: 8px;">
</td>

<td class=def align=left nowrap>
  <div id=pop$pop_id_period style="display:inline;width:1px;">&nbsp;</div>
  <div name="status$pop_id_period" id=status$pop_id_period style="display:inline; padding: 2px;" class=small>$mark_text</div>
</td>};
                $pop_id_period++;
            }
            else {
                if ( $enable_half_year and $is_half_year ) {
                    for ( 10 .. 11 ) {
                        $mark_id = sqlff "select t from SP_MARKS
                where y = $year_total and s = $subj
                and p = $_ and uid = $uids[$i]";
                        $mark_text = $mark_map{$mark_id} || '';
                        $pop_id_period++;
                        $x = $_ - 9;
                        $t .= qq{
<td class=def align=left nowrap>
  <input type=hidden name="hidden_status$uids[$i]h$x" id="hidden_status$uids[$i]h$x" value="$mark_id">
  <input name="f$uids[$i]h$x" id="f$uids[$i]h$x" value="$scores_total[$_]"
    type=text class=def size=2 maxlength=1 style="text-align: center; cursor:default;"
    OnChange='this.className = "highlight_edited_input";'
    onkeypress='kick_score($uids[$i],3,$x,$pop_id_period);'>
  <a href="#" class=small onclick="show_popup($pop_id_period); e('pop$pop_id_period').innerHTML = sp_popup(200,static_text,static_images,'js:sp_set_text($pop_id_period,t1,1,$uids[$i],$_,0)|js:sp_set_text($pop_id_period,t2,2,$uids[$i],$_,0)|js:sp_set_text($pop_id_period,t3,3,$uids[$i],$_,0)||js:sp_set_text($pop_id_period,t0,0,$uids[$i],$_,0);hide_popup($pop_id_period)');">
  &nbsp;<img src="$gconf{sproot}/img/popup_arrow_down.gif" align=absmiddle border=0>&nbsp;</a>
</td>
<td class=def align=left nowrap>
  <div id=pop$pop_id_period style="display:inline;width:1px;">&nbsp;</div><div name="status$pop_id_period" id=status$pop_id_period style="display:inline; padding: 2px;" class=small>$mark_text</div>
</td>};
                    }
                }
                elsif ( $periods_mode == 0 ) {
                    my $mark_period;
                    for ( my $x = 1 ; $x <= 3 ; $x++ ) {
                        $mark_period = $x + 4;
                        $mark_id     = sqlff "select t from SP_MARKS
                where y = $year_total and s = $subj
                and p = $mark_period and uid = $uids[$i]";
                        $mark_text = $mark_map{$mark_id} || '';
                        $pop_id_period++;
                        $t .= qq{
<td class=def align=left nowrap>
  <input type=hidden name="hidden_status$uids[$i]t$x" id="hidden_status$uids[$i]t$x" value="$mark_id">
  <input name="f$uids[$i]t$x" id="f$uids[$i]t$x" value="$scores_total[$x]"
    type=text class=def size=2 maxlength=1 style="text-align: center; cursor:default;"
    OnChange='this.className = "highlight_edited_input";'
    onkeypress='kick_score($uids[$i],0,$x,$pop_id_period);'>
  <a href="#" class=small onclick="show_popup($pop_id_period); e('pop$pop_id_period').innerHTML = sp_popup(200,static_text,static_images,'js:sp_set_text($pop_id_period,t1,1,$uids[$i],0,$x)|js:sp_set_text($pop_id_period,t2,2,$uids[$i],0,$x)|js:sp_set_text($pop_id_period,t3,3,$uids[$i],0,$x)||js:sp_set_text($pop_id_period,t0,0,$uids[$i],0,$x);hide_popup($pop_id_period)');">
  &nbsp;<img src="$gconf{sproot}/img/popup_arrow_down.gif" align=absmiddle border=0>&nbsp;</a>
</td>
<td class=def align=left nowrap>
  <div id=pop$pop_id_period style="display:inline;width:1px;">&nbsp;</div><div name="status$pop_id_period" id=status$pop_id_period style="display:inline; padding: 2px;" class=small>$mark_text</div>
</td>};
                    }
                }
                else {
                    my $score_index;
                    for ( my $x = 1 ; $x <= 4 ; $x++ ) {
                        $mark_id = sqlff "select t from SP_MARKS
                where y = $year_total and s = $subj
                and p = $x and uid = $uids[$i]";
                        $mark_text = $mark_map{$mark_id} || '';
                        $pop_id_period++;
                        $score_index = $x + 3;
                        $t .= qq{
<td class=def align=left nowrap>
  <input type=hidden name="hidden_status$uids[$i]q$x" id="hidden_status$uids[$i]q$x" value="$mark_id">
  <input name="f$uids[$i]q$x" id="f$uids[$i]q$x" value="$scores_total[$score_index]"
    type=text class=def size=2 maxlength=1 style="text-align: center; cursor:default;"
    OnChange='this.className = "highlight_edited_input";'
    onkeypress='kick_score($uids[$i],1,$x,$pop_id_period);'>
  <a href="#" class=small onclick="show_popup($pop_id_period); e('pop$pop_id_period').innerHTML = sp_popup(200,static_text,static_images,'js:sp_set_text($pop_id_period,t1,1,$uids[$i],1,$x)|js:sp_set_text($pop_id_period,t2,2,$uids[$i],1,$x)|js:sp_set_text($pop_id_period,t3,3,$uids[$i],1,$x)||js:sp_set_text($pop_id_period,t0,0,$uids[$i],1,$x);hide_popup($pop_id_period)');">
  &nbsp;<img src="$gconf{sproot}/img/popup_arrow_down.gif" align=absmiddle border=0>&nbsp;</a>
</td>
<td class=def align=left nowrap>
  <div id=pop$pop_id_period style="display:inline;width:1px;">&nbsp;</div><div name="status$pop_id_period" id=status$pop_id_period style="display:inline; padding: 2px;" class=small>$mark_text</div>
</td>};
                    }
                }
                $mark_id = sqlff "select t from SP_MARKS
            where y = $year_total and s = $subj
            and p = 0 and uid = $uids[$i]";
                $mark_text = $mark_id ? $mark_map{$mark_id} : '';
                $pop_id_period++;
                $t .= qq{
<td class=def align=left nowrap>
  <input type=hidden name="hidden_status$uids[$i]y" id="hidden_status$uids[$i]y" value="$mark_id">
  <input name="f$uids[$i]y" id="f$uids[$i]y" value="$scores_total[0]"
    type=text class=def size=2 maxlength=1 style="text-align: center; cursor:default;"
    OnChange='this.className = "highlight_edited_input";'
    onkeypress='kick_score($uids[$i],2,0,$pop_id_period);'>
  <a href="#" class=small onclick="show_popup($pop_id_period); e('pop$pop_id_period').innerHTML = sp_popup(200,static_text,static_images,'js:sp_set_text($pop_id_period,t1,1,$uids[$i],2,0)|js:sp_set_text($pop_id_period,t2,2,$uids[$i],2,0)|js:sp_set_text($pop_id_period,t3,3,$uids[$i],2,0)||js:sp_set_text($pop_id_period,t0,0,$uids[$i],2,0);hide_popup($pop_id_period)');">
  &nbsp;<img src="$gconf{sproot}/img/popup_arrow_down.gif" align=absmiddle border=0>&nbsp;</a>
</td>
<td class=def align=left nowrap>
  <div id=pop$pop_id_period style="display:inline;width:1px;">&nbsp;</div><div name="status$pop_id_period" id=status$pop_id_period style="display:inline; padding: 2px;" class=small>$mark_text</div>
</td>};
                my $exam_score = $scores_total[8];
                $exam_score .= "/$scores_total[12]" if $scores_total[12];
                $mark_id = sqlff "select t from SP_MARKS
            where y = $year_total and s = $subj
            and p = 8 and uid = $uids[$i]";
                $mark_text = $mark_id ? $mark_map{$mark_id} : '';
                $pop_id_period++;
                $t .= qq{
<td class=def align=left nowrap>
  <input type=hidden name="hidden_status$uids[$i]e" id="hidden_status$uids[$i]e" value="$mark_id">
  <input name="f$uids[$i]e" id="f$uids[$i]e" value="$exam_score"
    type=text class=def size=3 maxlength=3 style="text-align: center; cursor:default;"
    OnChange='this.className = "highlight_edited_input";'
    onkeypress='kick_score($uids[$i],8,0,$pop_id_period);'>
  <a href="#" class=small onclick="show_popup($pop_id_period); e('pop$pop_id_period').innerHTML = sp_popup(200,static_text,static_images,'js:sp_set_text($pop_id_period,t1,1,$uids[$i],8,0)|js:sp_set_text($pop_id_period,t2,2,$uids[$i],8,0)|js:sp_set_text($pop_id_period,t3,3,$uids[$i],8,0)||js:sp_set_text($pop_id_period,t0,0,$uids[$i],8,0);hide_popup($pop_id_period)');">
  &nbsp;<img src="$gconf{sproot}/img/popup_arrow_down.gif" align=absmiddle border=0>&nbsp;</a>
</td>
<td class=def align=left nowrap>
  <div id=pop$pop_id_period style="display:inline;width:1px;">&nbsp;</div><div name="status$pop_id_period" id=status$pop_id_period style="display:inline; padding: 2px;" class=small>$mark_text</div>
</td>};
                $mark_id = sqlff "select t from SP_MARKS
            where y = $year_total and s = $subj
            and p = 9 and uid = $uids[$i]";
                $mark_text = $mark_id ? $mark_map{$mark_id} : '';
                $pop_id_period++;
                $t .= qq{
<td class=def align=left nowrap>
  <input type=hidden name="hidden_status$uids[$i]t" id="hidden_status$uids[$i]t" value="$mark_id">
  <input name="f$uids[$i]t" id="f$uids[$i]y" value="$scores_total[9]"
    type=text class=def size=2 maxlength=1 style="text-align: center; cursor:default;"
    OnChange='this.className = "highlight_edited_input";'
    onkeypress='kick_score($uids[$i],9,0,$pop_id_period);'>
  <a href="#" class=small onclick="show_popup($pop_id_period); e('pop$pop_id_period').innerHTML = sp_popup(200,static_text,static_images,'js:sp_set_text($pop_id_period,t1,1,$uids[$i],9,0)|js:sp_set_text($pop_id_period,t2,2,$uids[$i],9,0)|js:sp_set_text($pop_id_period,t3,3,$uids[$i],9,0)||js:sp_set_text($pop_id_period,t0,0,$uids[$i],9,0);hide_popup($pop_id_period)');">
  &nbsp;<img src="$gconf{sproot}/img/popup_arrow_down.gif" align=absmiddle border=0>&nbsp;</a>
</td>
<td class=def align=left nowrap>
  <div id=pop$pop_id_period style="display:inline;width:1px;">&nbsp;</div><div name="status$pop_id_period" id=status$pop_id_period style="display:inline; padding: 2px;" class=small>$mark_text</div>
</td>};
            }
        }
        $t .= "</tr>";
    }

    my $setall;
    for (@scores) {
        $setall .= "<a href='javascript:SetScoreAll($_);'>$_</a> ";
    }
    if ( param('mode') != 3 ) {
        $setall .= q[| <a href='javascript:SetScoreAll("");'></a> ];
        $setall .= q[| <a href='javascript:SetScoreAll("");'></a> ];
    }
    $setall .= "| <a href='javascript:ClearScoreAll();'></a>";

    my $h;
    $h = "  $dat"       if param("mode") == 1;
    $h = "  $days " if param("mode") == 2;
    $h =
        '  ( '
      . $year_total
      . '&mdash;'
      . ( $year_total + 1 )
      . '  )'
      if param("mode") == 3;

    my $colspan_for_footer;
    if ( param('mode') == 1 ) { $colspan_for_footer = scalar(@scores) + 4; }
    if ( param('mode') == 2 ) { $colspan_for_footer = $days + 1; }
    if ( param('mode') == 3 ) { $colspan_for_footer = 15; }

    my %replace = (
        menu               => generate_menu(),
        score_min          => $gconf{"score_min"},
        score_max          => $gconf{"score_max"},
        h                  => $h,
        colspan_for_footer => $colspan_for_footer,
        d                  => $d,
        's'                => $subj,
        c                  => $class,
        p                  => $p,
        subj               => $s,
        class              => $c,
        g                  => filter_subgrp(
            $class,
            $subj,
            $g,
q[document.location.href = document.location.href.replace( /g=\d*/, "g="+this.options[this.selectedIndex].value);]
        ),
        setall     => $setall,
        worktype   => $worktype || '',
        head       => $head,
        table      => $t,
        value_mode => param('mode'),
        footers    => generate_footers()
    );
    tpl( "./tpl/score_form_class.html", \%replace );

}

sub score_class() {


    my @a;
    my ( $uid, $score, $date1, @id, $q );

    my $date = param('date');
    if ($date) { sec_gt0($date); }
    my $subj  = param('subj');
    my $work  = param('worktype');
    my $class = param('c');

    my $period = param('p');
    if ($period) {
        security_alert($period)
          unless grep /^\Q$period\E$/, ( 1 .. 7, 9 .. 11 );
    }

    sec_gt0($subj);
    sec_gt0($class);

    if ( $ggid == 2 ) { check_teacher_binded_to( $class, $subj ); }

    my (
        @scores_new, $i,             $score_now,
        $score_old,  $score_new_str, $scores_now_str,
        $scores_old_str, @scores_now, @scores_old, $score_old_NULL_check, );

    if ( param('mode') == 1 )  {
        @a = param;
        for my $l (@a) {
            if ( param $l and $l =~ m/^f[0-9]+/ ) {
                $uid = substr( $l, 1 );
                sec_gt0 $uid;
                $score_new_str = param $l;
                $score_new_str =~ s//-2/gi;
                $score_new_str =~ s//-1/gi;
                @scores_new = split( /\//, $score_new_str );
                @scores_now = @scores_old = ();
                $scores_now_str = '';
                $q              = sqlp "select score, score_src from sp_scores
                    where uid       = $uid
                      and subj      = $subj
                      and scoretime = $date";

                while ( ( $score_now, $score_old ) = $q->fetchrow_array() ) {
                    $score_now =~ s//-2/gi;
                    $score_old =~ s//-2/gi;
                    $score_now =~ s//-1/gi;
                    $score_old =~ s//-1/gi;
                    push @scores_now, $score_now;
                    push @scores_old, $score_old;
                    if ( $scores_now_str eq '' ) {
                        $scores_now_str = "$score_now";
                    }
                    else { $scores_now_str .= "/$score_now"; }
                }

                if ( $scores_new[0] and !$scores_old[0] ) {
                    next if $scores_now_str eq $score_new_str;
                     sql "delete from sp_scores
                where uid       = $uid
                  and subj      = $subj
                  and scoretime = $date";
                    for ( $i = 0 ; $i < scalar @scores_new ; $i++ ) {
                        $score_old_NULL_check = $scores_now[$i] || 'NULL';
                        sql "insert into sp_scores
                   (uid,prep_id,subj,scoretime,score,score_src,worktype)
                 values
                   ($uid,$guid,$subj,$date,$scores_new[$i],$score_old_NULL_check,$work)";
                        smsf( $uid, "d: s o", $date, $subj, $scores_new[$i] );
                    }
                }
                elsif ( $scores_new[0] and $scores_old[0] ) {
                    next if $scores_now_str eq $score_new_str;
                     sql "delete from sp_scores
                where uid       = $uid
                  and subj      = $subj
                  and scoretime = $date";
                    for ( $i = 0 ; $i < scalar @scores_new ; $i++ ) {
                        $score_old_NULL_check = $scores_old[$i] || 'NULL';
                        sql "insert into sp_scores
                   (uid,prep_id,subj,scoretime,score,score_src,worktype)
                 values
                   ($uid,$guid,$subj,$date,$scores_new[$i],$score_old_NULL_check,$work)";
                        smsf( $uid, "d: s o", $date, $subj, $scores_new[$i] );
                    }
                }
                else {
                    for (@scores_new) {
                        sql "insert into sp_scores
            (UID,PREP_ID,SCORE,SUBJ,WORKTYPE,SCORETIME)
            VALUES ($uid,$guid,$_,$subj,$work,$date)";
                        smsf( $uid, "d: s o", $date, $subj, $_ );
                    }
                }
            }

            if ( !param $l and $l =~ m/^f[0-9]+/ ) {
                $uid = substr( $l, 1 );
                if (
                    sqlff "select score from sp_scores
           where uid       = $uid
             and subj      = $subj
             and scoretime = $date"
                  )
                {
                    sql "delete from sp_scores
                where uid       = $uid
                  and subj      = $subj
                  and scoretime = $date";
                }
            }

        }
    }

    if ( param('mode') == 2 )  {
        @a = param;
        my ( $uid, $date, $l );
        for $l (@a) {
            next unless $l =~ m/^f\d+d\d+$/;
            $uid = substr( $l, 1, index( $l, 'd' ) - 1 );
            $date1 = substr( $l, index( $l, 'd' ) + 1 );
            sec_gt0($date1);
            $score_new_str = param $l;
            $score_new_str =~ s//-2/gi;
            $score_new_str =~ s//-1/gi;
            @scores_new = split( /\//, $score_new_str );
            @scores_now = @scores_old = ();
            $scores_now_str = '';
            $q              = sqlp "select score, score_src from sp_scores
                  where uid       = $uid
                    and subj      = $subj
                    and scoretime = $date1";

            while ( ( $score_now, $score_old ) = $q->fetchrow_array() ) {
                $score_now =~ s//-2/gi;
                $score_old =~ s//-2/gi;
                $score_now =~ s//-1/gi;
                $score_old =~ s//-1/gi;
                push @scores_now, $score_now;
                push @scores_old, $score_old;
                if ( $scores_now_str eq '' ) { $scores_now_str = "$score_now"; }
                else { $scores_now_str .= "/$score_now"; }
            }

            if ( $scores_new[0] and !$scores_old[0] ) {
                next if $scores_now_str eq $score_new_str;
                 sql "delete from sp_scores
              where uid       = $uid
                and subj      = $subj
                and scoretime = $date1";
                for ( $i = 0 ; $i < scalar @scores_new ; $i++ ) {
                    $score_old_NULL_check = $scores_now[$i] || 'NULL';
                    sql "insert into sp_scores
                 (uid,prep_id,subj,scoretime,score,score_src,worktype)
               values
                 ($uid,$guid,$subj,$date1,$scores_new[$i],$score_old_NULL_check,$work)";
                    smsf( $uid, "d: s o", $date1, $subj, $scores_new[$i] );
                }
            }
            elsif ( $scores_new[0] and $scores_old[0] ) {
                next if $scores_now_str eq $score_new_str;
                 sql "delete from sp_scores
              where uid       = $uid
                and subj      = $subj
                and scoretime = $date1";
                for ( $i = 0 ; $i < scalar @scores_new ; $i++ ) {
                    $score_old_NULL_check = $scores_old[$i] || 'NULL';
                    sql "insert into sp_scores
					(uid,prep_id,subj,scoretime,score,score_src,worktype)
				values
					($uid,$guid,$subj,$date1,$scores_new[$i],$score_old_NULL_check,$work)";
                    smsf( $uid, "d: s o", $date1, $subj, $scores_new[$i] );
                }
            }
            else {
                for (@scores_new) {
                    sql(
                        "insert into sp_scores
          (UID,PREP_ID,SCORE,SUBJ,WORKTYPE,SCORETIME)
          VALUES ($uid,$guid,$_,$subj,$work,$date1)"
                    );
                    smsf( $uid, "d: s o", $date1, $subj, $_ );
                }
            }
        }

        if ( !param $l and $l =~ m/^f[0-9]+/ ) {
            $uid = substr( $l, 1, index( $l, 'd' ) - 1 );
            if (
                sqlff "select score from sp_scores
         where uid       = $uid
           and subj      = $subj
           and scoretime = $date1"
              )
            {
                sql "delete from sp_scores
              where uid       = $uid
                and subj      = $subj
                and scoretime = $date1";
            }
        }

    }

    if ( param('mode') == 3 )  {
        @a = param;

        my ( $year, undef ) = year_academic();

        my ( $uid, $hidden_status );
        my %uids;
        for my $field (param) {
            if ( $field =~ m/^f[0-9]+/ ) {
                ( $uid = $field ) =~ s/^f(\d+)[ytqeh]\d?/$1/;
                $uids{$uid} = 1;
            }
            elsif ( $field =~ m/^hidden_status[0-9]+/ ) {
                ( $uid = $field ) =~ s/^hidden_status(\d+)[ytqeh]\d?/$1/;
                $uids{$uid} = 1;
            }
        }

        my $y = undef;
        my ( $Y, $T1, $T2, $T3, $Q1, $Q2, $Q3, $Q4, $E, $T, $H1, $H2, $E1 );
        my $need_delete;

        foreach $uid ( keys %uids ) {
            $Y  = param( "f$uid" . 'y' )  || 'NULL';
            $T1 = param( "f$uid" . 't1' ) || 'NULL';
            $T2 = param( "f$uid" . 't2' ) || 'NULL';
            $T3 = param( "f$uid" . 't3' ) || 'NULL';
            $Q1 = param( "f$uid" . 'q1' ) || 'NULL';
            $Q2 = param( "f$uid" . 'q2' ) || 'NULL';
            $Q3 = param( "f$uid" . 'q3' ) || 'NULL';
            $Q4 = param( "f$uid" . 'q4' ) || 'NULL';
            $E  = param( "f$uid" . 'e' )  || 'NULL';
            $T  = param( "f$uid" . 't' )  || 'NULL';
            $H1 = param( "f$uid" . 'h1' ) || 'NULL';
            $H2 = param( "f$uid" . 'h2' ) || 'NULL';
            if ( $E =~ m|^(\d)/(\d)$| ) {
                $E  = $1;
                $E1 = $2;
            }
            elsif ( $E =~ m|^(\d)$| ) {
                $E1 = 'NULL';
            }
            else {
                $E  = 'NULL';
                $E1 = 'NULL';
            }

            $y = sqlff "select SCOREYEAR from SP_SCORES_TOTALS
        where SCOREYEAR = $year and UID = $uid and SUBJ = $subj";

            if ($y) {
                my @testarr =
                  ( $Y, $T1, $T2, $T3, $Q1, $Q2, $Q3, $Q4, $E, $T, $H1, $H2 );
                $need_delete = 1;
                for (@testarr) {
                    if ( $_ ne 'NULL' ) { $need_delete = 0; last; }
                }
                if ( $need_delete and !$period ) {
                    sql "DELETE from SP_SCORES_TOTALS
               WHERE UID       = $uid  and
                     SCOREYEAR = $year and
                     SUBJ      = $subj";
                }
                else {
                    if ($period) {
                        my %sql_code_hash = (
                            '0' => "Y  = $Y", '1' => "Q1 = $Q1", '2' =>
                              "Q2 = $Q2", '3' => "Q3 = $Q3", '4' =>
                              "Q4 = $Q4", '5' => "T1 = $T1", '6' =>
                              "T2 = $T2", '7' => "T3 = $T3", '8' =>
                              "E  = $E",  '9' => "T  = $T",  '10' =>
                              "H1 = $H1", '11' => "H2 = $H2" );
                        sql "update sp_scores_totals
                set $sql_code_hash{$period}, prep_id = $guid
                where UID = $uid and SCOREYEAR = $year and SUBJ = $subj";
                    }
                    else {
                        for (@testarr) {
                            if ( $_ ne 'NULL' ) {
                                stop
"    &ndash; &laquo;$_&raquo;.<br>  : $gconf{'score_min'}&ndash;$gconf{'score_max'}."
                                  unless ( $_ >= $gconf{'score_min'}
                                    and $_ <= $gconf{'score_max'} );
                            }
                        }
                        if ( $E1 ne 'NULL' ) {
                            stop
"     &ndash; &laquo;$E1&raquo;.<br>  : $gconf{'score_min'}&ndash;$gconf{'score_max'}."
                              unless ( $E1 >= $gconf{'score_min'}
                                and $E1 <= $gconf{'score_max'} );
                        }
                        sql "update sp_scores_totals
                set T1 = $T1, T2 = $T2, T3 = $T3,
                    Q1 = $Q1, Q2 = $Q2, Q3 = $Q3, Q4 = $Q4,
                    E  = $E,  E1 = $E1,
                    H1 = $H1, H2 = $H2,
                    Y  = $Y,
                    T  = $T,
                    PREP_ID = $guid
                where UID = $uid and SCOREYEAR = $year and SUBJ = $subj";
                    }
                }
            }
            else {
                unless ($Y eq 'NULL'
                    and $T1 eq 'NULL'
                    and $T2 eq 'NULL'
                    and $T3 eq 'NULL'
                    and $Q1 eq 'NULL'
                    and $Q2 eq 'NULL'
                    and $Q3 eq 'NULL'
                    and $Q4 eq 'NULL'
                    and $E  eq 'NULL'
                    and $T  eq 'NULL'
                    and $H1 eq 'NULL'
                    and $H2 eq 'NULL' )
                {
                    sql "INSERT INTO SP_SCORES_TOTALS
               (UID,PREP_ID,SCOREYEAR,SUBJ,Y,T1,T2,T3,Q1,Q2,Q3,Q4,E,T,H1,H2) VALUES
               ($uid,$guid,$year,$subj,$Y,$T1,$T2,$T3,$Q1,$Q2,$Q3,$Q4,$E,$T,$H1,$H2)";

                }
            }

        }

        my %uids_all;
        for (param) {
            if (/^f(\d+)[ytqeh]/) { $uids_all{$1}++ }
        }

        my $t;

        my %periods_to_str_hash = reverse %g_period_to_str;

        if ($period) {
            for ( keys %periods_to_str_hash ) {
                delete $periods_to_str_hash{$_} unless $period == $_;
            }
        }

        for my $each_uid ( keys %uids_all ) {
            for ( keys %periods_to_str_hash ) {
                $t = sqlff "select t from sp_marks where
                UID = $each_uid
            and   P = $_
            and   S = $subj
            and   Y = $year";
                $hidden_status = param(
                    'hidden_status' . $each_uid . $periods_to_str_hash{$_} );
                if ($t) {
                    if ($hidden_status) {
                        if ( $hidden_status ne $t ) {
                            sql "update sp_marks set T = $hidden_status
                    where  UID = $each_uid
                      and  P = $_
                      and  S = $subj
                      and  Y = $year";
                        }
                    }
                    else {
                        if ( $t == 3 ) {
                            sql "delete from sp_marks where
                    uid = $each_uid and p = $_ and y = $year";
                        }
                        else {
                            sql "delete from sp_marks where
                    uid = $each_uid and p = $_ and s = $subj and y = $year";
                        }
                    }
                }
                else {
                    if ($hidden_status) {
                        if ( $hidden_status == 3 ) {
                            $q = sqlp 'select lesson_id from lesson';
                            my ( @lessons, $lesson_id );
                            while ( $lesson_id = $q->fetchrow_array() ) {
                                push @lessons, $lesson_id;
                            }
                            for $lesson_id (@lessons) {
                                sql
                                  "insert into sp_marks (UID, P, S, T, Y) values
                       ($each_uid, $_, $lesson_id, 3, $year)";
                            }
                        }
                        else {
                            sql "insert into sp_marks (UID, P, S, T, Y) values
                    ($each_uid, $_, $subj, $hidden_status, $year)";
                        }
                    }
                }
            }
        }

        redir "score_list_class_totals&s=$subj&c=" . param('c');
    }
    redir "score_list_class&s=$subj&c=" . param('c') . "&period=" . param('p');
}

sub main_pupil() {
    my ( $funcs, $q );

    my $myclass = get_pupil_class(1);
    $myclass =~ s/"/&ldquo;/;
    $myclass =~ s/"/&rdquo;/;
    $funcs = qq[<h1 align=center>  $myclass</h1>
<div align=center>
<a href="?act=score_all_subjects">   </a>
</div><br>];

    my @y = get_year_start_end();

    $q = sqlp "SELECT distinct lesson.KNOWLEDGE_AREA, KNOWLEDGE_AREA_REF.name
from lesson, sp_scores, KNOWLEDGE_AREA_REF
where lesson_id = subj
and sp_scores.scoretime between $y[0] and $y[1]
and KNOWLEDGE_AREA_REF.KNOWLEDGE_ID = lesson.KNOWLEDGE_AREA
order by KNOWLEDGE_AREA, lesson.name";
    my ( $a, %area );
    while ( $a = $q->fetch ) { $area{ $a->[0] } = $a->[1] }
    my %cell;
    my ( $counter, $i );
    $funcs .=
"<table class=def cellspacing=0 cellpadding=4 align=center> <tr><th class=def colspan=3> </th></tr>";

    for $i ( keys %area ) {
        $q = sqlp
"SELECT distinct lesson_id, lesson.name, KNOWLEDGE_AREA, KNOWLEDGE_AREA_REF.name
from lesson, sp_scores, KNOWLEDGE_AREA_REF
where lesson_id = subj
and KNOWLEDGE_AREA_REF.KNOWLEDGE_ID = lesson.KNOWLEDGE_AREA
and KNOWLEDGE_AREA_REF.KNOWLEDGE_ID = $i
and uid = $guid
order by KNOWLEDGE_AREA, lesson.name";
        while ( $a = $q->fetch ) {
            $cell{$i} .=
"<a class=ind onclick='LoadingShow(1);' href='?act=score_list_class&s=$a->[0]'>$a->[1]</a><br>";
        }
        $cell{$i} =~ s/<br>$//;
    }

    my $cell_number;
    $funcs .= "<tr class=def>";
    for $i ( sort keys %area ) {
        $funcs .=
"<td class=def nowrap style=\"font-size: 10pt; padding-right: 16px;\" valign=top><b>$area{$i}</b><br>";
        $funcs .= $cell{$i};
        $funcs .= "</td>";
        $cell_number++;
        if ( $cell_number % 3 == 0 ) {
            $funcs .= "</tr><tr class=def>";
        }
    }
    $cell_number %= 3;
    if ($cell_number) {
        for ( $i = 0 ; $i < ( 3 - $cell_number ) ; $i++ ) {
            $funcs .= "<td class=def>&nbsp;</td>";
        }
    }
    $funcs .= "</table>";

    $funcs .=
q[<div style="display: none;" id="loading" class=loading align=center><img src="/sp/img/ajax.gif" align=absmiddle>&nbsp;&nbsp; . , ...</div>];

    my %replace = (
        menu    => generate_menu(),
        funcs   => $funcs,
        footers => generate_footers(),
    );
    tpl( './tpl/main.html', \%replace );
}

sub is_half_year($) {
    my $c = shift;
    my ( $half_year_from, $half_year_to ) = split /,/,
      sqlff q[select f_char from sp_settings where name = 'half_year'];
    my $paralel = sqlff qq[select paralel from sys_matrix
where sys_matrix.class = $c
  and sys_matrix.view_class = 1
  and exists ( select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0)];
    return 1 if ( $paralel >= $half_year_from and $paralel <= $half_year_to );
    return 0;
}

1;
