#!/usr/bin/perl -w
# (C) http://spcms.ru
use strict;

my $issue = `cat /etc/issue`;

my $apache = 'apache';
$apache = 'www-data' if $issue =~ m/untu/i;
$apache = 'apache2' if -e '/etc/altlinux-release';

print "\n";

print "--------\n";
print "SP Setup\n";
print "--------\n";

print "Checking required modules...\n";

my @req = qw [
  Archive/Zip
  CGI
  CGI/Carp
  CGI/Cookie
  CGI/Session
  Compress/Zlib
  Cwd
  Data/Dumper
  DBI
  DBD/InterBase
  Digest/MD5
  Encode
  File/Find
  File/Copy
  File/stat
  GD
  GD/Graph/bars
  GD/Graph/pie
  HTML/TagFilter
  Image/Magick
  IO/File
  IO/Handle
  IO/Socket/INET
  locale
  Mail/Sender
  MIME/Base64
  POSIX
  strict
  Text/Iconv
  Time/HiRes
  Time/Local
];

my %mod = map { $_ => 1 } @req;

for my $path (@INC) {
    for my $m (@req) {
        if ( -e "$path/$m.pm" ) { delete $mod{"$m"} }
    }
}

if ( scalar %mod ) {
    print "ERROR: These modules are not installed:\n";
    print "---------------------------------------\n";
    print join "\n", sort keys %mod;
    print "\n";
    exit;
}

eval {
    require GD::Graph::bars;
    print 'WARNING: GD::Graph::bars v'
      . $GD::Graph::bars::VERSION
      . " installed. Must be at least v1.25\n"
      if $GD::Graph::bars::VERSION lt '1.25';
};

print "OK. All required modules installed.\n\n";

print "This script will chown -R to apache and chmod executables to 500\n";

unless ( defined $ARGV[0] and $ARGV[0] eq '--yes' ) {
    print "\nDo you really want to continue? ";
    $a = <>;
    exit if $a !~ /^y/i;
}
print "--- going /var/www/cgi-bin/sp\n";
chdir "/var/www/cgi-bin/sp";

print "--- chowning all to apache:apache...\n";
system "chown -R $apache:$apache *";
print "--- chmoding all to 400...\n";
system "chmod -R 400 *";

chdir "cms";
print "--- chmoding 500 cms/cms.pl\n";
system "chmod 500 cms.pl";
chdir "..";

print "--- chmoding 500 sp.cgi\n";
system "chmod 500 sp.cgi";

print "--- chmoding 500 msg.pl\n";
system "chmod 500 msg.pl";

print "--- chmoding 500 sms-cron.pl\n";
system "chmod 500 sms-cron.pl";

system "chmod 644 sms-log"  if ( -e 'sms-log' );
system "chmod 644 sms-log2" if ( -e 'sms-log2' );

system "chmod +x cms";
system "chmod +x tpl";
system "chmod +x dic";
system 'find tpl -type d -exec chmod u+x {} \;';
system 'find cms/tpl -type d -exec chmod +x {} \;';
system "touch sp.cgi";
system "touch msg.pl";
system "touch cms/cms.pl";

system "chmod o+r common.pl";

print "--- chmoding all dirs +x in tpl\n";
chdir "/var/www/cgi-bin/sp/tpl";
system 'find . -type d -exec chmod +x {} \;';
chdir "/var/www/cgi-bin/sp/cms/tpl";
system 'find . -type d -exec chmod +x {} \;';

chdir "/var/www/cgi-bin/sp";

print "--- moving sphtml/* to /var/www/html/sp/\n";

unless ( -e '/var/www/html/sp/' ) {
    mkdir '/var/www/html/sp/';
    system "chown $apache:$apache /var/www/html/sp/";
    system "chmod 755 /var/www/html/sp/";
}

system "cp -Rf -- sphtml/* /var/www/html/sp/";
system "rm -rf ./sphtml";

print "\n--- going /var/www/html/sp/\n";
chdir "/var/www/html/sp/";

print "--- chowning all to apache:apache...\n";
system "chown -R $apache:$apache *";

print "--- chmoding all to 600...\n";
system "chmod -R 600 *";

print "--- chmoding 500 connector.cgi\n";
system
"chmod 500 /var/www/html/sp/FCKeditor/editor/filemanager/connectors/perl/connector.cgi";
system
"touch /var/www/html/sp/FCKeditor/editor/filemanager/connectors/perl/connector.cgi";

print "--- chmoding all dirs +x\n";
system 'find . -type d -exec chmod +x {} \;';
