# (C) http://spcms.ru
use strict;
use vars qw/ $popup /;

sub setup_periods() {
    my ( $h1_from, $h1_to, $h2_from, $h2_to ) = split /,/,
      sqlff "select f_char from sp_settings where name = 'half_year_periods'";

    my $enable_half_year =
      ( sqlff "select f_int from sp_settings where name = 'enable_half_year'" )
      ? 'checked'
      : '';

    my $link = param('link') || 0;

    my ( $sel1, $sel2, $sel3 ) = ( '', '', '' );

    if ( $link == 0 ) { $sel1 = 'selected'; }
    if ( $link == 1 ) { $sel2 = 'selected'; }
    if ( $link == 2 ) { $sel3 = 'selected'; }

    my $links = "<option $sel1 value=0></option>
<option $sel2 value=1></option>
<option $sel3 value=2></option>";

    my @a = sqlf
"select time_start, time_end from sp_periods where link = $link and id = 0";
    my ( $year_start, $year_end ) = ( todate( $a[0] ), todate( $a[1] ) );

    @a = sqlf
      "select time_start, time_end from sp_periods where link=$link and id=1";
    my ( $q1_start, $q1_end ) = ( todate( $a[0] ), todate( $a[1] ) );
    @a = sqlf
      "select time_start, time_end from sp_periods where link=$link and id=2";
    my ( $q2_start, $q2_end ) = ( todate( $a[0] ), todate( $a[1] ) );
    @a = sqlf
      "select time_start, time_end from sp_periods where link=$link and id=3";
    my ( $q3_start, $q3_end ) = ( todate( $a[0] ), todate( $a[1] ) );
    @a = sqlf
      "select time_start, time_end from sp_periods where link=$link and id=4";
    my ( $q4_start, $q4_end ) = ( todate( $a[0] ), todate( $a[1] ) );

    @a = sqlf
      "select time_start, time_end from sp_periods where link=$link and id=5";
    my ( $t1_start, $t1_end ) = ( todate( $a[0] ), todate( $a[1] ) );
    @a = sqlf
      "select time_start, time_end from sp_periods where link=$link and id=6";
    my ( $t2_start, $t2_end ) = ( todate( $a[0] ), todate( $a[1] ) );
    @a = sqlf
      "select time_start, time_end from sp_periods where link=$link and id=7";
    my ( $t3_start, $t3_end ) = ( todate( $a[0] ), todate( $a[1] ) );

    my $periods_mode =
      sqlff q[select f_int from sp_settings where name = 'periods_mode'];

    my ( $half_year_from, $half_year_to ) = split( ',',
        sqlff qq[select f_char from sp_settings where name = 'half_year'] );

    my %replace = (
        menu       => generate_menu(),
        footers    => generate_footers(),
        link       => $links,
        year_start => $year_start,
        year_end   => $year_end, q1_start => $q1_start,
        q1_end     => $q1_end, q2_start => $q2_start,
        q2_end     => $q2_end, q3_start => $q3_start,
        q3_end     => $q3_end, q4_start => $q4_start,
        q4_end     => $q4_end, t1_start => $t1_start,
        t1_end     => $t1_end, t2_start => $t2_start,
        t2_end     => $t2_end, t3_start => $t3_start,
        t3_end     => $t3_end, periods_mode => $periods_mode == 0
        ? 'opt_trim'
        : 'opt_quad',
        half_year_from   => $half_year_from,
        half_year_to     => $half_year_to,
        h1_from          => todate $h1_from,
        h1_to            => todate $h1_to,
        h2_from          => todate $h2_from,
        h2_to            => todate $h2_to,
        enable_half_year => $enable_half_year,
    );
    tpl( './tpl/setup_periods.html', \%replace );
}

sub setup_periods_modify() {

    my $link = param('link');
    sec_range( $link, 0, 2 );

    my $ys = param 'year_start';
    sec_date $ys;
    $ys = totime $ys;
    my $ye = param 'year_end';
    sec_date $ye;
    $ye = totime $ye;

    my ( $qs1, $qe1, $qs2, $qe2, $qs3, $qe3, $qs4, $qe4 ) = (
        param('q1_start'), param('q1_end'),
        param('q2_start'), param('q2_end'),
        param('q3_start'), param('q3_end'),
        param('q4_start'), param('q4_end')
    );

    sex_date( $qs1, $qe1, $qs2, $qe2, $qs3, $qe3, $qs4, $qe4 );

    ( $qs1, $qe1, $qs2, $qe2, $qs3, $qe3, $qs4, $qe4 ) = (
        totime($qs1), totime($qe1), totime($qs2), totime($qe2),
        totime($qs3), totime($qe3), totime($qs4), totime($qe4)
    );

    my ( $ts1, $te1, $ts2, $te2, $ts3, $te3 ) = (
        param('t1_start'), param('t1_end'),
        param('t2_start'), param('t2_end'),
        param('t3_start'), param('t3_end')
    );

    sex_date( $ts1, $te1, $ts2, $te2, $ts3, $te3 );

    ( $ts1, $te1, $ts2, $te2, $ts3, $te3 ) = (
        totime($ts1), totime($te1), totime($ts2), totime($te2),
        totime($ts3), totime($te3)
    );

    if ( param('for_all_links') ) {
        sql(
"update sp_periods set time_start = $ys, time_end = $ye where id = 0"
        );
        sql(
"update sp_periods set time_start = $qs1, time_end = $qe1 where id = 1"
        );
        sql(
"update sp_periods set time_start = $qs2, time_end = $qe2 where id = 2"
        );
        sql(
"update sp_periods set time_start = $qs3, time_end = $qe3 where id = 3"
        );
        sql(
"update sp_periods set time_start = $qs4, time_end = $qe4 where id = 4"
        );
        sql(
"update sp_periods set time_start = $ts1, time_end = $te1 where id = 5"
        );
        sql(
"update sp_periods set time_start = $ts2, time_end = $te2 where id = 6"
        );
        sql(
"update sp_periods set time_start = $ts3, time_end = $te3 where id = 7"
        );
    }
    else {
        sql(
"update sp_periods set time_start = $ys, time_end = $ye where link = $link and id = 0"
        );
        sql(
"update sp_periods set time_start = $qs1, time_end = $qe1 where link = $link and id = 1"
        );
        sql(
"update sp_periods set time_start = $qs2, time_end = $qe2 where link = $link and id = 2"
        );
        sql(
"update sp_periods set time_start = $qs3, time_end = $qe3 where link = $link and id = 3"
        );
        sql(
"update sp_periods set time_start = $qs4, time_end = $qe4 where link = $link and id = 4"
        );
        sql(
"update sp_periods set time_start = $ts1, time_end = $te1 where link = $link and id = 5"
        );
        sql(
"update sp_periods set time_start = $ts2, time_end = $te2 where link = $link and id = 6"
        );
        sql(
"update sp_periods set time_start = $ts3, time_end = $te3 where link = $link and id = 7"
        );
    }

    my $mode = param("mode") || 0;
    sec_gteq0 $mode;
    sql qq[update sp_settings set f_int = $mode where name = 'periods_mode'];

    my ( $p_mim, $p_max ) = sqlf "select
(select min(paralel_id) from paralel),
(select max(paralel_id) from paralel) from dual";
    my $half_from = param('half_year_from');
    sec_range( $half_from, $p_mim, $p_max );
    my $half_to = param('half_year_to');
    sec_range( $half_to, $p_mim, $p_max );

    sql
"update sp_settings set f_char = '$half_from,$half_to' where name = 'half_year'";

    my $enable_half_periods = ( param('enable_half_year') eq 'on' ) ? 1 : 0;
    sql
"update sp_settings set f_int = $enable_half_periods where name = 'enable_half_year'";

    my $h1_from = param('h1_from');
    sec_date($h1_from);
    $h1_from = totime($h1_from);
    my $h2_from = param('h2_from');
    sec_date($h2_from);
    $h2_from = totime($h2_from);
    my $h1_to = param('h1_to');
    sec_date($h1_to);
    $h1_to = totime($h1_to);
    my $h2_to = param('h2_to');
    sec_date($h2_to);
    $h2_to = totime($h2_to);
    my $half_year_periods = "$h1_from,$h1_to,$h2_from,$h2_to";
    sql
"update sp_settings set f_char = '$half_year_periods' where name = 'half_year_periods'";

    redir( "setup_periods&link=$link" . $popup );
}

sub state_date_reset() {
    sql "update sp_users set state_date = NULL where uid = $guid";
    if   ( $ENV{'HTTP_REFERER'} ) { exit print redirect $ENV{'HTTP_REFERER'}; }
    else                          { redir('main'); }
}

sub state_date_form() {
    my %replace = (
        menu    => generate_menu(),
        footers => generate_footers(),
        date    => $gdate,
    );
    tpl './tpl/setup_state_date_form.html', \%replace;
}

sub state_date_set() {
    my $d = param('d');
    sec_date($d);
    $d = totime $d;
    if ( $d > timelocal(localtime) ) {
        $d = todate $d;
        my $now = todate( timelocal(localtime) );
        stop " $now.<br>
      ($d).<br>
     &mdash;  :)<br>
     <br>
   ,       .";
    }
    sql qq[update sp_users set state_date = '$d' where uid = $guid];
    if   ( $ENV{'HTTP_REFERER'} ) { exit print redirect $ENV{'HTTP_REFERER'}; }
    else                          { redir('main'); }
}

1;
