# (C) http://spcms.ru
#!/usr/bin/perl -w

use CGI qw(:standard escapeHTML -no_xhtml);
use CGI::Carp;
use locale;
use strict;

push @INC, '/var/www/cgi-bin/sp';

my $lock_file = '/var/www/cgi-bin/sp/sms-cron-lock';

require "common.pl";
require "misc.pl";

sub get_glued_sms($);

$ENV{'SERVER_NAME'} = $ENV{"SCRIPT_FILENAME"} = $ENV{'HTTP_USER_AGENT'} =
  'dummy';

my %gconf = read_config('sp.conf');
exit unless defined $gconf{'sms'};

OnStart();

die "Another copy of SP SMS cron job is running" if -e $lock_file;

our $DEBUG = 0;
our ( $queryes, $gentime );
$gentime = 0;

my @a;
sqla(
    \@a, "select
/* first 10 */
PHONE_NUMBER, TEXT, ID
from SMS_POOL
order by PHONE_NUMBER"
);

exit unless @a;

open L, ">$lock_file";
print L
"SP SMS sending cron job is running.\nThis file is a flag to disallow multiple copies to run at the same time.";
close L;

my %messages;

for (@a) {
    push @{ $messages{ $$_[0] } }, [ $$_[2], $$_[1] ];
}

my %glue160;

my %glue_ids;

for my $number ( keys %messages ) {
    for ( @{ $messages{$number} } ) {

        if ( $$_[1] =~ m/(\d+\.\d+): (.+) (\d|\w{1,2})$/ ) {
            my $score_date = $1;
            my $score_subj = $2;
            my $score      = $3;
            push @{ $glue160{$number}{$score_date}{$score_subj} },
              [ $score, $$_[0] ];
        }
    }
}

for my $number ( keys %glue160 ) {
    my ( $sms, @ids ) = get_glued_sms( $glue160{$number} );
    if ( scalar @ids ) {

        $sms =~ s/'//g;

        my $datetime = strftime( "%d %B %Y %H:%M", localtime );

        my $rc = system
qq[export LC_ALL=ru_RU.KOI8-R; echo '$sms' | gnokii --sendsms $number];

        my $id_commas = join( ',', @ids );

        if ( $rc == 0 or $rc == 2048 ) {
            system qq[echo '$datetime | $number | $sms' >> sms-log];
            sql("delete from SMS_POOL where ID in ($id_commas)");
        }
        else {
            system qq[echo '$datetime | Error code: $rc' >> sms-log];
        }

    };
}

sub get_glued_sms($) {
    my $sms_hash1 = shift;
    my $sms       = '';
    my ( $first_score, $first_subj );
    my @used_ids;

    my $sms_were_cut = 0;

    for my $date ( sort keys %$sms_hash1 ) {
        my $tmp_before_date = $sms;

        my $tmp_date = $sms;
        $tmp_date .= ($sms) ? "; $date: " : "$date: ";
        if ( length $tmp_date > 160 ) {
            $sms_were_cut = 1;
            last;
        }

        $sms .= $sms ? "; $date: " : "$date: ";

        $first_subj = 1;

        for my $subj ( sort keys %{ $$sms_hash1{$date} } ) {
            my $tmp_before_subj = $sms;
            my $tmp_subj        = $sms;
            $tmp_subj .= ($first_subj) ? "$subj " : ", $subj ";
            if ( length $tmp_subj > 160 ) {
                $sms_were_cut = 1;
                $sms          = $tmp_before_date;
                goto stop_compilation;
            }

            $sms .= $first_subj ? "$subj " : ", $subj ";

            $first_score = 1;

            for ( @{ $$sms_hash1{$date}{$subj} } ) {
                my $tmp_score = $sms;
                $tmp_score .= ($first_score) ? $$_[0] : "/$$_[0]";
                if ( length $tmp_score > 160 ) {
                    $sms_were_cut = 1;
                    if ($first_score) {
                        $sms = $tmp_before_date;
                    }
                    last;

                }

                $sms .= $first_score ? $$_[0] : "/$$_[0]";
                push @used_ids, $$_[1];
                $first_score = 0;
            }
            $first_subj = 0;
        }
    }

  stop_compilation:

    unless ($sms_were_cut) {
        if ( length($sms) < 147 ) {
            @used_ids = ();
        }
    }

    return ( $sms, @used_ids );
}

unlink $lock_file;

__END__

_:

5 :  1
5 :  2
5 : . 2
6 : . 2
6 :  1

:

2 :  ,  
2 :  ,  
2 :  ,  
2 :  ,  
     

:

5 :  1/2, . 2; 6 :  1, . 2
