# (C) http://spcms.ru
use locale;
use strict;

sub sms_print_class_numbers() {
    my $c = param('c');
    sec_gt0($c);

    my @pupils;
    sqla(
        \@pupils,
        "select
  vw_pupil,
  (select trim(last_name)||' '||first_name||' '||middle_name from human where human_id = cast(sys_matrix.vw_pupil as integer))
from sys_matrix inner join human on cast(vw_pupil as integer) = human_id
where
sys_matrix.view_class = 1
and sys_matrix.class = $c
and exists
(
  select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0)
  where saldo_sum <> 0
)
order by trim(human.last_name)"
    );

    my $t = '';

    for (@pupils) {
        my $phones;

        my @phones_by_uid;
        sqlffa \@phones_by_uid, "select phone_number from sms_recipient
		where sms_recipient.human_type in (1,2)
		and sms_recipient.uid = $$_[0]";

        $phones = join( ", ", @phones_by_uid );
        $phones ||= '&nbsp;';

        $t .= qq[<tr>
            <td>$$_[1]</td>
            <td class='phone'">$phones</td>
           </tr>];
    }

    tpl './tpl/sms/print_class_numbers.html',
      {
        menu       => generate_menu(),
        footers    => generate_footers(),
        class_name => resolve_class_id($c),
        t          => $t
      };

}

sub sms_group() {

    if ( param('id') ) {
        if ( $ENV{'REQUEST_METHOD'} eq 'GET' ) {

            my $people = '';

            my @a;
            sqla(
                \@a,
                q[select
				human_id,
				trim(last_name)||' '||first_name||' '||middle_name,
				(select log from sp_users where uid = human_id)
			from
				human
			where
				class = 0
			order by 2
			]
            );

            my $gid = param('id');

            my $edit_mode = 0;
            if ( $gid =~ m/^\d+$/ ) {
                $edit_mode = 1;
            }

            my $name = '';
            my @selected_members;

            if ($edit_mode) {
                sqlffa \@selected_members,
                  "select uid from sms_group_members where gid = $gid";
                $name = sqlff "select name from sms_group where id = $gid";
            }

            my %namesake;

            for my $human (@a) {
                if ( exists $namesake{ $$human[1] } ) {
                    $$human[1] .=
                      $$human[2]
                      ? " (: $$human[2])"
                      : " (UID: $$human[0])";
                }
                else {
                    $namesake{ $$human[1] }++;
                }

                my $checked =
                  grep ( /^\Q$$human[0]\E$/, @selected_members )
                  ? 'checked'
                  : '';
                $people .=
qq[<label for="u$$human[0]"><input id="u$$human[0]" name="u$$human[0]" type="checkbox" $checked> $$human[1]</label><br>];
            }

            tpl './tpl/sms/group_edit.html',
              {
                menu        => generate_menu(),
                footers     => generate_footers(),
                name        => $name,
                people      => $people,
                action_text => ( $edit_mode ? '' : '' ),
                action_button_text =>
                  ( $edit_mode ? ' ' : '' ),
                group_id => ( $edit_mode ? $gid : 'new' ),
              };

        }
        elsif ( $ENV{'REQUEST_METHOD'} eq 'POST' ) {

            my $name = param('name');
            escape_tag( \$name );
            $name = substr( $name, 0, 128 );

            if ( param('id') eq 'new' ) {
                sqlb "insert into sms_group (name) values (?)", $name;
                my $new_id = genid('gen_sms_group_id');
                for (param) {
                    if (/^u(\d+)/) {
                        my $uid = $_;
                        $uid =~ s/u//;
                        sql
"insert into sms_group_members (gid, uid) values ($new_id, $uid)";
                    }
                }
            }
            else {
                my $gid = param('id');
                sec_gteq0($gid);
                sqlb "update sms_group set name = ? where id = $gid", $name;
                sql "delete from sms_group_members where gid = $gid";
                for (param) {
                    if (/^u(\d+)/) {
                        my $uid = $_;
                        $uid =~ s/u//;
                        sql
"insert into sms_group_members (gid, uid) values ($gid, $uid)";
                    }
                }

            }
        }
        else { deny(); }
    }

    if ( param('delete') ) {
        my $del_id = param('delete');
        sec_gteq0 $del_id;
        sql "delete from SMS_GROUP_MEMBERS where GID = $del_id";
        sql "delete from SMS_GROUP where ID = $del_id";
        redir 'sms_group';
    }

    my %groups;

    my $q = sqlp "select
	name,
	id,
	(select count(1) from sms_group_members WHERE sms_group_members.gid = sms_group.id) as cnt
from
	sms_group";

    my %h;
    $q->bind_columns( \( @h{ @{ $q->{NAME_lc} } } ) );

    while ( $q->fetch ) {
        $groups{ $h{id} } = { name => $h{name}, cnt => $h{cnt} };
    }

    my $t = '';
    for ( sort { $groups{$a}{name} cmp $groups{$b}{name} } keys %groups ) {
        $t .=
qq[<div><a title=" " href="?act=sms_group&id=$_">$groups{$_}{name}</a> ($groups{$_}{cnt}) <a title=" " class="small sms_group_delete" href="?act=sms_group&delete=$_" onclick="return confirm(' ?')"></a></div>];
    }
    $t ||= '<p align="center">  .</p>';

    tpl './tpl/sms/group.html',
      {
        menu    => generate_menu(),
        footers => generate_footers(),
        t       => $t,
      };
}

sub sms_select_scores_by_date_and_recipients_form() {
    my $c    = param 'c';
    my $from = param 'from';
    my $to   = param 'to';
    sex_gt0( $c, $from, $to );

    ( $from, $to ) = ( todate($from), todate($to) );

    my @pupils;
    sqla \@pupils, "select
	human_id, last_name ||' '|| first_name ||' '|| middle_name,
	( select count(1) from sms_recipient where human_id = sms_recipient.uid )
from
	sys_matrix, human
where
	human_id = vw_pupil
	and sys_matrix.view_class = 1
	and sys_matrix.class = $c
	and exists
	(
		select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0)
		where saldo_sum <> 0
	)";

    my $t = '';

    my $there_is_grayed_pupil = 0;

    for (@pupils) {
        if ( $$_[2] > 0 ) {
            $t .=
qq[<label for="u$$_[0]"><input id="u$$_[0]" name="u$$_[0]" type="checkbox" checked> $$_[1]</label><br>];
        }
        else {
            $t .=
qq[<label style="color: gray"><input type="checkbox" disabled> $$_[1]</label><br>];
            $there_is_grayed_pupil = 1;
        }
    }

    if ($there_is_grayed_pupil) {
        $t .=
"<div class=help style='margin: 8px;'>  ,<br>     .<br>
		<a href='?act=sms_edit_numbers&c=$c'>    </a><br>
		 .</div>";
    }

    tpl './tpl/sms/select_scores_by_date_and_recipients_form.html',
      {
        menu       => generate_menu(),
        footers    => generate_footers(),
        t          => $t,
        class_name => resolve_class_id($c),
        from       => $from,
        to         => $to,
      };

}

sub sms_select_scores_by_date_and_recipients_preview() {
    my $from = param 'from';
    my $to   = param 'to';
    sex_date( $from, $to );
    my ( $from_date, $to_date ) = ( $from, $to );
    ( $from, $to ) = ( totime($from), totime($to) );

    my @recipient_id = param 'recipient';

    if ( scalar @recipient_id < 1 or scalar @recipient_id > 3 ) {
        stop('  1  3  SMS.');
    }
    sex_range( @recipient_id, 0, 2 );

    my @pupil;

    for (param) {
        if (/^u(\d+)$/) {
            push @pupil, $1;
        }
    }

    my $q = sqlp(
        "select uid,human_type,phone_number from sms_recipient
	where sms_recipient.human_type in (" . join( ',', @recipient_id ) . ")
	and sms_recipient.uid in (" . join( ',', @pupil ) . ")"
    );
    my %h;
    $q->bind_columns( \( @h{ @{ $q->{NAME_lc} } } ) );

    my %recipient;

    while ( $q->fetch ) {
        $recipient{ $h{uid} }{ $h{human_type} } = $h{phone_number};
    }
    $q->finish;

    my $sorry_no_phones = '';
    unless ( scalar keys %recipient ) {
        $sorry_no_phones =
q[<div class="infoblock" style="text-align:center"><h2>        .</h2><a href="?act=sms_edit_numbers"></a></div>];
    }

    my %number_has_more_than_one_pupil;
    sqlh \%number_has_more_than_one_pupil, "select n, c from
	(
		select phone_number AS n, count(uid) as c
		from sms_recipient
		group by phone_number
	)
	where c > 1";

    my @scores;

    sqla \@scores, "select uid, score, subj, scoretime
 from  sp_scores
where  uid IN (" . join( ',', @pupil ) . ")
  and  scoretime between $from and $to";

    my %scores_organized;

    for (@scores) {
        push @{ $scores_organized{ $$_[0] }{ sms_date( $$_[3] ) }
              { sms_subj( $$_[2] ) } },
          sms_score( $$_[1] );
    }

    my $glued_sms_for_pupil = "";

    my @sms_length;

    for ( sort keys %scores_organized ) {
        my $glued_sms = get_glued_sms2( $scores_organized{$_} );

        my $fio_added_to_sms = 0;

        for my $recipient_type_id (@recipient_id) {
            if ( exists $recipient{$_}{$recipient_type_id} ) {
                $glued_sms_for_pupil .=
qq[<tr><th id="$_|$recipient{$_}{$recipient_type_id}|header" colspan=3>${\(human_hash($_))} &rarr; ${\(lc @{$g_recipient_ref{$recipient_type_id}}[2])}  $recipient{$_}{$recipient_type_id}</th></tr>];

                if (
                    exists $number_has_more_than_one_pupil{ $recipient{$_}
                          {$recipient_type_id} } )
                {
                    unless ($fio_added_to_sms) {
                        $glued_sms =
                          ( ( $gconf{'sms_translit'} )
                            ? translit( human_hash( $_, 1 ) )
                            : human_hash( $_, 1 ) )
                          . " $glued_sms";

                        $fio_added_to_sms = 1;
                    }
                }

                if ( $gconf{'sms_translit'} ) {
                    $glued_sms = translit($glued_sms);
                }

                my $length            = length($glued_sms);
                my $sms_part_count    = ceil( $length / 160 ) - 1;
                my $chars_used_of_160 = $length % 160;

                push @sms_length, $length;

                my $expediency_percent =
                  sprintf( "%.0f", 100 * ( $length % 160 ) / 160 );
                my ( $channel_g, $channel_b ) = ( 240, 140 );
                my $expediency_percent_theshold = 80;
                if ( $expediency_percent < $expediency_percent_theshold ) {
                    my $interpolated_percent =
                      10000 / $expediency_percent_theshold / 100;
                    $channel_g = sprintf( "%.0f",
                        240 / 100 *
                          $expediency_percent *
                          $interpolated_percent );
                    $channel_b = sprintf( "%.0f",
                        140 / 100 *
                          $expediency_percent *
                          $interpolated_percent );
                }
                my $expediency_color = "200,$channel_g,$channel_b";

                $length = "<div>$length</div>"
                  . declension( $length, [ '', '', '' ] );

                my $additional_bars = '';
                for ( 1 .. $sms_part_count ) {
                    $additional_bars .=
qq[<div class="sms_expediency" style="background-color:rgb(200,240,140)"></div>];
                }

                $glued_sms_for_pupil .= qq[
<tr>
	<td>$length
		$additional_bars
		<div title="$chars_used_of_160  160 .  : $expediency_percent %" class="sms_expediency">
			<div style="width:$expediency_percent%;background-color:rgb($expediency_color)"></div>
		</div>
	</td>
	<td id="$_|$recipient{$_}{$recipient_type_id}|wrapper">
	<input id="$_|$recipient{$_}{$recipient_type_id}" type="checkbox" checked></td>
	<td onclick="switch_checkbox(this)" id="$_|$recipient{$_}{$recipient_type_id}|text">$glued_sms</td>
</tr>];
            }
        }
    }

    tpl './tpl/sms/select_scores_by_date_and_recipients_preview.html',
      {
        menu                => generate_menu(),
        footers             => generate_footers(),
        avg_length          => avg( \@sms_length ),
        count               => scalar(@sms_length),
        glued_sms_for_pupil => $glued_sms_for_pupil,
        sorry_no_phones     => $sorry_no_phones,
      };
}

sub get_glued_sms2($) {
    my $sms_hash1 = shift;
    my $sms       = '';
    my ( $first_score, $first_subj );

    for my $date (
        sort {
            substr( $a, 3, 2 ) <=> substr( $b, 3, 2 )
              || int($a) <=> int($b)
        } keys %$sms_hash1
      )
    {
        my $tmp_before_date = $sms;

        $sms .= $sms ? "; $date: " : "$date: ";

        $first_subj = 1;

        for my $subj ( sort keys %{ $$sms_hash1{$date} } ) {
            $sms .= $first_subj ? "$subj " : ", $subj ";

            $first_score = 1;

            for ( @{ $$sms_hash1{$date}{$subj} } ) {
                $sms .= $first_score ? $_ : "/$_";
                $first_score = 0;
            }
            $first_subj = 0;
        }
    }

    return $sms;
}

sub sms_edit_numbers() {
    if ( $ENV{'REQUEST_METHOD'} eq 'GET' ) {

        my $c = param('c');

        my $t;

        my $filter_class =
          ( $c =~ /^\d+$/ ) ? '' : '<option value="">&hellip;</option>';

        my $form_bottom_html = qq[
	<div align=center>
		<br>
		<button type=button onclick="sms_edit_numbers_clear_fields()"><img src="/sp/img/reload.gif">  </button>
		<button type=reset><img src="/sp/img/reload.gif"> </button>
		<button style="margin-left: 16px" type=submit><img src="/sp/img/save.png"> </button>
	</div>

	</form>
	];

        if ( $c ne 'teachers' ) {

            sec_gt0 $c if $c;

            $filter_class .= filter_class($c);

            my $parents_per_class_html = '';

            unless ($c) {
                my %parents_per_class;

                my %class_hash;
                fill_class_ref( \%class_hash );

                sqlh \%parents_per_class, "SELECT
		sys_matrix.class,
		count(uid)
	FROM sms_recipient, sys_matrix
	where cast (sys_matrix.vw_pupil as integer) = sms_recipient.uid
		and sys_matrix.view_class = 1
		and exists
		(
			select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0)
			where saldo_sum <> 0
		)
	GROUP by sys_matrix.class, sys_matrix.paralel";
                $parents_per_class_html .=
'<div class="infoblock"><h2>    </h2>';
                my $counter = 0;
                for ( sort keys %parents_per_class ) {
                    $counter++;
                    $parents_per_class_html .=
qq[<a href="?act=sms_edit_numbers&c=$_">$class_hash{$_} &mdash; $parents_per_class{$_}</a>];
                }

                unless ($counter) {
                    $parents_per_class_html .= qq[
					<div style="text-align:center; padding: 32px 0">
						    .<br>
						     .
					</div>
					];
                }

                my $q = sqlp "select phone_number, count(uid)
	from sms_recipient
	group by phone_number
	order by 2 desc";

                my @a;

                while ( ( @a = $q->fetchrow_array ) and $a[1] > 1 ) {
                    $parents_per_class_html .=
                      " $a[0]   $a[1] <br>";
                }
                $q->finish;

                $parents_per_class_html .= '</div>';
            }

            if ($c) {
                my @a;
                sqla \@a, "SELECT
	sys_matrix.vw_pupil,
	(
		select name
		from vw_pupil
		where vw_pupil.human_id = sys_matrix.vw_pupil
	),
	human_type,
	phone_number
	FROM sys_matrix left join sms_recipient on sms_recipient.uid = cast (sys_matrix.vw_pupil as integer)
	where
	sys_matrix.view_class = 1
	and sys_matrix.class = $c
	and exists
	(
		select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0)
		where saldo_sum <> 0
	)
	order by 2";

                my %parent_numbers;
                for (@a) {
                    if ( exists $parent_numbers{ $$_[1] } ) {
                        $parent_numbers{ $$_[1] }{ $$_[2] } = $$_[3];
                    }
                    else {
                        $parent_numbers{ $$_[1] } = {
                            uid    => $$_[0],
                            $$_[2] => $$_[3]
                        };
                    }
                }

                $t = qq[
	<form method=POST>
		<input type=hidden name="act" value="sms_edit_numbers">
		<input type=hidden name="c" value="$c">
		<table class="d pad" align=center cellspacing=0 cellpadding=3><tr><th colspan=2></th><th></th><th></th><th></th></tr>
	];

                my $counter = 1;

                for ( sort keys %parent_numbers ) {
                    $t .= qq[
	<tr>
		<td align=right>$counter</td>
		<td>$_</td>
		<td><input name="mom-$parent_numbers{$_}{uid}" value="$parent_numbers{$_}{1}" class=def type=text size=13 maxlength=13></td>
		<td><input name="dad-$parent_numbers{$_}{uid}" value="$parent_numbers{$_}{2}" class=def type=text size=13 maxlength=13></td>
		<td><input  name="me-$parent_numbers{$_}{uid}" value="$parent_numbers{$_}{0}" class=def type=text size=13 maxlength=13></td>
	</tr>];
                    $counter++;
                }
                $t .= "</table>";

                $t .= $form_bottom_html;

            }

            tpl './tpl/sms/edit_numbers.html',
              {
                menu         => generate_menu(),
                footers      => generate_footers(),
                filter_class => $filter_class,
                t            => $c ? $t : $parents_per_class_html,
                opt          => $c
                ? qq[<a href="?act=sms_print_class_numbers&c=$c"></a>]
                : '',
              };

        }
        else {

            my @a;
            sqla \@a, "select
				human_id,
				trim(last_name)||' '||first_name||' '||middle_name,
				phone_number
			from
				human left join sms_recipient on sms_recipient.uid = human.human_id
			where
				class = 0
			order by 2";

            $t = qq[
	<form method=POST>
		<input type=hidden name="act" value="sms_edit_numbers">
		<input type=hidden name="c" value="teachers">
		<table class="d pad" align=center cellspacing=0 cellpadding=3><tr><th colspan=2></th><th></th></tr>
	];

            my $counter = 1;

            for (@a) {
                $t .= qq[
	<tr>
		<td align=right>$counter</td>
		<td>$$_[1]</td>
		<td><input name="me-$$_[0]" value="$$_[2]" class=def type=text size=13 maxlength=13></td>
	</tr>];
                $counter++;
            }
            $t .= "</table>";

            $t .= $form_bottom_html;

            tpl './tpl/sms/edit_numbers.html',
              {
                menu         => generate_menu(),
                footers      => generate_footers(),
                filter_class => $filter_class . filter_class(),
                t            => $t,
                opt          => '',
              };

        }

    }
    elsif ( $ENV{'REQUEST_METHOD'} eq 'POST' ) {

        my %human_type = ( 'me', 0, 'mom', 1, 'dad', 2 );

        for ( param() ) {
            if (/^(mom|dad|me)-(\d+)$/) {
                my $number        = param("$1-$2");
                my $uid           = $2;
                my $human_type_id = $human_type{$1};

                sql(
"delete from SMS_RECIPIENT where UID = $uid and HUMAN_TYPE = $human_type_id"
                );

                $number =~ s/^8/+7/;

                if (   $number =~ m/^\+7\d{10}$/
                    or $number =~ m/^\+4\d{11}$/ )
                {
                    sql qq[
INSERT INTO SMS_RECIPIENT (UID,  HUMAN_TYPE,     PHONE_NUMBER)
                   VALUES ($uid, $human_type_id, '$number')];
                }
            }
        }

        redir( "sms_edit_numbers&c=" . ( param('c') ) );

    }
    else { deny(); }
}

sub sms_setup_recipient() {
    msg(
        "     SMS   .",
" ,     ,  &nbsp;  ."
    ) unless $gconf{'sms'};

    security_alert('only for pupils') unless $ggid == 4;

    if ( $ENV{'REQUEST_METHOD'} eq 'GET' ) {

        my $sms_disable_pupil_edit_numbers = sqlff(
"select 1 from sp_settings where name = 'sms_disable_pupil_edit_numbers'"
        ) ? ' disabled' : '';

        my %n = ( 0, '', 1, '', 2, '' );
        sqlh \%n,
"select human_type, phone_number from sms_recipient where uid = $guid";

        my %a;
        sqlh \%a, "select human_type, 1 from sms_acl where acl_id = 0";
        my $denied =
" (<span class=hint title='       .    ,        ,        .'></span>)";

        tpl './tpl/sms/setup_recipient_form.html',
          {
            menu           => generate_menu(),
            footers        => generate_footers(),
            n0             => $n{'0'},
            n1             => $n{'1'},
            n2             => $n{'2'},
            a0             => $a{'0'} ? '' : $denied,
            a1             => $a{'1'} ? '' : $denied,
            a2             => $a{'2'} ? '' : $denied,
            disabled_field => $sms_disable_pupil_edit_numbers,
          };

    }
    elsif ( $ENV{'REQUEST_METHOD'} eq 'POST' ) {

        if (
            sqlff(
"select 1 from sp_settings where name = 'sms_disable_pupil_edit_numbers'"
            )
          )
        {
            stop(
                "     ."
            );
        }

        my %numbers;
        $numbers{'0'} = param('me');
        $numbers{'1'} = param('mom');
        $numbers{'2'} = param('dad');
        for ( keys %numbers ) {
            if ( defined( $numbers{$_} ) and $numbers{$_} ne '' ) {
                $numbers{$_} =~ s/^8/+7/;

                unless ( $numbers{$_} =~ m/^\+7\d{10}$/
                    or $numbers{$_} =~ m/^\+4\d{11}$/ )
                {
                    escape_tag( \$numbers{$_} );
                    stop
"  <br>$numbers{$_}<br> : +7XXXXXXXXXX  8XXXXXXXXXX.";
                }

                if ( sqlff
"select 1 from sms_recipient where uid = $guid and human_type = $_"
                  )
                {
                    sql
"update sms_recipient set phone_number = '$numbers{$_}' where uid = $guid and human_type = $_";
                }
                else {
                    sql
"insert into sms_recipient (uid,human_type,phone_number) values ($guid,$_,'$numbers{$_}')";
                }
            }
            else {
                sql
"delete from sms_recipient where uid = $guid and human_type = $_";
            }
        }

        redir('sms_setup_recipient');

    }
    else { deny(); }
}

sub sms_setup() {

    if ( $ENV{'REQUEST_METHOD'} eq 'GET' ) {

        my %n;
        sqlh \%n, "select human_type, 'checked' from sms_acl where acl_id = 0";

        my $tab_content .= tab_div(
            [
                '',
                tpl_str(
                    './tpl/sms/setup_permissions_tab.html',
                    {
                        n0                 => $n{'0'},
                        n1                 => $n{'1'},
                        n2                 => $n{'2'},
                        disable_pupil_edit => (
                            sqlff(
"select 1 from sp_settings where name = 'sms_disable_pupil_edit_numbers'"
                            )
                          ) ? 'checked' : ''
                    }
                )
            ],
            [ ' ', 'lesson_abbr&tab=2', 1 ],
            8 );

        my $unsent_score_number = sqlff("select count(*) from sms_pool");

        tpl './tpl/sms/setup.html',
          {
            menu          => generate_menu(),
            footers       => generate_footers(),
            tab_content   => $tab_content,
            unsent_scores => $unsent_score_number
            ? qq[<div align=center><a href="?act=sms_dump_pool">  ($unsent_score_number)</a> | <a onClick="return confirm('        ?')" href="?act=sms_empty_pool">  </a></div>]
            : '',
          };

    }
    elsif ( $ENV{'REQUEST_METHOD'} eq 'POST' ) {

        my %human_type = ( 'me', 0, 'mom', 1, 'dad', 2 );

        for ( keys %human_type ) {
            if ( param($_) eq 'on' ) {
                unless ( sqlff
"select 1 from sms_acl where acl_id = 0 and human_type = $human_type{$_}"
                  )
                {
                    sql
"insert into sms_acl (acl_id, human_type) values (0, $human_type{$_})";
                }
            }
            else {
                sql
"delete from sms_acl where acl_id = 0 and human_type = $human_type{$_}";
            }
        }

        if ( param('disable_pupil_edit') eq 'on' ) {
            unless (
                sqlff(
"select 1 from sp_settings where name = 'sms_disable_pupil_edit_numbers'"
                )
              )
            {
                sql(
"insert into sp_settings (name, f_int) values ('sms_disable_pupil_edit_numbers', 1)"
                );
            }
        }
        else {
            sql(
"delete from sp_settings where name = 'sms_disable_pupil_edit_numbers'"
            );
        }

        redir('sms_setup');

    }
    else { deny(); }
}

sub lesson_abbr() {

    if ( $ENV{'REQUEST_METHOD'} eq 'GET' ) {

        my $mover =
          q[OnMouseOver='m_over_score(this);' OnMouseOut='m_out_score(this);'];
        my %hardcoded_abbr = (
            '',             '-',
            '',              '-',
            ' ',            '.',
            ' ',              '.',
            ' ',            '.',
            ' ',        '.',
            ' ',     '.',
            ' ',         '-',
            ' ',         '.',
            ' ',      '.',
            ' ',       '.',
            ' ', '.',
            ' ',              '.',
            ' ',             '.',
            ' ',               '.',
            ' ',      '.',
            ' ',       '.',
            ' ',             '.',
            '',              '',
            '',                       '',
        );

        my $t = '';
        my @a;
        sqla \@a,
"select lesson_id, name, substr(name,1,3), substr(name,1,4), name_abbr from lesson order by name";

        my %repeating;
        my $has_unset = 0;
        for (@a) {
            unless ( defined $$_[4] ) {
                $has_unset++;
            }
            $repeating{ $$_[4] }++ if $$_[4];
        }

        my $abuse = '';
        if ($has_unset) {
            $abuse .= " $has_unset "
              . declension(
                $has_unset,
                [
                    " ",
                    " ",
                    " "
                ]
              ) . ".<br>";
        }
        for ( keys %repeating ) {
            if ( $repeating{$_} > 1 ) {
                $abuse .=
" &laquo;<b>$_</b>&raquo;    .<br>";
            }
        }

        if ($abuse) {
            $abuse = qq[<div class="warning">$abuse</div>];
        }

        for (@a) {
            my $tmp;
            my $tmp2 = $hardcoded_abbr{ $$_[1] } || '&nbsp;';
            my @tmp2 = split /\s+/, $$_[1];
            if ( @tmp2 > 1 ) {
                for (@tmp2) {
                    $tmp .= uc substr( $_, 0, 1 );
                }
            }
            my $value = $$_[4] || '';
            my $mover_first_letters =
              $tmp ? qq[onclick="set_abbr(this,'l$$_[0]')"  $mover] : '';
            my $mover_hardcoded =
              $hardcoded_abbr{ $$_[1] }
              ? qq[onclick="set_abbr(this,'l$$_[0]')"  $mover]
              : '';
            $tmp ||= '&nbsp;';
            $t .= qq[<tr>
	<td>$$_[1]</td>
	<td><input type=text id="l$$_[0]" name="l$$_[0]" class=def size=11 maxlength=10 value="$value"></td>
	<td $mover_hardcoded>$tmp2</td>
	<td onclick="set_abbr(this,'l$$_[0]')" $mover>$$_[2]</td>
	<td onclick="set_abbr(this,'l$$_[0]')" $mover>$$_[3]</td>
	<td $mover_first_letters>$tmp</td>
</tr>];
        }

        my $tab_content .= tab_div(
            [ '', "sms_setup", 1 ],
            [
                ' ',
                tpl_str(
                    './tpl/sms/setup_lesson_abbr_tab.html',
                    {
                        abuse => $abuse,
                        t     => $t,
                    }
                )
            ],
            8
        );

        my $unsent_score_number = sqlff("select count(*) from sms_pool");

        tpl './tpl/sms/setup.html',
          {
            menu          => generate_menu(),
            footers       => generate_footers(),
            tab_content   => $tab_content,
            unsent_scores => $unsent_score_number
            ? qq[<div align=center><a href="?act=sms_dump_pool">  ($unsent_score_number)</a> | <a onClick="return confirm('        ?')" href="?act=sms_empty_pool">  </a></div>]
            : '',
          };

    }
    elsif ( $ENV{'REQUEST_METHOD'} eq 'POST' ) {
        my @a = param();
        for (@a) {
            if (/^l(\d+)$/) {
                my $t = param("l$1");
                if ( $t eq '' ) { $t = undef; }
                sqlb "update lesson set name_abbr = ? where lesson_id = $1", $t;
            }
        }
        redir('lesson_abbr&tab=2');
    }
    else { deny(); }

}

sub sms_empty_pool() {
    sql "delete from sms_pool";
    msg( '   .', '' );
}

sub sms_dump_pool() {
    my @a;
    sqla( \@a, 'select phone_number, text from sms_pool' );
    my %h;
    for (@a) {
        push @{ $h{ $$_[0] } }, $$_[1];
    }

    my $t;
    for ( sort keys %h ) {
        $t .= "<br><b>$_</b><br>";
        for my $message ( @{ $h{$_} } ) {
            $t .= "$message<br>";
        }
    }
    msg( ' ', $t );
}

sub sms_send() {

    my @c = param('c');
    my @g = param('g');

    if ( scalar @c == 0 and scalar @g == 0 ) {

        my %sms_group;
        sqlh \%sms_group, "select id, name from sms_group";
        my $sms_group_count = sqlff "select count(1) from sms_group";

        my $sms_group_html = '';
        for ( sort { $sms_group{$a} cmp $sms_group{$b} } keys %sms_group ) {
            $sms_group_html .=
              qq[<option value='$_'>$sms_group{$_}</option><br>];
        }

        msg(
            " 1:  ",
            "
<script type='text/javascript'>
function CheckForm()
{
	//    ,   ,   ,  
	if ( !document.f.c.value && document.f.g.value )
	{
		return true;
	}
  if ( !document.f.recipient.value )
    { alert('  ,  .'); return false; }
  return true;
}
</script>

<form name=f method=get onsubmit='return CheckForm()'>

	<input type=hidden name='act' value='sms_send'>

	<fieldset>
		<legend></legend>
		<table cellspacing='0' cellpadding='5'>
			<tr>
				<td>
					<select name=c size=10 multiple>" . filter_class() . "</select>
				</td>
				<td valign='top'>
					<div style='margin-bottom: 4px;'>:</div>
					<select name=recipient size=3>
						<option value='0'></option>
						<option value='1'></option>
						<option value='2'></option>
					</select>
				</td>
			</tr>
		</table>
	</fieldset>

	<fieldset>
		<legend></legend>
		<select name=g size=$sms_group_count multiple>
		$sms_group_html
		</select>
	</fieldset>

	<button type=submit></button>

</form>"
        );

    }
    elsif (scalar @c > 0
        or scalar @g > 0 )
    {

        sex_gt0(@c);

        my %class_ref;
        fill_class_ref( \%class_ref );

        my $recipient = param('recipient');
        if ( scalar @c > 0 ) {
            sec_range( $recipient, 0, 2 );
        }

        my $to = '';

        for my $class_id (@c) {
            $to .=
"<a href='?act=sms_edit_numbers&c=$class_id' title='  '><h2>$class_ref{$class_id}</h2></a>";
            my @pupils;
            sqla(
                \@pupils, "select
/* vw_pupil, */
(
	select trim(last_name)||' '||first_name||' '||middle_name
	from human where human_id = sys_matrix.vw_pupil
),
(
	select PHONE_NUMBER from SMS_RECIPIENT
	where UID = sys_matrix.vw_pupil
	and HUMAN_TYPE = $recipient
)
from sys_matrix inner join human on cast(vw_pupil as integer) = human_id
where
sys_matrix.view_class = 1
and sys_matrix.class = $class_id
and exists
(
  select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0)
  where saldo_sum <> 0
)
order by trim(human.last_name)"
            );

            for (@pupils) {
                if ( defined $$_[1] ) {
                    $to .=
qq[<label title="$$_[1]" for="u$$_[1]"><input id="u$$_[1]" type="checkbox" checked> $$_[0]</label><br>];
                }
                else {
                    $to .=
                        qq[<label style="color: gray" title="  ]
                      . lc( @{ $g_recipient_ref{$recipient} }[1] )
                      . qq[  "><input type="checkbox" disabled> $$_[0]</label><br>];
                }
            }

        }

        my %sms_group_ref;
        sqlh( \%sms_group_ref, "select id, name from sms_group" );
        for my $sms_group_id (@g) {
            $to .=
"<a href='?act=sms_edit_numbers&c=teachers' title='  '><h2>$sms_group_ref{$sms_group_id}</h2></a>";
            my @group_members;
            sqla(
                \@group_members, "select
(
	select trim(last_name)||' '||first_name||' '||middle_name
	from HUMAN where HUMAN_ID = UID
),
(
	select PHONE_NUMBER from SMS_RECIPIENT
	where SMS_RECIPIENT.UID = SMS_GROUP_MEMBERS.UID
	and HUMAN_TYPE = 0
),
(
	select log from sp_users where uid = human_id
),
uid
from SMS_GROUP_MEMBERS inner join human on cast(UID as integer) = HUMAN_ID
where SMS_GROUP_MEMBERS.GID = $sms_group_id
order by trim(human.last_name)"
            );

            my %namesake;

            for (@group_members) {
                if ( exists $namesake{ $$_[0] } ) {
                    $$_[0] .= $$_[2] ? " (: $$_[2])" : " (UID: $$_[3])";
                }
                else {
                    $namesake{ $$_[0] }++;
                }

                if ( defined $$_[1] ) {
                    $to .=
qq[<label title="$$_[1]" for="u$$_[1]"><input id="u$$_[1]" type="checkbox" checked> $$_[0]</label><br>];
                }
                else {
                    $to .=
                        qq[<label style="color: gray" title="  ]
                      . lc( @{ $g_recipient_ref{$recipient} }[1] )
                      . qq[  "><input type="checkbox" disabled> $$_[0]</label><br>];
                }
            }

        }

        tpl(
            './tpl/sms/send_to_pupils.html',
            {
                menu      => generate_menu(),
                footers   => generate_footers(),
                to        => $to,
                recipient => lc( @{ $g_recipient_ref{$recipient} }[0] ),
            }
        );

    }

}

sub sms($$) {
    return unless $gconf{'sms'};

    my $sid = sid();

    my $uid  = shift;
    my $text = shift;

    if ( 1 != sqlff "select class from human where human_id = $uid" ) {
        stop
"SMS         (UID = $uid).";
    }

    my @phone_numbers;
    sqlffa \@phone_numbers, "select phone_number from sms_recipient
where uid = $uid and exists
(
 select 1 from sms_acl
 where acl_id = 0
 and sms_acl.human_type = sms_recipient.human_type
)";
    if ( $gconf{'sms_translit'} ) {
        $text = translit($text);
    }

    for my $phone_number (@phone_numbers) {
        sqlb qq[insert into sms_pool
		(sid, phone_number, text)
		values
		($sid, '$phone_number', ?)], $text;
    }
}

sub sms_subj($) {
    my $id = shift;
    return sqlff "select iif (lesson.name_abbr = '',name,name_abbr)
from lesson
where lesson_id = $id";
}

sub sms_mark($) {
    my $t = shift;
    if    ( $t == 1 ) { return '/'; }
    elsif ( $t == 2 ) { return ''; }
    else              { return ''; }
}

sub sms_date($) {
    my $t = todate shift;
    $t =~ /^(\d+)\.(\d+)/;

    return "$1.$2";

}

sub sms_period($) {
    my %h = (
        0  => '',
        5  => '1 ',
        6  => '2 ',
        7  => '3 ',
        1  => '1 ',
        2  => '2 ',
        3  => '3 ',
        4  => '4 ',
        8  => '',
        9  => '',
        10 => '1 ',
        11 => '2 '
    );
    my $key = shift;
    return $h{$key};
}

sub sms_score($) {
    my $score = shift;
    return ''  if $score == -1;
    return '' if $score == -2;
    return $score;
}

sub smsf {
    my $uid           = shift;
    my $format_string = shift;
    my @values        = @_;

    my %fx = (
        's', 'sms_subj', 'p', 'sms_period', 'm', 'sms_mark',
        'd', 'sms_date', 'o', 'sms_score',
    );

    my @replaces;

    my $value_idx = 0;

    my @l = split //, $format_string;

    for ( my $i = 0 ; $i < @l ; $i++ ) {
        for my $key ( keys %fx ) {
            if ( $l[$i] eq $key ) {
                push @replaces, [ $i, $fx{$key}, $values[$value_idx] ];
                $value_idx++;
            }
        }
    }

    my $formatted;
    my $st_char_index = 0;
    for (@replaces) {
        $$_[0]++;
        $formatted .=
          substr( $format_string, $st_char_index, $$_[0] - $st_char_index - 1 );
        {
            no strict 'refs';
            $formatted .= $$_[1]( $$_[2] );
        }
        $st_char_index = $$_[0]++;
    }

    sms( $uid, $formatted );
}

1;
