#!/usr/bin/speedy -X
# (C) http://spcms.ru
#!/usr/bin/perl -W

if ( $ENV{'SERVER_NAME'} eq 'school19.tgl.ru' ) {
    $ENV{TZ} = 'GMT-4';
}

push @INC, '.';

use CGI qw(:standard escapeHTML -no_xhtml);
use GD;
use GD::Graph::bars;
use GD::Graph::pie;
use locale;

use strict;

$CGI::POST_MAX = 1_000_000;
use vars qw /$DEBUG $GZIP %SQLH $gpage @modules $login_form $HTTP_HEADER_ADD/;

use CGI::Carp qw/fatalsToBrowser name=SP/;

require "common.pl";
require "misc.pl";
require "main.pl";
require "menu.pl";
require "logs.pl";
require "reg.pl";
require "ktp.pl";
require "score.pl";
require "reports.pl";
require "teacher.pl";
require "setup_periods.pl";
require "setup_class_links.pl";
require "subgroups.pl";
require "ajax.pl";
require "test.pl";
require "test_report.pl";
require "sms.pl";

sub form_login();

our $version;
our ( %gconf, $gdsn, $gdb, %ACL, $gdate, $state_date, $connected, $sact );
our ( $guid, $ggid );
our ( $gteacher_show_all, $stat_inbox_new );

our ( $queryes, $gentime );
$GZIP            = 0;
$gpage           = '';
%SQLH            = ();
$HTTP_HEADER_ADD = '';

$queryes = 0;

our @months3 = qw(           );
our @mnths2 =
  qw(           );
our @wdays2      = qw(      );
our @daysinmonth = ( 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 );
our $popup       = param('popup') ? '&popup=1' : '';

our %g_period_to_str = (
    't1' => 5,
    't2' => 6,
    't3' => 7,
    'q1' => 1,
    'q2' => 2,
    'q3' => 3,
    'q4' => 4,
    'y'  => 0,
    'e'  => 8,
    't'  => 9,
    'h1' => 10,
    'h2' => 11
);

our %g_period_to_name = (
    't1' => '1 ',
    't2' => '2 ',
    't3' => '3 ',
    'q1' => '1 ',
    'q2' => '2 ',
    'q3' => '3 ',
    'q4' => '4 ',
    'y'  => '',
    'e'  => '',
    't'  => '',
    'h1' => '1 ',
    'h2' => '2 '
);

our %g_period_id_to_name = (
    5  => '1 ',
    6  => '2 ',
    7  => '3 ',
    1  => '1 ',
    2  => '2 ',
    3  => '3 ',
    4  => '4 ',
    0  => '',
    8  => '',
    9  => '',
    10 => '1 ',
    11 => '2 '
);

our %g_recipient_ref = (
    0 => [ ' ', '', '' ],
    1 => [ '',          '',    '' ],
    2 => [ '',          '',    '' ]
);

our @exclude =
  qw/login login_form aj_login_free reg1 reg2 reg3 test_export kill_speedy/;

our @access_all = qw/main logout logout2 logout3 su_logout session_keep_alive/;

our @access_pupil = qw/main_pupil score_list_class score_list_class_totals
  score_all_subjects score_list_pupil_totals
  score_year change_password test name_rating score_top sms_setup_recipient/;

our @access_teacher = qw/
  score_form_select_class score_form_class score_class
  all_pupils gen_list_form gen_list pupil_info
  report_form report report_form_parallel report_parallel report_school report_form_school
  report_form_links report_links
  report_form_teacher report_teacher
  report_form_progress_movement report_progress_movement
  report_form_totals report_totals
  report_knowledge_area_form report_knowledge_area
  state_date_form state_date_set state_date_reset
  subgroups subgrp_list subgrp_kill_all
  teacher_switch_binding teacher_list_bindings
  req_view maketest test_report
  score_all_subjects_class score_all_subjects_class_form/;

our @access_admin = qw/
  logged registered aj_acl_switch session_kill user_delete clear_logged
  setup_periods setup_periods_modify
  class_links_list class_links_setup req_edit
  register_teacher_form register_teacher users_teachers
  register_sp_teachers set_password
  teacher_placement teacher_place teacher_placement_stop
  teacher_form_master teacher_form_master_place teacher_form_master_stop
  set_default_sou_form set_default_sou
  aj_subgrp logs wizard_new_year
  internet_access_control
  change_teachers_passwords
  teacher_subjects
  change_and_print_class_passwords
  sms_setup lesson_abbr sms_dump_pool
  sms_edit_numbers sms_empty_pool
  sms_group sms_send aj_sms_send
  sms_select_scores_by_date_and_recipients_form
  sms_select_scores_by_date_and_recipients_preview
  sms_print_class_numbers
  payfood_error_pay
  aj_autocomplete
  medallist_editor
  pupil_import_csv
  teacher_import_csv
  /;

push @access_pupil,   @access_all;
push @access_teacher, @access_pupil;
push @access_admin,   @access_teacher;

OnStart();
ConnectDBCms();

if ($DEBUG) { $gentime = Time::HiRes::time(); }

if ( $gconf{'gzip'} && ( $ENV{HTTP_ACCEPT_ENCODING} || '' ) =~ /gzip/o ) {
    $GZIP = 1;
}

my $searchfor = param("act");
$sact = param("sact");

if (   param('act') eq 'test'
    or param('act') eq 'maketest'
    or param('act') eq 'test_export'
    or param('act') eq 'test_report' )
{
    our ( $id, $act, $tab );
    $id   = param("id");
    $act  = param("act");
    $sact = param("sact") || '';
    $tab  = param("tab") || 0;
}

my $count = grep ( /^\Q$searchfor\E$/, @exclude );

if ( !$count ) {

    session_check();

    ( $guid, $ggid, $state_date ) = uid_gid_gdate();

    if ( $ggid == 2 ) {
        $gteacher_show_all = sqlff(
            "select f_int from sp_user_settings where uid = $guid and id=0");
    }
    $gdate = ($state_date) ? todate($state_date) : todate(time);
    read_acl();

    @access_teacher = @access_admin if $ACL{'1'};

    session_access();
    session_keep_alive();
    $stat_inbox_new = get_new_message_count();
}
else {
    $gdate = todate(time);
}

if (    defined $ggid
    and 4 == $ggid
    and $gconf{'disable_pupil_view_class_scores'}
    and param('act') eq 'score_list_class' )
{
    stop("      .");
}

if    ( param("act") eq 'main' )       { print_main(); }
elsif ( param("act") eq 'login_form' ) { form_login(); }
elsif ( param("act") eq 'login' ) {
    Time::HiRes::sleep(0.5) unless ($DEBUG);
    if ( $ENV{'REQUEST_METHOD'} ne 'POST' ) {
        security_alert('  GET  POST');
    }
    clear_expired_sessions();
    my $uid;
    my $sid;
    my $log = param('log');
    my $pwd = param('pwd');
    my $ip  = $ENV{'REMOTE_ADDR'};
    $ip =~ s/'//g;
    my $ip_for = $ENV{'HTTP_X_FORWARDED_FOR'} || '';
    $ip_for =~ s/'//g;
    my $agent = substr( $ENV{'HTTP_USER_AGENT'}, 0, 127 );
    $agent =~ s/'//g;
    my $datetime = time;

    my $user_valid = 0;

    $log = substr( $log, 0, 64 );
    $pwd = substr( $pwd, 0, 64 );

    my $q = $gdb->prepare('select uid, pas from sp_users where log = ?')
      or db_error();
    $q->execute($log) or db_error();
    my @data = $q->fetchrow_array();
    $q->finish;

    if ( $data[0] ) {
        unless (
            sqlff(
                "select 1 from sp_users, sp_gid_ref
             where uid = $data[0] and sp_users.gid = sp_gid_ref.gid"
            )
          )
        {
            stop("    .");
        }
    }

    if ( $data[0] and $data[1] eq $pwd ) {
        $user_valid = 1;
    }
    elsif ( $data[0] ) {
        log_user_sesion( 7, $log, $pwd );
        error(
"    .  .<br><br>$login_form"
        );
    }

    if ($user_valid) {
        $uid = $data[0];

        my $logged = 0;

        if ( @data =
            sqlf("select uid, sid from sp_users_logged where uid = $uid") )
        {
            $logged = 1;
        }

        unless ($logged) {
            my $fail = 1;
            my @data1;

            while ($fail) {
                $sid = int( rand(2147483644) ) + 1;
                $q = sqlp("select sid from sp_users_logged where sid = '$sid'");
                @data1 = $q->fetchrow_array();
                $q->finish;
                if ( !@data1 ) { undef $fail; }
            }

            sql(
"INSERT INTO sp_users_logged (uid,logtime,lasttime,ip,ip_for,agent,sid)  VALUES
			('$uid', '$datetime', '$datetime', '$ip', '$ip_for', '$agent', '$sid')"
            );
        }
        else {
            my ( $IP, $IP_FOR, $AGENT, $SID ) = sqlf(
                "select
			IP,  IP_FOR,  AGENT,  SID
			from sp_users_logged WHERE uid = $uid"
            );

            my $sid_from_cookie = cookie("sp_sid");

            if (   $SID != $sid_from_cookie
                or $IP     ne $ip
                or $IP_FOR ne $ip_for
                or $AGENT  ne $agent )
            {

                setcookie( 'sp_sid', $SID, '+24h' );

                sql(
                    "update
				sp_users_logged
			set
				IP     = '$ip',
				IP_FOR = '$ip_for',
				AGENT  = '$agent'
			where
				uid = $uid"
                );
            }

            sql(
"update sp_users_logged set lasttime = $datetime where sid = $data[1]"
            );
            redir('main');
        }
        $guid = $uid;
        $ggid = sqlff("select gid from sp_users where uid = $uid");
        log_user_sesion( 1, $sid );
        my $sid_cookie = cookie(
            -name    => 'sp_sid',
            -value   => $sid || $data[0],
            -expires => '+24h'
        );
        exit print redirect (
            -uri    => '?act=main',
            -cookie => $sid_cookie
        );
    }
    else {
        log_user_sesion( 6, $log, $pwd );
        error(
"    .  .<br><br>$login_form"
        );
    }
}
elsif ( param('act') eq 'reg1' ) {
    if ( $gconf{'light'} ) { exit print redirect '/'; }

    Time::HiRes::sleep(0.5) unless ($DEBUG);
    tpl( './tpl/register1.html', { footers => generate_footers() } );
}
elsif ( param('act') eq 'reg2' ) {
    if ( $gconf{'light'} ) { exit print redirect '/'; }

    Time::HiRes::sleep(1) unless ($DEBUG);
    if ( $ENV{'REQUEST_METHOD'} ne 'POST' ) {
        security_alert('  GET  POST');
    }
    my $ser = trim( param('ser') );
    my $num = trim( param('num') );
    if ( $ser eq '' or $num eq '' ) {
        stop("  (  )   .");
    }
    else {
        my $a;
        my $ref = \$a;
        if ( check_ser_num( $ser, $num, $ref, undef ) ) {
            form_register2( $ref, $ser, $num );
        }
        else {
            stop("        .");
        }
    }
}
elsif ( param('act') eq 'reg3' ) {
    if ( $gconf{'light'} ) { exit print redirect '/'; }

    Time::HiRes::sleep(1) unless ($DEBUG);
    if ( $ENV{'REQUEST_METHOD'} ne 'POST' ) {
        security_alert('  GET  POST');
    }
    my $tmp_login = param('log');
    if ( grep /\Q$tmp_login\E/, @modules or $tmp_login eq 'rootforum' ) {
        stop(" .  .");
    }
    unless ( param('log') =~ m/^[0-9a-zA-Z_.\-]+$/ ) {
        stop(   "    .<br>"
              . ": A&ndash;Z a&ndash;z 0&ndash;9 _ . -" );
    }
    my $ser = trim( param('hser') );
    my $num = trim( param('hnum') );
    my $a;
    my $ref = \$a;
    my $b;
    my $ref2   = \$b;
    my $result = 0;

    if ( check_ser_num( $ser, $num, $ref, $ref2 ) ) { $result = 1; }

    if ( param('log') eq '' ) {
        stop("  .");
    }

    my $password2 = param('pas2');
    if ( !( param('pas') =~ m/^$password2$/ ) ) {
        stop(
'      .        .'
        );
    }

    if ( trim( param('pas') ) eq '' ) {
        stop('    .');
    }

    if ( weak_password( param('pas') ) ) {
        stop(   "    . "
              . "        . "
              . "   .   .    ."
        );
    }

    my $result_check = user_check( $ref2, param('log') );
    if ( $result_check == 1 ) {
        log_user_sesion( 9, $ref2 );
        stop("  .");
    }
    if ( $result_check == 2 ) {
        log_user_sesion( 10, $ref2, param('log') );
        stop( param("log")
              . " &ndash;    - .    (      )   .   ."
        );
    }

    if ($result) {
        user_add( $ref2, param("log"), param("pas") );
        log_user_sesion( 11, $ref2, param('log') );
        form_register3( param("log"), param("pas") );
    }
    else {
        stop("   .");
    }
}
elsif ( param('act') eq 'logout' ) {
    my $sid = sid();
    sql("delete from sp_users_logged where sid = '$sid'");

    log_user_sesion( 2, $sid );

    printfile('./tpl/logout.html');
}
elsif ( param('act') eq 'logout2' ) {
    my $sid = sid();

    log_user_sesion( 3, $sid );

    sql("delete from sp_users_logged where sid = '$sid'");

    printfile('./tpl/logout2.html');
}
elsif ( param('act') eq 'logout3' ) {
    my $sid = sid();

    log_user_sesion( 4, $sid );

    sql("delete from sp_users_logged where sid = '$sid'");

    printfile('./tpl/logout2.html');
}

elsif ( param('act') eq 'main_pupil' ) { main_pupil(); }
elsif ( param('act') eq 'score_form_select_class' ) {
    score_form_select_class();
}
elsif ( param('act') eq 'score_list_class' ) { score_list_class(); }
elsif ( param('act') eq 'score_list_class_totals' ) {
    score_list_class_totals();
}
elsif ( param('act') eq 'score_list_pupil_totals' ) {
    score_list_pupil_totals();
}
elsif ( param('act') eq 'score_form_class' )   { score_form_class(); }
elsif ( param('act') eq 'score_class' )        { score_class(); }
elsif ( param('act') eq 'score_all_subjects' ) { score_all_subjects(); }
elsif ( param('act') eq 'score_all_subjects_class' ) {
    score_all_subjects_class();
}
elsif ( param('act') eq 'score_all_subjects_class_form' ) {
    score_all_subjects_class_form();
}
elsif ( param('act') eq 'score_year' ) { score_year(); }
elsif ( param('act') eq 'score_top' )  { score_top(); }

elsif ( param('act') eq 'all_pupils' )  { users_all_pupils(); }
elsif ( param('act') eq 'name_rating' ) { name_rating(); }

elsif ( param('act') eq 'state_date_reset' ) { state_date_reset(); }
elsif ( param('act') eq 'state_date_form' )  { state_date_form(); }
elsif ( param('act') eq 'state_date_set' )   { state_date_set(); }

elsif ( param('act') eq 'report_form' )          { report_form(); }
elsif ( param('act') eq 'report' )               { report(); }
elsif ( param('act') eq 'report_form_parallel' ) { report_parallel_form(); }
elsif ( param('act') eq 'report_parallel' )      { report_parallel(); }
elsif ( param('act') eq 'report_form_links' )    { report_links_form(); }
elsif ( param('act') eq 'report_links' )         { report_links(); }
elsif ( param('act') eq 'report_form_school' )   { report_school_form(); }
elsif ( param('act') eq 'report_school' )        { report_school(); }
elsif ( param('act') eq 'report_form_teacher' )  { report_teacher_form(); }
elsif ( param('act') eq 'report_teacher' )       { report_teacher(); }
elsif ( param('act') eq 'report_form_totals' )   { report_totals_form(); }
elsif ( param('act') eq 'report_totals' )        { report_totals(); }
elsif ( param('act') eq 'report_form_progress_movement' ) {
    report_progress_movement_form();
}
elsif ( param('act') eq 'report_progress_movement' ) {
    report_progress_movement();
}

elsif ( param('act') eq 'report_form_multiclass' ) { report_form_multiclass(); }
elsif ( param('act') eq 'report_knowledge_area_form' ) {
    report_knowledge_area_form();
}
elsif ( param('act') eq 'report_knowledge_area' ) { report_knowledge_area(); }

elsif ( param('act') eq 'users_teachers' )         { users_teachers(); }
elsif ( param('act') eq 'teacher_placement' )      { teacher_placement(); }
elsif ( param('act') eq 'teacher_place' )          { teacher_place(); }
elsif ( param('act') eq 'teacher_placement_stop' ) { teacher_placement_stop(); }
elsif ( param('act') eq 'teacher_form_master' )    { teacher_form_master(); }
elsif ( param('act') eq 'teacher_form_master_place' ) {
    teacher_form_master_place();
}
elsif ( param('act') eq 'teacher_form_master_stop' ) {
    teacher_form_master_stop();
}
elsif ( param('act') eq 'teacher_switch_binding' ) { teacher_switch_binding(); }
elsif ( param('act') eq 'teacher_list_bindings' )  { teacher_list_bindings(); }
elsif ( param('act') eq 'teacher_subjects' )       { teacher_subjects(); }
elsif ( param('act') eq 'aj_subgrp' )              { aj_subgrp(); }
elsif ( param('act') eq 'subgroups' )              { subgroups(); }
elsif ( param('act') eq 'subgrp_list' )            { subgrp_list(); }
elsif ( param('act') eq 'subgrp_kill_all' )        { subgrp_kill_all(); }
elsif ( param('act') eq 'gen_list_form' )          { gen_list_form(); }
elsif ( param('act') eq 'gen_list' )               { gen_list(); }
elsif ( param('act') eq 'pupil_info' )             { pupil_info(); }

elsif ( param('act') eq 'req_view' )             { req_view(); }
elsif ( param('act') eq 'req_edit' )             { req_edit(); }
elsif ( param('act') eq 'set_default_sou_form' ) { set_default_sou_form(); }
elsif ( param('act') eq 'set_default_sou' )      { set_default_sou(); }

elsif ( param('act') eq 'logged' )                { users_logged(); }
elsif ( param('act') eq 'registered' )            { users_registered(); }
elsif ( param('act') eq 'set_password' )          { set_password(); }
elsif ( param('act') eq 'session_kill' )          { session_kill(); }
elsif ( param('act') eq 'user_delete' )           { user_delete(); }
elsif ( param('act') eq 'clear_logged' )          { users_clear_logged(); }
elsif ( param('act') eq 'aj_acl_switch' )         { aj_acl_switch(); }
elsif ( param('act') eq 'register_sp_teachers' )  { register_sp_teachers(); }
elsif ( param('act') eq 'register_teacher_form' ) { register_teacher_form(); }
elsif ( param('act') eq 'register_teacher' )      { register_teacher(); }
elsif ( param('act') eq 'SQL' )                   { sql_execute_form(); }
elsif ( param('act') eq 'sql_execute' )           { sql_execute(); }
elsif ( param('act') eq 'change_and_print_class_passwords' ) {
    change_and_print_class_passwords();
}
elsif ( param('act') eq 'medallist_editor' )   { medallist_editor(); }
elsif ( param('act') eq 'pupil_import_csv' )   { pupil_import_csv(); }
elsif ( param('act') eq 'teacher_import_csv' ) { teacher_import_csv(); }

elsif ( param('act') eq 'setup_periods' )        { setup_periods(); }
elsif ( param('act') eq 'setup_periods_modify' ) { setup_periods_modify(); }
elsif ( param('act') eq 'class_links_list' )     { class_links_list(); }
elsif ( param('act') eq 'class_links_setup' )    { class_links_setup(); }

elsif ( param('act') eq 'internet_access_control' ) {
    internet_access_control();
}

elsif ( param('act') eq 'aj_login_free' ) {
    if ( $gconf{'light'} ) { exit print redirect '/'; }
    aj_login_free();
}
elsif ( param('act') eq 'session_keep_alive' ) {
    session_keep_alive();
    http_headers();
    exit;
}
elsif ( param('act') eq 'aj_autocomplete' ) { aj_autocomplete(); }

elsif ( param('act') eq 'change_password' ) { change_password(); }
elsif ( param('act') eq 'change_teachers_passwords' ) {
    change_teachers_passwords();
}

elsif ( param('act') eq 'logs' ) { logs(); }

elsif ( param('act') eq 'test' )        { test_desktop(); }
elsif ( param('act') eq 'maketest' )    { test_maketest_desktop(); }
elsif ( param('act') eq 'test_report' ) { test_report_desktop(); }
elsif ( param("act") eq 'test_export' ) { test_export(); }

elsif ( param('act') eq 'wizard_new_year' ) { check_new_year(); }

elsif ( param('act') eq 'score_form' )           { score_form(); }
elsif ( param('act') eq 'score' )                { score(); }
elsif ( param('act') eq 'ktp_list_all' )         { ktp_list_all(); }
elsif ( param('act') eq 'ktp_form_create' )      { ktp_form_create(); }
elsif ( param('act') eq 'ktp_form_add' )         { ktp_form_add(); }
elsif ( param('act') eq 'ktp_create' )           { ktp_create(); }
elsif ( param('act') eq 'ktp_view' )             { ktp_view(); }
elsif ( param('act') eq 'ktp_add' )              { ktp_add(); }
elsif ( param('act') eq 'ktp_form_modify' )      { ktp_form_modify(); }
elsif ( param('act') eq 'ktp_modify' )           { ktp_modify(); }
elsif ( param('act') eq 'ktp_section_list_all' ) { ktp_section_list_all(); }
elsif ( param('act') eq 'ktp_section_add' )      { ktp_section_add(); }
elsif ( param('act') eq 'ktp_section_delete' )   { ktp_section_delete(); }
elsif ( param('act') eq 'ktp_form_section_modify' ) {
    ktp_form_section_modify();
}
elsif ( param('act') eq 'ktp_section_modify' ) { ktp_section_modify(); }

elsif ( param('act') eq 'sms_setup_recipient' ) { sms_setup_recipient(); }
elsif ( param('act') eq 'sms_setup' )           { sms_setup(); }
elsif ( param('act') eq 'lesson_abbr' )         { lesson_abbr(); }
elsif ( param('act') eq 'sms_dump_pool' )       { sms_dump_pool(); }
elsif ( param('act') eq 'sms_edit_numbers' )    { sms_edit_numbers(); }
elsif ( param('act') eq 'sms_empty_pool' )      { sms_empty_pool(); }
elsif ( param('act') eq 'sms_send' )            { sms_send(); }
elsif ( param('act') eq 'aj_sms_send' )         { aj_sms_send(); }
elsif ( param('act') eq 'sms_select_scores_by_date_and_recipients_form' ) {
    sms_select_scores_by_date_and_recipients_form();
}
elsif ( param('act') eq 'sms_select_scores_by_date_and_recipients_preview' ) {
    sms_select_scores_by_date_and_recipients_preview();
}
elsif ( param('act') eq 'sms_group' ) { sms_group(); }
elsif ( param('act') eq 'sms_print_class_numbers' ) {
    sms_print_class_numbers();
}

elsif ( param('act') eq 'payfood_error_pay' ) { payfood_error_pay(); }
elsif ( param('act') eq 'kill_speedy' )       { kill_speedy(); }

elsif ( param('act') eq 'su' )        { su(); }
elsif ( param('act') eq 'su_logout' ) { su_logout(); }

else {
    print_main();
}

security_alert('    500');

sub form_login() {
    my %replace = ( footers => generate_footers() );
    tpl( "./tpl/login.html", \%replace );
}
