/*  */
CREATE TABLE sp_users (
uid             INTEGER NOT NULL,
gid             INTEGER NOT NULL,
log             VARCHAR(64) NOT NULL,
pas             VARCHAR(64) NOT NULL,
state_date      INTEGER
);

/*    */
CREATE TABLE sp_users_acl (
uid             INTEGER NOT NULL,
gid             INTEGER NOT NULL
);

/*   */
CREATE TABLE sp_users_logged (
uid             INTEGER NOT NULL,
logtime         INTEGER NOT NULL,
lasttime        INTEGER NOT NULL,
ip              VARCHAR(15) NOT NULL,
ip_for          VARCHAR(40),
agent           VARCHAR(128),
sid             INTEGER NOT NULL,
menu            VARCHAR(64) NOT NULL
);

/*    */
CREATE TABLE SP_GID_REF (
    GID   INTEGER NOT NULL,
    NAME  VARCHAR(32) NOT NULL);

COMMIT;

ALTER TABLE SP_GID_REF ADD CONSTRAINT PK_SP_GID_REF PRIMARY KEY (GID);

COMMIT;

INSERT INTO SP_GID_REF (GID,NAME) VALUES (0,'');
INSERT INTO SP_GID_REF (GID,NAME) VALUES (1,' ');
INSERT INTO SP_GID_REF (GID,NAME) VALUES (2,'');
INSERT INTO SP_GID_REF (GID,NAME) VALUES (3,'');
INSERT INTO SP_GID_REF (GID,NAME) VALUES (4,'');
INSERT INTO SP_GID_REF (GID,NAME) VALUES (5,' ');
INSERT INTO SP_GID_REF (GID,NAME) VALUES (6,'Web-');

COMMIT;

INSERT INTO HUMAN_CLASS_REF (CLASS_ID,NAME) VALUES (10,'');

COMMIT;

/*    */
create table sp_ktp_ref (
ktp_id       INTEGER,
name         VARCHAR(128),      /*  */
subj         INTEGER NOT NULL,  /*      */
time_start   INTEGER NOT NULL,  /*     */
time_end     INTEGER NOT NULL   /*   ~ */
);

/*   */
create table sp_ktp (
ktp_id   INTEGER NOT NULL, /*  id       */
id       INTEGER NOT NULL PRIMARY KEY, /*     */
section  INTEGER NOT NULL, /*        */
theme    VARCHAR(254),     /*          */
theor    INTEGER,          /*       */
pract    INTEGER           /*     */
);

COMMIT;

create generator gen_ktpid;

COMMIT;

SET TERM ^ ;
CREATE TRIGGER trigger_sp_ktp_id FOR sp_ktp
ACTIVE BEFORE INSERT AS
BEGIN
NEW.id = GEN_ID(gen_ktpid, 1);
END;
^
SET TERM ; ^

COMMIT;

create table sp_ktp_section_ref (
id       INTEGER NOT NULL PRIMARY KEY,
ktp      INTEGER NOT NULL,
name     VARCHAR(128) /*        */
);

COMMIT;

create generator gen_ktp_section_ref_id;

COMMIT;

SET TERM ^ ;
CREATE TRIGGER trigger_sp_ktp_section_id FOR sp_ktp_section_ref
ACTIVE BEFORE INSERT AS
BEGIN
NEW.id = GEN_ID(gen_ktp_section_ref_id, 1);
END;
^
SET TERM ; ^

COMMIT;

/*  */
CREATE TABLE sp_scores (
uid         INTEGER NOT NULL,  /*  */
prep_id     INTEGER NOT NULL,  /*    */
score       SMALLINT,          /* -1 = , -2 =  */
score_src   SMALLINT,          /*   ,    */
subj        INTEGER NOT NULL,  /*  */
worktype    SMALLINT,          /*   */
scoretime   INTEGER NOT NULL,  /* unixtime   */
absence     SMALLINT,          /* TODO ,   ? */
comment     VARCHAR(256)       /*  */
);

/*     */
create table sp_req (
y smallint,
c smallint,
s smallint,
f smallint,
g integer
);

CREATE INDEX IDX_SP_SCORES ON SP_SCORES(SUBJ,SCORETIME);
CREATE INDEX IDX_SP_REQ ON SP_REQ(C);

COMMIT;

/*   */
CREATE TABLE sp_scores_totals (
uid             INTEGER NOT NULL,    /* uid  */
prep_id         INTEGER NOT NULL,    /* uid   */
scoreyear       smallint NOT NULL,   /*   */
subj            smallint NOT NULL,   /*  */
y               smallint,            /*    */
t1              smallint,            /*   1  */
t2              smallint,            /*   2  */
t3              smallint,            /*   3  */
q1              smallint,            /*   1  */
q2              smallint,            /*   2  */
q3              smallint,            /*   3  */
q4              smallint,            /*   4  */
e               smallint,            /*    */
t               smallint             /*   */
);

COMMIT;

CREATE INDEX IDX_SP_SCORES_TOTALS ON SP_SCORES_TOTALS (UID,SCOREYEAR);

COMMIT;

/*  ,        
   id : 0 = 
                1 = 1   5 = 1 
                2 = 2   6 = 2 
                3 = 3   7 = 3 
                4 = 4 
                8 = 
                9 = 
                10 = 1 
                11 = 2 
*/
create table sp_marks (
UID INTEGER,  /*  */
P   SMALLINT, /* : .   id  */
S   SMALLINT, /*  */
T   SMALLINT, /* :    1 =  , 2 = , 3 = (?) */
Y   SMALLINT  /*  */
);

COMMIT;

/*   =  */
create table sp_ktp_class (
ktp_id    INTEGER NOT NULL,
class_id  INTEGER NOT NULL
);

COMMIT;

/* */
CREATE TABLE sp_pupil_absent (
  UID        INTEGER NOT NULL,
  ABSTIME    INTEGER NOT NULL,
  ABSID      INTEGER NOT NULL,
  ABSCOMMENT VARCHAR(255)
);

/* */
create table SP_ABSENCE_REF
(
  id      INTEGER NOT NULL,  /* id */
  name    VARCHAR(64)        /*   */
);

/* todo      */
/*    */
create table sp_absence (
id      INTEGER NOT NULL,  /* id */
a_type  INTEGER NOT NULL,  /* : 0 =  1 =  2 =  */
name    VARCHAR(128)       /*   */
);

INSERT INTO SP_ABSENCE (ID,A_TYPE,NAME) VALUES (0,0,'');
INSERT INTO SP_ABSENCE (ID,A_TYPE,NAME) VALUES (1,1,'');
INSERT INTO SP_ABSENCE (ID,A_TYPE,NAME) VALUES (2,0,'');
INSERT INTO SP_ABSENCE (ID,A_TYPE,NAME) VALUES (3,0,'');
INSERT INTO SP_ABSENCE (ID,A_TYPE,NAME) VALUES (4,0,'');
INSERT INTO SP_ABSENCE (ID,A_TYPE,NAME) VALUES (5,1,'');
INSERT INTO SP_ABSENCE (ID,A_TYPE,NAME) VALUES (6,2,'');

/* /todo */

COMMIT;

/*   ( ) */
create table sp_worktype (
id    INTEGER NOT NULL,  /* id */
name  VARCHAR(128)       /*   */
);

COMMIT;

INSERT INTO SP_WORKTYPE (ID,NAME) VALUES ( 0,'  ');
INSERT INTO SP_WORKTYPE (ID,NAME) VALUES ( 1,' ');
INSERT INTO SP_WORKTYPE (ID,NAME) VALUES ( 2,'');
INSERT INTO SP_WORKTYPE (ID,NAME) VALUES ( 3,'');
INSERT INTO SP_WORKTYPE (ID,NAME) VALUES ( 4,'');
INSERT INTO SP_WORKTYPE (ID,NAME) VALUES ( 5,'');
INSERT INTO SP_WORKTYPE (ID,NAME) VALUES ( 6,'');
INSERT INTO SP_WORKTYPE (ID,NAME) VALUES ( 7,'');
INSERT INTO SP_WORKTYPE (ID,NAME) VALUES ( 8,'');
INSERT INTO SP_WORKTYPE (ID,NAME) VALUES ( 9,'');
INSERT INTO SP_WORKTYPE (ID,NAME) VALUES (10,'');
INSERT INTO SP_WORKTYPE (ID,NAME) VALUES (11,'   ');

COMMIT;

/*



   
       

create table sp_class_links (
id         INTEGER NOT NULL,
class_id   INTEGER NOT NULL
);

COMMIT;

*/

/*  */ 
create table sp_periods (
link       INTEGER NOT NULL, /*   = ,, */
id         INTEGER NOT NULL, /*     = ,, */
time_start INTEGER NOT NULL, /*  =   */
time_end   INTEGER NOT NULL  /*   =   */
);

/*  id = 0 == 
    id = 1 == 1 id = 2 == 2 id = 3 == 3 id = 4 == 4 
    id = 5 == 1 id = 6 == 2 id = 7 == 3    */

/*  */
INSERT INTO SP_PERIODS (link,id,TIME_START,TIME_END) VALUES (0,0,1125514800,1156964400);
INSERT INTO SP_PERIODS (link,id,TIME_START,TIME_END) VALUES (1,0,1125514800,1156964400);
INSERT INTO SP_PERIODS (link,id,TIME_START,TIME_END) VALUES (2,0,1125514800,1156964400);
/* 1,2,3      */
INSERT INTO SP_PERIODS (link,id,TIME_START,TIME_END) VALUES (0,1,1125514800,1131566400);
INSERT INTO SP_PERIODS (link,id,TIME_START,TIME_END) VALUES (1,1,1125514800,1131566400);
INSERT INTO SP_PERIODS (link,id,TIME_START,TIME_END) VALUES (2,1,1125514800,1131566400);
INSERT INTO SP_PERIODS (link,id,TIME_START,TIME_END) VALUES (0,2,1131652800,1137009600);
INSERT INTO SP_PERIODS (link,id,TIME_START,TIME_END) VALUES (1,2,1131652800,1137009600);
INSERT INTO SP_PERIODS (link,id,TIME_START,TIME_END) VALUES (2,2,1131652800,1137009600);
INSERT INTO SP_PERIODS (link,id,TIME_START,TIME_END) VALUES (0,3,1137096000,1143745200);
INSERT INTO SP_PERIODS (link,id,TIME_START,TIME_END) VALUES (1,3,1137096000,1143745200);
INSERT INTO SP_PERIODS (link,id,TIME_START,TIME_END) VALUES (2,3,1137096000,1143745200);
INSERT INTO SP_PERIODS (link,id,TIME_START,TIME_END) VALUES (0,4,1143831600,1149015600);
INSERT INTO SP_PERIODS (link,id,TIME_START,TIME_END) VALUES (1,4,1143831600,1149015600);
INSERT INTO SP_PERIODS (link,id,TIME_START,TIME_END) VALUES (2,4,1143831600,1149015600);
/*       */
INSERT INTO SP_PERIODS (link,id,TIME_START,TIME_END) VALUES (0,5,1125514800,1133294400);
INSERT INTO SP_PERIODS (link,id,TIME_START,TIME_END) VALUES (1,5,1125514800,1133294400);
INSERT INTO SP_PERIODS (link,id,TIME_START,TIME_END) VALUES (2,5,1125514800,1133294400);
INSERT INTO SP_PERIODS (link,id,TIME_START,TIME_END) VALUES (0,6,1133380800,1141070400);
INSERT INTO SP_PERIODS (link,id,TIME_START,TIME_END) VALUES (1,6,1133380800,1141070400);
INSERT INTO SP_PERIODS (link,id,TIME_START,TIME_END) VALUES (2,6,1133380800,1141070400);
INSERT INTO SP_PERIODS (link,id,TIME_START,TIME_END) VALUES (0,7,1141156800,1149015600);
INSERT INTO SP_PERIODS (link,id,TIME_START,TIME_END) VALUES (1,7,1141156800,1149015600);
INSERT INTO SP_PERIODS (link,id,TIME_START,TIME_END) VALUES (2,7,1141156800,1149015600);

COMMIT;

/*  -   */
create table sp_class_subgrp_ref (
    id    integer not null,    /* id   */
    c     smallint not null,   /* id  */
    s     smallint,            /*  */
    name  varchar(64) not null /*   */
);
/*  -  */
create table sp_class_subgrp (
    id   integer not null, /* id    */
    uid  integer not null  /* uid  */
);
COMMIT;

CREATE GENERATOR GEN_SP_CLASS_SUBGRP_REF_ID;
COMMIT;
SET GENERATOR GEN_SP_CLASS_SUBGRP_REF_ID TO 0;
COMMIT;

SET TERM ^ ;
CREATE TRIGGER SP_CLASS_SUBGRP_REF_BI FOR SP_CLASS_SUBGRP_REF
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(GEN_SP_CLASS_SUBGRP_REF_ID,1);
END;
^
SET TERM ; ^

COMMIT;

create table sp_settings (
name    VARCHAR(64),  /*  */
f_int   INTEGER,      /*   */
f_float FLOAT,        /*   */
f_char  VARCHAR(254)  /*   */
);

/*     */
/* =============================== */
/*   */
INSERT INTO SP_SETTINGS (NAME,F_INT) VALUES ('score_min',1 );
/*   */
INSERT INTO SP_SETTINGS (NAME,F_INT) VALUES ('score_max',5);
/*    ( ) */
INSERT INTO SP_SETTINGS (NAME,F_INT) VALUES ('session_idle_max',900);
/*    */
INSERT INTO SP_SETTINGS (NAME,F_CHAR) VALUES ('title',' 0');
/*    - */
INSERT INTO SP_SETTINGS (NAME,F_CHAR) VALUES ('serv_name','www.your_edu_org.ru');
/*   CSS */
INSERT INTO SP_SETTINGS (NAME,F_CHAR) VALUES ('style','/style.css');
/*      */
INSERT INTO SP_SETTINGS (NAME,F_INT) VALUES ('year_start',1125514800);
INSERT INTO SP_SETTINGS (NAME,F_INT) VALUES ('year_end',  1156964400);
/*  : 1 = , 0 =  */
INSERT INTO SP_SETTINGS (NAME,F_INT) VALUES ('periods_mode', 0);
/*    */
insert into sp_settings (name,f_int) values ('default_sou', 3);
/*   */
insert into sp_settings (name,f_char) values ('class_links', '1,4,5,9,10,11');

/* === SP 2.0 === */

/*  */
INSERT INTO SYS_MODEL_REF (MODEL_ID, NAME)  VALUES (4,  '. ');

/*    */
INSERT INTO SYS_VIEW_CLASS (CLASS_ID, NAME) VALUES (9001, '');
INSERT INTO SYS_VIEW_CLASS (CLASS_ID, NAME) VALUES (9002, ' ');
INSERT INTO SYS_VIEW_CLASS (CLASS_ID, NAME) VALUES (9003, ' ');

/*    (  ) */
INSERT INTO SYS_UNIT_REF (UNIT_ID, NAME) VALUES ('', '');
INSERT INTO SYS_UNIT_REF (UNIT_ID, NAME) VALUES ('', ' ');

/*      */
INSERT INTO SYS_VIEW (MODEL_ID, VIEW_CLASS) VALUES (4, 9001 );
INSERT INTO SYS_VIEW (MODEL_ID, VIEW_CLASS) VALUES (4, 9002 );
INSERT INTO SYS_VIEW (MODEL_ID, VIEW_CLASS) VALUES (4, 9003 );

/*  - 3D: 
                  
                   */
INSERT INTO SYS_VIEW_CLASS_TREE (CLASS_ID, DESCRIPTOR_ID, PARENT_DESCRIPTOR) VALUES (9001, 6, NULL);
INSERT INTO SYS_VIEW_CLASS_TREE (CLASS_ID, DESCRIPTOR_ID, PARENT_DESCRIPTOR) VALUES (9001, 2, 6);
INSERT INTO SYS_VIEW_CLASS_TREE (CLASS_ID, DESCRIPTOR_ID, PARENT_DESCRIPTOR) VALUES (9001, 5, 2);

/* .  - 1D:  */
INSERT INTO SYS_VIEW_CLASS_TREE (CLASS_ID, DESCRIPTOR_ID, PARENT_DESCRIPTOR) VALUES (9002, 6, NULL);

/*   - 2D: 
                               */
INSERT INTO SYS_VIEW_CLASS_TREE (CLASS_ID, DESCRIPTOR_ID, PARENT_DESCRIPTOR) VALUES (9003, 6, NULL);
INSERT INTO SYS_VIEW_CLASS_TREE (CLASS_ID, DESCRIPTOR_ID, PARENT_DESCRIPTOR) VALUES (9003, 2, 6);

/*   */
INSERT INTO SYS_DOC_CLASS_REF (DOC_CLASS_ID, NAME)       VALUES (20, ' ');
INSERT INTO SYS_DOC_CLASS_REF (DOC_CLASS_ID, NAME)       VALUES (21, ' ');
INSERT INTO SYS_DOC_NUMBER    (DOC_CLASS,    NEXT_VALUE) VALUES (20, 0);
INSERT INTO SYS_DOC_NUMBER    (DOC_CLASS,    NEXT_VALUE) VALUES (21, 0);

COMMIT;

/*
DEBET_NODE  => node_id  
CREDIT_NODE => node_id 
OPER_ID     => 4 ( - DOC_OPER_REF)
DOC_CLASS   => 20 ( ) SYS_DOC_CLASS_REF
DOC         =>  SYS_DOC_NUMBER
ADD_ATTR    =>     ,
                     

$doc_number = select NEXT_VALUE from GET_NEXT_DOC_NO(20)

INSERT INTO SYS_ENTRY ( ENTRY_DATE,  DEBET_NODE, CREDIT_NODE, UNIT,  UNIT_VALUE, DOC_CLASS, DOC,          OPER_ID, ADD_ATTR )
               VALUES ( '1.11.2006', 19634,      19633,       '',  1,          20,        $doc_number,  4,       NULL )
*/

/*--------------------------------
,     ,
..      (  =  )
        .
:  - 
           -  
           -  -...
          (   (  )     .)
 ,  GET_NODE_SALDO
    :  -  
.. GET_NODE_SALDO_BY_UNIT(, , '')
 ,  - ,   ,  ,
         
(         )
--------------------------------*/

SET TERM ^ ;
CREATE PROCEDURE GET_NODE_SALDO_BY_UNIT (
    node_id INTEGER,
    on_date TIMESTAMP, /*  DATE */
    unit_id VARCHAR(5),
    side INTEGER)
RETURNS (
    saldo_sum NUMERIC(15,4))
AS
DECLARE VARIABLE debet_sum  NUMERIC(15,4);
DECLARE VARIABLE credit_sum NUMERIC(15,4);
BEGIN
  select sum(debet_trn), sum(credit_trn) from sys_turnover where node_id = :node_id and entry_date <= :on_date and unit = :unit_id
  into :debet_sum, :credit_sum;

  IF (DEBET_SUM IS NULL) THEN DEBET_SUM = 0;
  IF (CREDIT_SUM IS NULL) THEN CREDIT_SUM = 0;
  IF (SIDE = 0) THEN
     SALDO_SUM = DEBET_SUM - CREDIT_SUM;
  ELSE
     SALDO_SUM = CREDIT_SUM - DEBET_SUM;
  SUSPEND;
END;
^
SET TERM ; ^

/*
     
  id=0:  ,  F_INT=1 -                 ->   
  id=1:   (ajax), F_INT=n,  n    ->  
*/
CREATE TABLE SP_USER_SETTINGS (
    UID    INTEGER NOT NULL,
    ID     INTEGER,
    F_INT  INTEGER
);

COMMIT;

CREATE INDEX SP_USER_SETTINGS_IDX1 ON SP_USER_SETTINGS (UID);

COMMIT;

/*
 SUBGRP  sys_matrix     
  (VIEW_CLASS = 9)
*/
ALTER TABLE SYS_MATRIX ADD SUBGRP VARCHAR(10)
CHARACTER SET WIN1251 COLLATE PXW_CYRL;

COMMIT;

CREATE INDEX IDX_SYS_MATRIX_SUBGRP ON SYS_MATRIX (SUBGRP);

/* sp-2.1 */

CREATE INDEX IDX_SP_SCORES_UID ON SP_SCORES (UID);

INSERT INTO SP_SETTINGS (NAME, F_CHAR)
VALUES ('half_year',         '10,11');

INSERT INTO SP_SETTINGS (NAME, F_CHAR)
VALUES ('half_year_periods', '1157050800,1167508800,1167595200,1180551600');

INSERT INTO SP_SETTINGS (NAME, F_INT)
VALUES ('enable_half_year', 0 );

ALTER TABLE SP_SCORES_TOTALS ADD H1 SMALLINT;
ALTER TABLE SP_SCORES_TOTALS ADD H2 SMALLINT;

/* sp-2.1.5 */

ALTER TABLE SP_SCORES_TOTALS ADD E1 SMALLINT;

/*  2.2.0   */
/*  2.2.1   */

/*--------------------------------*/

/* sp-2.5 */

/*
   -1  -1       
          -1  - system
    -1  -   
*/

INSERT INTO SP_SETTINGS (NAME, F_INT) VALUES ('last_auto_check', 0 );

/* sp-2.5.5 */

CREATE INDEX SP_USERS_IDX1 ON SP_USERS (UID);

/*  2.6.0   */
/*  2.7.0   */
/*  2.8.0   */
/*  2.9.0   */

/*  3.0 */
CREATE INDEX IDX_SP_SCORES_UT ON SP_SCORES (UID, SCORETIME);
drop table SP_PUPIL_ABSENT;
drop table SP_ABSENCE_REF;
drop table SP_ABSENCE;

/*  3.1 */
CREATE UNIQUE INDEX IDX_SP_USERS_LOGGED ON SP_USERS_LOGGED(SID);
ALTER TABLE SP_USERS_LOGGED DROP MENU;

/*  3.2 */
ALTER TABLE SP_USER_SETTINGS ALTER COLUMN F_INT TYPE VARCHAR(512);

/*  4.0 SMS */
CREATE TABLE SMS_RECIPIENT (   /*  .     */
    UID           INTEGER,     /* 101910235 */
    HUMAN_TYPE    SMALLINT,    /* 0,1,2 = ,, */
    PHONE_NUMBER  VARCHAR(13)  /* '+79275555553' */
);

CREATE TABLE SMS_ACL_REF (     /*  */
    ID   SMALLINT,             /*   */
    NAME VARCHAR(128)          /*   */
);

INSERT INTO SMS_ACL_REF (ID, NAME) VALUES
(0, '   ');

CREATE TABLE SMS_ACL (         /*    ?   - ,  -  */
    ACL_ID     SMALLINT,       /*   */
    HUMAN_TYPE SMALLINT        /*  ?
                                      
                                    SMS_RECIPIENT.HUMAN_TYPE */
);

ALTER TABLE LESSON ADD NAME_ABBR VARCHAR(10);

CREATE TABLE sms_pool (
    id            INTEGER,          /*    */
	sid			  INTEGER NOT NULL, /* 54444687 */
    phone_number  VARCHAR(13),      /* '+79275555553' */
    text          VARCHAR(100)      /* '5 : .: 5' */
);

CREATE generator GEN_SMS_POOL_ID;

SET TERM ^ ;
CREATE TRIGGER SMS_POOL_BI FOR SMS_POOL
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(GEN_SMS_POOL_ID,1);
END;
^
SET TERM ; ^

/* 4.1 */

update RDB$RELATIONS
set RDB$DESCRIPTION = '4.1'
where RDB$RELATION_NAME = 'SP_SETTINGS';

/* SMS- */
CREATE TABLE SMS_GROUP (
    ID INTEGER NOT NULL,
    NAME VARCHAR(128)
);

/*  SMS- */
CREATE TABLE SMS_GROUP_MEMBERS (
    ID INTEGER NOT NULL,
    GID INTEGER NOT NULL,
    UID INTEGER NOT NULL
);

alter table SMS_GROUP         add constraint PK_SMS_GROUP         primary key (ID);
alter table SMS_GROUP_MEMBERS add constraint PK_SMS_GROUP_MEMBERS primary key (ID);

CREATE generator GEN_SMS_GROUP_ID;
CREATE generator GEN_SMS_GROUP_MEMBERS_ID;

SET TERM ^ ;
CREATE TRIGGER sms_group_bi FOR sms_group
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.id IS NULL) THEN
    NEW.id = GEN_ID(gen_sms_group_id,1);
END;
^
SET TERM ; ^

SET TERM ^ ;
CREATE TRIGGER sms_group_members_bi FOR sms_group_members
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.id IS NULL) THEN
    NEW.id = GEN_ID(gen_sms_group_members_id,1);
END;
^
SET TERM ; ^
