#!/usr/bin/perl

#####
#  FCKeditor - The text editor for Internet - http://www.fckeditor.net
#
#  == BEGIN LICENSE ==
#
#  Licensed under the terms of any of the following licenses at your
#  choice:
#
#   - GNU General Public License Version 2 or later (the "GPL")
#     http://www.gnu.org/licenses/gpl.html
#
#   - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
#     http://www.gnu.org/licenses/lgpl.html
#
#   - Mozilla Public License Version 1.1 or later (the "MPL")
#     http://www.mozilla.org/MPL/MPL-1.1.html
#
#  == END LICENSE ==
#
#  This is the File Manager Connector for Perl.
#####

##
# ATTENTION: To enable this connector, look for the "SECURITY" comment in this file.
##

## START: Hack for Windows (Not important to understand the editor code... Perl specific).
if(Windows_check()) {
	chdir(GetScriptPath($0));
}

sub Windows_check
{
	# IIS,PWS(NT/95)
	$www_server_os = $^O;
	# Win98 & NT(SP4)
	if($www_server_os eq "") { $www_server_os= $ENV{'OS'}; }
	# AnHTTPd/Omni/IIS
	if($ENV{'SERVER_SOFTWARE'} =~ /AnWeb|Omni|IIS\//i) { $www_server_os= 'win'; }
	# Win Apache
	if($ENV{'WINDIR'} ne "") { $www_server_os= 'win'; }
	if($www_server_os=~ /win/i) { return(1); }
	return(0);
}

sub GetScriptPath {
	local($path) = @_;
	if($path =~ /[\:\/\\]/) { $path =~ s/(.*?)[\/\\][^\/\\]+$/$1/; } else { $path = '.'; }
	$path;
}
## END: Hack for IIS

require 'util.pl';
require 'io.pl';
require 'basexml.pl';
require 'commands.pl';
require 'upload_fck.pl';

# ============================
# <SP>
# ============================

use CGI::Carp qw/fatalsToBrowser name=FCK/;

require "/var/www/cgi-bin/sp/common.pl";
require "/var/www/cgi-bin/sp/misc.pl";

#  
our (%SQLH, %ACL, %gconf, $gdsn, $gdb, $gdbcms, $gdate, $guid, $ggid, $state_date, $connected, @months3);

# %gconf = read_config('/var/www/cgi-bin/sp/sp.conf');
%gconf = read_config('../../../../../../../cgi-bin/sp/sp.conf');

OnStart(); #    :   , , etc

# ,    
unless ( $ENV{HTTP_COOKIE} =~ m/sp_sid/ )
{
	#die "no cookie sp_sid";
	#exit print '<Error number="911" originalDescription="" />';
	SendError(10001, "no cookie sp_sid");
}

#  
if ( $ENV{HTTP_COOKIE} =~ m/sp_sid=(\d+)/ )
{
	$sid = $1;
	#die "coolie sp_sid <= 0" if $sid <= 0;
	SendError(10002, "coolie sp_sid <= 0") if $sid <= 0;
}
else
{
	SendError(10003, "cookie sp_sid: regex mismatch");
	#die "cookie sp_sid: regex mismatch";
}

my @logged_info = sqlf("select lasttime, ip, ip_for, agent from sp_users_logged where sid = $sid");

my $guid = sqlff("select uid from sp_users_logged where sid = $sid");
sqlh ( \%ACL, "select gid,1 from sp_users_acl where sp_users_acl.uid = $guid" );

  if (!@logged_info) { 	SendError(10004, "not logged 1"); }

  my $ip     = $ENV{'REMOTE_ADDR'};
  my $ip_for = $ENV{'HTTP_X_FORWARDED_FOR'} || '';
  my $agent  = substr($ENV{'HTTP_USER_AGENT'},0,127);
  my $now    = timelocal(localtime);

  #  IP   
  if (    $logged_info[1] ne $ip
       or $logged_info[2] ne $ip_for
       or $logged_info[3] ne $agent
     )
    {
		SendError(10005, "not logged 2");
    }

  #     
  if ( $now - $logged_info[0] > $gconf{'session_idle_max'} ) { SendError(10006, "not logged 3"); }

#  
my $now = timelocal(localtime);
my $r = $gdb->do("update sp_users_logged set LASTTIME = $now where sid = $sid");
#    !
unless ( $r == -1 )
{
  my $retry_count = 0;
  while ( 1 )
  {
    $retry_count++;
    last if $retry_count > 10;
    last if -1 == $gdb->do("update sp_users_logged set LASTTIME = $now where sid = $sid");
    Time::HiRes::sleep(0.05);
  }
}

# ============================
# </SP>
# ============================

##
# SECURITY: REMOVE/COMMENT THE FOLLOWING LINE TO ENABLE THIS CONNECTOR.
##
# 	&SendError( 1, 'This connector is disabled. Please check the "editor/filemanager/connectors/perl/connector.cgi" file' ) ;

	&read_input();

# ============================
# <SP>
# ============================

#  web-  
if ( $ACL{'6'} )
{
  $GLOBALS{'UserFilesPath'} = '/sp/pic/';
}
#        
#  uid
else
{
  $GLOBALS{'UserFilesPath'} = "/sp/cms/themes/Users_Themes/$guid/pic/";
}

# ============================
# </SP>
# ============================

	# Map the "UserFiles" path to a local directory.
	$rootpath = &GetRootPath();
	$GLOBALS{'UserFilesDirectory'} = $rootpath . $GLOBALS{'UserFilesPath'};
# ============================
# <SP>
# ============================
  unless ( -e $GLOBALS{'UserFilesDirectory'} )
  {
    system 'mkdir', '-p', $GLOBALS{'UserFilesDirectory'};
  }
# ============================
# </SP>
# ============================

	&DoResponse();

sub DoResponse
{

	if($FORM{'Command'} eq "" || $FORM{'Type'} eq "" || $FORM{'CurrentFolder'} eq "") {
		return ;
	}
	# Get the main request informaiton.
	$sCommand		= $FORM{'Command'};
	$sResourceType	= $FORM{'Type'};
	$sCurrentFolder	= $FORM{'CurrentFolder'};

# ============================
# <SP>
# ============================
  if ( $FORM{'Command'} eq 'DeleteFile' )
  {
    $sFileName = $FORM{'DelFileName'};
    return unless $sFileName;
  }
# ============================
# </SP>
# ============================

	# Check the current folder syntax (must begin and start with a slash).
	if(!($sCurrentFolder =~ /\/$/)) {
		$sCurrentFolder .= '/';
	}
	if(!($sCurrentFolder =~ /^\//)) {
		$sCurrentFolder = '/' . $sCurrentFolder;
	}

	# Check for invalid folder paths (..)
	if ( $sCurrentFolder =~ /(?:\.\.|\\)/ ) {
		SendError( 102, "" ) ;
	}

	# File Upload doesn't have to Return XML, so it must be intercepted before anything.
	if($sCommand eq 'FileUpload') {
		FileUpload($sResourceType,$sCurrentFolder);
		return ;
	}

	print << "_HTML_HEAD_";
Content-Type:text/xml; charset=utf-8
Pragma: no-cache
Cache-Control: no-cache
Expires: Thu, 01 Dec 1994 16:00:00 GMT

_HTML_HEAD_

	&CreateXmlHeader($sCommand,$sResourceType,$sCurrentFolder);

	# Execute the required command.
	if($sCommand eq 'GetFolders') {
		&GetFolders($sResourceType,$sCurrentFolder);
	} elsif($sCommand eq 'GetFoldersAndFiles') {
		&GetFoldersAndFiles($sResourceType,$sCurrentFolder);
	} elsif($sCommand eq 'CreateFolder') {
		&CreateFolder($sResourceType,$sCurrentFolder);
	}
# ============================
# <SP>
# ============================
  if($sCommand eq 'DeleteFile') {
    &DeleteFile($sResourceType,$sCurrentFolder,$sFileName);
  }
# ============================
# </SP>
# ============================

	&CreateXmlFooter();

	exit ;
}
