# (C) http://spcms.ru
use locale;
use strict;

use vars qw( $gteacher_show_all );

sub subgroups() {

    if ( param('op') and param('op') eq 'create' ) {
        my @uids = param;
        my $s    = param('s');
        sec_gt0($s);
        my $c = param('c');
        sec_gt0($c);
        if ( $ggid == 2 ) { check_teacher_binded_to( $c, $s ); } my $name =
          substr( param('new'), 0, 65 );

        sqlb 'insert into sp_class_subgrp_ref (c,s,name) values (?, ?, ?)',
          $c, $s, $name;

        my $id = sqlff "SELECT id from sp_class_subgrp_ref
where c = $c and s = $s and name = '$name'";

        for (@uids) {
            if ( $_ =~ m/^u\d+$/ ) {
                substr( $_, 0, 1 ) = '';
                if ( 1 == sqlff "select class from human where human_id = $_" )
                {
                    sql
                      qq[insert into sp_class_subgrp (id,uid) values ($id, $_)];
                }
            }
        }
        DrawVerticalText( $id, $name, 1 );
        redir "subgroups&c=$c&s=$s";
    }

    if ( param('op') and param('op') eq 'kill' ) {
        my ( $c, $s, $gid ) = ( param('c'), param('s'), param('gid') );
        sec_gt0 $s;
        sec_gt0 $c;
        if ( $ggid == 2 ) { check_teacher_binded_to( $c, $s ); } sec_gteq0 $gid;
        sql qq[delete from sp_class_subgrp where id=$gid];
        sql qq[delete from sp_class_subgrp_ref where id=$gid and c=$c and s=$s];
        DrawVerticalText( $gid, undef, -1 );
        redir "subgroups&c=$c&s=$s";
    }

    if ( param('op') and param('op') eq 'del' ) {
        my ( $c, $s, $gid ) = ( param('c'), param('s'), param('gid') );
        sec_gt0 $s;
        sec_gt0 $c;
        if ( $ggid == 2 ) { check_teacher_binded_to( $c, $s ); } my @a = param;
        for (@a) {
            if (/^id\d+u(\d+)$/) {
                sql qq[delete from sp_class_subgrp where id=$gid and uid=$1];
            }
        }
        redir "subgroups&c=$c&s=$s";
    }

    if ( param('op') and param('op') eq 'add' ) {
        my ( $c, $s, $gid ) = ( param('c'), param('s'), param('gid') );
        sec_gt0 $s;
        sec_gt0 $c;
        if ( $ggid == 2 ) { check_teacher_binded_to( $c, $s ); } my @a = param;
        for (@a) {
            if (/^u(\d+)$/) {
                unless ( sqlff
                    "select 1 from sp_class_subgrp where id=$gid and uid=$1" )
                {
                    if ( 1 ==
                        sqlff "select class from human where human_id = $1" )
                    {
                        sql
qq[insert into sp_class_subgrp (id,uid) values ($gid, $1)];
                    }
                }
            }
        }
        redir "subgroups&c=$c&s=$s";
    }

    if ( param('op') and param('op') eq 'auto_sex' ) {
        my ( $c, $s ) = ( param('c'), param('s') );
        sec_gt0($c);
        sec_gt0($s);
        if ( $ggid == 2 ) { check_teacher_binded_to( $c, $s ); }

        internal_kill_all_subgrp( $c, $s );

        my $q = sqlp "select human_id, sex from human where
exists
(
  select 1 from sys_matrix
  where sys_matrix.view_class = 1
    and sys_matrix.vw_pupil = human.human_id
    and sys_matrix.class = $c
    and exists ( select 1 from get_node_saldo
    ( sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0 )
)";
        my @a;
        my %sex;
        while ( @a = $q->fetchrow_array ) { $sex{ $a[0] } = $a[1]; }

        my $created_boys  = 0;
        my $created_girls = 0;

        my $boys_id;
        my $girls_id;

        for ( keys %sex ) {
            if ( !$created_boys and $sex{$_} == 1 ) {
                sql
"insert into sp_class_subgrp_ref (c, s, name) values ($c, $s, '')";
                $boys_id = sqlff
"select id from sp_class_subgrp_ref where c=$c and s=$s and name=''";
                $created_boys = 1;
                DrawVerticalText( $boys_id, '', 1 );
            }
            if ( !$created_girls and $sex{$_} == 0 ) {
                sql
"insert into sp_class_subgrp_ref (c, s, name) values ($c, $s, '')";
                $created_girls = 1;
                $girls_id      = sqlff
"select id from sp_class_subgrp_ref where c=$c and s=$s and name=''";
                DrawVerticalText( $girls_id, '', 1 );
            }
        }

        for ( keys %sex ) {
            if ( $sex{$_} == 1 ) {
                sql
                  "insert into sp_class_subgrp (id, uid) values ($boys_id, $_)";
            }
            else {
                sql
"insert into sp_class_subgrp (id, uid) values ($girls_id, $_)";
            }
        }

        redir "subgroups&c=$c&s=$s";
    }

    if ( param('op') and param('op') eq 'auto_lang' ) {

        my ( $c, $s ) = ( param('c'), param('s') );
        sec_gt0($c);
        sec_gt0($s);
        if ( $ggid == 2 ) { check_teacher_binded_to( $c, $s ); }

        internal_kill_all_subgrp( $c, $s );

        my $q = sqlp "select sys_matrix.vw_pupil, language_ref.name
from sys_matrix, human_language, language_ref
where
    human_language.human_lang_type = 3
and human_language.language_id = language_ref.language_id
and sys_matrix.view_class = 1
and sys_matrix.class = $c
and sys_matrix.vw_pupil = human_language.human_id
and exists
(
  select 1 from get_node_saldo
  (sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0
)";
        my @a;
        my %uid_lang;
        while ( @a = $q->fetchrow_array ) {
            $a[1] = ucfirst lc $a[1];
            $uid_lang{ $a[0] } = $a[1];
        }

        if ( !%uid_lang ) {
            stop
"            .         .      .";
        }

        my %unical_lang;
        for ( keys %uid_lang ) {
            if ( !$unical_lang{ $uid_lang{$_} } ) {
                $unical_lang{ $uid_lang{$_} }++;
            }
        }

        my %langs_id;
        for ( keys %unical_lang ) {
            sql
"insert into sp_class_subgrp_ref (c, s, name) values ($c, $s, '$_')";
            $langs_id{$_} = sqlff
"select id from sp_class_subgrp_ref where c=$c and s=$s and name='$_'";
            DrawVerticalText( $langs_id{$_}, $_, 1 );
        }

        for ( keys %uid_lang ) {
            sql
"insert into sp_class_subgrp (id, uid) values ($langs_id{$uid_lang{$_}}, $_)";
        }

        redir "subgroups&c=$c&s=$s";
    }

    if ( param('op') and param('op') eq 'rename' ) {
        my ( $c, $s, $gid ) = ( param('c'), param('s'), param('gid') );
        sec_gt0($c);
        sec_gt0($s);
        sec_gt0($gid);
        if ( $ggid == 2 ) { check_teacher_binded_to( $c, $s ); }

        my @a = param;
        my $name;
        for (@a) {
            if (m/^r$gid$/) { $name = substr( param($_), 0, 65 ); last }
        }

        sqlb
'update sp_class_subgrp_ref set name = ? where c = ? and s = ? and id = ?',
          $name, $c, $s, $gid;

        DrawVerticalText( $gid, undef, -1 );
        DrawVerticalText( $gid, $name, 1 );
        redir "subgroups&c=$c&s=$s";
    }

    my ( @a, $q );

    my $class = param('c');
    my $subj  = param('s');

    if ( defined $class ) { sec_gt0 $class; }
    if ( defined $subj )  { sec_gt0 $subj; }

    my %grouped_uids;
    $q = sqlp "select sp_class_subgrp.uid from sp_class_subgrp
  where sp_class_subgrp.id in
  (select id from sp_class_subgrp_ref where c = $class and s = $subj)";
    while ( @a = $q->fetchrow_array ) { $grouped_uids{ $a[0] }++ }

    $q = sqlp "select human_id, last_name, first_name, middle_name
  from sys_matrix, human
  where
    human_id = vw_pupil and
    sys_matrix.view_class = 1 and
    sys_matrix.class = $class and
    exists(select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0)
  order by last_name, first_name, middle_name";
    my $pupils;
    my @human;
    my $id_inc  = 0;
    my $counter = 1;
    my $all     = 0;
    while ( @a = $q->fetchrow_array() ) {
        $all++;
        next if $grouped_uids{ $a[0] };
        $pupils .=
qq[<input type=checkbox id="id$id_inc" name="u$a[0]"><label for="id$id_inc">];
        $pupils .=
            "$counter.&nbsp;"
          . trim( $a[1] )
          . '&nbsp;'
          . substr( trim( $a[2] ), 0, 1 ) . '. '
          . substr( trim( $a[3] ), 0, 1 ) . '.',
          $pupils .= '</label><br>';
        $id_inc++;
        $counter++;
    }
    $q->finish;

    my $pupils_in_class =
      "$all " . declension( $all, [ '', '', '' ] );

    my @grp;
    my $groups;

    $q = sqlp
qq[select id,name from sp_class_subgrp_ref where c = '$class' and s = $subj order by name];
    while ( @a = $q->fetchrow_array ) { push @grp, [@a] }

    for (@grp) {
        if ($DEBUG) {
            $_->[1] .= "&nbsp;(ID&nbsp;=&nbsp;$_->[0])";
        }
        $groups .= qq[<td class=n valign=top>
    <table class=d cellspacing=0 cellpadding=4>
    <tr><th><span id="capt$_->[0]">$_->[1]</span>
    <input name="r$_->[0]" type=text class="def thid" value="$_->[1]" size=15 maxlength=64>
    <input name="s$_->[0]" type=submit class="def thid" value="Ok"
      onclick='javascript: document.f.gid.value="$_->[0]"; document.f.op.value="rename";'>
    </th></tr>
    <tr>
      <td align=center>
<button type=submit class=btn title="     " onclick='javascript: document.f.gid.value="$_->[0]"; document.f.op.value="add";'>
<img src="/sp/img/grp_add.gif"></button>
<button type=submit class=btn title="     " onclick='javascript: document.f.gid.value="$_->[0]"; document.f.op.value="del";'>
<img src="/sp/img/grp_del.gif"></button>
<button type=button class=btn title="  " onclick='javascript: document.f.r$_->[0].className="def"; document.f.s$_->[0].className="def"; document.getElementById("capt$_->[0]").innerHTML=""; document.f.r$_->[0].select(); document.f.r$_->[0].focus();'>
<img src="/sp/img/edit-16.gif"></button>
<button type=submit class=btn title="  " onclick='javascript: if ( confirm("     ?") ) { document.f.gid.value="$_->[0]"; document.f.op.value="kill"; } else return false;'>
<img src="/sp/img/grp_kill.gif" width="18" height="18"></button>
      </td>
    </tr>
    <tr><td>
    <a href="#" onclick="Select_All_subgrp_UIDS('$_->[0]')"> </a><br>
    <nobr>
    ];
        $q = sqlp qq[select uid, last_name, first_name, middle_name
from sp_class_subgrp, human where id = $_->[0]
and human.human_id = sp_class_subgrp.uid
order by last_name, first_name, middle_name];
        $counter = 1;
        while ( @a = $q->fetchrow_array ) {
            $groups .=
qq[<input type=checkbox id="id$id_inc" name="id$_->[0]u$a[0]"><label for="id$id_inc">];
            $groups .=
                "$counter.&nbsp;"
              . trim( $a[1] )
              . '&nbsp;'
              . substr( trim( $a[2] ), 0, 1 ) . '. '
              . substr( trim( $a[3] ), 0, 1 ) . '.',
              $groups .= '</label><br>';
            $id_inc++;
            $counter++;
        }
        $groups .= qq[</td></tr></table></td>];
    }

    my $new .= "";
    my $new_test;

    $counter  = 1;
    $new_test = $new . $counter;
    while ( sqlff
qq[select 1 from sp_class_subgrp_ref where c=$class and s=$subj and name = "$new_test"]
      )
    {
        $counter++;
        $new_test = $new . $counter;
    }
    $new = $new_test;

    $groups ||= '<td class=n></td>';

    my $filter_class;
    my $filter_subj;
    if ( $ggid == 2 ) {
        $filter_class =
          ($gteacher_show_all)
          ? filter_class($class)
          : filter_class_teacher_binded($class);
        $filter_subj =
          ($gteacher_show_all)
          ? filter_subj($subj)
          : filter_subj_teacher_binded($subj);
    }
    else {
        $filter_class = filter_class($class);
        $filter_subj  = filter_subj($subj);
    }

    if ( $ggid == 2 ) {
        my $corrected_class = $class;
        my $corrected_subj  = $subj;
        my $redir           = 0;
        unless ( $filter_class =~ m/value="$class"/ ) {
            $redir = 1;
            $filter_class =~ /value="(\d+)"/;
            $corrected_class = $1;
        }
        unless ( $filter_subj =~ m/value="$subj"/ ) {
            $redir = 1;
            $filter_subj =~ /value="(\d+)"/;
            $corrected_subj = $1;
        }
        if ($redir) {
            redir "subgroups&c=$corrected_class&s=$corrected_subj";
        }
    }

    tpl './tpl/subgroups.html',
      {
        menu            => generate_menu(),
        footers         => generate_footers(),
        filter_class    => $filter_class,
        filter_subj     => $filter_subj,
        's'             => $subj,
        c               => $class,
        pupils          => $pupils,
        groups          => $groups,
        new             => $new,
        pupils_in_class => $pupils_in_class,
      };
}

sub subgrp_kill_all() {
    my $c = param('c');
    sec_gt0($c);
    my $s = param('s');
    sec_gt0($s);
    if ( $ggid == 2 ) { check_teacher_binded_to( $c, $s ); } internal_kill_all_subgrp(
        $c, $s );
    redir "subgroups&c=$c&s=$s";
}

sub internal_kill_all_subgrp($$) {
    my $c = shift;
    my $s = shift;

    my $q = sqlp qq[select id from sp_class_subgrp_ref where c=$c and s=$s];
    my @sub;
    push @sub, $_ while ( $_ = ( $q->fetchrow_array )[0] );

    for (@sub) {
        sql "delete from sp_class_subgrp where id=$_";
        DrawVerticalText( $_, undef, -1 );
    }

    sql qq[delete from sp_class_subgrp_ref where c=$c and s=$s];
}

sub subgrp_list() {

    if (
        !sqlff "select count(1) from sp_class_subgrp_ref
join sys_matrix on class = c
join class on class = class_id
join lesson on s = lesson_id
where
sys_matrix.view_class = 7
and exists
(select 1 from get_node_saldo (sys_matrix.node_id, '$gdate', 0)
where saldo_sum <> 0)"
      )
    {
        msg ' ',
qq[   . <a href="?act=score_form_select_class&goto=subgroups"></a>];
    }

    sub subgrp_list_link($$) {
        my $p1 = shift;
        my $p2 = shift;
        my $q;

        my %bindings;
        if ( $ggid == 2 and !$gteacher_show_all ) {

            $q = sqlp qq[select sys_matrix.class, sys_matrix.lesson
from sys_matrix where view_class = 9001
and vw_teacher = $guid and exists ( select 1 from get_node_saldo_by_unit ( sys_matrix.node_id, '$gdate', '', 0 )
where saldo_sum <> 0)];
            my ( $tmp_c, $tmp_s );
            while ( ( $tmp_c, $tmp_s ) = $q->fetchrow_array() ) {
                $bindings{ $tmp_c . '_' . $tmp_s } = 1;
            }
        }

        $gdb->{"AutoCommit"} = 0;

        $q = sqlp
"select c,s,sp_class_subgrp_ref.name,class.name, lesson.name, paralel, id from sp_class_subgrp_ref
join sys_matrix on class = c
join class on class = class_id
join lesson on s = lesson_id
where
sys_matrix.view_class = 7
and paralel between $p1 and $p2
and exists
(select 1 from get_node_saldo (sys_matrix.node_id, '$gdate', 0)
where saldo_sum <> 0)
order by paralel, class.name, lesson.name, sp_class_subgrp_ref.name";
        my @a;
        my $html = '';
        my ( $c, $s );
        while ( @a = $q->fetchrow_array ) {
            my $binding_count = scalar keys %bindings;
            if ( $ggid == 2 and !$gteacher_show_all ) {
                if ($binding_count) {
                    next
                      unless $bindings{ $a[0] . '_' . $a[1] };
                }
            }

            if ( $c != $a[0] ) {
                my $pupil_count = sqlff "select count(1) from sys_matrix
					where sys_matrix.view_class = 1 and
					sys_matrix.class = $a[0] and
					exists(select 1 from get_node_saldo(
					sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0)";

                $a[3] =~ s/^("\w").+/$1/o;

                if ($DEBUG) {
                    $html .=
"<div class=grp_class>$a[5]&nbsp;$a[3]&nbsp;(<span class='subgrp'>$pupil_count</span>) ID=$a[0]</div>";
                }
                else {
                    $html .=
"<div class=grp_class>$a[5]&nbsp;$a[3]&nbsp;(<span class='subgrp'>$pupil_count</span>)</div>";
                }
                $c = $a[0];
                undef $s;
            }

            if ( $s != $a[1] ) {
                if ($DEBUG) {
                    $html .=
qq[<div class=grp_subj><a href="?act=subgroups&c=$a[0]&s=$a[1]">$a[4]</a> ID=$a[1]</div>];
                }
                else {
                    $html .=
qq[<div class=grp_subj><a href="?act=subgroups&c=$a[0]&s=$a[1]">$a[4]</a></div>];
                }
                $s = $a[1];
            }

            if ($DEBUG) {
                $html .= "<div class=grp_name><b>ID=$a[6]</b> $a[2]</div>";
            }
            else {
                $html .= "<div class=grp_name>$a[2]</div>";
            }

        }

        $gdb->{"AutoCommit"} = 1;

        return $html;
    }

    my ( $l1f, $l1t, $l2f, $l2t, $l3f, $l3t ) = split( ',',
        sqlff qq[select f_char from sp_settings where name = 'class_links'] );

    tpl './tpl/subgroups_list.html',
      {
        menu    => generate_menu(),
        footers => generate_footers(),
        l1      => subgrp_list_link( $l1f, $l1t ),
        l2      => subgrp_list_link( $l2f, $l2t ),
        l3      => subgrp_list_link( $l3f, $l3t )
      };

}

1;
