# (C) http://spcms.ru
use strict;

use vars qw/$act $sact $id $tab/;
our (%human_class_hash);
my ($q);

sub test_report_desktop () {
    my $title_d     = " ";
    my @access_make = qw/report_list report_fullscore/;

    if ( $sact ne '' ) {
        my $denied = 1;
        $denied = 0 if ( grep /^\Q$sact\E$/, @access_make );
        if ($denied) {
            redir 'maketest';
        }
        else {
            no strict 'refs';
            &{$sact}();
        }
    }
    else {
        report_list();
    }

}

sub report_list() {
    my ( $SQL, @gid_ref, $count, $tests, $tmp, @result );

    my ( %h_cat_item_count, %ref_cat_l, %ref_cat_k, %ref_cat_i, $panel_cat,
        %cat_sel, %cat_sd, $sel );
    %cat_sel = %cat_sd = ();
    my $tcat_sel_type  = param('f') || 0;
    my $cat_sel_filter = param('k') || 0;
    my $cat_sel_filter_t =
      ( param('t') ? param('t') : cookie("SP_test_thm") || -1 );

    if ( defined param('t') and param('t') == 0 ) {
        setcookie('SP_test_thm');
        $cat_sel_filter_t = -1;
    }
    elsif ( param('t') ) {
        setcookie( 'SP_test_thm', param('t') );
    }

    if ( $tcat_sel_type != 0 ) {
        if ( $tcat_sel_type < 0 ) {
            $tcat_sel_type = $cat_sel_filter = 0;
            setcookie('SP_test_cat');
        }
        else {
            setcookie( 'SP_test_cat', "$tcat_sel_type|$cat_sel_filter" );
        }
    }
    else {
        my @a = split( /[|]/, cookie("SP_test_cat") || '' );
        if ( scalar @a > 1 ) {
            $tcat_sel_type  = $a[0];
            $cat_sel_filter = $a[1];
        }
    }

    sec_gteq0( $cat_sel_filter, 1 );
    sec_gteq0( $tcat_sel_type,  1 );
    if (   $cat_sel_filter_t !~ m/^\d+$/
        or $cat_sel_filter_t < -1
        or $cat_sel_filter_t > 4294967295 )
    {
        $cat_sel_filter_t = -1;
    }

    $q = sqlpcms
"SELECT cat_type,category,COUNT('id') FROM test_test GROUP BY cat_type, category
  UNION SELECT 0,cat_them,COUNT('id') FROM test_test where cat_them is not null GROUP BY cat_them";
    while ( @result = $q->fetchrow_array() ) {
        $h_cat_item_count{ $result[0] }{ $result[1] } = $result[2];
    }

    $cat_sd{1} = $cat_sd{2} = $cat_sd{3} = ' class="dn"';
    $cat_sd{$tcat_sel_type} = '';
    $cat_sel{1} = $cat_sel{2} = $cat_sel{3} = '';
    $cat_sel{$tcat_sel_type} = ' selected';

    $panel_cat = q[<div align="center" class="panel"><b></b>:

  <select id="cat_type" onchange="sel_categories(e('cat_type').value);">
    <option value="-1"></option>];
    if ( scalar keys %{ $h_cat_item_count{2} } > 0 ) {
        $panel_cat .= qq[<option value="2"$cat_sel{2}></option>];
    }
    if ( scalar keys %{ $h_cat_item_count{3} } > 0 ) {
        $panel_cat .= qq[<option value="3"$cat_sel{3}> </option>];
    }
    if ( scalar keys %{ $h_cat_item_count{1} } > 0 ) {
        $panel_cat .= qq[<option value="1"$cat_sel{1}></option>];
    }
    $panel_cat .= q[</select>&nbsp;&nbsp;];
    my @ref_cat_type = ( '', '', ' -', '  -' );

    if ( scalar keys %{ $h_cat_item_count{2} } > 0 ) {
        $q = sqlp "SELECT lesson_id,name FROM lesson ORDER BY name";
        $panel_cat .=
qq[<select id="cat2" $cat_sd{2} onchange="add_categories('cat2','test_report&sact=report_list&f=2')"><option> -  -</option>];
        while ( @result = $q->fetchrow_array() ) {
            unless ( $h_cat_item_count{2}{ $result[0] } ) { next; }
            $sel =
              ( $result[0] == $cat_sel_filter and $tcat_sel_type == 2 )
              ? ' selected'
              : '';
            $panel_cat .=
"<option value='$result[0]'$sel>$result[1] ($h_cat_item_count{2}{$result[0]})</option>";
            $ref_cat_l{ $result[0] } = $result[1];
        }
        $panel_cat .= '</select>';
    }

    if ( scalar keys %{ $h_cat_item_count{3} } > 0 ) {
        $q = sqlp
          "SELECT knowledge_id, name FROM knowledge_area_ref ORDER BY name";
        $panel_cat .=
qq[<select id="cat3" $cat_sd{3} onchange="add_categories('cat3','test_report&sact=report_list&f=3')"><option> -  -</option>];
        while ( @result = $q->fetchrow_array() ) {
            unless ( $h_cat_item_count{3}{ $result[0] } ) { next; }
            $sel =
              ( $result[0] == $cat_sel_filter and $tcat_sel_type == 3 )
              ? ' selected'
              : '';
            $panel_cat .=
"<option value='$result[0]'$sel>$result[1] ($h_cat_item_count{3}{$result[0]})</option>";
            $ref_cat_k{ $result[0] } = $result[1];
        }
        $panel_cat .= '</select>';
    }

    my @test_categories;
    $q = sqlpcms "SELECT cid, name, ctype FROM test_categories ORDER BY name";
    while ( @result = $q->fetchrow_array() ) {
        push @test_categories, [@result];
    }
    if ( scalar keys %{ $h_cat_item_count{1} } > 0 ) {
        $panel_cat .=
qq[<select id="cat1" $cat_sd{1} onchange="add_categories('cat1','test_report&sact=report_list&f=1')"><option> -  -</option>];

        for (@test_categories) {
            if ( $$_[2] == 0 ) {
                unless ( $h_cat_item_count{1}{ $$_[0] } ) { next; }
                $sel =
                  ( $$_[0] == $cat_sel_filter and $tcat_sel_type == 1 )
                  ? ' selected'
                  : '';
                $panel_cat .=
"<option value='$$_[0]'$sel>$$_[1] ($h_cat_item_count{1}{$$_[0]})</option>";
                $ref_cat_i{ $$_[0] } = $$_[1];
            }
        }
        $panel_cat .= '</select>';
    }

    if ( scalar keys %{ $h_cat_item_count{0} } > 0 ) {
        $panel_cat .=
q[&nbsp;&nbsp;<b></b>: <select id="catTh0" onchange="add_categories('catTh0','test_report&sact=report_list')"><option value="0"></option>];
        for (@test_categories) {
            if ( $$_[2] == 1 ) {
                unless ( $h_cat_item_count{0}{ $$_[0] } ) { next; }
                $sel = $$_[0] == $cat_sel_filter_t ? ' selected' : '';
                $panel_cat .=
"<option value='$$_[0]'$sel>$$_[1] ($h_cat_item_count{0}{$$_[0]})</option>";
                $ref_cat_i{ $$_[0] } = $$_[1];
            }
        }
        $panel_cat .= '</select>';
    }
    $panel_cat .= qq[</div>];

    if ( isadmin() ) { $SQL = ''; } else {
        $SQL =
"WHERE autor = $guid OR EXISTS (SELECT first 1 1 FROM test_access_teacher WHERE tid = test_test.id AND uid = $guid)";
    }

    if ( $tcat_sel_type > 0 ) {
        $SQL .= $SQL ? ' AND ' : 'WHERE';
        if ( $tcat_sel_type == 3 ) {
            my @a;
            sqlffa \@a, "SELECT lesson_id FROM lesson WHERE knowledge_area = "
              . $cat_sel_filter;
            $SQL .= "(cat_type=2 AND (";
            for ( my $i = scalar(@a) - 1 ; $i >= 0 ; $i-- ) {
                $SQL .= "category = $a[$i]" . ( $i > 0 ? ' OR ' : '' );
            }
            $SQL .= ")) OR ";
        }
        $SQL .= " (cat_type = $tcat_sel_type AND category = $cat_sel_filter)";
    }
    if ( $cat_sel_filter_t > 0 ) {
        $SQL .= $SQL ? ' AND ' : 'WHERE';
        $SQL .= " (cat_type = 1 AND cat_them = $cat_sel_filter_t)";
    }

    $q = sqlpcms
"SELECT id, name, (SELECT count('id') FROM test_question_list WHERE tid = test_test.id),
  (SELECT count('id') FROM test_users_execution WHERE tid = test_test.id AND uid != $guid)
  FROM test_test $SQL ORDER BY id DESC";

    $tests = q[<table cellspacing="0" cellpadding="0">
  <tr class=grey><th></th><th></th><th title="  ">.</th></tr>];

    while ( @result = $q->fetchrow_array() ) {
        unless ( defined param("aj")
            && defined param("NoExe")
            && $result[3] <= 0 )
        {
            $tests .=
qq[<tr onmouseover="m_over(this);" onmouseout="m_out(this);" class="c">
		<td onClick="rt($result[0]);" class="handa l">$result[1]</td>
		<td>$result[3]</td>
		<td title="  ">$result[2]</td></td>];
        }
    }

    $tests .= q[</table>];

    if ( defined param("aj") ) {
        aj_print($tests);
    }

    my %replace = (
        menu    => generate_menu(),
        tests   => $tests,
        body    => mesg() . $panel_cat,
        footers => generate_footers(),
    );
    tpl( "./tpl/test/report_form.html", \%replace );
}

sub report_fullscore() {
    sec_gteq0 $id;
    my $access = maketest_access($id);
    if ( $access < 1 ) { redir "$act"; }

    sub total_block_score($$$) {
        my ( $report_bl, $max, $min );
        my $j             = shift || 0;
        my @score_min_max = @{ shift() };
        my $score_avg     = shift;
        $max = 0;
        $min = 100;

        if ( $j == 0 ) {
            $report_bl = "<td colspan=3>&nbsp;</td>";
        }
        elsif ( $j == 1 ) {
            $report_bl =
              "<td colspan=3 class='g s@{$score_avg}[0]'>@{$score_avg}[0]</td>";
        }
        else {
            for (@score_min_max) {
                $max = $_ if ( $max < $_ );
                $min = $_ if ( $min > $_ );
            }
            $report_bl =
              "<td class='g s$max'>$max</td><td class='g s$min'>$min</td><td>"
              . ( avg $score_avg, 2 ) . "</td>";
        }
        $report_bl .= "</tr>\n";

        return $report_bl;
    }

    sub total_block_fullscore($$$$) {
        my ( $tmp, $TEMP, $max, $min, @score_avg, @score_min_max );
        my $num_colspan_for_scors = shift;
        my $penalty_score         = shift;
        my @spe                   = ( shift(), shift() );

        $TEMP =
          qq[<tr onmouseout="m_out(this);" onmouseover="m_over(this);" class=c>
		<td nowrap class=l>&nbsp;&nbsp;<b>$spe[0]:</b></td>\n];
        $max       = 1;
        $min       = 100;
        @score_avg = @score_min_max = ();
        if ( defined( @{$penalty_score}[0] )
            and scalar @{$penalty_score}[0] >= 1 )
        {

            for ( 0 .. ( $num_colspan_for_scors - 1 ) ) {
                if ( @{$penalty_score}[$_] ) {
                    push @score_min_max, @{ @{$penalty_score}[$_] };
                    $TEMP .=
                      '<td>' . ( avg @{$penalty_score}[$_], 1 ) . '</td>';
                }
                else {
                    $TEMP .= '<td>&nbsp;</td>';
                }
            }

            for (@score_min_max) {
                $max = $_ if ( $max < $_ );
                $min = $_ if ( $min > $_ );
            }
            $TEMP .=
              "<td class='g s$max'>$max</td><td class='g s$min'>$min</td><td>"
              . ( avg \@score_min_max, 2 ) . "</td>";
        }
        else {
            $TEMP .=
              "<td colspan=" . ( $num_colspan_for_scors + 3 ) . ">$spe[1]</td>";
        }
        return $TEMP;
    }

    my (
        $body,  $bottom,    @bodytab, @gid_ref, @a_access,
        $i,     $j,         $tmp,     $TEMP,    %class,
        %human, %execution, @result
    );
    my @qa =
      sqlfcms "SELECT name, autor, passmark, maxtime, penalty_test, penalty_qest
    FROM test_test WHERE id = $id";
    $body = qq[<h1>  <br>"$qa[0]"</h1>];

    $q = sqlp(
        "SELECT gid, name from sp_gid_ref WHERE EXISTS
     (SELECT 1 from sp_users where sp_users.gid = sp_gid_ref.gid) ORDER BY gid"
    );
    while ( @result = $q->fetchrow_array() ) {
        $gid_ref[ $result[0] ] = $result[1];
    }

    $q = sqlp "SELECT human_id, last_name ||' '|| first_name ||' '|| middle_name
  FROM human";
    while ( @result = $q->fetchrow_array() ) {
        $human{ $result[0] } = $result[1];
    }

    my @a_access_human_individ;
    $q = sqlpcms "SELECT atype, afor, date_start, date_stop FROM
  test_access WHERE tid = $id and atype != 10 ORDER BY atype, afor",
      { ib_timestampformat => "%d.%m.%Y %H:%M" };
    while ( @result = $q->fetchrow_array() ) {
        push @result, $human{ $result[1] };
        if   ( $result[0] == 4 ) { push @a_access_human_individ, [@result]; }
        else                     { push @a_access,               [@result]; }
    }

    if ( scalar(@a_access_human_individ) > 1 ) {
        @a_access_human_individ =
          sort { $$a[4] cmp $$b[4] } @a_access_human_individ;
    }

    $q = sqlp
"SELECT class, paralel ||' '|| (SELECT name from class where class_id = sys_matrix.class)
    FROM sys_matrix WHERE view_class = 7 AND exists (
     SELECT 1 from get_node_saldo
     (sys_matrix.node_id, 'now', 0) WHERE saldo_sum <> 0 )";
    while ( @result = $q->fetchrow_array() ) {
        $class{ $result[0] } = $result[1];
    }

    my %execution_h;
    $q = sqlpcms
      "SELECT id, uid, date_start, date_stop, penalty, score, time_e, pause
  FROM test_users_execution WHERE tid = $id",
      { ib_timestampformat => '%d.%m.%Y %H:%M' };
    while ( @result = $q->fetchrow_array() ) {
        $execution{ $result[1] } = [ @result, $human{ $result[0] } ];

        if ( defined $execution_h{ $result[1] } ) {
            push @{ $execution_h{ $result[1] } }, [@result];
        }
        else {
            $execution_h{ $result[1] } = [ [@result] ];
        }
    }

    my $num_colspan_for_headr       = $qa[4] + 4;
    my $num_colspan_for_scors       = $qa[4];
    my $num_colspan_for_scors_headr = $qa[4] + 3;

    my ( $paralel1, $paralel2 ) = paralel_h();
    my ( $pupil1,   $pupil2 )   = pupil_h();
    my (
        $all_list_report, $exe_list_report,    $report_bl,
        $min,             $max,                $avg,
        @score_min_max,   @score_avg,          @penalty_score,
        @full_score,      @full_penalty_score, %full_users
    );
    $all_list_report = $exe_list_report = '';
    $full_score[0]   = $full_score[1] = $full_score[2]  = $full_score[3] =
      $full_score[4] = $full_score[5] = $full_score[6]  = $full_score[7] =
      $full_score[8] = $full_score[9] = $full_score[10] = 0;
    @full_penalty_score     = ();
    $full_users{'userNp'}   = 0;
    $full_users{'userEx'}   = 0;
    $full_users{'userExNo'} = ();

    my $human_onse = 1;
    for my $it (@a_access) {

        if ( $$it[0] == 1 ) {
            $TEMP =
"<tr class=light_grey><td colspan='$num_colspan_for_headr' class=rep_h> $$it[1]</td></tr>\n";
            $all_list_report .= $TEMP;
            $exe_list_report .= $TEMP;
            for my $p_class ( @{ $$paralel1{ $$it[1] } } ) {
                $class{$p_class} =~ s/(.+\").+/$1/;
                $TEMP =
"<tr class=light_grey><td colspan='$num_colspan_for_headr' class=rep_h>&nbsp;&nbsp; $class{$p_class} "
                  . ( $DEBUG ? ' id:' . $p_class : '' )
                  . "</td></tr>\n";
                $all_list_report .= $TEMP;
                $exe_list_report .= $TEMP;
                $i             = 1;
                @penalty_score = ();

                unless ( defined $$pupil1{$p_class} ) {
                    next;
                }

                if ( scalar( @{ $$pupil1{$p_class} } ) > 1 ) {
                    @{ $$pupil1{$p_class} } =
                      sort { $human{$a} cmp $human{$b} }
                      @{ $$pupil1{$p_class} };
                }

                for my $p ( @{ $$pupil1{$p_class} } ) {
                    @score_avg = @score_min_max = ();
                    if ( $execution_h{$p} and @{ $execution_h{$p} }[0] ) {
                        $full_users{'userEx'}++;
                    }
                    else {
                        $full_users{'userNp'}++;
                        push @{ $full_users{'userExNo'} }, $p;
                    }
                    $report_bl =
qq[<tr onmouseout="m_out(this);" onmouseover="m_over(this);" class="c" id="p$p">
		<td nowrap class=l>$i. <a href="?act=test&sact=expandedinfo&id=$id&uid=$p" class=small>$human{$p}</a></td>\n];
                    my $j = 0;
                    for ( 0 .. ( $num_colspan_for_scors - 1 ) ) {
                        $tmp =
                          ( $execution_h{$p} and @{ $execution_h{$p} }[$_] )
                          ? @{ @{ $execution_h{$p} }[$_] }[5]
                          : 0;
                        if ($tmp) {
                            $j++;
                            push @score_avg, $tmp;
                            push @{ $penalty_score[$_] },      $tmp;
                            push @{ $full_penalty_score[$_] }, $tmp;
                            push @score_min_max, $tmp;
                        }
                        $full_score[$tmp]++;
                        if ( $tmp < 1 ) {
                            $tmp =
                              ( $execution_h{$p} and @{ $execution_h{$p} }[$_] )
                              ? '/'
                              : '&nbsp';
                        }
                        if ( $execution_h{$p} and @{ $execution_h{$p} }[$_] ) {
                            $report_bl .=
"<td class='hand g s$tmp' onClick='ei(@{@{$execution_h{$p}}[$_]}[0]);'>$tmp</td>";
                        }
                        else {
                            $report_bl .= "<td>$tmp</td>";
                        }
                    }

                    $report_bl .=
                      total_block_score( $j, \@score_min_max, \@score_avg );

                    if ( $j > 0 ) {
                        $exe_list_report .= $report_bl;
                    }
                    $all_list_report .= $report_bl;
                    $i++;
                }

                $TEMP = total_block_fullscore(
                    $num_colspan_for_scors, \@penalty_score,
                    '  ',
                    '     '
                );

                $all_list_report .= $TEMP;
                $exe_list_report .= $TEMP;
            }
        }

        elsif ( $$it[0] == 2 ) {
            $class{ $$it[1] } =~ s/(.+\").+/$1/;
            $TEMP =
"<tr class=light_grey><td colspan='$num_colspan_for_headr' class=rep_h> $class{$$it[1]}"
              . ( $DEBUG ? ' id:' . $$it[1] : '' )
              . "</td></tr>\n";
            $all_list_report .= $TEMP;
            $exe_list_report .= $TEMP;
            $i             = 1;
            @penalty_score = ();
            if ( defined @{ $$pupil1{ $$it[1] } } ) {
                if ( scalar( @{ $$pupil1{ $$it[1] } } ) > 1 ) {
                    @{ $$pupil1{ $$it[1] } } =
                      sort { $human{$a} cmp $human{$b} }
                      @{ $$pupil1{ $$it[1] } };
                }
            }
            else {
                $TEMP =
qq[<tr><td colspan='$num_colspan_for_headr' class=rep_h>   "$gdate"    .<br>
	  <i>]
                  . ( $state_date ? '' : '' )
                  . q[</i>      <br>
	 .]
                  . ( $state_date
                    ? '  <a href="/cgi-bin/sp/sp.cgi?act=state_date_reset" class="small">  </a>.'
                    : '' )
                  . q[</tr>];
                $all_list_report .= $TEMP;
                $exe_list_report .= $TEMP;
            }
            for my $p ( @{ $$pupil1{ $$it[1] } } ) {
                if ( $execution_h{$p} and @{ $execution_h{$p} }[0] ) {
                    $full_users{'userEx'}++;
                }
                else {
                    $full_users{'userNp'}++;
                    push @{ $full_users{'userExNo'} }, $p;
                }
                $report_bl =
qq[<tr onmouseout="m_out(this);" onmouseover="m_over(this);" class="c" id="p$p">
		<td nowrap class=l>$i. <a href="?act=test&sact=expandedinfo&id=$id&uid=$p" class=small>$human{$p}</a></td>\n];
                my $j = 0;
                @score_avg = @score_min_max = ();
                for ( 0 .. ( $num_colspan_for_scors - 1 ) ) {
                    $tmp =
                      ( $execution_h{$p} and @{ $execution_h{$p} }[$_] )
                      ? @{ @{ $execution_h{$p} }[$_] }[5]
                      : 0;
                    if ($tmp) {
                        $j++;
                        push @score_avg, $tmp;
                        push @{ $penalty_score[$_] },      $tmp;
                        push @{ $full_penalty_score[$_] }, $tmp;
                        push @score_min_max, $tmp;
                    }
                    $full_score[$tmp]++;
                    if ( $tmp < 1 ) {
                        $tmp =
                          ( $execution_h{$p} and @{ $execution_h{$p} }[$_] )
                          ? '/'
                          : '&nbsp';
                    }
                    if ( $execution_h{$p} and @{ $execution_h{$p} }[$_] ) {
                        $report_bl .=
"<td class='g hand s$tmp' onClick='ei(@{@{$execution_h{$p}}[$_]}[0])'>$tmp</td>";
                    }
                    else {
                        $report_bl .= "<td>$tmp</td>";
                    }
                }

                $report_bl .=
                  total_block_score( $j, \@score_min_max, \@score_avg );

                if ( $j > 0 ) {
                    $exe_list_report .= $report_bl;
                }
                $all_list_report .= $report_bl;
                $i++;
            }

            $TEMP = total_block_fullscore(
                $num_colspan_for_scors, \@penalty_score,
                '  ',
                '     '
            );

            $all_list_report .= $TEMP;
            $exe_list_report .= $TEMP;
        }

        elsif ( $$it[0] == 5 ) {
            $TEMP =
"<tr class=light_grey><td colspan='$num_colspan_for_headr' class=rep_h>$gid_ref[$$it[1]]</td></tr>\n";
            $all_list_report .= $TEMP;
            $exe_list_report .= $TEMP;
            $i             = 1;
            @penalty_score = ();

            my @teacher;
            $q = sqlp "SELECT human_id FROM human WHERE class = 0";
            while ( @result = $q->fetchrow_array() ) {
                push @teacher, $result[0];
            }

            if ( scalar(@teacher) > 1 ) {
                @teacher = sort { $human{$a} cmp $human{$b} } @teacher;
            }

            for my $p (@teacher) {
                $max       = $avg           = 0;
                $min       = 100;
                @score_avg = @score_min_max = ();
                if ( $execution_h{$p} and @{ $execution_h{$p} }[0] ) {
                    $full_users{'userEx'}++;
                }
                else {
                    $full_users{'userNp'}++;
                    push @{ $full_users{'userExNo'} }, $p;
                }
                $report_bl =
qq[<tr onmouseout="m_out(this);" onmouseover="m_over(this);" class="c" id="p$p">
		<td nowrap class=l>$i. <a href="?act=test&sact=expandedinfo&id=$id&uid=$p" class=small>$human{$p}</a></td>\n];
                my $j = 0;
                for ( 0 .. ( $num_colspan_for_scors - 1 ) ) {
                    $tmp =
                      ( $execution_h{$p} and @{ $execution_h{$p} }[$_] )
                      ? @{ @{ $execution_h{$p} }[$_] }[5]
                      : 0;
                    if ($tmp) {
                        $j++;
                        push @score_avg, $tmp;
                        push @{ $penalty_score[$_] },      $tmp;
                        push @{ $full_penalty_score[$_] }, $tmp;
                        push @score_min_max, $tmp;
                    }
                    $full_score[$tmp]++;
                    if ( $tmp < 1 ) {
                        $tmp =
                          ( $execution_h{$p} and @{ $execution_h{$p} }[$_] )
                          ? '/'
                          : '&nbsp';
                    }
                    if ( $execution_h{$p} and @{ $execution_h{$p} }[$_] ) {
                        $report_bl .=
"<td class='hand g s$tmp' onClick='ei(@{@{$execution_h{$p}}[$_]}[0]);'>$tmp</td>";
                    }
                    else {
                        $report_bl .= "<td>$tmp</td>";
                    }
                }

                $report_bl .=
                  total_block_score( $j, \@score_min_max, \@score_avg );

                if ( $j > 0 ) {
                    $exe_list_report .= $report_bl;
                }
                $all_list_report .= $report_bl;
                $i++;
            }

            $TEMP = total_block_fullscore(
                $num_colspan_for_scors, \@penalty_score,
                '  ',      ' '
            );

            $all_list_report .= $TEMP;
            $exe_list_report .= $TEMP;
        }

    }

    $human_onse = 1;
    $TEMP       = '';
    for my $it (@a_access_human_individ) {
        if ( $human_onse == 1 ) {
            $TEMP =
"<tr class=light_grey><td colspan='$num_colspan_for_headr' class=rep_h></td></tr>\n";
            $all_list_report .= $TEMP;
            $exe_list_report .= $TEMP;
        }
        $max       = $avg           = 0;
        $min       = 100;
        @score_avg = @score_min_max = ();
        if ( $execution_h{ $$it[1] } and @{ $execution_h{ $$it[1] } }[0] ) {
            $full_users{'userEx'}++;
        }
        else {
            $full_users{'userNp'}++;
            push @{ $full_users{'userExNo'} }, $$it[1];
        }

        $report_bl =
qq[<tr onmouseout="m_out(this);" onmouseover="m_over(this);" class="c" id="p$$it[1]">
		<td nowrap class=l>$human_onse. <a href="?act=test&sact=expandedinfo&id=$id&uid=$$it[1]" class=small>$$it[4]</a></td>\n];

        $j = 0;
        for ( 0 .. ( $num_colspan_for_scors - 1 ) ) {
            $tmp =
              ( $execution_h{ $$it[1] } and @{ $execution_h{ $$it[1] } }[$_] )
              ? @{ @{ $execution_h{ $$it[1] } }[$_] }[5]
              : 0;
            if ($tmp) {
                $j++;
                push @score_avg, $tmp;
                push @{ $penalty_score[$_] },      $tmp;
                push @{ $full_penalty_score[$_] }, $tmp;
                push @score_min_max, $tmp;
            }
            $full_score[$tmp]++;
            if ( $tmp < 1 ) {
                $tmp =
                  ( $execution_h{ $$it[1] }
                      and @{ $execution_h{ $$it[1] } }[$_] ) ? '/' : '&nbsp';
            }
            if ( $execution_h{ $$it[1] } and @{ $execution_h{ $$it[1] } }[$_] )
            {
                $report_bl .=
"<td class='hand g s$tmp' onClick='ei(@{@{$execution_h{$$it[1]}}[$_]}[0]);'>$tmp</td>";
            }
            else {
                $report_bl .= "<td>$tmp</td>";
            }
        }

        $report_bl .= total_block_score( $j, \@score_min_max, \@score_avg );

        if ( $j > 0 ) {
            $exe_list_report .= $report_bl;
        }
        $all_list_report .= $report_bl;
        $human_onse++;
    }

    if ( $human_onse > 1 ) {
        $TEMP = total_block_fullscore(
            $num_colspan_for_scors,   \@penalty_score,
            '  ', '   '
        );

        $all_list_report .= $TEMP;
        $exe_list_report .= $TEMP;
    }

    if ( $all_list_report ne '' ) {

        $TEMP =
"<tr class=light_grey><td colspan='$num_colspan_for_headr' class='rep_h'>&nbsp;</td></tr>\n";
        $TEMP .=
          qq[<tr onmouseout="m_out(this);" onmouseover="m_over(this);" class=c>
  	<td nowrap class=l>&nbsp;&nbsp;<b>:</b></td>\n];
        $max       = $avg           = 1;
        $min       = 100;
        @score_avg = @score_min_max = ();
        if ( defined $full_penalty_score[0]
            && scalar $full_penalty_score[0] >= 1 )
        {
            for ( 0 .. ( $num_colspan_for_scors - 1 ) ) {
                if ( $full_penalty_score[$_] ) {
                    push @score_min_max, @{ $full_penalty_score[$_] };
                    $TEMP .= '<td>'
                      . ( avg \@{ $full_penalty_score[$_] }, 1 ) . '</td>';
                }
                else {
                    $TEMP .= '<td>&nbsp;</td>';
                }
            }
            for (@score_min_max) {
                $max = $_ if ( $max < $_ );
                $min = $_ if ( $min > $_ );
            }
            $avg = avg \@score_min_max, 2;
            $TEMP .= "<td>$max</td><td>$min</td><td>$avg</td>";
        }
        else {
            $TEMP .=
              "<td colspan=" . ( $num_colspan_for_scors + 3 ) . ">&mdash;</td>";
            $max = $min = $avg = '&mdash;';
        }
        $all_list_report .= $TEMP;
        $exe_list_report .= $TEMP;

        $TEMP = qq[
<div style="padding: 10px;"><table cellspacing="0" cellpadding="1" class="d" align=center>
<tr>
  <th rowspan="3"></th>
  <th colspan="$num_colspan_for_scors_headr"></th>
</tr>
<tr>
  <th colspan="$num_colspan_for_scors"> </th>
  <th rowspan="2"></th>
  <th rowspan="2"></th>
  <th rowspan="2"></th>
</tr>
<tr>\n];
        for ( 1 .. $num_colspan_for_scors ) {
            $TEMP .= "<th>$_</th>";
        }
        $bodytab[0] .= $TEMP;
        $bodytab[1] .= $TEMP;

        $bodytab[0] .= qq[\n</tr>\n$all_list_report\n</table>];
        $bodytab[1] .= qq[\n</tr>\n$exe_list_report\n</table>];

        $full_score[2] += $full_score[1];
        $full_score[7] = @a_access;
        $full_score[0] /= $num_colspan_for_scors;
        for ( 1 .. scalar @full_score ) {
            $full_score[$_] += 0;
        }

        $TEMP = qq[<br>
<table cellspacing="0" cellpadding="1" class="d" align=center>
<tr>
  <th></th>
  <th></th>
</tr>
<tr>
  <td>- <b class=s5>5</b></td>
  <td class=c>$full_score[5]</td>
</tr>
<tr>
  <td>- <b class=s4>4</b></td>
  <td class=c>$full_score[4]</td>
</tr>
<tr>
  <td>- <b class=s3>3</b></td>
  <td class=c>$full_score[3]</td>
</tr>
<tr>
  <td>- <b class=s2>2</b>  <b class=s1>1</b></td>
  <td class=c>$full_score[2]</td>
</tr>
<tr>
  <td> </td>
  <td class='c g s$max'>$max</td>
</tr>
<tr>
  <td> </td>
  <td class='c g s$min'>$min</td>
</tr>
<tr>
  <td> </td>
  <td class='c g s] . ( sprintf( "%.0f", $avg ) ) . qq['>$avg</td>
</tr>
<tr>
  <td> </td>
  <td class=c>$full_users{'userEx'}&nbsp;.</td>
</tr>
<tr>
  <td>  </td>
  <td class=c>$full_users{'userNp'}&nbsp;.</td>
</tr>
</table>
</div>];

        $TEMP .=
q[<table cellspacing="0" cellpadding="4" align="center" class="memu_bar dontprint"><tr>];
        $TEMP .=
qq[<td onmouseout="mo(this);" onmouseover="mi(this);" onClick="if(confirm('       ?')){redir('?act=maketest&sact=massive_operation&operation=score_recal&id=$id')}"><dl class="calkul48"></dl><div>   </div></td>];
        $TEMP .=
qq[<td onmouseout="mo(this);" onmouseover="mi(this);" onClick="if(confirm('       ?')){redir('?act=maketest&sact=massive_operation&operation=del_all_executetest&id=$id')}"><dl class="del48"></dl><div>   </div></td>];
        $TEMP .= q[<tr></table><br>];

        $bodytab[0] .= $TEMP;
        $bodytab[1] .= $TEMP;
    }
    else {
        $bodytab[0] = $bodytab[1] =
q[<div align=center style="padding:15px">   ,  <br>     .</div>];
    }

    $bottom = q[<script type="text/javascript">
var tab_act=] . ( defined param('tab') ? param('tab') * 1 : 0 ) . qq[;
function ei(id) { if(id != undefined) {redir("?act=test&sact=totalsscore&id="+id+"&ref=$id&tab="+tab_act);} }
function tabcontrol_act_tab(key) {tab_act = key=='_0'?0:1;}
</script>];

    if ( $access > 1 ) {
        $body .= tab_div(
            [ "1: ",            $bodytab[0] ],
            [ "2:  ", $bodytab[1] ],
        );
    }
    else {
        $body .= tab_div(
            [ "1: ",            $bodytab[0] ],
            [ "2:  ", $bodytab[1] ],
        );
    }

    my %replace = (
        act     => $act,
        body    => ( mesg() . $body ),
        bottom  => $bottom,
        menu    => generate_menu(),
        footers => generate_footers(),
    );
    tpl( "./tpl/test/desktop_tab.html", \%replace );
}

1;
